{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Basic Authorization Dialog                                        }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Basicdlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Dlghead, ComCtrls, ExtCtrls, EnhListView, ExtListView, StdCtrls,
  Buttons, IniFiles, ZonuClass, Hzbconst;

type
  TBasicAuthorizationForm = class(TForm)
    HeaderFrame1: THeaderFrame;
    ListView1: TdfsExtListView;
    BitBtn3: TBitBtn;
    Bevel1: TBevel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    ComboBoxEx1: TComboBoxEx;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ComboBoxEx1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  BasicAuthorizationForm: TBasicAuthorizationForm;

implementation

{$R *.dfm}

uses
  ZonuConf;

{ TBasicAuthorizationForm }

{
procedure TBasicAuthorizationForm.SaveIni;
var
  ini: TMemIniFile;
begin
  ini     :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_BASIC_AUTHOR);
  ini.ReadString(Site.SiteID + Self.BoardID, 'PASSWORD', Value);
  ini.UpdateFile;
  ini.Free;

end;
}

procedure TBasicAuthorizationForm.FormCreate(Sender: TObject);
var
  i: integer;
  Item  : TComboExItem;
begin
  ComboBoxEx1.OnChange  :=  nil;
  for i :=  0 to  ZonuEnviron.SiteList.Count - 1 do  begin
    Item  :=  ComboBoxEx1.ItemsEx.Add;
    Item.Caption    :=  ZonuEnviron.SiteList[i].SiteName;
    Item.Data       :=  ZonuEnviron.SiteList[i];
    Item.ImageIndex :=  ZonuEnviron.SiteList[i].ImageIndex;
  end;
  ComboBoxEx1.OnChange  :=  ComboBoxEx1Change;
  if  (ComboBoxEx1.Items.Count > 0) then  begin
    ComboBoxEx1.ItemIndex :=  0;
    ComboBoxEx1.OnChange(ComboBoxEx1);
  end;
end;

procedure TBasicAuthorizationForm.ComboBoxEx1Change(Sender: TObject);
var
  Site: TSite;
  Board: TBoard;
  Item: TListItem;
  i: integer;
begin
  Site  :=  TSite(ComboBoxEx1.ItemsEx[ComboBoxEx1.ItemIndex].Data);
  ListView1.Items.Clear;
  for i :=  0 to  Site.BoardList.Count - 1 do  begin
    Board :=  Site.BoardList[i];
    Item  :=  ListView1.Items.Add;
    Item.Caption  :=  Board.Name;
    Item.SubItems.Add(Board.BoardID);
    Item.SubItems.Add(Board.BasicAuthorization_UserName);
    Item.Data :=  Board;
  end;
end;

procedure TBasicAuthorizationForm.BitBtn1Click(Sender: TObject);
var
  Board: TBoard;
  ini: TMemIniFile;
begin
  if  (ListView1.Selected <> nil) then  begin
    Board   :=  TBoard(ListView1.Selected.Data);
    if  (Board <> nil)  then  begin
      ini     :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_BASIC_AUTHOR);
      if  (Edit1.Text <> '')  then  begin
        ini.WriteString(Board.Site.SiteID + Board.BoardID, 'USERNAME', Edit1.Text);
        ini.WriteString(Board.Site.SiteID + Board.BoardID, 'PASSWORD', Edit2.Text);
      end else begin
        ini.DeleteKey(Board.Site.SiteID + Board.BoardID, 'USERNAME');
        ini.DeleteKey(Board.Site.SiteID + Board.BoardID, 'PASSWORD');
      end;
      ini.UpdateFile;
      ini.Free;
      ListView1.Selected.SubItems[1]  :=  Edit1.Text;
    end;
  end;
end;

procedure TBasicAuthorizationForm.ListView1SelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if  (Selected)  then  begin
    Edit1.Text  :=  TBoard(ListView1.Selected.Data).BasicAuthorization_UserName;
    Edit2.Text  :=  TBoard(ListView1.Selected.Data).BasicAuthorization_Password;
  end;
end;

procedure TBasicAuthorizationForm.BitBtn2Click(Sender: TObject);
begin
  ModalResult :=  mrOk;
end;

end.
