{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 BBS Dialog Unit                                                   }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit BbsOrder;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Main, ExtCtrls, Dlghead, CheckLst;

type
  TBBSOrderDialog = class(TForm)
    Button3: TButton;
    Button4: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    ListBox1: TListBox;
    Button2: TButton;
    Button1: TButton;
    HeaderFrame1: THeaderFrame;
    TabSheet2: TTabSheet;
    Button5: TButton;
    Button6: TButton;
    CheckListBox1: TCheckListBox;
    Button7: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      ARect: TRect; State: TOwnerDrawState);
    procedure FormDestroy(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private 錾 }
    FBmpWork: TBitmap;
  public
    { Public 錾 }
  end;

var
  BBSOrderDialog: TBBSOrderDialog;

implementation

{$R *.dfm}

uses
  ZonuConf, Hzbconst, ZonuClass, MonaUtils;

procedure TBBSOrderDialog.FormCreate(Sender: TObject);
var
  i, x : integer;
  b : boolean;
  s : TStringList;
  sx: string;
  Site  : TSite;
begin
  FBmpWork  :=  TBitmap.Create;
  s :=  TStringList.Create;
  if  (FileExists(ZonuConfig.UsersPath + FILE_USER_BBS))  then  begin
    s.LoadFromFile(ZonuConfig.UsersPath + FILE_USER_BBS);
  end;
  for i :=  0 to  s.Count - 1 do  begin
    if  (ZonuEnviron.SiteList.FindSite(s[i], Site))  then  begin
      ListBox1.Items.Objects[ListBox1.Items.Add(Site.SiteName)] := Site;
    end;
  end;
  //
  s.Clear;
  if  (FileExists(ZonuConfig.UsersPath + FILE_BBS_TOOLBAR)) then  begin
    s.LoadFromFile(ZonuConfig.UsersPath + FILE_BBS_TOOLBAR);
  end;
  for i :=  0 to  s.Count - 1 do  begin
    sx  :=  ChooseString(s[i], #9, 0);
    if  (ZonuEnviron.SiteList.FindSite(sx, Site))  then  begin
      sx  :=  ChooseString(s[i], #9, 1);
      x :=  CheckListBox1.Items.Add(sx);
      CheckListBox1.Items.Objects[x] := Site;
      CheckListBox1.Checked[x]  :=  True;
    end;
  end;
  for i :=  0 to  ZonuEnviron.SiteList.Count - 1  do  begin
    b :=  False;
    for x :=  0 to  CheckListBox1.Items.Count - 1 do  begin
      if  (ZonuEnviron.SiteList[i] = TSite(CheckListBox1.Items.Objects[x])) then
      begin
        b :=  True;
        Break;
      end;
    end;
    if  (not b) then  begin
      CheckListBox1.Items.Objects[CheckListBox1.Items.Add(ZonuEnviron.SiteList[i].SiteName)] := ZonuEnviron.SiteList[i];
    end;
  end;
  s.Free;
  CheckBox2.Checked :=  ZonuConfig.ShowBBSToolBar;
  CheckBox1.Checked :=  ZonuConfig.BBSToolBarShowImage;
  PageControl1.ActivePageIndex  :=  0;
end;

procedure TBBSOrderDialog.FormDestroy(Sender: TObject);
begin
  FBmpWork.Free;
end;

procedure TBBSOrderDialog.Button1Click(Sender: TObject);
var
  n : integer;
  ls: TCustomListBox;
begin
  if  (Sender = Button1)  then  begin
    ls  :=  ListBox1;
  end else begin
    ls  :=  CheckListBox1;
  end;
  if  (ls.ItemIndex > 0)  then  begin
    n :=  ls.ItemIndex;
    ls.Items.Move(ls.ItemIndex,ls.ItemIndex - 1);
    ls.ItemIndex  :=  n - 1;
  end;
end;

procedure TBBSOrderDialog.Button2Click(Sender: TObject);
var
  n : integer;
  ls: TCustomListBox;
begin
  if  (Sender = Button2)  then  begin
    ls  :=  ListBox1;
  end else begin
    ls  :=  CheckListBox1;
  end;
  if  (ls.ItemIndex < ls.Items.Count - 1)  then  begin
    n :=  ls.ItemIndex;
    ls.Items.Move(ls.ItemIndex, ls.ItemIndex + 1);
    ls.ItemIndex  :=  n + 1;
  end;
end;

procedure TBBSOrderDialog.Button3Click(Sender: TObject);
var
  i : integer;
  s : TStringList;
begin
  s :=  TStringList.Create;
  for i :=  0 to  ListBox1.Items.Count - 1 do  begin
    s.Add(TSite(ListBox1.Items.Objects[i]).SiteID);
  end;
  s.SaveToFile(ZonuConfig.UsersPath + FILE_USER_BBS);

  s.Clear;
  for i :=  0 to  CheckListBox1.Items.Count - 1 do  begin
    if  (CheckListBox1.Checked[i])  then  begin
      s.Add(TSite(CheckListBox1.Items.Objects[i]).SiteID + #9 + CheckListBox1.Items[i]);
    end;
  end;
  s.SaveToFile(ZonuConfig.UsersPath + FILE_BBS_TOOLBAR);
  s.Free;
  ZonuConfig.BBSToolBarShowImage  :=  CheckBox1.Checked;
  ZonuConfig.ShowBBSToolBar       :=  CheckBox2.Checked;
  ModalResult :=  mrOk;
end;

procedure TBBSOrderDialog.Button4Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

procedure TBBSOrderDialog.ListBox1DrawItem(Control: TWinControl;
  Index: Integer; ARect: TRect; State: TOwnerDrawState);
begin
  {
  if  (ListBox1.Items.Objects[Index] <> nil)  then  begin
    HotzonuForm.ImageList2.GetBitmap(TSite(ListBox1.Items.Objects[Index]).ImageIndex, FBmpWork);
    ListBox1.Canvas.TextRect(ARect, ARect.Left + 18, ARect.Top, TSite(ListBox1.Items.Objects[Index]).SiteName);
    ListBox1.Canvas.CopyRect(
              Rect(ARect.Left, ARect.Top, ARect.Left + FBmpWork.Width, ARect.Top + FBmpWork.Height),
              FBmpWork.Canvas,
              Rect(0, 0, FBmpWork.Width, FBmpWork.Height));
  end;
  }
end;

procedure TBBSOrderDialog.Button7Click(Sender: TObject);
var
  s: string;
begin
  if  (CheckListBox1.ItemIndex > -1)  then  begin
    s :=  CheckListBox1.Items[CheckListBox1.ItemIndex];
    if  (InputQuery('OύX', '', s)) then  begin
      CheckListBox1.Items[CheckListBox1.ItemIndex]  :=  s;
    end;
  end;
end;

end.
