{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Bookmark Editor Unit                                              }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Bookedt;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, Main, EnhListView, ExtListView, ZonuConf,
  Hzbconst, Hzbclass, Hzbfunc, ZonuClass, ZonuFavorites, ActnList, StdCtrls,
  Menus, OleCtrls, IniFiles;

type
  TBookmarkEditor = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Panel4: TPanel;
    ListView1: TdfsExtListView;
    ActionList1: TActionList;
    Label1: TLabel;
    PopupMenu1: TPopupMenu;
    Panel3: TPanel;
    PopupMenu2: TPopupMenu;
    N3: TMenuItem;
    Edit1: TMenuItem;
    Delete1: TMenuItem;
    Timer1: TTimer;
    N4: TMenuItem;
    CategoryList: TListBox;
    Splitter2: TSplitter;
    Panel5: TPanel;
    actCategoryNew: TAction;
    actCategoryDelete: TAction;
    actCategoryRename: TAction;
    actBookmarkDelete: TAction;
    D1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure CategoryListClick(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure CategoryListDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure CategoryListDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure actCategoryNewExecute(Sender: TObject);
    procedure actCategoryRenameExecute(Sender: TObject);
    procedure actCategoryDeleteExecute(Sender: TObject);
    procedure actBookmarkDeleteExecute(Sender: TObject);
  private
    { Private 錾 }
    FBrowser: TZonuBrowser;
    FThreadList: TList;
    procedure BuildBookmarkList;
    procedure WebBrowserBeforeNavigate2(Sender: TObject;
      const pDisp: IDispatch; var AURL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure WebBrowserNewWindow2(Sender: TObject; var ppDisp: IDispatch;
      var Cancel: WordBool);
    function ExistsCategory(const CategoryName: string): boolean;
    procedure SaveCategoryList; //XbhǗ
    //FCategories: TStringList; //JeSǗ
    //Strings[x] = JeS
    //Objects[x] = TList ̃JeS̃Xbhꗗ
  public
    { Public 錾 }
  end;

var
  BookmarkEditor: TBookmarkEditor;

implementation

{$R *.dfm}

uses
  Zonutils, MonaUtils;

const
  NO_TITLE  =  '()';


procedure TBookmarkEditor.FormCreate(Sender: TObject);
var
  ThreadItem: TThreadItem;
  i, x, n: integer;
  s: string;
begin
  //JeSXg[h
  CategoryList.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_BOOKMARK_CATEGORY);
  for i :=  0 to  CategoryList.Count - 1  do  begin
    CategoryList.Items.Objects[i] :=  TList.Create;
  end;
  CategoryList.Items.Insert(0, NO_TITLE);
  CategoryList.Items.Objects[0] :=  TList.Create;

  //
  //  ͂łXbḧꗗ쐬
  //
  FThreadList :=  TList.Create;
  for i   :=  0 to  HotzonuWindow.BookmarkFile.Count - 1  do  begin
    s :=  HotzonuWindow.BookmarkFile.Names[i];
    ThreadItem  :=  TThreadItem.Create;
    ThreadItem.CreateThreadItem(ChooseString(s, '/', 2),
                                ChooseString(s, '/', 1),
                                ChooseString(s, '/', 0),
                                ChooseString(HotzonuWindow.BookmarkFile[i], '=', 1));
    if  (ThreadItem.Site  <> nil)  and
        (ThreadItem.Board <> nil)  then
    begin
      if  (ThreadItem.BookmarkList.Count > 0) then  begin
        //肪̂ŃXgɒǉ
        FThreadList.Add(ThreadItem);
        //ǂ̃JeSɑ邩`FbN
        for x :=  0 to  ThreadItem.BookmarkList.Count - 1 do  begin
          if  (ThreadItem.BookmarkList[x].Category = '')  then  begin
            n :=  0;  //JeS̏ꍇ ()
          end else begin
            n :=  CategoryList.Items.IndexOf(ThreadItem.BookmarkList[x].Category);
          end;
          if  (n < 0) then  begin
            n :=  CategoryList.Items.Add(ThreadItem.BookmarkList[x].Category);
            CategoryList.Items.Objects[n] :=  TList.Create;
          end;
          TList(CategoryList.Items.Objects[n]).Add(ThreadItem.BookmarkList[x]);
        end;
      end else begin
        ThreadItem.ReleaseRef;
      end;
    end else begin
      ThreadItem.ReleaseRef;
    end;
  end;
  //
  //  X\puEU
  //
  FBrowser  :=  TZonuBrowser.Create(Self);
  TOleControl(FBrowser).Parent  :=  Panel5;
  FBrowser.Align    :=  alClient;
  FBrowser.ResList  :=  TResList.Create(nil);
  FBrowser.OnBeforeNavigate2       :=  WebBrowserBeforeNavigate2;
  FBrowser.OnNewWindow2            :=  WebBrowserNewWindow2;
end;

procedure TBookmarkEditor.CategoryListClick(Sender: TObject);
begin
  //JeSIꂽ
  //̃JeSɑ邵̈ꗗ\
  BuildBookmarkList;
end;

procedure TBookmarkEditor.BuildBookmarkList;
var
  i: integer;
  SioriList: TList;
  BookmarkRes: TBookmarkRes;
  ThreadItem: TThreadItem;
  Item: TListItem;
begin
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  //̈ꗗ擾
  SioriList :=  TList(CategoryList.Items.Objects[CategoryList.ItemIndex]);
  //̈ꗗXbhXg쐬
  for i :=  0 to  SioriList.Count - 1 do  begin
    BookmarkRes :=  TBookmarkRes(SioriList[i]);
    ThreadItem  :=  BookmarkRes.ThreadItem;
    Item        :=  ListView1.Items.Add;
    Item.Caption    :=  ThreadItem.Site.SiteName;
    Item.SubItems.Add(ThreadItem.Board.Name);
    Item.SubItems.Add(ThreadItem.Title);
    Item.SubItems.Add(IntToStr(BookmarkRes.ResNo));
    Item.SubItems.Add(TrimTag(BookmarkRes.Body));
    Item.Data   :=  SioriList[i];
  end;
  ListView1.Items.EndUpdate;
end;

procedure TBookmarkEditor.ListView1SelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
  procedure OutputRes(ThreadItem: TThreadItem; BookmarkRes: TBookmarkRes);
  var
    Res: TRes;
  begin
    FBrowser.ThreadItem         :=  ThreadItem;
    ThreadItem.AddRef;
    FBrowser.ResList.ThreadItem :=  ThreadItem;

    Res :=  TRes.Create;
    Res.BBS   :=  ThreadItem.BBS;
    Res.Site  :=  ThreadItem.Site;
    Res.No    :=  BookmarkRes.ResNo;
    Res.Name  :=  BookmarkRes.Name;
    Res.Mail  :=  '';
    Res.Date  :=  BookmarkRes.Date;
    Res.Body  :=  BookmarkRes.Body;
    FBrowser.ResList.Add(Res);
    FBrowser.WriteRes(Res);
  end;
var
  BookmarkRes: TBookmarkRes;
begin
  if  (Selected) and (Item <> nil)  then  begin
    FBrowser.OnBeforeNavigate2  :=  nil;
    if  (FBrowser.ThreadItem <> nil)  then  begin
      FBrowser.ThreadItem.ReleaseRef;
    end;
    FBrowser.Clear;
    FBrowser.InitSkin('', 'siori_manager');
    FBrowser.InitOutputRes;

    if  (Item.Data <> nil)  then  begin
      BookmarkRes :=  TBookmarkRes(Item.Data);
      FBrowser.ThreadItem :=  BookmarkRes.ThreadItem;
      FBrowser.ResList.Create(BookmarkRes.ThreadItem);
      FBrowser.WriteHeader;
      OutputRes(BookmarkRes.ThreadItem, BookmarkRes);
      FBrowser.EndOutputRes;
    end;
    FBrowser.OnBeforeNavigate2  :=  WebBrowserBeforeNavigate2;
  end;
end;

procedure TBookmarkEditor.WebBrowserBeforeNavigate2(Sender: TObject;
  const pDisp: IDispatch; var AURL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
begin
  Cancel  :=  True;
end;

procedure TBookmarkEditor.WebBrowserNewWindow2(Sender: TObject;
  var ppDisp: IDispatch; var Cancel: WordBool);
begin
  Cancel  :=  True;
end;

procedure TBookmarkEditor.CategoryListDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept  :=  (Source = CategoryList) or (Source = ListView1);
end;

procedure TBookmarkEditor.CategoryListDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  i: integer;
  ToIndex: integer;
  SelCount: integer;
  SelIndex: integer;
begin

  if  (Source = CategoryList) then  begin

    SelCount  :=  CategoryList.SelCount;
    ToIndex   :=  CategoryList.ItemAtPos(Point(X, Y), False);
    SelIndex  :=  -1;
    for i :=  0 to  CategoryList.Items.Count - 1  do  begin
      if  (CategoryList.Selected[i])  then  begin
        SelIndex  :=  i;
        Break;
      end;
    end;
    if  (ToIndex > SelIndex)  then  begin
      for i :=  0 to  SelCount - 1  do  begin
        CategoryList.Items.Move(SelIndex, ToIndex - 1);
      end;
    end else begin
      for i :=  0 to  SelCount - 1  do  begin
        CategoryList.Items.Move(SelIndex + i, ToIndex + i);
      end;
    end;
    if  (ToIndex > SelIndex)  then  begin
      if  (SelCount = 1)  then  begin
        CategoryList.Selected[ToIndex - 1]  :=  True;
      end else begin
        for i :=  ToIndex - SelCount  to  ToIndex - 1  do  begin
          CategoryList.Selected[i]  :=  True;
        end;
      end;
    end else begin
      if  (SelCount = 1)  then  begin
        CategoryList.Selected[ToIndex]  :=  True;
      end else begin
        for i :=  ToIndex to  ToIndex + SelCount - 1  do  begin
          CategoryList.Selected[i]  :=  True;
        end;
      end;
    end;

  end else
  if  (Source = ListView1)  then  begin

    ListView1.Items.BeginUpdate;
    ToIndex   :=  CategoryList.ItemAtPos(Point(X, Y), False);
    for i :=  ListView1.Items.Count - 1 downto  0 do  begin
      if  (ListView1.Items[i].Selected) then  begin
        TBookmarkRes(ListView1.Items[i].Data).Category  :=  CategoryList.Items[ToIndex];
        TBookmarkRes(ListView1.Items[i].Data).ThreadItem.SaveConfig;

        for x :=  TList(CategoryList.Items.Objects[CategoryList.ItemIndex]).Count - 1 downto  0 do  begin
          if  (TList(CategoryList.Items.Objects[CategoryList.ItemIndex]).Items[x] = ListView1.Items[i].Data)  then
          begin
            TList(CategoryList.Items.Objects[CategoryList.ItemIndex]).Delete(x);
          end;
        end;

        TList(CategoryList.Items.Objects[ToIndex]).Add(TBookmarkRes(ListView1.Items[i].Data));
        ListView1.Items.Delete(i);

      end;
    end;
    ListView1.Items.EndUpdate;


  end;
  
end;
{
var
  SelList: TStringList;
  ToIndex: integer;
  SelectFrom, SelectTo: integer;
  i: integer;
begin
  if  (Source = CategoryList) then  begin
    ToIndex :=  CategoryList.ItemAtPos(Point(X, Y), False);
    SelList :=  TStringList.Create;
    for i :=  0 to  CategoryList.Items.Count - 1  do  begin
      if  (CategoryList.Selected[i])  then  begin
        SelList.Add(IntToStr(i));
      end;
    end;
    {
        if  (ToIndex > i) then  begin
          CategoryList.Items.Move(i, ToIndex - 1);
        end else begin
          CategoryList.Items.Move(i, ToIndex);
        end;
      end;
    end;
  end;
end;}

procedure TBookmarkEditor.FormDestroy(Sender: TObject);
begin
  //JeSꗗ̕ۑ
  SaveCategoryList;
end;

procedure TBookmarkEditor.actCategoryNewExecute(Sender: TObject);
var
  n: integer;
  s: string;
begin
  n :=  0;
  repeat
    Inc(n);
    s :=  Format('JeS%d', [n]);
  until (CategoryList.Items.IndexOf(s) < 0);
  while (true)  do  begin
    if  (InputQuery('JeS̐VK쐬', 'JeS', s)) then  begin
      if  (not ExistsCategory(s)) then  begin
        if  (s <> '') then  begin
          n :=  CategoryList.Items.Add(s);
          CategoryList.ItemIndex  :=  n;
          CategoryList.Items.Objects[n] :=  TList.Create;
          Break;
        end;
      end else begin
        MessageDlg('łɎgĂJeSłB', mtError, [mbOk], 0);
      end;
    end;
  end;
end;

function TBookmarkEditor.ExistsCategory(const CategoryName: string): boolean;
begin
  Result  :=  (CategoryList.Items.IndexOf(CategoryName) > -1);
end;

procedure TBookmarkEditor.actCategoryRenameExecute(Sender: TObject);
var
  n: integer;
  s: string;
  o: string;
begin
  o :=  CategoryList.Items[CategoryList.ItemIndex];
  CategoryList.Items[CategoryList.ItemIndex]  :=  '';
  s := o;
  while (true)  do  begin
    if  (InputQuery('JeS̕ύX', 'JeS', s)) then  begin
      if  (not ExistsCategory(s)) then  begin
        if  (s <> '') then  begin
          {
          ThreadItem  :=  TBookmarkRes(CategoryList.Items.Objects[CategoryList.ItemIndex]);
          for n :=  0 to  ThreadItem.BookmarkList.Count - 1 do  begin
            if  (ThreadItem.BookmarkList[n].Category  = CategoryList.Items[CategoryList.ItemIndex]) then  begin
              ThreadItem.BookmarkList[n].Category :=  s;
            end;
          end;
          }
          for n :=  0 to  TList(CategoryList.Items.Objects[CategoryList.ItemIndex]).Count - 1 do  begin
            TBookmarkRes(TList(CategoryList.Items.Objects[CategoryList.ItemIndex])[n]).Category := s;
            TBookmarkRes(TList(CategoryList.Items.Objects[CategoryList.ItemIndex])[n]).ThreadItem.SaveConfig;
          end;
          CategoryList.Items[CategoryList.ItemIndex]  :=  s;
          Break;
        end;

      end else begin
        MessageDlg('łɎgĂJeSłB', mtError, [mbOk], 0);
      end;
    end else begin
      CategoryList.Items[CategoryList.ItemIndex]  :=  o;
    end;
  end;
end;

procedure TBookmarkEditor.SaveCategoryList;
var
  sl: TStringList;
  n: integer;
begin
  sl  :=  TStringList.Create;
  sl.Assign(CategoryList.Items);
  n :=  sl.IndexOf(NO_TITLE);
  if  (n > -1)  then  begin
    sl.Delete(n);
  end;
  sl.SaveToFile(ZonuConfig.UsersPath + FILE_BOOKMARK_CATEGORY);
end;

procedure TBookmarkEditor.actCategoryDeleteExecute(Sender: TObject);
var
  BookmarkRes: TBookmarkRes;
  ThreadItem: TThreadItem;
  List: TList;
  i, x, y: integer;
begin
  for i :=  CategoryList.Count - 1  downto  0 do  begin
    if  (CategoryList.Selected[i])  and (CategoryList.Items[i] <> NO_TITLE)  then  begin
      List  :=  TList(CategoryList.Items.Objects[i]);
      for x :=  List.Count - 1  downto  0 do  begin
        BookmarkRes  :=  TBookmarkRes(List[x]);
        ThreadItem  :=  TThreadItem.Create;
        ThreadItem.Assign(BookmarkRes.ThreadItem);
        ThreadItem.LoadConfig;
        for y :=  ThreadItem.BookmarkList.Count - 1 downto  0 do  begin
          if  (ThreadItem.BookmarkList[y].ResNo = BookmarkRes.ResNo) then  begin
            ThreadItem.BookmarkList.Delete(y);
          end;
        end;
        ThreadItem.SaveConfig;
        ThreadItem.ReleaseRef;
      end;
      CategoryList.Items.Delete(i);
      List.Free;
    end;
  end;
  ListView1.Items.Clear;
end;

procedure TBookmarkEditor.actBookmarkDeleteExecute(Sender: TObject);
var
  ThreadItem: TThreadItem;
  BookmarkRes: TBookmarkRes;
  List: TList;
  y: integer;
begin
  //for i :=  ListView1.Items.Count -1 downto  0 do  begin
    BookmarkRes :=  TBookmarkRes(ListView1.Selected.Data);
    ThreadItem  :=  TThreadItem.Create;
    ThreadItem.Assign(BookmarkRes.ThreadItem);
    ThreadItem.LoadConfig;
    for y :=  ThreadItem.BookmarkList.Count - 1 downto  0 do  begin
      if  (ThreadItem.BookmarkList[y].ResNo = BookmarkRes.ResNo) then  begin
        ThreadItem.BookmarkList.Delete(y);
      end;
    end;
    List  :=  TList(CategoryList.Items.Objects[CategoryList.ItemIndex]);
    for y :=  List.Count - 1  downto  0 do  begin
      if  (List[y] = BookmarkRes) then  begin
        List.Delete(y);
      end;
    end;
    BookmarkRes.Free;
    ListView1.Selected.Delete;
    ThreadItem.SaveConfig;
    //ThreadItem.ReleaseRef;
  //end;
end;

end.

