{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Bookmark Manager Unit                                             }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Bookmk2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, EnhListView, ExtListView, Dlghead, Inifiles,
  OleCtrls,
  ZonuClass, ZonuConf, Hzbclass, Hzbfunc, Hzbconst, Main, Menus, Tabs;

type
  TBookmarkManager2 = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    ListViewThread: TdfsExtListView;
    Splitter2: TSplitter;
    HeaderFrame1: THeaderFrame;
    Splitter3: TSplitter;
    Panel2: TPanel;
    PopupMenu1: TPopupMenu;
    ResPopup: TPopupMenu;
    N1: TMenuItem;
    DeleteBookmark: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    Panel3: TPanel;
    Notebook1: TNotebook;
    ListViewBBS: TdfsExtListView;
    Splitter1: TSplitter;
    ListViewBoard: TdfsExtListView;
    ListViewCategory: TdfsExtListView;
    TabSet1: TTabSet;
    N6: TMenuItem;
    N7: TMenuItem;
    PopupMenu2: TPopupMenu;
    Refresh1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure ListViewBBSSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ListViewBoardSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ListViewThreadDrawItem(Control: TWinControl;
      var ACanvas: TCanvas; Index: Integer; ARect: TRect;
      State: TOwnerDrawState; var DefaultDrawing, FullRowSelect: Boolean);
    procedure ListViewThreadSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure DeleteBookmarkClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure TabSet1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure ListViewCategorySelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure N6Click(Sender: TObject);
    procedure Refresh1Click(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
    FList: TList;
    FBrowser: TZonuBrowser;
    FHintWindow: TZonuHintWindow;
    FSaveHeight : integer;
    procedure WebBrowserNewWindow2(Sender: TObject; var ppDisp: IDispatch;
      var Cancel: WordBool);
    procedure WebBrowserBeforeNavigate2(Sender: TObject;
      const pDisp: IDispatch; var AURL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure ClearnupList;
    procedure BuildCategoryList;
  public
    { Public 錾 }
    procedure BuildBBSList;
    procedure BuildBoardList(ASite: TSite);
    procedure BuildThreadList(ABoard: TBoard);
    procedure BuildThreadListEx(ACategory: string);
  end;

var
  BookmarkManager2: TBookmarkManager2;

implementation

{$R *.dfm}

uses
  MonaUtils, Expdlg, Bookcate;
  
{ TBookmarkManager2 }

procedure TBookmarkManager2.FormCreate(Sender: TObject);
var
  ThreadItem: TThreadItem;
  i: integer;
  s: string;
begin
  FList         :=  TList.Create;
  FHintWindow   :=  TZonuHintWindow.Create(Self);
  for i :=  0 to  HotzonuWindow.BookmarkFile.Count - 1  do  begin
    s :=  HotzonuWindow.BookmarkFile.Names[i];
    ThreadItem  :=  TThreadItem.Create;
    ThreadItem.CreateThreadItem(ChooseString(s, '/', 2),
                                ChooseString(s, '/', 1),
                                ChooseString(s, '/', 0),
                                ChooseString(HotzonuWindow.BookmarkFile[i], '=', 1));
    if  (ThreadItem.Site  <> nil)  and
        (ThreadItem.Board <> nil)  then
    begin
      if  (ThreadItem.BookmarkList.Count > 0) then  begin
        FList.Add(ThreadItem);
      end else begin
        ThreadItem.ReleaseRef;
      end;
    end else begin
      ThreadItem.ReleaseRef;
    end;
  end;
  //
  BuildBBSList;
  FSaveHeight             :=  Height;
  //
  Notebook1.ActivePage  :=  Notebook1.Pages[0];  
  BuildCategoryList;
end;

procedure TBookmarkManager2.BuildBBSList;
var
  ThreadItem: TThreadItem;
  Item: TListItem;
  i, x: integer;
  b: boolean;
begin
  ListViewBBS.Items.Clear;
  Item  :=  ListViewBBS.Items.Add;
  Item.Caption  :=  '(ׂ)';
  for i :=  0 to  FList.Count - 1  do  begin
    b :=  False;
    ThreadItem  :=  TThreadItem(FList[i]);
    for x :=  0 to  ListViewBBS.Items.Count - 1 do  begin
      if  (ListViewBBS.Items[x].Data <> nil)  then  begin
        if  (TSite(ListViewBBS.Items[x].Data) = ThreadItem.Site)  then  begin
          b :=  True;
          break;
        end;
      end;
    end;
    if  (not b) then  begin
      Item  :=  ListViewBBS.Items.Add;
      Item.Caption  :=  ThreadItem.Site.SiteName;
      Item.Data     :=  ThreadItem.Site;
    end;
  end;
  ListViewBBS.Resort;
end;

procedure TBookmarkManager2.BuildBoardList(ASite: TSite);
var
  ThreadItem: TThreadItem;
  Item: TListItem;
  i, x: integer;
  b: boolean;
begin
  ListViewBoard.Items.Clear;
  Item  :=  ListViewBoard.Items.Add;
  Item.Caption  :=  '(ׂ)';
  //
  for i :=  0 to  FList.Count - 1  do  begin
    b :=  False;
    ThreadItem  :=  TThreadItem(FList[i]);
    for x :=  0 to  ListViewBoard.Items.Count - 1 do  begin
      if  (ListViewBoard.Items[x].Data <> nil)  then  begin
        if  (TBoard(ListViewBoard.Items[x].Data) = ThreadItem.Board)  then  begin
          b :=  True;
          break;
        end;
      end;
    end;
    if  (not b) then  begin
      if  (ASite <> nil) then  begin
        if  (ASite <> ThreadItem.Site)  then  begin
          b :=  True;
        end;
      end;
      if  (not b) then  begin
        Item  :=  ListViewBoard.Items.Add;
        Item.Caption  :=  ThreadItem.Board.Name;
        Item.Data     :=  ThreadItem.Board;
      end;
    end;
  end;
  ListViewBoard.Resort;
end;

procedure TBookmarkManager2.BuildThreadList(ABoard: TBoard);
var
  ThreadItem: TThreadItem;
  Item: TListItem;
  FSite: TSite;
  i: integer;
  b: boolean;
begin
  ListViewThread.Items.Clear;
  Item  :=  ListViewThread.Items.Add;
  Item.Caption  :=  '(ׂ)';
  //
  FSite :=  TSite(ListViewBBS.Selected.Data);
  //
  for i :=  0 to  FList.Count - 1  do  begin
    b :=  False;
    ThreadItem  :=  TThreadItem(FList[i]);
    if  (ABoard <> nil) then  begin
      if  (ABoard <> ThreadItem.Board)  then  begin
        b :=  True;
      end;
    end;
    if  (FSite <> nil) then  begin
      if  (FSite  <> ThreadItem.Site)  then  begin
        b :=  True;
      end;
    end;
    if  (not b) then  begin
      Item  :=  ListViewThread.Items.Add;
      Item.Caption  :=  ThreadItem.Title;
      Item.SubItems.Add(IntToSTr(ThreadItem.BookmarkList.Count));
      Item.SubItems.Add(ThreadItem.LastLoadDate);
      Item.SubItems.Add(ThreadItem.DatNo);
      Item.SubItems.Add(ThreadItem.Board.Name);
      Item.SubItems.Add(ThreadItem.Site.SiteName);
      Item.Data     :=  ThreadItem;
    end;
  end;
  ListViewThread.Resort;
end;

procedure TBookmarkManager2.ListViewBBSSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if  (Selected)  then  begin
    BuildBoardList(TSite(Item.Data));
  end;
end;

procedure TBookmarkManager2.ListViewBoardSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if  (Selected)  then  begin
    BuildThreadList(TBoard(Item.Data));
  end;
end;

procedure TBookmarkManager2.ListViewThreadDrawItem(Control: TWinControl;
  var ACanvas: TCanvas; Index: Integer; ARect: TRect;
  State: TOwnerDrawState; var DefaultDrawing, FullRowSelect: Boolean);
begin
  if  (Odd(Index)) then  begin
    ACanvas.Brush.Color :=  ZonuConfig.ThreadListBkColor2;
  end else begin
    ACanvas.Brush.Color :=  ZonuConfig.ThreadListBkColor1;
  end;
  ACanvas.Font.Color    :=  ZonuConfig.ThreadListTextColor;
  DefaultDrawing :=  True;
  FullRowSelect :=  True;
end;

procedure TBookmarkManager2.ListViewThreadSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
  procedure OutputRes(ThreadItem: TThreadItem);
  var
    ini: TMemIniFile;
    i: integer;
    Res: TRes;
    b: boolean;
    c: string;
  begin
    FBrowser.ThreadItem         :=  ThreadItem;
    ThreadItem.AddRef;
    FBrowser.ResList.ThreadItem :=  ThreadItem;

    ini :=  TMemIniFile.Create(ChangeFileExt(ThreadItem.LocalDatFileName, '.inf'));
    for i :=  0 to  ini.ReadInteger('BOOKMARK', 'COUNT', 0) - 1 do  begin
      b :=  True;
      if  (Notebook1.ActivePage = 'Category') then  begin
        if  (ListViewCategory.Selected <> nil)  then  begin
          c :=  ListViewCategory.Selected.Caption;
          if  (c = '()') then  c  :='';
          if  (c <> ini.ReadString('BOOKMARK', 'CATEGORY' + IntToStr(i + 1), '')) then
          begin
            b :=  False;
          end;
        end;
      end;
      if  (b) then  begin
        Res :=  TRes.Create;
        Res.BBS   :=  ThreadItem.BBS;
        Res.Site  :=  ThreadItem.Site;
        Res.No    :=  ini.ReadInteger('BOOKMARK', 'RESNO' + IntToStr(i + 1), 0);
        Res.Name  :=  ini.ReadString('BOOKMARK', 'NAME' + IntToStr(i + 1), '');
        Res.Mail  :=  '';
        Res.Date  :=  ini.ReadString('BOOKMARK', 'DATE' + IntToStr(i + 1), '');
        Res.Body  :=  ini.ReadString('BOOKMARK', 'BODY' + IntToStr(i + 1), '');
        //Res.IsSiori   :=  True;
        FBrowser.ResList.Add(Res);
        FBrowser.WriteRes(Res);
      end;
    end;
    ini.Free;
  end;
var
  i: integer;
begin
  if  (Selected)  then  begin
    FBrowser.OnBeforeNavigate2  :=  nil;
    if  (FBrowser.ThreadItem <> nil)  then  begin
      FBrowser.ThreadItem.ReleaseRef;
    end;
    FBrowser.Clear;
    FBrowser.InitSkin('', 'siori_manager');
    FBrowser.InitOutputRes;

    if  (Item <> nil) then  begin
      if  (Item.Data <> nil)  then  begin
        FBrowser.ThreadItem :=  TThreadItem(Item.Data);
        FBrowser.ResList.Create(TThreadItem(Item.Data));
        FBrowser.WriteHeader;
        OutputRes(TThreadItem(Item.Data));
        FBrowser.EndOutputRes;
      end else begin
        for i :=  1 to  ListViewThread.Items.Count - 1  do  begin
          FBrowser.ThreadItem :=  TThreadItem(ListViewThread.Items[i].Data);
          FBrowser.ResList.Create(TThreadItem(ListViewThread.Items[i].Data));
          FBrowser.WriteHeader;
          OutputRes(TThreadItem(ListViewThread.Items[i].Data));
          if  (i < ListViewThread.Items.Count - 1)  then  begin
            FBrowser.WriteFooter;
          end else begin
            FBrowser.EndOutputRes;
          end;
        end;
      end;
    end;
    FBrowser.OnBeforeNavigate2  :=  WebBrowserBeforeNavigate2;
    //ListView2.Resort;
  end;
end;

procedure TBookmarkManager2.FormActivate(Sender: TObject);
begin
  FBrowser  :=  TZonuBrowser.Create(Self);
  TOleControl(FBrowser).Parent  :=  Panel2;
  FBrowser.Align    :=  alClient;
  FBrowser.ResList  :=  TResList.Create(nil);
  FBrowser.OnBeforeNavigate2       :=  WebBrowserBeforeNavigate2;
  FBrowser.OnNewWindow2            :=  WebBrowserNewWindow2;

  AlphaBlend  :=  False;
  if  (ZonuConfig.BookmarkManagerExpand) then  begin
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  end;
  Height  :=  FSaveHeight;
  SetForegroundWindow(Self.Handle);
end;

procedure TBookmarkManager2.WebBrowserBeforeNavigate2(Sender: TObject;
  const pDisp: IDispatch; var AURL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
var
  p: TPoint;
begin
  if  (AnsiPos('zonu://res/?no=', AURL) = 1) or (AnsiPos('menu:', AURL) = 1)  then  begin //age16
    Cancel  :=  True;
    if  (TZonuBrowser(Sender).ThreadItem <> nil) then  begin
      TZonuBrowser(Sender).PopupResNo :=  TZonuBrowser(Sender).StrToResNo(AURL);
      FHintWindow.ReleaseHandle; //12
      GetCursorPos(p);
      ResPopup.Popup(p.x, p.y);
    end;
    Exit;
  end;
end;

procedure TBookmarkManager2.WebBrowserNewWindow2(Sender: TObject;
  var ppDisp: IDispatch; var Cancel: WordBool);
begin
  Cancel  :=  True;
end;

procedure TBookmarkManager2.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  //
end;

procedure TBookmarkManager2.FormDestroy(Sender: TObject);
begin
  FHintWindow.Free;
end;

procedure TBookmarkManager2.DeleteBookmarkClick(Sender: TObject);
var
  x: integer;
begin
  if  (FBrowser.ThreadItem <> nil)  then  begin
    for x :=  FBrowser.ThreadItem.BookmarkList.Count - 1  downto  0  do  begin
      if  (FBrowser.ThreadItem.BookmarkList[x].ResNo = FBrowser.PopupResNo) then
      begin
        FBrowser.ThreadItem.BookmarkList.Delete(x);
        FBrowser.ThreadItem.SaveConfig;

        CleanupBookmarkFile(FBrowser.ThreadItem);
        ClearnupList;

        Break;
      end;
    end;
  end;
end;

procedure TBookmarkManager2.N1Click(Sender: TObject);
begin
  if  (ListViewThread.Selected <> nil)  then  begin
    if  (ListViewThread.Selected.Data <> nil)  then  begin
      HotzonuWindow.LoadRes(TThreadItem(ListViewThread.Selected.Data),
                            False,
                            True,
                            True,
                            True,
                            0,
                            False,
                            '');
    end;
  end;
end;

procedure TBookmarkManager2.N2Click(Sender: TObject);
begin
  if  (ListViewThread.Selected <> nil)  then  begin
    if  (ListViewThread.Selected.Data <> nil)  then  begin
      HotzonuWindow.LoadRes(TThreadItem(ListViewThread.Selected.Data),
                            False,
                            True,
                            True,
                            True,
                            FBrowser.PopupResNo,
                            False,
                            '');
    end;
  end;
end;

procedure TBookmarkManager2.N5Click(Sender: TObject);
begin
  if  (ListViewThread.Selected <> nil)  then  begin
    if  (ListViewThread.Selected.Data <> nil)  then  begin
      TThreadItem(ListViewThread.Selected.Data).BookmarkList.Clear;
      TThreadItem(ListViewThread.Selected.Data).SaveConfig;
      CleanupBookmarkFile(TThreadItem(ListViewThread.Selected.Data));
      ClearnupList;
    end;
  end;
end;

procedure TBookmarkManager2.ClearnupList;
var
  i: integer;
begin
  for i :=  FList.Count - 1 downto  0 do  begin
    if  (TThreadItem(FList[i]).BookmarkList.Count = 0)  then  begin
      TThreadItem(FList[i]).Free;
      FList.Delete(i);
    end;
  end;
end;

procedure TBookmarkManager2.TabSet1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  Notebook1.ActivePage  :=  Notebook1.Pages[NewTab];
end;

procedure TBookmarkManager2.BuildCategoryList;
var
  Item: TListItem;
  sl: TStringList;
  n: integer;
begin
  ListViewCategory.Items.Clear;
  Item  :=  ListViewCategory.Items.Add;
  Item.Caption  :=  '()';
  if  (FileExists(ZonuConfig.UsersPath + FILE_BOOKMARK_CATEGORY)) then  begin
    sl  :=  TStringList.Create;
    sl.LoadFromFile(ZonuConfig.UsersPath + FILE_BOOKMARK_CATEGORY);
    for n :=  0 to  sl.Count - 1  do  begin
      Item  :=  ListViewCategory.Items.Add;
      Item.Caption  :=  sl[n];
    end;
    sl.Free;
  end;
end;

procedure TBookmarkManager2.ListViewCategorySelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if  (Selected)  then  begin
    BuildThreadListEx(Item.Caption);
  end;
end;

procedure TBookmarkManager2.BuildThreadListEx(ACategory: string);
var
  ThreadItem: TThreadItem;
  Item: TListItem;
  i, n: integer;
  b: boolean;
  c: string;
begin
  ListViewThread.Items.Clear;
  Item  :=  ListViewThread.Items.Add;
  Item.Caption  :=  '(ׂ)';
  //
  c :=  ACategory;
  if  (c = '()') then c := '';
  for i :=  0 to  FList.Count - 1  do  begin
    b :=  False;
    ThreadItem  :=  TThreadItem(FList[i]);
    for n :=  0 to  ThreadItem.BookmarkList.Count - 1 do  begin
      if  (ThreadItem.BookmarkList[n].Category = c) then  begin
        b :=  True;
        Break;
      end;
    end;
    if  (b) then  begin
      Item  :=  ListViewThread.Items.Add;
      Item.Caption  :=  ThreadItem.Title;
      Item.SubItems.Add(IntToStr(ThreadItem.BookmarkList.Count));
      Item.SubItems.Add(ThreadItem.LastLoadDate);
      Item.SubItems.Add(ThreadItem.DatNo);
      Item.SubItems.Add(ThreadItem.Board.Name);
      Item.SubItems.Add(ThreadItem.Site.SiteName);
      Item.Data     :=  ThreadItem;
    end;
  end;
  ListViewThread.Resort;
end;



procedure TBookmarkManager2.N6Click(Sender: TObject);
var
  bk: TBookmarkRes;
begin
  bk  :=  FBrowser.ThreadItem.BookmarkList.FindRes(FBrowser.PopupResNo);
  if  (bk <> nil) then  begin
    BookmarkCategoryDialog  :=  TBookmarkCategoryDialog.Create(Self);
    BookmarkCategoryDialog.Edit1.Text :=  bk.Category;
    if  (BookmarkCategoryDialog.ShowModal = mrOk) then  begin
      bk.Category :=  BookmarkCategoryDialog.SelectedCategory;
      FBrowser.ThreadItem.SaveConfig;
    end;
    BookmarkCategoryDialog.Release;
  end;
end;

procedure TBookmarkManager2.Refresh1Click(Sender: TObject);
begin
  //
  ListViewThread.Items.Clear;
  BuildCategoryList;
end;

procedure TBookmarkManager2.FormHide(Sender: TObject);
begin
  //ListView1.OnChange  :=  nil;
  ZonuConfig.BookmarkManagerWindowState :=  WindowState;
  if  (WindowState = wsNormal)  then  begin
    ZonuConfig.BookmarkManagerPosLeft   :=  Left;
    ZonuConfig.BookmarkManagerPosTop    :=  Top;
    ZonuConfig.BookmarkManagerWidth     :=  Width;
    ZonuConfig.BookmarkManagerHeight    :=  Height;
  end;
  //ZonuConfig.BookmarkManagerPaneWidth   :=  Panel1.Width;
  //ZonuConfig.BookmarkManagerPaneHeight  :=  ListView1.Height;
end;

procedure TBookmarkManager2.FormDeactivate(Sender: TObject);
begin
  if  (ZonuConfig.BookmarkManagerTrans)  then
  begin
    AlphaBlend  :=  True;
    AlphaBlendValue :=  128;
  end;
  FSaveHeight :=  Height;
  if  (ZonuConfig.BookmarkManagerExpand) then  begin
    Height      :=  0;
  end;
end;

procedure TBookmarkManager2.FormShow(Sender: TObject);
begin
  WindowState :=  ZonuConfig.BookmarkManagerWindowState;
  if  (WindowState = wsNormal)  then  begin
    Self.SetBounds( ZonuConfig.BookmarkManagerPosLeft,
                    ZonuConfig.BookmarkManagerPosTop,
                    ZonuConfig.BookmarkManagerWidth,
                    ZonuConfig.BookmarkManagerHeight);
  end;
end;

end.
