{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Memo Window Unit                                                  }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Comntdlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, ZonuClass, Dlghead;

type
  TSaveCommentEvt =  procedure (Sender: TObject; ThreadItem: TThreadItem) of object;
  TCommentDialog = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Panel2: TPanel;
    Memo1: TMemo;
    HeaderFrame1: THeaderFrame;
    procedure FormActivate(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    FThreadItem: TThreadItem;
    FSaveComment: TSaveCommentEvt;
    procedure SetThreadItem(const Value: TThreadItem);
  public
    { Public 錾 }
    property  ThreadItem: TThreadItem   read  FThreadItem write SetThreadItem;
    property  OnSaveComment: TSaveCommentEvt  read  FSaveComment write FSaveComment;
  end;

var
  CommentDialog: TCommentDialog;

implementation

{$R *.DFM}

uses
  ZonuConf, Hzbfunc;

procedure TCommentDialog.FormActivate(Sender: TObject);
begin
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  Memo1.SetFocus;
end;

procedure TCommentDialog.FormHide(Sender: TObject);
begin
  ZonuConfig.CommentPosTop     :=  Top;
  ZonuConfig.CommentPosLeft    :=  Left;
  ZonuConfig.CommentWidth      :=  Width;
  ZonuConfig.CommentHeight     :=  Height;
end;

procedure TCommentDialog.FormShow(Sender: TObject);
begin
  SetBounds(
    ZonuConfig.CommentPosLeft,
    ZonuConfig.CommentPosTop,
    ZonuConfig.CommentWidth,
    ZonuConfig.CommentHeight);
end;

procedure TCommentDialog.SetThreadItem(const Value: TThreadItem);
begin
  Caption         :=  '̕ҏWF' + Value.Title;
  FThreadItem     :=  Value;
  FThreadItem.AddRef;
  Memo1.Lines.Text := FThreadItem.Memo;
end;

procedure TCommentDialog.FormCreate(Sender: TObject);
begin
  //
end;

procedure TCommentDialog.BitBtn1Click(Sender: TObject);
begin
  FThreadItem.Memo  :=  Memo1.Lines.Text;
  FThreadItem.SaveConfig;
  if  (Assigned(FSaveComment))  then begin
    FSaveComment(Self, FThreadItem);
  end;
  Close;
end;

procedure TCommentDialog.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TCommentDialog.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  //DeleteWindowList(Self);
end;

procedure TCommentDialog.FormDestroy(Sender: TObject);
begin
  FThreadItem.ReleaseRef;
end;

end.
