{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Filter Dialog Unit                                                }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Filterdlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ZonuClass, Dlghead;

type
  TFilterDialog = class(TForm)
    Button1: TButton;
    Button2: TButton;
    PageControl1: TPageControl;
    tabRes: TTabSheet;
    Label1: TLabel;
    Bevel1: TBevel;
    RadioButton1: TRadioButton;
    HandleName: TComboBox;
    ID: TComboBox;
    ComboBox2: TComboBox;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Body: TComboBox;
    tabThread: TTabSheet;
    RadioButton6: TRadioButton;
    ComboBox5: TComboBox;
    RadioButton4: TRadioButton;
    ComboBox1: TComboBox;
    Label2: TLabel;
    Bevel2: TBevel;
    RadioButton5: TRadioButton;
    Mail: TComboBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    HeaderFrame1: THeaderFrame;
    RadioButton7: TRadioButton;
    ComboBox3: TComboBox;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure HandleNameChange(Sender: TObject);
    procedure IDChange(Sender: TObject);
    procedure BodyChange(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MailChange(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    FResList : TResList;
    FThreadItemList : TThreadItemList;
    function GetIgnoreCase: boolean;
  public
    { Public 錾 }
    procedure  SetResList(ResList: TResList);
    procedure  SetThreadItemList(ThreadItemList: TThreadItemList);
    //function  GetFilter: string;
  public
    { Public 錾 }
    property IgnoreCase: boolean  read  GetIgnoreCase;
  end;

var
  FilterDialog: TFilterDialog;

implementation

{$R *.dfm}

uses
  ZonuConf, Hzbconst, Zonutils, MonaUtils;

procedure TFilterDialog.FormCreate(Sender: TObject);
begin
  ComboBox2.ItemIndex   :=  ZonuConfig.ResFilterHandleIndex;
  RadioButton7.Checked  :=  ZonuConfig.ResFilterAllChecked;
  RadioButton1.Checked  :=  ZonuConfig.ResFilterHandleChecked;
  RadioButton2.Checked  :=  ZonuConfig.ResFilterIDChecked;
  RadioButton3.Checked  :=  ZonuConfig.ResFilterBodyChecked;
  if  (FileExists(ZonuConfig.UsersPath + FILE_FIND_LOG))  then  begin
    Body.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_FIND_LOG);
    ComboBox3.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_FIND_LOG);
  end;
  //7 begin
  CheckBox3.Checked :=  ZonuConfig.FilterIgnoreCase; //悭lIgnoreCase
  CheckBox4.Checked :=  ZonuConfig.FilterIgnoreCase; //啶ȁA
  //7 end
  //13 begin
  ComboBox3.AutoComplete  :=  ZonuConfig.FilterAutoComplete;
  HandleName.AutoComplete :=  ZonuConfig.FilterAutoComplete;
  Mail.AutoComplete       :=  ZonuConfig.FilterAutoComplete;
  ID.AutoComplete         :=  ZonuConfig.FilterAutoComplete;
  Body.AutoComplete       :=  ZonuConfig.FilterAutoComplete;
  ComboBox5.AutoComplete  :=  ZonuConfig.FilterAutoComplete;
  ComboBox1.AutoComplete  :=  ZonuConfig.FilterAutoComplete;
  //13 end
end;

procedure TFilterDialog.SetThreadItemList(ThreadItemList: TThreadItemList);
var
  i : integer;
  s : string;
begin
  for i :=  0 to  ThreadItemList.Count - 1  do  begin
    s :=  Trim(ThreadItemList[i].DatNo);
    if  (s <> '') then  begin
      if  (ComboBox1.Items.IndexOf(s) < 0) then  begin
        ComboBox1.Items.Add(s);
      end;
    end;
  end;

  if  (FileExists(ZonuConfig.UsersPath + FILE_FIND_LOG))  then  begin
    ComboBox5.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_FIND_LOG);
  end;

  ComboBox1.Sorted  :=  True; //DATNO
  FThreadItemList   :=  ThreadItemList;
  PageControl1.ActivePage :=  tabThread;
end;

procedure TFilterDialog.SetResList(ResList: TResList);
var
  i : integer;
  s : string;
begin
  if  (ResList <> nil)  then  begin
    for i :=  0 to  ResList.Count - 1 do  begin
      s :=  Trim(ResList[i].Name);
      if  (s <> '') then  begin
        s :=  TrimTag(s);
        if  (HandleName.Items.IndexOf(s) < 0) then  begin
          HandleName.Items.Add(s);
        end;
      end;
      s :=  Trim(ResList[i].Mail);
      if  (s <> '') then  begin
        if  (Mail.Items.IndexOf(s) < 0) then  begin
          Mail.Items.Add(s);
        end;
      end;
      s :=  Trim(ResList[i].ID);
      if  (s <> '') then  begin
        if  (ID.Items.IndexOf(s) < 0) then  begin
          ID.Items.Add(s);
        end;
      end;
    end;
    HandleName.Sorted :=  True;
  end;
  FResList  :=  ResList;
  PageControl1.ActivePage :=  tabRes;
end;

procedure TFilterDialog.Button1Click(Sender: TObject);
var
  s:  string;
  ComboBox: TComboBox; //8
begin
  if  (PageControl1.ActivePage = tabRes)  then  begin
    ZonuConfig.ResFilterHandleIndex     :=  ComboBox2.ItemIndex;
    ZonuConfig.ResFilterAllChecked      :=  RadioButton7.Checked;
    ZonuConfig.ResFilterHandleChecked   :=  RadioButton1.Checked;
    ZonuConfig.ResFilterIDChecked       :=  RadioButton2.Checked;
    ZonuConfig.ResFilterBodyChecked     :=  RadioButton3.Checked;
    if  (RadioButton3.Checked)  and (Trim(Body.Text) <> '') then begin
      ComboBox  :=  Body; //8
      s         :=  ComboBox.Text; //8
      if  (Body.Items.IndexOf(Body.Text) < 0) then  begin
        Body.Items.Insert(0, Body.Text);
      end else begin
        Body.Items.Move(Body.Items.IndexOf(Body.Text) ,0);
      end;
      Body.Items.SaveToFile(ZonuConfig.UsersPath + FILE_FIND_LOG);
      ComboBox.Text :=  s;  //8
    end;
    if  (RadioButton7.Checked)  and (Trim(ComboBox3.Text) <> '') then begin
      ComboBox  :=  ComboBox3;      //8
      s         :=  ComboBox.Text;  //8
      if  (ComboBox3.Items.IndexOf(ComboBox3.Text) < 0) then  begin
        s :=  ComboBox3.Text;
        ComboBox3.Items.Insert(0, ComboBox3.Text);
        ComboBox3.Text  :=  s;
      end else begin
        s :=  ComboBox3.Text;
        ComboBox3.Items.Move(ComboBox3.Items.IndexOf(ComboBox3.Text) ,0);
        ComboBox3.Text  :=  s;
      end;
      ComboBox3.Items.SaveToFile(ZonuConfig.UsersPath + FILE_FIND_LOG);
      ComboBox.Text :=  s;  //8
    end;
  end else begin
    if  (RadioButton6.Checked)  then  begin
      ComboBox  :=  ComboBox5;      //8
      s         :=  ComboBox.Text;  //8
      if  (s <> '') then  begin
        if  (ComboBox5.Items.IndexOf(s) < 0) then  begin
          ComboBox5.Items.Insert(0, s);
          ComboBox5.Text  :=  s;
        end else begin
          ComboBox5.Items.Move(ComboBox5.Items.IndexOf(s), 0);
          ComboBox5.Text  :=  s;
        end;
        ComboBox5.Items.SaveToFile(ZonuConfig.UsersPath + FILE_FIND_LOG);
      end;
      ComboBox.Text :=  s;  //8
    end;
  end;
  //7 begin
  if  (PageControl1.ActivePage = tabRes)  then  begin
    ZonuConfig.FilterIgnoreCase :=  CheckBox3.Checked;
  end else begin
    ZonuConfig.FilterIgnoreCase :=  CheckBox4.Checked;
  end;
  //7 end
  ModalResult :=  mrOk;
end;

procedure TFilterDialog.Button2Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

{
function TFilterDialog.GetFilter: string;
var
  r : string;
begin
  r :=  '';
  if  (RadioButton1.Checked)  then  begin
    if  (ComboBox2.ItemIndex = 0) then  begin
      r :=  'HANDLE=' + HandleName.Text;
    end else begin
      r :=  'HANDLE_LIKE=' + HandleName.Text;
    end;
  end else
  if  (RadioButton2.Checked)  then  begin
    r :=  'ID=' + ID.Text;
  end else
  if  (RadioButton3.Checked)  then  begin
    r :=  'BODY=' + Body.Text;
  end;
  Result  :=  r;
end;
}

procedure TFilterDialog.HandleNameChange(Sender: TObject);
begin
  RadioButton1.Checked  :=  True;
end;

procedure TFilterDialog.IDChange(Sender: TObject);
begin
  RadioButton2.Checked  :=  True;
end;

procedure TFilterDialog.BodyChange(Sender: TObject);
begin
  RadioButton3.Checked  :=  True;
end;

procedure TFilterDialog.ComboBox5Change(Sender: TObject);
begin
  RadioButton6.Checked  :=  True;
end;

procedure TFilterDialog.ComboBox1Change(Sender: TObject);
begin
  RadioButton4.Checked  :=  True;
end;

procedure TFilterDialog.FormShow(Sender: TObject);
begin
  if  (PageControl1.ActivePage = tabThread)  then  begin
    ComboBox5.SetFocus;
  end else
  if  (PageControl1.ActivePage = tabRes)  then  begin
    ComboBox3.SetFocus;
  end;
end;

procedure TFilterDialog.MailChange(Sender: TObject);
begin
  RadioButton5.Checked  :=  True;
end;

procedure TFilterDialog.ComboBox3Change(Sender: TObject);
begin
  RadioButton7.Checked  :=  True;
end;

procedure TFilterDialog.FormActivate(Sender: TObject);
begin
  if  (PageControl1.ActivePage  =  tabRes)  then  begin
    if  (RadioButton7.Checked)  then  begin
      ComboBox3.SetFocus;
    end else
    if  (RadioButton1.Checked)  then  begin
      HandleName.SetFocus;
    end else
    if  (RadioButton5.Checked)  then  begin
      Mail.SetFocus;
    end else
    if  (RadioButton2.Checked)  then  begin
      ID.SetFocus;
    end else
    if  (RadioButton3.Checked)  then  begin
      Body.SetFocus;
    end;
    
  end else begin
    if  (RadioButton6.Checked)  then  begin
      ComboBox5.SetFocus;
    end else
    if  (RadioButton4.Checked)  then  begin
      ComboBox1.SetFocus;
    end;
  end;
end;

//7
function TFilterDialog.GetIgnoreCase: boolean;
begin
  if  (PageControl1.ActivePage = tabRes)  then  begin
    Result  :=  CheckBox3.Checked;
  end else begin
    Result  :=  CheckBox4.Checked;
  end;
end;

end.
