{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Find Dialog Unit                                                  }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Finddlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Main, Menus, Buttons,
  ZonuClass, ZonuConf, Hzbconst, Hzbclass, Hzbfunc, Dlghead, EnhListView,
  ExtListView;

type
  TFindWindow = class(TForm)
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    PopupMenu1: TPopupMenu;
    SelectAll1: TMenuItem;
    Label2: TLabel;
    Label3: TLabel;
    RadioGroup1: TRadioGroup;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    X1: TMenuItem;
    N3: TMenuItem;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Label4: TLabel;
    StaticText1: TStaticText;
    HeaderFrame1: THeaderFrame;
    ListView1: TdfsExtListView;
    procedure N1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FCurrentBoard: TBoard;
    procedure SetCurrentBoard(const Value: TBoard);
    { Private 錾 }
  public
    { Public 錾 }
    procedure Rebuild;
    procedure CheckCurrentBoard;
    property  CurrentBoard: TBoard  read  FCurrentBoard write SetCurrentBoard;
  end;

var
  FindWindow: TFindWindow;

implementation

{$R *.DFM}

uses
  MonaUtils;

{ TFindWindow2 }

procedure TFindWindow.Rebuild;
  procedure _Rebuild(const SiteName: string; BoardList: TBoardList);
  var
    Item  : TListItem;
    i : integer;
  begin
    for i :=  0 to  BoardList.Count - 1 do  begin
      if  (DirectoryExists(BoardList[i].CachePath)) then  begin
        Item  :=  ListView1.Items.Add;
        Item.Caption    :=  BoardList[i].Name;
        Item.SubItems.Add(BoardList[i].CategoryName);
        Item.SubItems.Add(SiteName);
        Item.Data       :=  BoardList[i];
        Item.Checked    :=  False;
        Item.ImageIndex :=  BoardList.Site.ImageIndex;
      end;
    end;
  end;
var
  i : integer;
begin
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  for i :=  0 to  ZonuEnviron.SiteList.Count - 1 do  begin
    if  (ZonuEnviron.SiteList[i].IsSubscription) and
        (ZonuEnviron.SiteList[i] <> ZonuEnviron.FavoritesSite)  then
    begin
      _Rebuild(ZonuEnviron.SiteList[i].SiteName, ZonuEnviron.SiteList[i].BoardList);
    end;
  end;
  ListView1.Items.EndUpdate;
  ListView1.AutoResort  :=  True;
end;

procedure TFindWindow.N1Click(Sender: TObject);
var
  i : integer;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    if  (Sender = SelectAll1) then  begin
      ListView1.Items[i].Checked  :=  True;
    end else
    if  (Sender = X1) then  begin
      ListView1.Items[i].Checked  :=  False;
    end;
  end;
end;

procedure TFindWindow.RadioGroup1Click(Sender: TObject);
begin
  ListView1.Enabled :=  (RadioGroup1.ItemIndex = 1);
  if  (RadioGroup1.ItemIndex = 0) then  begin
    CheckCurrentBoard;
  end;
end;

procedure TFindWindow.FormCreate(Sender: TObject);
begin
  if  (FileExists(ZonuConfig.UsersPath + FILE_FINDTEXT_LOG))  then  begin
    ComboBox1.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_FINDTEXT_LOG);
  end;
  if  (FileExists(ZonuConfig.UsersPath + FILE_FIND_LOG))  then  begin
    ComboBox2.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_FIND_LOG);
  end;
  //13 begin
  ComboBox1.AutoComplete  :=  ZonuConfig.FindDialogAutoComplete;
  ComboBox2.AutoComplete  :=  ZonuConfig.FindDialogAutoComplete;
  //13 end
end;

procedure TFindWindow.BitBtn1Click(Sender: TObject);
var
  s : string;
begin
  s :=  ComboBox1.Text;
  if  (s <> '') then  begin
    if  (ComboBox1.Items.IndexOf(s) < 0) then  begin
      ComboBox1.Items.Insert(0, s);
    end else begin
      ComboBox1.Items.Move(ComboBox1.Items.IndexOf(s), 0);
    end;
    ComboBox1.Items.SaveToFile(ZonuConfig.UsersPath + FILE_FINDTEXT_LOG);
    ComboBox1.Text  :=  s;
  end;
  //
  s :=  ComboBox2.Text;
  if  (s <> '') then  begin
    if  (ComboBox2.Items.IndexOf(s) < 0) then  begin
      ComboBox2.Items.Insert(0, s);
    end else begin
      ComboBox2.Items.Move(ComboBox2.Items.IndexOf(s), 0);
    end;
    ComboBox2.Items.SaveToFile(ZonuConfig.UsersPath + FILE_FIND_LOG);
    ComboBox2.Text  :=  s;
  end;
  //
  ModalResult     :=  mrOk;
end;

procedure TFindWindow.SetCurrentBoard(const Value: TBoard);
begin
  FCurrentBoard := Value;
  if  (Value <> nil)  then  begin
    RadioGroup1.ItemIndex :=  0;
    CheckBox1.Checked :=  True;
    CheckCurrentBoard;
    StaticText1.Caption :=  'u' + Value.Name + 'v';
  end else begin
    RadioGroup1.ItemIndex :=  1;
    CheckBox1.Checked :=  False;
    StaticText1.Caption :=  '(IĂ܂)';
  end;
end;

procedure TFindWindow.CheckCurrentBoard;
var
  i : integer;
begin
  if  (CurrentBoard <> nil)  then  begin
    for i :=  0 to  ListView1.Items.Count - 1 do  begin
      ListView1.Items[i].Checked  :=  (TBoard(ListView1.Items[i].Data).BoardID = CurrentBoard.BoardID);
    end;
  end;
end;

procedure TFindWindow.FormDestroy(Sender: TObject);
begin
  //
end;

end.
