{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 KeyBind Dialog Unit                                               }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Keybind;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ActnList, Menus, Main, SendForm, ExtCtrls,
  EnhListView, ExtListView, Dlghead;

type
  PKeyBind  = ^TKeyBind;
  TKeyBind  = record
    Form      : TForm;
    Action    : TAction;
    ShortCut  : TShortCut;
  end;

  TKeyBindDialog = class(TForm)
    HotKey1: THotKey;
    BitBtn3: TBitBtn;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Bevel1: TBevel;
    ListView1: TdfsExtListView;
    HeaderFrame1: THeaderFrame;
    procedure ListView1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure ListView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  KeyBindDialog: TKeyBindDialog;

implementation

{$R *.DFM}

uses
  ZonuConf;

var
  FSendDialog: TSendDialog;

procedure TKeyBindDialog.ListView1Click(Sender: TObject);
begin
  if  (ListView1.Selected <> nil) then  begin
    HotKey1.HotKey  :=  PKeyBind(ListView1.Selected.Data).ShortCut;
  end;
end;

procedure TKeyBindDialog.BitBtn3Click(Sender: TObject);
var
  i : integer;
begin
  if  (ListView1.Selected <> nil) then  begin
    PKeyBind(ListView1.Selected.Data).ShortCut  :=  HotKey1.HotKey;
    ListView1.Selected.SubItems[0]  :=  ShortCutToText(HotKey1.HotKey);

    for i :=  0 to  ListView1.Items.Count - 1 do  begin
      if  (ListView1.Items[i].SubItems.Count > 0) then  begin
        ListView1.Items[i].SubItemImages[0] :=  -1;
      end;
    end;

    if  (PKeyBind(ListView1.Selected.Data).ShortCut <> 0) then  begin
      for i :=  0 to  ListView1.Items.Count - 1 do  begin
        if  (ListView1.Items[i] <>  ListView1.Selected) then  begin
          if  (PKeyBind(ListView1.Items[i].Data).ShortCut = PKeyBind(ListView1.Selected.Data).ShortCut) then
          begin
            Beep;
            ListView1.Items[i].SubItemImages[0] :=  37;
            ListView1.Selected.SubItemImages[0] :=  37;
          end;
        end;
      end;
    end;
  end;
end;

procedure TKeyBindDialog.ListView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  HotKey1.SetFocus;
end;

procedure TKeyBindDialog.FormCreate(Sender: TObject);
var
  NewItem   : TListItem;
  AKeyBind  : PKeyBind;
  procedure SetKeyBind(Form: TForm; ActionList1: TActionList);
  var
    i : integer;
  begin
    for i :=  0 to  ActionList1.ActionCount - 1  do  begin
      NewItem   :=  ListView1.Items.Add;
      NewItem.Caption :=  '(' + ActionList1.Actions[i].Category + ') ' +
                          TAction(ActionList1.Actions[i]).Caption;
      NewItem.SubItems.Add(ShortCutToText(TAction(ActionList1.Actions[i]).ShortCut));
      if  (Form = HotzonuWindow)  then  begin
        NewItem.ImageIndex  :=  TAction(ActionList1.Actions[i]).ImageIndex;
      end else begin
        NewItem.ImageIndex  :=  -1;
      end;
      New(AKeyBind);
      AKeyBind.Form       :=  Form;
      AKeyBind.Action     :=  TAction(ActionList1.Actions[i]);
      AKeyBind.ShortCut   :=  TAction(ActionList1.Actions[i]).ShortCut;
      NewItem.Data        :=  AKeyBind;
    end;
  end;
begin
  FSendDialog := TSendDialog.Create(Self);
  FSendDialog.OnActivate  :=  nil;
  SetKeyBind(HotzonuWindow, HotzonuWindow.ActionList1);
  SetKeyBind(FSendDialog,   FSendDialog.ActionList1);
  ListView1.Resort;
end;

procedure TKeyBindDialog.FormDestroy(Sender: TObject);
var
  i : integer;
  AKeyBind : PKeyBind;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    AKeyBind  :=  PKeyBind(ListView1.Items[i].Data);
    Dispose(AKeyBind);
  end;
  FSendDialog.Release;
end;

procedure TKeyBindDialog.ListView1Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  if  (Item <> nil) then  begin
    if  (Item.Data <> nil)  then  begin
      HotKey1.HotKey  :=  PKeyBind(Item.Data).ShortCut;
    end;
  end;
end;

procedure TKeyBindDialog.BitBtn1Click(Sender: TObject);
var
  AKeyBind: PKeyBind;
  s : string;
  i : integer;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    AKeyBind  :=  PKeyBind(ListView1.Items[i].Data);
    if  (AKeyBind.Form = HotzonuWindow) then  begin
      s :=  '';
    end else begin
      s :=  '_' + AKeyBind.Form.Name;
    end;
    ZonuConfig.Fini.WriteString(
      'SHORTCUT' + s,
      AKeyBind.Action.Name,
      ShortCutToText(PKeyBind(ListView1.Items[i].Data).ShortCut));
  end;

  ModalResult :=  mrOk;
end;

end.
