{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Shortcut Editor Unit                                              }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Shrtcut;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Menus, ExtCtrls, ToolWin, ActnList, ZonuClass,
  ExtDlgs, ImgList, Dlghead;

type
  TShortcutEditor = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Panel2: TPanel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Panel3: TPanel;
    Splitter1: TSplitter;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Edit1: TMenuItem;
    Label1: TLabel;
    HeaderControl1: THeaderControl;
    ActionList1: TActionList;
    actNewTab: TAction;
    actRenameTab: TAction;
    actDeleteTab: TAction;
    N1: TMenuItem;
    PopupMenu1: TPopupMenu;
    N2: TMenuItem;
    R1: TMenuItem;
    N3: TMenuItem;
    actChangeTabColor: TAction;
    ColorDialog1: TColorDialog;
    C1: TMenuItem;
    actTabImage: TAction;
    OpenPictureDialog1: TOpenPictureDialog;
    I1: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    C2: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    PopupMenu2: TPopupMenu;
    actRenameShortcut: TAction;
    R2: TMenuItem;
    actDeleteShortcut: TAction;
    D1: TMenuItem;
    R3: TMenuItem;
    D2: TMenuItem;
    actSave: TAction;
    Save1: TMenuItem;
    SaveDialog1: TSaveDialog;
    actSaveAs: TAction;
    A1: TMenuItem;
    actOpen: TAction;
    OpenDialog1: TOpenDialog;
    N8: TMenuItem;
    O1: TMenuItem;
    actAddSeparator: TAction;
    N9: TMenuItem;
    P1: TMenuItem;
    P2: TMenuItem;
    ImageList1: TImageList;
    N10: TMenuItem;
    actProperty: TAction;
    Property1: TMenuItem;
    HeaderFrame1: THeaderFrame;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      ARect: TRect; State: TOwnerDrawState);
    procedure ListBox2DrawItem(Control: TWinControl; Index: Integer;
      ARect: TRect; State: TOwnerDrawState);
    procedure HeaderControl1SectionResize(HeaderControl: THeaderControl;
      Section: THeaderSection);
    procedure actNewTabExecute(Sender: TObject);
    procedure actRenameTabExecute(Sender: TObject);
    procedure actDeleteTabExecute(Sender: TObject);
    procedure actChangeTabColorExecute(Sender: TObject);
    procedure actTabImageExecute(Sender: TObject);
    procedure ListBox1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ListBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure actRenameShortcutExecute(Sender: TObject);
    procedure actDeleteShortcutExecute(Sender: TObject);
    procedure ListBox2DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ListBox2DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure actSaveExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure actSaveAsExecute(Sender: TObject);
    procedure actOpenExecute(Sender: TObject);
    procedure actAddSeparatorExecute(Sender: TObject);
    procedure ListBox2DblClick(Sender: TObject);
    procedure actPropertyExecute(Sender: TObject);
  private
    { Private 錾 }
    FChanged :  boolean;
    FModified:  boolean;
    procedure ReleaseShortcuts;
  public
    { Public 錾 }
    procedure LoadFromFile(FileName: string = '');
    procedure SaveToFile(FileName: string = '');
    property  ShortcutChanged: boolean  read  FChanged;
  end;

var
  ShortcutEditor: TShortcutEditor;

implementation

{$R *.dfm}

uses
  Hzbclass, Hzbfunc, Hzbconst, ZonuConf, MonaUtils, Zonutils, ZonuShortcutBar,
  Propdlg;

{ TShortcutEditor }

procedure TShortcutEditor.FormCreate(Sender: TObject);
begin
  FChanged  :=  False;
  FModified :=  False;
end;

procedure TShortcutEditor.FormDestroy(Sender: TObject);
begin
  ReleaseShortcuts;
end;

procedure TShortcutEditor.ReleaseShortcuts;
begin
  ReleaseShortcutList(ListBox1);
end;

procedure TShortcutEditor.LoadFromFile(FileName: string = '');
begin
  BuildShortcutList(ListBox1, FileName);
end;


procedure TShortcutEditor.ListBox1Click(Sender: TObject);
var
  TabData : TTabData;
  i : integer;
begin
  ListBox2.Items.Clear;
  TabData :=  TTabData(ListBox1.Items.Objects[ListBox1.ItemIndex]);
  for i :=  0 to  TabData.ShortcutCount - 1 do  begin
    ListBox2.Items.Objects[ListBox2.Items.Add(TabData.Shortcuts[i].Title)] := TabData.Shortcuts[i];
  end;
end;

procedure TShortcutEditor.ListBox1DrawItem(Control: TWinControl;
  Index: Integer; ARect: TRect; State: TOwnerDrawState);
begin
  DrawTabDataListBox(ListBox1, Index, ARect, State);
end;

procedure TShortcutEditor.ListBox2DrawItem(Control: TWinControl;
  Index: Integer; ARect: TRect; State: TOwnerDrawState);
  function GetRect(R: TRect; H: THeaderSection): TRect;
  begin
    Result  :=  Rect(R.Left + H.Left,
                     R.Top,
                     R.Left + H.Left + H.Width - 2,
                     R.Bottom);
  end;
var
  ShortcutData : TShortcutData;
  R: TRect;
  S: string;
  a: integer;
begin
  ShortcutData  :=  TShortcutData(TListBox(Control).Items.Objects[Index]);
  if  (ShortcutData = nil) and (Index = TListBox(Control).Items.Count - 1) then begin
    Exit;
  end else begin
    with  TListBox(Control).Canvas do  begin
      FillRect(ARect);
      a :=  (ARect.Bottom - ARect.Top - Abs(TextHeight(TListBox(Control).Items[Index]))) div 2;

      if  (odSelected in State) then  begin
        Font.Color  :=  clHighlightText;
      end else begin
        Font.Color  :=  clWindowText;
      end;

      if  (ShortcutData.ObjectType = otSeparator) then  begin
        MoveTo(ARect.Left  + 8, ARect.Top + (ARect.Bottom - ARect.Top) div 2);
        LineTo(ARect.Right - 16,ARect.Top + (ARect.Bottom - ARect.Top) div 2);
      end else begin
        S :=  ShortcutData.Title;
        R :=  GetRect(ARect, HeaderControl1.Sections[0]);
        TextRect(R, R.Left + 2, R.Top + a, S);

        case  ShortcutData.ObjectType of
          otBoard       : S :=  '';
          otThread      : S :=  'Xbh';
          otApplication : S :=  'Av';
          otWebPage     : S :=  'TCg';
          otCategory    : S :=  'JeS[';
        end;
        R :=  GetRect(ARect, HeaderControl1.Sections[1]);
        TextRect(R, R.Left + 2, R.Top + a, S);

        S :=  ShortcutData.Param1;
        R :=  GetRect(ARect, HeaderControl1.Sections[2]);
        TextRect(R, R.Left + 2, R.Top + a, S);

        S :=  ShortcutData.Param2;
        R :=  GetRect(ARect, HeaderControl1.Sections[3]);
        TextRect(R, R.Left + 2, R.Top + a, S);

        S :=  ShortcutData.Param3;
        R :=  GetRect(ARect, HeaderControl1.Sections[4]);
        TextRect(R, R.Left + 2, R.Top + a, S);

        {
        if  (ShortcutData.Board <> nil)  then  begin
          S :=  ShortcutData.Board.Name;
        end else begin
          S :=  '?' + ShortcutData.BoardID;
          Font.Color  :=  clRed;
        end;
        R :=  GetRect(ARect, HeaderControl1.Sections[1]);
        TextRect(R, R.Left + 2, R.Top + a, S);

        if  (ShortcutData.Site <> nil)  then  begin
          S :=  ShortcutData.Site.SiteName;
        end else begin
          S :=  '?' + ShortcutData.SiteID;
          Font.Color  :=  clRed;
        end;
        R :=  GetRect(ARect, HeaderControl1.Sections[2]);
        TextRect(R, R.Left + 2, R.Top + a, S);

        if  (ShortcutData.Board <> nil)  then  begin
          S :=  ShortcutData.Board.Url;
        end else begin
          S :=  '?';
        end;
        R :=  GetRect(ARect, HeaderControl1.Sections[3]);
        TextRect(R, R.Left + 2, R.Top + a, S);
        }
      end;
    end;
  end;
end;

procedure TShortcutEditor.HeaderControl1SectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
begin
  ListBox2.Invalidate;
end;

procedure TShortcutEditor.actNewTabExecute(Sender: TObject);
var
  TabData : TTabData;
  n : integer;
  s : string;
begin
  s :=  'VK^u';
  while true  do  begin
    if  (InputQuery('VK^u', '^u̖O', s)) then  begin
      if  (ListBox1.Items.IndexOf(s) > -1)  then  begin
        MessageDlg('ɂ̖Õ^u݂܂B', mtError, [mbOk], 0);
      end else
      if  (s = '')  then  begin
        MessageDlg('O͂ĂB', mtError, [mbOk], 0);
      end else begin
        n :=  ListBox1.ItemIndex + 1;
        ListBox1.Items.Insert(n, s);
        TabData :=  TTabData.Create;
        ListBox1.Items.Objects[n] :=  TabData;
        TabData.Title :=  s;
        TabData.Color :=  clBtnFace;
        TabData.BitmapFileName  :=  'images\folder.bmp';
        FModified :=  True;
        Break;
      end;
    end else begin
      Break;
    end;
  end;
end;

procedure TShortcutEditor.actRenameTabExecute(Sender: TObject);
var
  TabData : TTabData;
  s : string;
begin
  if  (ListBox1.ItemIndex > -1) and (ListBox1.ItemIndex < ListBox1.Items.Count) then  begin
    TabData :=  TTabData(ListBox1.Items.Objects[ListBox1.ItemIndex]);    
    s :=  TabData.Title;
    ListBox1.Items[ListBox1.ItemIndex] := '@';
    while true  do  begin
      if  (InputQuery('^u̖OύX', '^u̖O', s)) then  begin
        if  (ListBox1.Items.IndexOf(s) > -1)  then  begin
          MessageDlg('ɂ̖Õ^u݂܂B', mtError, [mbOk], 0);
        end else begin
          if  (s = '')  then  begin
            s :=  '@';
          end;
          TabData.Title :=  s;
          FModified :=  True;
          Break;
        end;
      end else begin
        Break;
      end;
    end;
    ListBox1.Items[ListBox1.ItemIndex]  :=  TabData.Title;
  end;
end;

procedure TShortcutEditor.actDeleteTabExecute(Sender: TObject);
var
  TabData : TTabData;
  ThreadItem : TThreadItem;
  i : integer;
begin
  if  (ListBox1.ItemIndex > -1) and (ListBox1.ItemIndex < ListBox1.Items.Count) then  begin
    TabData :=  TTabData(ListBox1.Items.Objects[ListBox1.ItemIndex]);
    for i :=  0 to  TabData.ShortcutCount - 1 do  begin
      if  (TabData.Shortcuts[i].ObjectType = otThread)  then  begin
        ThreadItem  :=  TThreadItem.Create;
        if  (ThreadItem.CreateThreadItem(
                                   TabData.Shortcuts[i].Param3,
                                   TabData.Shortcuts[i].Param2,
                                   TabData.Shortcuts[i].Param1,
                                   ''))  then
        begin
          ThreadItem.LoadConfig;
          DeleteFromShortcut(ThreadItem);
          ThreadItem.InShortcut :=  False;
          ThreadItem.SaveConfig;
          ThreadItem.Free;
        end;
      end;
    end;

    
    TabData.Free;
    ListBox1.Items.Delete(ListBox1.ItemIndex);
    ListBox2.Items.Clear;
    FModified :=  True;
  end;
end;

procedure TShortcutEditor.actChangeTabColorExecute(Sender: TObject);
var
  TabData : TTabData;
begin
  if  (ListBox1.ItemIndex > -1) and (ListBox1.ItemIndex < ListBox1.Items.Count) then  begin
    TabData :=  TTabData(ListBox1.Items.Objects[ListBox1.ItemIndex]);
    ColorDialog1.Color  :=  TabData.Color;
    if  (ColorDialog1.Execute)  then  begin
      TabData.Color :=  ColorDialog1.Color;
      FModified :=  True;
    end;
    ListBox1.Invalidate;
  end;
end;

procedure TShortcutEditor.actTabImageExecute(Sender: TObject);
var
  TabData : TTabData;
begin
  if  (ListBox1.ItemIndex > -1) and (ListBox1.ItemIndex < ListBox1.Items.Count) then  begin
    TabData :=  TTabData(ListBox1.Items.Objects[ListBox1.ItemIndex]);
    OpenPictureDialog1.FileName :=  TabData.BitmapFileName;
    if  (OpenPictureDialog1.Execute)  then  begin
      TabData.BitmapFileName  :=  ExtractRelativePath(ZonuConfig.AppPath, OpenPictureDialog1.FileName);
      FModified :=  True;
    end;
    ListBox1.Invalidate;
  end;
end;

procedure TShortcutEditor.ListBox1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept  :=  (Sender is TListBox);
end;

procedure TShortcutEditor.ListBox1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  i : integer;
  Index : integer;
  //List : TList;
  ShortcutData : TShortcutData;
  NewShortcut  : TShortcutData;
begin
  if  (Source = ListBox1) then  begin
    Index :=  ListBox1.ItemAtPos(Point(X, Y), False);
    if  (Index > ListBox1.Items.Count - 1)  then  begin
      ListBox1.Items.Move(ListBox1.ItemIndex, ListBox1.Items.Count - 1);
    end else begin
      ListBox1.Items.Move(ListBox1.ItemIndex, Index);
    end;
    ListBox1.ItemIndex  :=  Index;
    FModified :=  True;
  end else
  if  (Source = ListBox2) then  begin
    for i :=  0 to  ListBox2.Items.Count - 1  do  begin
      if  (ListBox2.Selected[i])  then  begin
        ShortcutData  :=  TShortcutData(ListBox2.Items.Objects[i]);
        Index :=  ListBox1.ItemAtPos(Point(X, Y), False);
        if  (Index = ListBox1.ItemIndex)  then  Exit;
        NewShortcut   :=  TTabData(ListBox1.Items.Objects[Index]).Add;
        NewShortcut.Assign(ShortcutData);
      end;
    end;
    for i :=  ListBox2.Items.Count - 1  downto  0 do  begin
      if  (ListBox2.Selected[i])  then  begin
        TTabData(ListBox1.Items.Objects[ListBox1.ItemIndex]).Delete(i);
        ListBox2.Items.Delete(i);
      end;
    end;
    FModified :=  True;
  end;
end;

procedure TShortcutEditor.actRenameShortcutExecute(Sender: TObject);
var
  ShortcutData : TShortcutData;
  s : string;
begin
  if  (ListBox1.ItemIndex > -1) then  begin
    if  (ListBox2.ItemIndex > -1) and (ListBox2.ItemIndex < ListBox2.Items.Count) then  begin
      ShortcutData :=  TShortcutData(ListBox2.Items.Objects[ListBox2.ItemIndex]);
      if  (ShortcutData.Title = '-')  then  begin
        MessageDlg('Zp[^̖O͕ύXł܂B', mtError, [mbOk], 0);
      end else begin
        s :=  ShortcutData.Title;
        if  (InputQuery('OύX', 'V[gJbg̖O', s)) then  begin
          if  (s = '') then begin
            s := '@';
          end;
          ShortcutData.Title :=  s;
          FModified :=  True;
        end;
        ListBox2.Items[ListBox2.ItemIndex]  :=  ShortcutData.Title;
      end;
    end;
  end;
end;

procedure TShortcutEditor.actDeleteShortcutExecute(Sender: TObject);
var
  ShortcutData : TShortcutData;
  ThreadItem  : TThreadItem;
  //Site  : TSite;
  //Board : TBoard;
  i : integer;
begin
  if  (ListBox1.ItemIndex > -1) then  begin
    for i :=  ListBox2.Items.Count - 1  downto  0 do  begin
      if  (ListBox2.Selected[i])  then  begin
        ShortcutData  :=  TShortcutData(ListBox2.Items.Objects[i]);
        ThreadItem    :=  TThreadItem.Create;
        if  (ThreadItem.CreateThreadItem(
                                   ShortcutData.Param3,
                                   ShortcutData.Param2,
                                   ShortcutData.Param1,
                                   ''))  then
        begin
          DeleteFromShortcut(ThreadItem);
          ThreadItem.InShortcut           :=  False;
          ThreadItem.SaveConfig;
          ThreadItem.Free;
        end;
        TTabData(ListBox1.Items.Objects[ListBox1.ItemIndex]).Delete(i);
        ListBox2.Items.Delete(i);
        FModified :=  True;
      end;
    end;
    ListBox2.Invalidate;
  end;
end;

procedure TShortcutEditor.ListBox2DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept  :=  (Sender = ListBox2);
end;

procedure TShortcutEditor.ListBox2DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  i : integer;
  Index : integer;
  //TabData : TTabData;
  ShortcutData : TShortcutData;
  List : TList;
begin
  Index :=  ListBox2.ItemAtPos(Point(X, Y), False);
  if  (Index > -1) then begin
    List  :=  TList.Create;
    for i :=  0 to  ListBox2.Items.Count - 1  do  begin
      if  (ListBox2.Selected[i])  then  begin
        ShortcutData  :=  TShortcutData.Create;
        ShortcutData.Assign(TShortcutData(ListBox2.Items.Objects[i]));
        List.Add(ShortcutData);
      end;
    end;
    for i :=  ListBox2.Items.Count - 1  downto  0 do  begin
      if  (ListBox2.Selected[i])  then  begin
        TTabData(ListBox1.Items.Objects[ListBox1.ItemIndex]).Delete(i);
        ListBox2.Items.Delete(i);
        if  (i < Index) then  begin
          Index := Index - 1;
          if  (Index < 0) then  Index :=  0;
        end;
      end;
    end;
    for i :=  List.Count - 1  downto  0  do  begin
      ShortcutData  :=  TTabData(ListBox1.Items.Objects[ListBox1.ItemIndex]).Insert(Index);
      ShortcutData.Assign(TShortcutData(List[i]));
      ListBox2.Items.Insert(Index, ShortcutData.Title);
      ListBox2.Items.Objects[Index] :=  ShortcutData;
      TShortcutData(List[i]).Free;
    end;
    List.Free;
    FModified :=  True;
  end;
end;

procedure TShortcutEditor.actSaveExecute(Sender: TObject);
begin
  if  (FModified) then  begin
    SaveToFile;
    FChanged := True;
    FModified:= False;
  end;
end;

procedure TShortcutEditor.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
{
var
  r : integer;
begin
  if  (FModified) then  begin
    r :=  MessageDlg('V[gJbgۑ܂H', mtWarning, [mbYes, mbNo, mbCancel], 0);
    if  (r = mrYes) then  begin
      SaveToFile;
      FChanged  := True;
      CanClose  :=  True;
    end else
    if  (r = mrNo) then  begin
      CanClose  :=  True;
    end else begin
      CanClose  :=  False;
    end;
  end;
}
  SaveToFile;
  FChanged  := True;
  CanClose  :=  True;
end;

procedure TShortcutEditor.SaveToFile(FileName: string = '');
begin
  SaveShortcutList(ListBox1, FileName);
end;

procedure TShortcutEditor.actSaveAsExecute(Sender: TObject);
begin
  if  (SaveDialog1.Execute) then  begin
    SaveToFile(SaveDialog1.FileName);
  end;
end;

procedure TShortcutEditor.actOpenExecute(Sender: TObject);
begin
  if  (OpenDialog1.Execute) then  begin
    ReleaseShortcuts;
    LoadFromFile(OpenDialog1.FileName);
  end;
end;

procedure TShortcutEditor.actAddSeparatorExecute(Sender: TObject);
var
  sd : TShortcutData;
  n : integer;
begin
  if  (ListBox1.ItemIndex > -1) then  begin
    n :=  ListBox2.ItemIndex;
    if  (n < 0) then  n :=  0;
    sd  :=  TTabData(ListBox1.Items.Objects[ListBox1.ItemIndex]).Insert(n);
    sd.ObjectType   :=  otSeparator;
    sd.Title        :=  '';
    sd.Param1       :=  '';
    sd.Param2       :=  '';
    sd.Param3       :=  '';
    ListBox2.Items.Insert(n, '-');
    ListBox2.Items.Objects[n] :=  sd;
    ListBox2.Invalidate;
    FModified :=  True;
  end;
end;

procedure TShortcutEditor.ListBox2DblClick(Sender: TObject);
begin
  if  (ListBox2.ItemIndex > -1) then  actRenameShortcut.Execute;
end;

procedure TShortcutEditor.actPropertyExecute(Sender: TObject);
var
  ShortcutData: TShortcutData;
  ThreadItem: TThreadItem;
  Site : TSite;
  Board: TBoard;
begin
  if  (ListBox1.ItemIndex > -1) then  begin
    if  (ListBox2.ItemIndex > -1) and (ListBox2.ItemIndex < ListBox2.Items.Count) then  begin
      ShortcutData :=  TShortcutData(ListBox2.Items.Objects[ListBox2.ItemIndex]);
      if  (ShortcutData.Title = '-')  then  begin
        Exit;
      end else
      if  (ShortcutData.ObjectType = otBoard) then  begin
        if  (ZonuEnviron.SiteList.FindSite(ShortcutData.Param2, Site)) then  begin
          if  (Site.BoardList.FindBoard(ShortcutData.Param1, Board))  then  begin
            PropertyWindow  :=  TPropertyWindow.Create(Self);
            PropertyWindow.SetBoard(Board);
            if  (PropertyWindow.ShowModal = mrOk) then  begin
              //
            end;
            PropertyWindow.Release;
          end;
        end;
      end else
      if  (ShortcutData.ObjectType = otThread) then  begin
        ThreadItem  :=  TThreadItem.Create;
        if  (ThreadItem.CreateThreadItem( ShortcutData.Param3,
                                          ShortcutData.Param2,
                                          ShortcutData.Param1,
                                          '')) then
        begin
          PropertyWindow  :=  TPropertyWindow.Create(Self);
          PropertyWindow.SetThreadItem(ThreadItem);
          if  (PropertyWindow.ShowModal = mrOk) then  begin
            if  (not ThreadItem.InShortcut) then  begin
              actDeleteShortcut.Execute;
            end;
            ListBox1.OnClick(ListBox1);
          end;
          PropertyWindow.Release;
        end;
        ThreadItem.Free;
      end;
    end;
  end;
end;

end.
