//
//  M&Ĩy[W
//  http://homepage3.nifty.com/m-and-i/tips/utftosjis.htm
//
unit Utf8tosjis;

interface

uses
  Windows, Sysutils;

type
  //UTF-8 Unknown code
  EUTF8UnknownCode = class(Exception)
  end;

// UTF-8(BOMt) -> SJIS
function UTFtoSJIS(UTFStr: string): string;
// UTF-8N -> SJIS
function UTFNtoSJIS(UTFStr: string): string;
// SJIS -> UTF-8(BOMt)
function SJIStoUTF(Str: string): string;
// SJIS -> UTF-8N
function SJIStoUTFN(Str: string): string;

implementation

// UTF-8SJISɕϊ
function UTF82Sjis(UTFStr: string): string;
var
  usc2, uc: PChar;
  pwc: PWideChar;
  len: integer;
  un: WORD;
begin
  Result := '';
  len := Length(UTFStr);
  // ̏Io邽߂ɔԕSl𗧂Ă
  uc := PChar(UTFStr + #0#0#0#0);
  // SĂS{̃m
  usc2 := AllocMem(len * 4);
  // usc2̓|C^ƂĎĝpwcɐ擪AhXۑ
  pwc := PWideChar(usc2);
  try
    while uc^ <> #0 do
    begin
      // ASCII
      if uc^ in [#0..#$7F] then
      begin
        usc2^ := uc^;
        (usc2+1)^ := #0;
        Inc(usc2, 2);
        Inc(uc);
      // 2bytêP
      end else if uc^ in [#$C0.. #$DF] then
      begin
        un := (Ord(uc^) and $1F) shl 6 + Ord((uc+1)^) and $3F;
        usc2^ := Char(Lo(un));
        (usc2+1)^ := Char(Hi(un));
        Inc(usc2, 2);
        Inc(uc, 2);
      // 2bytêQ
      end else if uc^ in [#$E0..#$EF] then
      begin
        un := (Ord(uc^) and $0F) shl 12 + (Ord((uc+1)^) and $3F) shl 6 
              + (Ord((uc+2)^) and $3F);
        usc2^ := Char(Lo(un));
        (usc2+1)^ := Char(Hi(un));
        Inc(usc2, 2);
        Inc(uc, 3);
      // 4byte(USC-4̂)
      end else if uc^ in [#$F0..#$F7] then
      begin
        un := (Ord(uc^) and $07) shl 2 + (Ord((uc+1)^) shr 4) and $03;
        usc2^ := Char(Lo(un));
        (usc2+1)^ := Char(Hi(un));
        Inc(usc2, 2);
        Inc(uc);
        un := ((Ord(uc^) shl 4) and $F0) + (Ord((uc+1)^) and $3F) shl 6 
              + (Ord((uc+2)^) and $3F);
        usc2^ := Char(Lo(un));
        (usc2+1)^ := Char(Hi(un));
        Inc(usc2, 2);
        Inc(uc, 3);
      end else
        raise EUTF8UnknownCode.Create('UTF-8 Unknown code.');
    end;
    Result := pwc;
  finally
    // UTFϊUnicodeString^ŕԂBꂾSjisɂȂႤ
    FreeMem(pwc);
  end;
end;

// SJISUTF-8ɕϊ
function SJIS2UTF(Str: string): string;
var
  uc, sc: PChar;
  usc2: PWideChar;
  pw: ^Word;
  //w1, w2: Word;
  len: integer;
begin
  Result := '';
  len := Length(Str);
  usc2 := AllocMem(len * 4 + 4);
  pw := Pointer(usc2);
  try
    uc := AllocMem(len * 3 + 3);
    sc := uc;
    try
      // UUnicodeɕϊ
      StringToWideChar(Str, usc2, len * 4);
      while pw^ <> 0 do
      begin
        {USC-4̏BUninode(USC-2)ł͕svBłȂ疢mFB
        // 00000000-000wwwxx-xxxxyyyy-yyzzzzzz
        if ((pw^ and $FFE0) = 0) and ((pw2^ and $F800) <> 0) then
        begin
          w1 := pw^;
          Inc(pw);
          w2 := pw^;
          Inc(pw);
          // 11110www
          uc^ := Char($F0 + (w2 shr 2));
          Inc(uc);
          // 10xxxxxx
          uc^ := Char($80 + ((w2 and $03) shl 4) + (w1 shr 12));
          Inc(uc);
          // 10yyyyyy
          uc^ := Char($80 + ((w1 shr 6) and $3F));
          Inc(uc^);
          // 10zzzzzz
          uc^ := Char($80 + (w1 and $3F));
          Inc(uc);
        // 00000000-0xxxxxxx
        end else }
        if (pw^ and $FF80) = 0 then
        begin
          uc^ := Char(Lo(pw^));
          Inc(uc);
          Inc(pw);
        // 00000xxx-xxyyyyyy
        end else if (pw^ and $F800) = 0 then      
        begin
          // 110xxxxx
          uc^ := Char($C0 + (pw^ shr 6));
          Inc(uc);
          // 10yyyyyy
          uc^ := Char($80 + (pw^ and $3F));
          Inc(uc);
          Inc(pw);
        // xxxxyyyy-yyzzzzzz
        end else begin
          // 1110xxxx
          uc^ := Char($E0 + (pw^ shr 12));
          Inc(uc);
          // 10yyyyyy
          uc^ := Char($80 + ((pw^ shr 6) and $3F));
          Inc(uc);
          // 10zzzzzz
          uc^ := Char($80 + (pw^ and $3F));
          Inc(uc);
          Inc(pw);
        end;
      end;
      uc^ := #0;
      Result := sc;
    finally
      Freemem(sc);
    end;
  finally
    FreeMem(usc2);
  end;
end;

// UTF-8(BOMt) -> SJIS
function UTFtoSJIS(UTFStr: string): string;
begin
  if  (Copy(UTFStr,1,3) = #$EF#$BB#$BF) then  begin
    Delete(UTFStr, 1, 3);
  end;
  Result := UTF82Sjis(UTFStr);
end;

// UTF-8N -> SJIS
function UTFNtoSJIS(UTFStr: string): string;
begin
  Result := UTF82SJIS(UTFStr);
end;

// SJIS -> UTF-8(BOMt)
function SJIStoUTF(Str: string): string;
begin
  Result := #$EF#$BB#$BF + SJIS2UTF(Str);
end;

// SJIS -> UTF-8N
function SJIStoUTFN(Str: string): string;
begin
  Result := SJIS2UTF(Str);
end;

end.



