unit Webcaptr;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, SHDocVw, EmbeddedWB, ExtCtrls, StdCtrls;

type
  TCaptureType = (ctHtml, ctImage);
  TWebCaptureForm = class(TForm)
    WebBrowser1: TEmbeddedWB;
    procedure WebBrowser1DownloadComplete(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure Capture(const ACaptureType: TCaptureType; const AUrl: string);
  end;

var
  WebCaptureForm: TWebCaptureForm;

implementation

{$R *.dfm}

uses
  ZonuClass;

{ TWebCaptureForm }

procedure TWebCaptureForm.Capture(const ACaptureType: TCaptureType;
  const AUrl: string);
var
  doc: variant;
begin
  if  (not Assigned(WebBrowser1.Document))  then  begin
    WebBrowser1.Navigate('about:blank');
    while (not Assigned(WebBrowser1.Document)) do  begin
      Application.ProcessMessages;
      if  (ZonuEnviron.Disconnected)  then  begin
        raise EZonuError.Create('ؒf܂B');
      end;
    end;
  end;
  doc :=  WebBrowser1.Document;
  doc.Clear;
  doc.Write('<HTML><HEAD><META HTTP-EQUIV="Content-Type" CONTENT="text/html;CHARSET=x-sjis"></HEAD>');
  doc.Write('<BODY BGCOLOR="#ffffff" TOPMARGIN=0 LEFTMARGIN=0 SCROLL="NO">');
  if  (ACaptureType = ctHtml) then  begin
    doc.Write(Format('<img src="http://img.simpleapi.net/small/%s" alt="" width="128" height="128" align="left" border="0">', [AUrl]));
  end else
  if  (ACaptureType = ctImage) then  begin
    doc.Write(Format('<img src="%s" alt="" width="128" height="128" align="left" border="0">', [AUrl]));
  end;
  doc.Write('</BODY></HTML>');
  doc.Close;
  //WebBrowser1.Navigate('http://img.simpleapi.net/small/' + AUrl);
  Show;
end;

procedure TWebCaptureForm.WebBrowser1DownloadComplete(Sender: TObject);
begin
  Show;
end;

procedure TWebCaptureForm.FormCreate(Sender: TObject);
var
  rgn: HRgn;
begin
  Height  :=  133; //138;
  Width   :=  136; //138;
  rgn :=  CreateRectRgn(2, 2, Width -2, Height -2);
  SetWindowRgn(Handle, rgn, True);
end;

end.
