unit Exifunit;

interface

uses
  Classes, SysUtils, Types;

  function GetExif(const AFileName: string; Strings: TStrings): boolean;


implementation

type
  PDWORD = ^DWORD;


{
  by ͖M  (GCC02240)
  http://forum.nifty.com/fdelphi/samples/01347.html
}

// JPEGt@C̃ZOgiSegTypeŎނwj擾
procedure GetSegFromJPEG(Dst, Src: TStream; SegType: BYTE);
var
  bCode: BYTE;
  wData: WORD;
begin
  if (Src.Read(wData, 2) = 2)and(wData = $d8ff) then
  begin
    while Src.Read(bCode, 1) = 1 do
    begin
      if bCode <> $ff then
        break; // tH[}bg
      // ZOgԂ $ff ͖
      while Src.Read(bCode, 1) = 1 do
        if bCode <> $ff then break;
      // ̃ZOgȂ
      if bCode = $ff then
        break;
      if bCode = SegType then
      begin
        // 擾ZOg
        // 擾
        if Src.Read(wData, 2) <> 2 then
          break;
        wData := (wData shl 8 and $ff00)or(wData shr 8 and $ff);
        if wData < 2 then
          break; // TCY񂪈ُ
        // ZOg̃f[^Rs[
        Dst.CopyFrom(Src, wData - 2);
      end
      else if bCode in [$01, $b0..$b7] then
        // ̃ZOg͒Ȃ
      else if bCode = $da then
        // SOS(Start Of Scan) ZOg
        // ̃ZOgȍ~C[Wf[^
        break
      else // ̑̃ZOg̓XLbv
      begin
        if Src.Read(wData, 2) <> 2 then
          break;
        wData := (wData shl 8 and $ff00)or(wData shr 8 and $ff);
        if wData < 2 then
          break; // TCY񂪈ُ
        Src.Seek(wData - 2, soFromCurrent);
      end;
    end;
  end; // Code = $d8ff
end;

// JPEGt@C Exif ïꕔj擾
function GetExifFromJPEG(Dst: TStrings; Src: TStream): Boolean;
type
  TTiffHeader = packed record
    ID: WORD;
    Code: WORD;
    Offset: DWORD;
  end;
  TFIDHeader = packed record
    ID: WORD;
    DataType: WORD;
    Count: DWORD;
    Offset: DWORD;
  end;
const
  OfsToHeader = 6;
var
  Data: TMemoryStream;
  Header: TTiffHeader;
  BigEndian: Boolean;
  wValue, wNumEntry: WORD;
  hFID: TFIDHeader;
  I, J: Integer;
  
  function GetWORD(Value: WORD): WORD;
  begin
    if BigEndian then
      Result := (Value shl 8 and $ff00)or(Value shr 8 and $ff)
    else
      Result := Value;
  end;
  
  function GetDWORD(Value: DWORD): DWORD;
  var
    I, IMax: Integer;
    pDst, pSrc: PChar;
  begin
    if BigEndian then
    begin
      pDst := @Result;
      pSrc := @Value;
      IMax := sizeof(DWORD) - 1;
      for I := 0 to IMax do
        pDst[I] := pSrc[iMax - I];
    end
    else
      Result := Value;
  end;
  
  function GetFIDStr: string;
  var
    P1, P2: Pointer;
  begin
    Result := '';
    case GetWORD(hFID.DataType) of
    1: // BYTE
      Result := IntToStr(GetDWORD(hFID.Offset));
    2: // ASCII
      Result := PChar(
        DWORD(Data.Memory) + OfsToHeader +
        + GetDWORD(hFID.Offset)
      );
    3: // SHORT
      Result := IntToStr(GetDWORD(hFID.Offset));
    4: // LONG
      Result := IntToStr(GetDWORD(hFID.Offset));
    5: // RATIONAL
      begin
        P1 := Pointer(
          DWORD(Data.Memory) + OfsToHeader +
          + GetDWORD(hFID.Offset)
        );
        P2 := Pointer(DWORD(P1) + 4);
        Result := FloatToStr(PDWORD(P1)^ / PDWORD(P2)^);
      end;
    7:; // UNDEFINED
    9: // SLONG
      Result := IntToStr(Integer(GetDWORD(hFID.Offset)));
    10:// SRATIONAL
      begin
        P1 := Pointer(
          DWORD(Data.Memory) + OfsToHeader +
          + GetDWORD(hFID.Offset)
        );
        P2 := Pointer(DWORD(P1) + 4);
        Result := FloatToStr(PInteger(P1)^ / PInteger(P2)^);
      end;
    end;
  end;
  
  function GetFIDExpTime: string;
  var
    P1, P2: Pointer;
    exValue: Extended;
  begin
    Result := '';
    case GetWORD(hFID.DataType) of
    1: // BYTE
      Result := IntToStr(GetDWORD(hFID.Offset));
    2: // ASCII
      Result := PChar(
        DWORD(Data.Memory) + OfsToHeader +
        + GetDWORD(hFID.Offset)
      );
    3: // SHORT
      Result := IntToStr(GetDWORD(hFID.Offset));
    4: // LONG
      Result := IntToStr(GetDWORD(hFID.Offset));
    5: // RATIONAL
      begin
        P1 := Pointer(
          DWORD(Data.Memory) + OfsToHeader +
          + GetDWORD(hFID.Offset)
        );
        P2 := Pointer(DWORD(P1) + 4);
        exValue := PDWORD(P1)^ / PDWORD(P2)^;
        if (exValue > 0)and(exValue < 1.0) then
          Result := '1/' + IntToStr(Round(1/exValue))
        else
          Result := FloatToStr(exValue);
      end;
    7:; // UNDEFINED
    9: // SLONG
      Result := IntToStr(Integer(GetDWORD(hFID.Offset)));
    10:// SRATIONAL
      begin
        P1 := Pointer(
          DWORD(Data.Memory) + OfsToHeader +
          + GetDWORD(hFID.Offset)
        );
        P2 := Pointer(DWORD(P1) + 4);
        exValue := PInteger(P1)^ / PInteger(P2)^;
        if (exValue > 0)and(exValue < 1.0) then
          Result := '1/' + IntToStr(Round(1/exValue))
        else
          Result := FloatToStr(exValue);
      end;
    end;
  end;
  
begin
  Result := FALSE;
  Data := TMemoryStream.Create;
  try
    // APP1 ZOg擾
    GetSegFromJPEG(Data, Src, $e1);
    if(Data.Size > 0)and
      (StrLIComp(PChar(Data.Memory), PChar('Exif'+#0), 5) = 0) then
    begin
      Data.Position := OfsToHeader;
      if (Data.Read(Header, sizeof(Header)) = sizeof(Header)) and
         ((Header.ID = $4949)or(Header.ID = $4d4d)) and
         (GetWORD(Header.Code) = 42) then
      begin
        BigEndian := Header.ID = $4d4d;
        Data.Position := OfsToHeader + GetDWORD(Header.Offset);
        Data.ReadBuffer(wValue, sizeof(wValue));
        wValue := GetWORD(wValue);
        // ŏ̂ehc̃XL
        for I := 0 to wValue - 1 do
        begin
          Data.ReadBuffer(hFID, sizeof(hFID));
          if GetWORD(hFID.ID) = $8769 then
          begin
            // Exif 
            Data.Position :=
              OfsToHeader + GetDWORD(hFID.Offset);
            // Gg̐𓾂
            Data.ReadBuffer(wNumEntry, sizeof(wNumEntry));
            wNumEntry := GetWORD(wNumEntry);
            for J := 0 to wNumEntry - 1 do
            begin
              Data.ReadBuffer(hFID, sizeof(hFID));
              case GetWORD(hFID.ID) of
              $829a: Dst.Values['Vb^[x'] := GetFIDExpTime;
              $829d: Dst.Values['el'] := GetFIDStr;
              $8827: Dst.Values['hrnx'] := GetFIDStr;
              $9003: Dst.Values['Be'] := GetFIDStr;
              $920a: Dst.Values['Y̏œ_'] := GetFIDStr;
              else
              Dst.Add('?=' + GetFIDStr);
              end;
            end;
            Result := TRUE;
            break;
          end;
        end;
      end; // Header ̃`FbN
    end; // 'Exif' ̃`FbN'
  finally
    Data.Free;
  end;
end;

{
function GetExif(const AFileName: string
var
  fs: TFileStream;
  sl: TStringList;
begin
  Result  :=  True;
  fs  :=  TFileStream.Create(AFileName, fmOpenRead or fmShareDenyWrite);
  try
    sl  :=  TStringList.Create;
    try
      GetExifFromJPEG(sl, fs);
      if  (sl.Count > 0)  then  begin
        ValueListEditor1.Strings.Assign(sl);
      end else begin
        Result  :=  False;
      end;
    finally
      sl.Free;
    end;
  finally
    fs.Free;
  end;
}

function GetExif(const AFileName: string; Strings: TStrings): boolean;
var
  fs: TFileStream;
  sl: TStringList;
begin
  Result  :=  True;
  fs  :=  TFileStream.Create(AFileName, fmOpenRead or fmShareDenyWrite);
  try
    sl  :=  TStringList.Create;
    try
      GetExifFromJPEG(sl, fs);
      if  (sl.Count > 0)  then  begin
        Strings.Assign(sl);
      end else begin
        Result  :=  False;
      end;
    finally
      sl.Free;
    end;
  finally
    fs.Free;
  end;
end;

end.
