{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Class Library                                                     }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit ZonuClass;

interface

uses
  Windows, Classes, SysUtils, Graphics, Forms, Contnrs, HTTPApp, IniFiles,
  MonaUtils, Hzbconst;

type
  TBBSClass       = class of  TBBS;
  TZonuEnviron    = class;
  TBBSList        = class;
  TBBS            = class;
  TSiteList       = class;
  TSite           = class;
  TBoardList      = class;
  TBoard          = class;
  TThreadItemList = class;
  TThreadItem     = class;
  TResList        = class;
  TRes            = class;

  TScriptParam    = class;
  TBookmarkList   = class;
  TBookmarkRes    = class;
  TSendData       = class;

  TDownloader           = class;
  TThreadListDownloader = class;
  TResDownloader        = class;
  TBoardListDownloader  = class;
  TUploader             = class;
  TResUploader          = class;
  TThreadUploader       = class;

  TItemsSortType = (isNone,
                    isNo,
                    isUpdateInfo,
                    isReadInfo,
                    isTitle,
                    isCount,
                    isNewCount,
                    isReadCount,
                    isPriority,
                    isLastLoadDate,
                    isLastSentDate,
                    isMemo,
                    isBoard,
                    isSite,
                    isReadPoint,
                    isReadPointNo,
                    isDat,
                    isSince,
                    isThreadNo);

  TSendOption = set of  (soSage,      //@\
                         soSageMail,  //Ń[sage
                         soPre,       //PRE@\
                         soTouhaba,   //@\
                         soPassword); //폜pX[h(VX̏ꍇ̂)

  TBoardType  = (btBBSBoard,
                 btFavorites,
                 btLocalFolder,
                 btWebPage,
                 btRSS);  //14
  //
  //  :EVENT
  //
  //Xbhꗗ擾Cxg
  TThreadListDownloadEvt  = procedure (Sender: TThreadListDownloader;
    ThreadItem: TThreadItem; Size, TotalSize: integer; var MoreData: boolean) of object;
  //X擾Cxg
  TResDownloadEvt = procedure (Sender: TResDownloader; Res: TRes;
    Size, TotalSize: integer) of object;
  //EFuy[Wւ̃_CNg(TWebScriptp)
  TRedirectEvt = procedure (Sender: TResDownloader; Url: string) of object; //14
  //{[hꗗ擾Cxg
  TBoardListDownloadEvt = procedure (Sender: TBoardListDownloader; ALine: string;
    Size, TotalSize: integer) of object;
  //_E[hICxg
  TEndDownloadEvt   = procedure (Sender: TDownloader; Error: boolean) of object;
  //_E[hG[Cxg
  TDownloadErrorEvt = procedure (Sender: TDownloader; ErrorCode: integer;
    ErrorMsg, LastResponse: string) of object;
  //Abv[hICxg
  TEndUploadEvt   = procedure (Sender: TUploader; Error: boolean) of object;
  //Abv[hG[Cxg
  TUploadErrorEvt = procedure (Sender: TUploader; ErrorCode: integer;
    ErrorMsg, LastResponse: string) of object;
  //gC
  TSendRetryEvt = procedure (Sender: TUploader; Str: string) of object;
  //
  TZonuMsgEvt = procedure (Sender: TObject; Msg: string) of object;

  EZonuError = Exception;

  //
  //  :ZONUENVIRON
  //
  TZonuEnviron  = class(TObject)
  private
    FState: TAppState;
    FBBSList: TBBSList;
    FSiteList:  TSiteList;
    FFavoritesSite: TSite;
    FLocalSite: TSite;
    FUserSite: TSite;
    FRssSite: TSite; //14
    FDisconnected: boolean;
    FLogStrings: TStrings;
    function GetCached: boolean;
    procedure SetCached(const Value: boolean);
  public
    constructor Create;
    destructor  Destroy; override;
    procedure LoadBBS;
    procedure LoadSite;
    property  Cached: boolean read  GetCached write SetCached;
    property  State: TAppState  read  FState  write FState;
    property  SiteList: TSiteList   read  FSiteList   write FSiteList;
    property  BBSList: TBBSList   read  FBBSList   write FBBSList;
    property  FavoritesSite : TSite read  FFavoritesSite  write FFavoritesSite;
    property  LocalSite: TSite  read  FLocalSite  write FLocalSite;
    property  UserSite: TSite read  FUserSite write FUserSite;
    property  RssSite: TSite  read  FRssSite  write FRssSite; //14
    property  Disconnected: boolean read  FDisconnected write FDisconnected;
    property  LogStrings: TStrings  read  FLogStrings write FLogStrings;
  end;

  //
  //  :TBBSList
  //
  TBBSList = class(TList)
  private
    function GetBBS(index: integer): TBBS;
    procedure SetBBS(index: integer; const Value: TBBS);
  public
    destructor Destroy; override;
    function  Add(Value: TBBS): integer;
    function  FindBBS(ABBSClass: TBBSClass): TBBS; overload;
    function  FindBBS(const ABBSID: string): TBBS; overload;
    procedure Delete(Index: integer);
    procedure Clear; override;
    procedure LoadPluginBBS;
    property  Items[index: integer]: TBBS read GetBBS write SetBBS; default;
  end;

  //
  //  :TBBS
  //
  TBBS  = class(TObject)
  private
    FBBSID: string;
    FConfigPath: string;
    FAboneText: string;
    FScriptName: string;
    //FCrypt: string;
    FSendResultErr: string;
    FCharset: TCharset;
    FSettingUrl: string;
    FLastModified: string;
    FVersion: string;
  protected
    FNewThreadParam: TScriptParam;
    FSendParam: TScriptParam;
    FSendOption: TSendOption;
    FNewThreadOption: TSendOption;
    function GetThreadListType: TThreadListAccessType; virtual; abstract;
    function GetThreadDownloadMode: TThreadDownloadMode; virtual; abstract;
    function GetNeedHRefLink: boolean; virtual; abstract;
    function GetNeedLinkTarget: boolean; virtual; abstract;
    function GetRelativeLink: boolean; virtual; abstract;
    function GetSendResultErr: string;  virtual;
    function GetIsPublished: boolean; virtual; abstract;
    function GetWebRedirect: boolean; virtual; //14
    procedure ZonuDataThreadList(Sender: TObject; Downloader: TDownloader;
      Data: string; TotalSize, DownloadSize: integer; var MoreData: boolean); virtual;
    procedure ZonuEndThreadList(Sender: TObject; Downloader: TDownloader;
      Error: boolean); virtual;
    procedure ZonuThreadListError(Sender: TObject; Downloader: TDownloader;
      ErrorCode: integer; ErrorMsg, LastResponse: string); virtual;
    procedure ZonuDataRes(Sender: TObject; Downloader: TDownloader;
      Data: string; TotalSize, DownloadSize: integer; var MoreData: boolean); virtual;
    procedure ZonuEndRes(Sender: TObject; Downloader: TDownloader;
      Error: boolean); virtual;
    procedure ZonuResError(Sender: TObject; Downloader: TDownloader;
      ErrorCode: integer; ErrorMsg, LastResponse: string); virtual;
    procedure ZonuSendEnd(Sender: TObject; Uploader: TUploader;
      RecvStr: string; Error: boolean); virtual;
    procedure ZonuSendError(Sender: TObject; Uploader: TUploader;
      ErrorCode: integer; ErrorMsg, Html: string); virtual;
  public
    constructor Create(const ABBSID: string); virtual;
    destructor Destroy; override;
    function  GetSubjectUrl(Board: TBoard; const PageIndex: integer = 0): string;
    function  GetDatUrl(ThreadItem: TThreadItem): string; overload;
    function  GetDatUrl(Board: TBoard; DatNo: string): string; overload;
    function  GetReadCgiUrl: string; overload;
    function  GetReadCgiUrl(ThreadItem: TThreadItem): string; overload; virtual;
    function  GetReadCgiUrl(Board: TBoard; DatNo: string): string; overload;
    function  GetRemoteDatFileName(ThreadItem: TThreadItem): string;
    function  GetDisplayUrl(ThreadItem: TThreadItem): string; virtual; abstract;
    function  GetResUrl(ThreadItem: TThreadItem; const StartNo, ToNo: integer;
      const NoFirst: boolean = True): string; virtual;
    //
    procedure DownloadThreadList(Downloader: TThreadListDownloader;
      const NoCache, ASync, InfSave: boolean); virtual; abstract;
    procedure DownloadNextThreadList(Downloader: TThreadListDownloader;
      const PageIndex: integer); virtual;
    procedure DownloadThreadItem(Downloader: TResDownloader;
        const NoCache, ASync, InfSave, AutoPilot: boolean); virtual; abstract;
    //
    procedure ParseSubject(subject: string; out FileName: string;
      out Title: string; out Count: integer); virtual; abstract;
    procedure ParseDat(const ALine: string; const index: integer;
      var ARes: TRes; out ASubject: string); virtual; abstract;
    function ConvUrl(const Url: string): string; virtual;
    //
    function  GetSendUrl(Board: TBoard; ThreadItem: TThreadItem): string;
    function  GetSendParam: string;
    function  GetSendCookie: string;
    //
    function  GetNewThreadUrl(Board: TBoard): string;
    function  GetNewThreadParam: string;
    function  GetNewThreadCookie: string;
    function  GetDir(const Url: string): string; virtual;
    //
    procedure SendRes(Uploader: TResUploader); virtual; abstract;
    procedure SendThread(Uploader: TThreadUploader); virtual; abstract;
    //
    procedure UpdateSetting;
    //
    property  ScriptName: string  read  FScriptName;
    property  BBSID: string read  FBBSID;
    property  ConfigPath: string  read  FConfigPath;
    property  ThreadListType: TThreadListAccessType read  GetThreadListType;
    property  ThreadDownlaodMode: TThreadDownloadMode read  GetThreadDownloadMode;
    property  NeedHRefLink: boolean read  GetNeedHRefLink;
    property  NeedLinkTarget: boolean read  GetNeedLinkTarget;
    property  RelativeLink: boolean read  GetRelativeLink;
    property  SendParam: TScriptParam   read  FSendParam  write FSendParam;
    property  NewThreadParam: TScriptParam   read  FNewThreadParam  write FNewThreadParam;
    property  AboneText: string   read  FAboneText  write FAboneText;
    //property  Crypt: string   read  FCrypt  write FCrypt;
    property  SendOption: TSendOption read  FSendOption write FSendOption;
    property  NewThreadOption: TSendOption read  FNewThreadOption write FNewThreadOption;
    property  Charset: TCharset  read  FCharset;
    property  SendResultErr: string read  GetSendResultErr;
    property  IsPublished: boolean  read  GetIsPublished;
    property  Version: string read  FVersion;
    property  LastModified: string  read  FLastModified;
    property  SettingUrl: string  read  FSettingUrl;
    property  WebRedirect: boolean  read  GetWebRedirect;  //14
  end;

  //
  //  :TSiteList
  //
  TSiteList = class(TList)
  private
    function GetSite(index: integer): TSite;
    procedure SetSite(index: integer; const Value: TSite);
  public
    destructor Destroy; override;
    function  Add(Value: TSite): integer;
    procedure Delete(Index: integer);
    procedure Clear; override;
    property  Items[index: integer]: TSite read GetSite write SetSite; default;
    function  FindSite(const SiteID: string; var Site: TSite): boolean;
    function  FindBoard(const BoardPath, BoardID: string; var Board: TBoard): boolean; overload;
    function  FindBoard(const URL: string; var Board: TBoard): boolean; overload;
  end;

  //
  //  :TSite
  //
  TSite = class(TObject)
  private
    FBoardList: TBoardList;
    FBBS: TBBS;
    FSiteName: string;
    FConfigPath: string;
    FCharSet: TCharSet;
    FSiteID: string;
    FIncludeUrl: string;
    FImageIndex: integer;
    FIsSubscription: boolean;
    FUrl: string;
    FSiteType: TSiteType;
    FImage: TBitmap;
    FNinkinetID: string;
    function GetCachePath: string;
  protected
    FSiteIni : TMemIniFile;
  public
    constructor Create(const ABBSID, Path: string; AConfigPath: string = ''); virtual;  //BBSClass: TBBSClass); virtual;
    destructor Destroy; override;
    function  GetLocalRuleUrl(Board: TBoard): string;
    function  IsInclude(const AUrl: string): boolean;
    procedure LoadBoardList;
    property  BoardList: TBoardList   read  FBoardList  write FBoardList;
    property  BBS : TBBS  read  FBBS  write FBBS;
    property  SiteName : string read  FSiteName write FSiteName;
    property  CharSet: TCharSet read  FCharSet  write FCharSet;
    property  ConfigPath: string  read  FConfigPath;
    property  CachePath: string read  GetCachePath;
    property  SiteID: string  read  FSiteID;
    property  Url: string  read  FUrl write FUrl;
    property  IncludeUrl: string  read  FIncludeUrl;
    property  ImageIndex: integer read  FImageIndex write FImageIndex;
    property  Image: TBitmap  read  FImage  write FImage;
    property  IsSubscription: boolean  read FIsSubscription write FIsSubscription;
    property  SiteType: TSiteType read  FSiteType write FSiteType;
    property  NinkinetID: string  read  FNinkinetID write FNinkinetID;
  end;

  //
  //  :TBoardList
  //
  TBoardList  = class(TList)
  private
    FBBS: TBBS;
    FSite: TSite;
    function GetBoard(index: integer): TBoard;
    procedure SetBoard(index: integer; const Value: TBoard);
  public
    destructor Destroy; override;
    function  Add(Value: TBoard): integer;
    function FindBoard(const BoardID: string; var Board: TBoard): boolean;
    function FindBoardFromBoardPath(const BoardPath, BoardID: string; var Board: TBoard): boolean;
    function FindBoardFromURL(const URL: string; var Board: TBoard): boolean; //31
    procedure SaveToFile(const FileName: string);
    procedure Delete(Index: integer);
    procedure Clear; override;
    property  Items[index: integer]: TBoard read GetBoard write SetBoard; default;
    property  Site: TSite read  FSite write FSite;
    property  BBS: TBBS read  FBBS  write FBBS;
  end;

  //
  //  :TBoard
  //
  TBoard = class(TObject)
  private
    FUrl: string;
    FBoardID: string;
    FName: string;
    FData: Pointer;
    FBold: boolean;
    FReverse: boolean;
    FColor: TColor;
    FGaishutu: boolean;
    FWebPageUrl: string;
    FKey: string;
    FSite: TSite;
    FExpanded: boolean;
    FBBS: TBBS;
    FCategoryName: string;
    FBoardPath: string;
    FCharSet: TCharSet;
    FCachePath: string;
    FRemoteBoardID: string;
    FBoardType: TBoardType;
    procedure SetReverse(const Value: boolean);
    function GetCachePath: string;
    function GetCanWrite: boolean;
    function GetDir: string;
    //8 begin
    function GetBAPassword: string;
    function GetBAUserName: string;
    //8 end
  public
    constructor Create;
    destructor Destroy; override;
    procedure Assign(Source: TBoard);
    function  GetThreadTitle(const DatNo: string): string;
    property  BoardType: TBoardType read  FBoardType  write FBoardType;
    property  Name: string read FName write FName;
    property  BBS: TBBS read  FBBS  write FBBS;
    property  Site : TSite  read  FSite  write FSite;
    property  BoardPath: string read FBoardPath write FBoardPath;
    property  BoardID: string read FBoardID write FBoardID;
    property  RemoteBoardID: string read FRemoteBoardID write FRemoteBoardID;
    property  CategoryName: string  read  FCategoryName write FCategoryName;
    property  Url: string read FUrl write FUrl;
    property  Key : string  read  FKey  write FKey;
    property  Bold : boolean  read  FBold write FBold;
    property  Reverse : boolean  read  FReverse write SetReverse;
    property  Color: TColor read  FColor  write FColor;
    property  Gaishutu: boolean read  FGaishutu write FGaishutu;
    property  Expanded: boolean read  FExpanded write FExpanded; // Category
    property  WebPageUrl: string  read  FWebPageUrl write FWebPageUrl;
    property  CachePath: string read  GetCachePath write  FCachePath;
    property  CharSet: TCharSet read  FCharSet  write FCharSet;
    property  CanWrite: boolean read  GetCanWrite;
    property  Data: Pointer read FData write FData;
    property  Dir: string read GetDir; //JBBŜ
    property  BasicAuthorization_UserName: string read  GetBAUserName; //8
    property  BasicAuthorization_Password: string read  GetBAPassword; //8
  end;

  //
  //  :TThreadItemList
  //
  TThreadItemList = class(TList)
  private
    FBBS: TBBS;
    FSite: TSite;
    FCurrentSortAscending: boolean;
    function GetThreadItem(index: integer): TThreadItem;
    procedure SetThreadItem(index: integer; const Value: TThreadItem);
    function GetNewCount: integer;
  public
    destructor Destroy; override;
    function  Add(Value: TThreadItem): integer;
    function  FindThreadItem(const DatFileName: string): TThreadItem;
    procedure Delete(Index: integer);
    procedure DeleteForce(Index: integer);
    procedure Erase(Index: integer);
    procedure Clear; override;
    procedure SortItems(SortType:TItemsSortType; Ascend:boolean);
    property  Items[index: integer]: TThreadItem read GetThreadItem write SetThreadItem; default;
    property  BBS: TBBS read  FBBS  write FBBS;
    property  Site: TSite read  FSite write FSite;
    property  CurrentSortAscending: boolean read  FCurrentSortAscending write FCurrentSortAscending;
    property  NewCount: integer read  GetNewCount;
  end;

  //
  //  :TThreadItem
  //
  TThreadItem = class(TObject)
  private
    FBoardID: string;
    FBBS: TBBS;
    FSite: TSite;
    FRefCount: integer;
    FNo: integer;
    FIsNew: boolean;
    FReverse: boolean;
    FIsAboned: boolean;
    FUpdated: boolean;
    FBold: boolean;
    FIsKakoLog: boolean;
    FAgeCount: integer;
    FNewCount: integer;
    FDownloadCount: integer;
    FReadCount: integer;
    FDatFileName: string;
    FLocalDatFileName: string;
    FTitle: string;
    FRemoteDatFileName: string;
    FColor: TColor;
    FInFavorites: boolean;
    FInShortcut: boolean;
    FScrollTop: integer;
    FPriority: integer;
    FLoadCount: integer;
    FMemo: string;
    FLastLoadDate: string;
    FLastLoadDate_: string; //12
    FLastSentDate: string;
    FCrypt: string;
    FBookmarkList: TBookmarkList;
    FDownloading: boolean;
    FInVisible: boolean;
    FLastModified: string;
    FAbonedList: TMemIniFile;
    FReadPoint: integer;
    //FShowAll: boolean;
    FCanDownload: boolean;
    FIsBroken: boolean;
    FInLocalFolder: boolean;
    FConfigLoaded: boolean;
    FReleaseRefEvt: TNotifyEvent;
    FAddRefEvt: TNotifyEvent;
    FDestroyEvt: TNotifyEvent;
    FDatDate: string;
    FProfiler: TMonaProfiler;
    FSentCount: integer; //12
    FDatSince: string; //14
    FBoard: TBoard;
    FThreadNo: string;
    function GetBoard: TBoard;
    function GetDatExists: boolean;
    function GetInfExists: boolean; //14
    function GetDatNo: string;
    procedure SetPriority(const Value: integer);
    function GetSortInfo: integer;
    function GetDatSize: integer;
    procedure SetLocalDatFileName(const Value: string);
    function GetLocalDatFileName: string;
    procedure SetIsKakoLog(const Value: boolean);
    function GetDatSince: string; virtual;
    procedure SetDatDate(const Value: string);
    //function GetLastBookmarkDate: string; //7
    procedure SetLastLoadDate(const Value: string);
    procedure SetReadCount(const Value: integer); //12
    procedure SetTitle(const Value: string);
    procedure SetRemoteDatFileName(const Value: string);
  public
    constructor Create;
    destructor Destroy; override;
    function CreateThreadItem(const ASiteID, ABoardID, ADatNo, ATitle: string;
      XSite : TSite = nil; XBoard: TBoard = nil): boolean;
    function  IsAbonedRes(const ResNo: integer): boolean;
    procedure Assign(Source : TThreadItem);
    procedure SaveConfig;
    procedure SaveJaneIdx; //24
    procedure LoadConfig;
    procedure LoadJaneIdx; //24
    procedure AddRef;
    procedure ReleaseRef;
    procedure LoadAbonedList;
    procedure LoadFromFile(var ResList: TResList);
    procedure DeleteLog(DatDelete, InfDelete, OtherDelete, InfClear: boolean);
    property  BBS:  TBBS    read  FBBS    write FBBS;
    property  Site: TSite   read  FSite   write FSite;
    property  Board: TBoard read  GetBoard;
    property  BoardID: string read  FBoardID  write FBoardID;
    property  RefCount: integer read  FRefCount;
    property  No: integer   read  FNo     write FNo;
    property  DatFileName: string read  FDatFileName  write FDatFileName;
    property  DatNo: string read  GetDatNo;
    property  DatSince: string read  GetDatSince  write FDatSince; //15
    property  RemoteDatFileName: string read  FRemoteDatFileName  write SetRemoteDatFileName;
    property  LocalDatFileName: string read  GetLocalDatFileName  write SetLocalDatFileName;
    property  Title: string read FTitle write SetTitle;
    property  AgeCount: integer read FAgeCount write FAgeCount;
    property  IsNew: boolean read FIsNew write FIsNew;
    property  Updated: boolean read FUpdated write FUpdated;
    property  Bold: boolean read  FBold write FBold;
    property  Reverse: boolean  read  FReverse  write FReverse;
    property  Color: TColor read  FColor  write FColor;
    property  IsAboned: boolean  read  FIsAboned  write FIsAboned;
    property  ReadCount: integer  read  FReadCount  write SetReadCount;
    property  DownloadCount: integer  read  FDownloadCount  write FDownloadCount;
    property  DatExists: boolean  read  GetDatExists;
    property  InfExists: boolean  read  GetInfExists; //14
    property  IsKakoLog: boolean read  FIsKakoLog write SetIsKakoLog;
    property  NewCount : integer  read  FNewCount write FNewCount;
    property  ScrollTop: integer  read  FScrollTop  write FScrollTop;
    property  Priority: integer read  FPriority write SetPriority;
    property  Memo: string read  FMemo write FMemo;
    property  Crypt: string read  FCrypt  write FCrypt;
    //property  LastLoadDate: string  read  FLastLoadDate write FLastLoadDate;  //12
    property  LastLoadDate: string  read  FLastLoadDate write SetLastLoadDate;  //12
    property  LastLoadDate_: string  read  FLastLoadDate_ write FLastLoadDate_; //12
    property  LastSentDate: string  read  FLastSentDate write FLastSentDate;
    property  LoadCount: integer  read  FLoadCount  write FLoadCount;
    property  SentCount: integer  read  FSentCount  write FSentCount; //12
    property  BookmarkList: TBookmarkList read  FBookmarkList  write FBookmarkList;
    property  InFavorites: boolean  read  FInFavorites  write FInFavorites;
    property  InShortcut: boolean  read  FInShortcut  write FInShortcut;
    property  SortInfo: integer read  GetSortInfo;
    property  InVisible: boolean  read  FInVisible  write FInVisible; //ځ[񂳂Ĕ\
    property  LastModified: string  read  FLastModified;  //write FLastModified;  
    property  Downloading: boolean  read  FDownloading  write FDownloading;
    property  ReadPoint: integer  read  FReadPoint  write FReadPoint; //܂ł񂾁B
    property  DatSize: integer  read  GetDatSize;
    //property  ShowAll: boolean  read  FShowAll  write FShowAll;
    property  CanDownload: boolean  read  FCanDownload;
    property  IsBroken: boolean read  FIsBroken write FIsBroken; //񎞂ɃG[
    property  InLocalFolder: boolean  read  FInLocalFolder  write FInLocalFolder;
    property  ConfigLoaded: boolean read  FConfigLoaded;
    property  DatDate: string   read  FDatDate  write SetDatDate; //GetDate̒l
    property  Profiler: TMonaProfiler read  FProfiler write FProfiler;
    property  OnAddRef: TNotifyEvent  read  FAddRefEvt  write FAddRefEvt;
    property  OnReleaseRef: TNotifyEvent  read  FReleaseRefEvt  write FReleaseRefEvt;
    property  OnDestroy: TNotifyEvent read  FDestroyEvt write FDestroyEvt;
    //property  LastBookmarkDate: string read GetLastBookmarkDate;  //7
    property  ThreadNo: string read FThreadNo write FThreadNo; 
  end;

  //
  //  :TResList
  //
  TResList = class(TList)
  private
    FLocalDatFileName: string;
    FMegaCrypt: string;
    FThreadItem: TThreadItem;
    FNGResNoList: TStrings;
    //FRefCount: integer;
    function GetRes(index: integer): TRes;
    procedure SetRes(index: integer; const Value: TRes);
    procedure SetNGResNoList(const Value: TStrings);
  public
    constructor Create(AThreadItem: TThreadItem);
    destructor Destroy; override;
    function IsRefNGRes(const ResBody: string): integer;
    function  Add(Value: TRes): integer;
    function  FindRes(const No: integer): TRes;
    //procedure AddRef;
    //procedure ReleaseRef;
    procedure Delete(Index: integer);
    procedure Clear; override;
    procedure SaveToFile(const FileName: string);
    property  Items[index: integer]: TRes read  GetRes  write SetRes; default;
    property  LocalDatFileName: string  read  FLocalDatFileName write FLocalDatFileName;
    property  MegaCrypt: string   read  FMegaCrypt  write FMegaCrypt;
    property  ThreadItem: TThreadItem read  FThreadItem write FThreadItem;
    property  NGResNoList: TStrings read  FNGResNoList  write SetNGResNoList;
  end;

  //
  //  :TRes
  //
  TRes = class(TObject)
  private
    FName  : string;
    FMail  : string;
    FDate  : string;
    FBody  : string;
    FNo    : integer;
    FIsNew : boolean;
    FData  : Pointer;
    FID    : string;
    FThreadTitle: string;
    FBBS: TBBS;
    FSite: TSite;
    FRemoteHost: string;
    FVisible: boolean;
    FIsAboned: boolean;
    FIsNG: boolean;
    FShowing: boolean;
    FIsReadPoint: boolean;
    FIsSiori: boolean;
    FIsChecked: boolean;
    FBodyBk: string;  //9
    FBeID: string;    //11
    FBeLevel: integer;//11
    FImgURL: string;  //26
    FStockURL: string;  //41
    FStockText: string; //41
    procedure SetMail(const Value: string);
    procedure SetID(const Value: string); //11
  public
    constructor Create;
    procedure Assign(Source : TRes);
    property  No: integer       read  FNo     write FNo;
    property  Name: string      read  FName   write FName;
    property  Mail: string      read  FMail   write SetMail;
    property  Date: string      read  FDate   write FDate;
    property  Body: string      read  FBody   write FBody;
    property  IsNew : boolean   read  FIsNew  write FIsNew;
    property  Data  : Pointer   read  FData   write FData;
    //property  ID : string       read  FID     write FID;
    property  ID : string       read  FID     write SetID; //11
    property  BeID: string      read  FBeID   write FBeID; //11
    property  BeLevel: integer  read  FBeLevel  write FBeLevel; //11
    property  RemoteHost: string  read  FRemoteHost write FRemoteHost;
    property  ThreadTitle: string read  FThreadTitle  write FThreadTitle;
    property  BBS: TBBS   read  FBBS  write FBBS;
    property  Site: TSite read  FSite write FSite;
    property  Visible: boolean  read  FVisible  write FVisible;
    property  IsAboned: boolean  read  FIsAboned write FIsAboned;
    property  IsNG: boolean read  FIsNG write FIsNG;
    property  Showing: boolean  read  FShowing  write FShowing; //LbVŕ\͈͊O
    property  IsReadPoint: boolean  read  FIsReadPoint  write FIsReadPoint;
    property  IsSiori: boolean  read  FIsSiori  write FIsSiori;
    property  IsChecked : boolean read  FIsChecked  write FIsChecked; //ANṼ`FbNς݂ǂ
    property  BodyBk: string    read  FBodyBk write FBodyBk; //9 (tB^̃IWibZ[Wۑ)
    property  ImgURL: string    read  FImgURL write FImgURL; //26
    property  StockText: string read  FStockText  write FStockText; //41
    property  StockURL: string read  FStockURL  write FStockURL;  //41
  end;

  //
  //  :TDownloader
  //
  TDownloader = class(TObject)
  private
    FViewObject: TObject;
    FBBS: TBBS;
    FSite: TSite;
    FParamData: Pointer;
    FCharSet: TCharSet;
    FNotModified: boolean;
    FTemp: string;
  protected
    FEndDownloadEvt: TEndDownloadEvt;
    FErrorEvt: TDownloadErrorEvt;
  public
    procedure FireEndDownload(const Error: boolean);
    procedure FireDownloadError(const ErrorCode: integer; ErrorMsg, LastResponse: string);
    property  BBS: TBBS   read  FBBS  write FBBS;
    property  Site: TSite read  FSite write FSite;
    property  ViewObject: TObject read  FViewObject write FViewObject;
    property  ParamData: Pointer  read  FParamData  write FParamData;
    property  CharSet: TCharSet   read  FCharSet    write FCharSet;
    property  NotModified: boolean    read  FNotModified    write FNotModified;
    property  Temp: string  read  FTemp write FTemp;
    property  OnEnd: TEndDownloadEvt  read  FEndDownloadEvt write FEndDownloadEvt;
    property  OnError: TDownloadErrorEvt  read  FErrorEvt write FErrorEvt;
  end;

  //
  //  :TThreadListDownloader
  //
  TThreadListDownloader = class(TDownloader)
  private
    FBoard: TBoard;
    FThreadItemList: TThreadItemList;
    FDataEvt: TThreadListDownloadEvt;
  public
    procedure FireDataEvt(ThreadItem: TThreadItem; Size, TotalSize: integer;
      var MoreData: boolean);
    property  Board: TBoard   read  FBoard    write FBoard;
    property  ThreadItemList: TThreadItemList read  FThreadItemList write FThreadItemList;
    property  OnData: TThreadListDownloadEvt  read  FDataEvt  write FDataEvt;
  end;

  //
  //  :TResDownloader
  //
  TResDownloader = class(TDownloader)
  private
    FBoard: TBoard;
    FResList: TResList;
    FDataEvt: TResDownloadEvt;
    FThreadItem: TThreadItem;
    FOriginalUrl: string;
    FNoCache: boolean;
    FAutoPilot: boolean;
    FCacheReady: boolean;
    FHttpObj: TObject;
    FRedirectEvt: TRedirectEvt; //14
    procedure SetCacheReady(const Value: boolean);
    procedure SetOriginalUrl(const Value: string);
  public
    constructor Create;
    procedure FireDataEvt(Res: TRes; Size, TotalSize: integer);
    procedure FireRedirect(Url: string); //14
    property  Board: TBoard   read  FBoard    write FBoard;
    property  ThreadItem: TThreadItem read  FThreadItem write FThreadItem;
    property  ResList: TResList read  FResList write FResList;
    property  OriginalUrl: string read  FOriginalUrl  write SetOriginalUrl;
    property  NoCache: boolean  read  FNoCache  write FNoCache;
    property  AutoPilot: boolean  read  FAutoPilot  write FAutoPilot;
    property  CacheReady: boolean read  FCacheReady write SetCacheReady;
    property  HttpObj:  TObject read  FHttpObj  write FHttpObj;
    property  OnData: TResDownloadEvt  read  FDataEvt  write FDataEvt;
    property  OnRedirect: TRedirectEvt  read  FRedirectEvt  write FRedirectEvt; //14
  end;

  //
  //  :TBoardListDownloader
  //
  TBoardListDownloader = class(TDownloader)
  private
    //FBoard: TBoard;
    //FThreadItemList: TThreadItemList;
    FDataEvt: TBoardListDownloadEvt;
    FBoardList: TBoardList;
  public
    procedure FireDataEvt(s: string; Size, TotalSize: integer;
      var MoreData: boolean);
    property  BoardList: TBoardList read  FBoardList  write FBoardList;
    property  OnData: TBoardListDownloadEvt  read  FDataEvt  write FDataEvt;
  end;

  //
  //  :TUploader
  //
  TUploader = class(TDownloader)
  private
    FEndUploadEvt: TEndUploadEvt;
    FUploadErrorEvt: TUploadErrorEvt;
    FSendRetryEvt: TSendRetryEvt;
    FResponseText: string;
    FSendData: TSendData;
    FBoard: TBoard;
  protected
  public
    procedure FireEndUpload(const Error: boolean);
    procedure FireUploadError(const ErrorCode: integer; ErrorMsg: string);
    procedure FireSendRetry(RecvStr: string);
    property  OnEnd: TEndUploadEvt  read  FEndUploadEvt write FEndUploadEvt;
    property  OnError: TUploadErrorEvt  read  FUploadErrorEvt write FUploadErrorEvt;
    property  OnSendRetry: TSendRetryEvt  read  FSendRetryEvt write FSendRetryEvt;
    property  Board: TBoard   read  FBoard    write FBoard;
    property  SendData: TSendData read  FSendData write FSendData;
    property  ResponseText: string  read  FResponseText write FResponseText;
  end;

  //
  //  :TResUploader
  //
  TResUploader = class(TUploader)
  private
    //FBoard: TBoard;
    FResList: TResList;
    //FDataEvt: TResDownloadEvt;
    FThreadItem: TThreadItem;
    //FHttpObj: TObject;
    //FSendData: TSendData;
    //FResponseText: string;
  public
    constructor Create;
    destructor Destroy; override;
    //property  Board: TBoard   read  FBoard    write FBoard;
    property  ThreadItem: TThreadItem read  FThreadItem write FThreadItem;
    //property  HttpObj:  TObject read  FHttpObj  write FHttpObj;
    //property  SendData: TSendData read  FSendData write FSendData;
    //property  ResponseText: string  read  FResponseText write FResponseText;
  end;

  //
  //  :TThreadUploader
  //
  TThreadUploader = class(TUploader)
  private
    FContentDate: string;
    //FBoard: TBoard;
    //FHttpObj: TObject;
    //FSendData: TSendData;
    //FResponseText: string;
  public
    constructor Create;
    destructor Destroy; override;
    //property  Board: TBoard   read  FBoard    write FBoard;
    //property  HttpObj:  TObject read  FHttpObj  write FHttpObj;
    property  ContentDate: string read  FContentDate  write FContentDate;
  end;

  //
  //  :TScriptParam
  //
  TScriptParam    = class(TPersistent)
  private
    FParamBBS: string;
    FParamNoFirst: string;
    FParamDat: string;
    FParamStart: string;
    FParamEnd: string;
    FParamRes: string;
    FParamTrue: string;
    FParamFalse: string;

    FValuePre: string;
    FValueSage: string;
    FValueTouhaba: string;

    FUsePathInfo: boolean;
    FPathInfoReadCGI: string;
    FPathInfoParamNofirst: string;
  public
    constructor Create;
    procedure Assign(Source: TPersistent); override;
    property  ParamBBS: string    read  FParamBBS     write FParamBBS;
    property  ParamDat: string    read  FParamDat     write FParamDat;
    property  ParamStart: string  read  FParamStart   write FParamStart;
    property  ParamEnd: string    read  FParamEnd     write FParamEnd;
    property  ParamRes: string    read  FParamRes     write FParamRes;
    property  ParamNoFirst: string  read  FParamNoFirst write FParamNoFirst;
    property  ParamTrue:  string  read  FParamTrue    write FParamTrue;
    property  ParamFalse: string  read  FParamFalse   write FParamFalse;
    property  ValueSage: string   read  FValueSage    write FValueSage;
    property  ValuePre: string    read  FValuePre     write FValuePre;
    property  ValueTouhaba: string  read  FValueTouhaba write FValueTouhaba;

    property  UsePathInfo: boolean  read  FUsePathInfo  write FUsePathInfo;
    property  PathInfoReadCGI: string       read  FPathInfoReadCGI      write FPathInfoReadCGI;
    property  PathInfoParamNofirst: string  read  FPathInfoParamNofirst write FPathInfoParamNofirst;
  end;

  //
  //  :TBookmarkList
  //
  TBookmarkList = class(TList)
  private
    function GetBookmarkRes(index: integer): TBookmarkRes;
    procedure SetBookmarkRes(index: integer; const Value: TBookmarkRes);
  public
    constructor Create;
    destructor  Destroy; override;
    procedure Assign(Source: TObject);
    function  Add(Value: TBookmarkRes): integer;
    function  FindRes(ResNo: integer): TBookmarkRes;
    procedure Delete(Index: integer);
    procedure Clear; override;
    property  Items[index: integer]: TBookmarkRes read GetBookmarkRes write SetBookmarkRes; default;
  end;

  //
  //  :TBookmarkRes
  //
  TBookmarkRes  = class(TPersistent)
  private
    FResNo: integer;
    FBody: string;
    FName: string;
    FDate: string;
    FMemo: string;
    FCategory: string; //13
    FThreadItem: TThreadItem; //15
  public
    procedure Assign(Source: TPersistent); override;
    property  Memo: string    read  FMemo   write FMemo;
    property  ResNo: integer  read  FResNo    write FResNo;
    property  Name: string    read  FName   write FName;
    property  Date: string    read  FDate   write FDate;
    property  Body: string    read  FBody write FBody;
    property  Category: string  read  FCategory write FCategory; //13
    property  ThreadItem: TThreadItem read  FThreadItem  write FThreadItem;  //15
  end;

  //
  //  Mf[^
  //
  TSendData  = class(TObject)
  private
    FBody: string;
    FMail: string;
    FName: string;
    FCrypt: string;
    FSage: boolean;
    FPre: boolean;
    FTouhaba: boolean;
    FBoardID: string;
    FDatNo: string;
    FReferer: string;
    FValuePre: string;
    FValueSage: string;
    FValueTouhaba: string;
    FSubject: string;
    FBoard: TBoard;
    FPassword: string;
    FExtraContent: string;
    FServerDate: string;
  public
    constructor Create;
    function  ConvSendContent(Param: string; AServerDate: string = ''; Sa: integer = 0): string;
    property  Name: string  read  FName write FName;
    property  Mail: string  read  FMail write FMail;
    property  Body: string  read  FBody write FBody;
    property  Crypt: string read  FCrypt  write FCrypt;
    property  Pre: boolean  read  FPre  write FPre;
    property  Sage: boolean read  FSage write FSage;
    property  Touhaba: boolean  read  FTouhaba  write FTouhaba;
    property  Password: string read  FPassword write FPassword;
    property  BoardID: string read  FBoardID  write FBoardID;
    property  DatNo: string read  FDatNo  write FDatNo;
    property  Referer: string read  FReferer  write FReferer;
    property  ValueSage: string read  FValueSage  write FValueSage;
    property  ValuePre: string  read  FValuePre   write FValuePre;
    property  ValueTouhaba: string  read  FValueTouhaba write FValueTouhaba;
    property  Subject: string read  FSubject  write FSubject;
    property  Board: TBoard read  FBoard  write FBoard;
    property  ExtraContent: string  read  FExtraContent write FExtraContent;  //48
    property  ServerDate: string  read  FServerDate write FServerDate;
  end;

  //24
  TStringListLF = class(TStringList)
  public
    //procedure SaveToFile(const FileName: string); override;
    procedure SaveToFileLF(const FileName: string); 
  end;

var
  ZonuEnviron : TZonuEnviron;

implementation

uses
  ZonuDolib,
  ZonuLocal,
  ZonuFavorites,
  Zonu2ch,
  ZonuMegabbs,
  ZonuShitaraba,
  Zonu15ch,
  Zonu12ch,
  ZonuCustom,
  ZonuJbbs,
  ZonuAhhan,
  ZonuMachibbs,
  Zonu1_5ch,
  Zonu2chKakolog,
  //ZonuAmezor,
  ZonuShitarabaJbbs,
  ZonuWeb,
  ZonuRSS,
  //ZonuTheBBS,
  ZonuConf, ZonuHttp, Zonutils, ZonuCommon;

var
  AscendSort  : boolean;

////////////////////////////////////////////////////////////////////////////////
{ TZonuEnviron }
////////////////////////////////////////////////////////////////////////////////

constructor TZonuEnviron.Create;
begin
  FState          :=  asOnline;
  FDisconnected   :=  False;
  FLogStrings     :=  nil;
end;

destructor TZonuEnviron.Destroy;
begin
  FBBSList.Free;
  FSiteList.Free;
  inherited;
end;

procedure TZonuEnviron.LoadSite;
var
  SiteListini, ini : TMemIniFile;
  Site      : TSite;
  BBSType   : string;
  SiteID    : string;
  SiteCount : integer;
  i : integer;
  b : boolean;
  sl: TStringList;
  //s : string;
begin
  FSiteList :=  TSiteList.Create;

  if  (not DirectoryExists(ZonuConfig.UsersPath + PATH_CONFIG)) then  begin
    ForceDirectories(ZonuConfig.UsersPath + PATH_CONFIG);
  end;
  if  (not FileExists(ZonuConfig.UsersPath + INI_SITELIST)) then  begin
    CopyFileEx(ZonuConfig.AppPath + PATH_DEF + INI_SITELIST,
               ZonuConfig.UsersPath + INI_SITELIST,
               True);
  end;

  if  (not DirectoryExists(ZonuConfig.UsersPath + PATH_SITE_CONFIG)) then  begin
    ForceDirectories(ZonuConfig.UsersPath + PATH_SITE_CONFIG);
  end;

  if  (not DirectoryExists(ZonuConfig.UsersPath + PATH_CONFIG + PATH_FAVORITES)) then  begin
    ForceDirectories(ZonuConfig.UsersPath + PATH_CONFIG + PATH_FAVORITES);
    CopyFileEx(ZonuConfig.AppPath + PATH_DEF + PATH_CONFIG + PATH_FAVORITES + '*.*',
               ZonuConfig.UsersPath + PATH_CONFIG + PATH_FAVORITES,
               True);
  end;

  if  (not DirectoryExists(ZonuConfig.UsersPath + PATH_CONFIG + PATH_LOCAL)) then  begin
    ForceDirectories(ZonuConfig.UsersPath + PATH_CONFIG + PATH_LOCAL);
    CopyFileEx(ZonuConfig.AppPath + PATH_DEF + PATH_CONFIG + PATH_LOCAL + '*.*',
               ZonuConfig.UsersPath + PATH_CONFIG + PATH_LOCAL,
               True);
  end;

  if  (not DirectoryExists(ZonuConfig.UsersPath + PATH_CONFIG + PATH_USER)) then  begin
    ForceDirectories(ZonuConfig.UsersPath + PATH_CONFIG + PATH_USER);
    CopyFileEx(ZonuConfig.AppPath + PATH_DEF + PATH_CONFIG + PATH_USER + '*.*',
               ZonuConfig.UsersPath + PATH_CONFIG + PATH_USER,
               True);
  end;

  //14 begin
  if  (not DirectoryExists(ZonuConfig.UsersPath + PATH_CONFIG + PATH_RSS)) then  begin
    ForceDirectories(ZonuConfig.UsersPath + PATH_CONFIG + PATH_RSS);
    CopyFileEx(ZonuConfig.AppPath + PATH_DEF + PATH_CONFIG + PATH_RSS + '*.*',
               ZonuConfig.UsersPath + PATH_CONFIG + PATH_RSS,
               True);
  end;
  //14 end

  FSiteList.Clear;
  SiteListini :=  TMemIniFile.Create(ZonuConfig.AppPath + INI_SITELIST);
  SiteCount   :=  SiteListini.ReadInteger('SITE', 'COUNT', 0);
  for i :=  1 to  SiteCount do  begin
    SiteID    :=  SiteListini.ReadString('SITE', 'SITE' + IntToStr(i), '');
    ini       :=  TMemIniFile.Create(ZonuConfig.AppPath  +
                                     PATH_SITE_CONFIG    +
                                     SiteID + '\' + INI_SITE);
    BBSType   :=  AnsiLowerCase(ini.ReadString('SITE','BBSTYPE', ''));
    Site      :=  TSite.Create(BBSType, SiteID);
    Site.Url  :=  ini.ReadString('SITE', 'URL', '');
    FSiteList.Add(Site);
    ini.Free;
    //22
    Site.LoadBoardList;
  end;
  SiteListini.Free;

  //[U[`TCg
  SiteListini :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_SITELIST);

  //22
  if  (not SiteListini.ReadBool('EX', 'RSS', False))  then  begin
    //14 begin (RSSǉ̃R[h)
    SiteCount   :=  SiteListini.ReadInteger('SITE', 'COUNT', 0);
    b := False;
    for i :=  1 to  SiteCount do  begin
      if  (SameText(SiteListini.ReadString('SITE', 'SITE' + IntToStr(i), ''), 'rss')) then
      begin
        b := True;
        Break;
      end;
    end;
    if  (not b) then begin
      i :=  SiteListini.ReadInteger('SITE','COUNT', 0);
      SiteListini.WriteInteger('SITE','COUNT', i + 1);
      SiteListini.WriteString('SITE', 'SITE' + IntToStr(i + 1), 'rss');
      SiteListini.UpdateFile;
      ForceDirectories(ZonuConfig.UsersPath + PATH_SITE_CONFIG + 'rss');
      sl := TStringList.Create;
      if  (FileExists(ZonuConfig.UsersPath + FILE_USER_BBS))  then  begin
        sl.LoadFromFile(ZonuConfig.UsersPath + FILE_USER_BBS);
      end;

      if  (sl.Count > 0)  then  begin
        sl.Add('rss');
        sl.SaveToFile(ZonuConfig.UsersPath + FILE_USER_BBS);
      end;
    
      sl.Free;
    end;
    //14 end
    SiteListini.WriteBool('EX', 'RSS', True);
    SiteListini.UpdateFile;
  end;

  SiteCount   :=  SiteListini.ReadInteger('SITE', 'COUNT', 0);
  for i :=  1 to  SiteCount do  begin
    SiteID    :=  SiteListini.ReadString('SITE', 'SITE' + IntToStr(i), '');
    ini       :=  TMemIniFile.Create(ZonuConfig.UsersPath  +
                                     PATH_SITE_CONFIG      +
                                     SiteID + '\' + INI_SITE);
    BBSType   :=  AnsiLowerCase(ini.ReadString('SITE','BBSTYPE', ''));
    Site      :=  TSite.Create(BBSType, SiteID,
                               ZonuConfig.UsersPath +
                               PATH_SITE_CONFIG + SiteID + '\');
    Site.Url  :=  ini.ReadString('SITE', 'URL', '');
    FSiteList.Add(Site);
    if  (Site.SiteType = stFavorites)  then  begin
      FFavoritesSite  :=  Site;
    end else
    if  (Site.SiteType  = stLocal)  then  begin
      FLocalSite :=  Site;
    end else
    if  (Site.SiteType  = stUser) then  begin
      FUserSite :=  Site;
    end else
    //14 begin
    if  (Site.SiteType  = stRSS) then  begin
      FRssSite :=  Site;
    //14 end;
    end;
    ini.Free;
    //22
    if  (Site <> FavoritesSite) then  begin
      Site.LoadBoardList;
    end;
  end;
  SiteListini.Free;

  //22
  {
  for i :=  0 to  FSiteList.Count - 1 do  begin
    if  (FSiteList[i] <> FavoritesSite) then  begin
      FSiteList[i].LoadBoardList;
    end;
  end;
  }
  if  (FavoritesSite <> nil) then  begin
    FavoritesSite.LoadBoardList;  //Cɓ͍ŌɁîaar̔QƂĂꍇ邩j
  end;
end;


function TZonuEnviron.GetCached: boolean;
begin
  Result  :=  ZonuConfig.Cached;
end;

procedure TZonuEnviron.SetCached(const Value: boolean);
begin
  ZonuConfig.Cached :=  Value;
end;

procedure TZonuEnviron.LoadBBS;
begin
  FBBSList  :=  TBBSList.Create;
  BBSList.Add(TLocalScript.Create(BBS_LOCAL));
  BBSList.Add(TFavoritesScript.Create(BBS_FAVORITES));
  BBSList.Add(TDolibScript.Create(BBS_DOLIB));
  BBSList.Add(T2chScript.Create(BBS_2CH));
  BBSList.Add(TJbbsScript.Create(BBS_JBBS));
  BBSList.Add(TMegabbsScript.Create(BBS_MEGABBS));
  BBSList.Add(TShitarabaScript.Create(BBS_SHITARABA));
  BBSList.Add(T15chScript.Create(BBS_15CH));
  BBSList.Add(T12chScript.Create(BBS_12CH));
  BBSList.Add(TAhhanScript.Create(BBS_AHHAN));
  BBSList.Add(TMachibbsScript.Create(BBS_MACHIBBS));
  BBSList.Add(T1_5chScript.Create(BBS_1_5CH));
  BBSList.Add(T2chKakolog.Create(BBS_2CHKAKOLOG));
  //BBSList.Add(TShitarabaJbbsScript.Create(BBS_SHITARABAJBBS));  bata
  //BBSList.Add(TAmezorScript.Create(BBS_AMEZOR));
  BBSList.Add(TWebScript.Create(BBS_WEB));  //14
  BBSList.Add(TRssScript.Create(BBS_RSS));  //14
  //BBSList.Add(TTheBBSScript.Create(BBS_THEBBS));  //30
  BBSList.LoadPluginBBS;
end;

////////////////////////////////////////////////////////////////////////////////
{ TBBSList }
////////////////////////////////////////////////////////////////////////////////

function TBBSList.Add(Value: TBBS): integer;
begin
  Result  :=  inherited Add(Value);
end;

procedure TBBSList.Clear;
var
  i : integer;
begin
  for i :=  Count - 1 downto  0 do  begin
    Delete(i);
  end;
  inherited;
end;

procedure TBBSList.Delete(Index: integer);
begin
  TBBS(Items[Index]).Free;
  inherited Delete(Index);
end;

destructor TBBSList.Destroy;
begin
  Clear;
  inherited;
end;

function TBBSList.FindBBS(ABBSClass: TBBSClass): TBBS;
var
  i : integer;
begin
  Result  :=  nil;
  for i :=  0 to  Count - 1 do  begin
    if  (Items[i] is ABBSClass) then  begin
      Result  :=  Items[i];
      Break;
    end;
  end;
end;

function TBBSList.FindBBS(const ABBSID: string): TBBS;
var
  i : integer;
begin
  Result  :=  nil;
  for i :=  0 to  Count - 1 do  begin
    if  (AnsiLowerCase(Items[i].BBSID) = AnsiLowerCase(ABBSID)) then  begin
      Result  :=  Items[i];
      Break;
    end;
  end;
end;

function TBBSList.GetBBS(index: integer): TBBS;
begin
  Result  :=  TBBS(inherited Items[index]);
end;

procedure TBBSList.LoadPluginBBS;
var
  ini, bbs : TMemIniFile;
  CustomScript : TCustomScript;
  i : integer;
  s, sx : string;
begin
  ini :=  TMemIniFile.Create(ZonuConfig.AppPath + INI_BBSLIST);
  for i :=  0 to  ini.ReadInteger('BBS', 'COUNT', 0)  do  begin
    s :=  ini.ReadString('BBS', 'BBS' + IntToStr(i + 1), '');
    if  (s <> '') then  begin
      //łɓo^ς݂ID́ATCustomScriptpĂ邶Ȃ
      if  (ZonuEnviron.BBSList.FindBBS(s) = nil)  then  begin
        sx  :=  ZonuConfig.AppPath + PATH_BBS_CONFIG + s + '\' + INI_BBS;
        if  (FileExists(sx))  then  begin
          bbs :=  TMemIniFile.Create(sx);
          CustomScript  :=  TCustomScript.Create(bbs.ReadString('SCRIPT', 'ID', ''));
          CustomScript.ParseThreadSource  :=  ZonuConfig.AppPath + PATH_BBS_CONFIG + s + '\' + FILE_PARSE_THREAD;
          CustomScript.ParseResSource     :=  ZonuConfig.AppPath + PATH_BBS_CONFIG + s + '\' + FILE_PARSE_RES;
          Add(CustomScript);
          bbs.Free;
        end;
      end else begin
        sx  :=  ZonuConfig.AppPath + PATH_BBS_CONFIG + s + '\' + INI_BBS;
        if  (FileExists(sx))  then  begin
          bbs :=  TMemIniFile.Create(sx);
          CustomScript  :=  TCustomScript(ZonuEnviron.BBSList.FindBBS(s));
          CustomScript.ParseThreadSource  :=  ZonuConfig.AppPath + PATH_BBS_CONFIG + s + '\' + FILE_PARSE_THREAD;
          CustomScript.ParseResSource     :=  ZonuConfig.AppPath + PATH_BBS_CONFIG + s + '\' + FILE_PARSE_RES;
          bbs.Free;
        end;
      end;
    end;
  end;
  ini.Free;
end;

procedure TBBSList.SetBBS(index: integer; const Value: TBBS);
begin
  inherited Items[index]  :=  Value;
end;

////////////////////////////////////////////////////////////////////////////////
{ TSiteList }
////////////////////////////////////////////////////////////////////////////////

function TSiteList.Add(Value: TSite): integer;
begin
  Result  :=  inherited Add(Value);
end;

procedure TSiteList.Clear;
var
  i : integer;
begin
  for i :=  Count - 1 downto  0 do  begin
    Delete(i);
  end;
  inherited;
end;

procedure TSiteList.Delete(Index: integer);
begin
  TSite(Items[Index]).Free;
  inherited Delete(Index);
end;

destructor TSiteList.Destroy;
begin
  Clear;
  inherited;
end;

function TSiteList.FindBoard(const BoardPath, BoardID: string;
  var Board: TBoard): boolean;
var
  ABoard  : TBoard;
  i : integer;
begin
  Result  :=  False;
  for i :=  0 to  Count - 1 do  begin
    if  (Items[i] <> ZonuEnviron.FavoritesSite) then  begin
      if  (Items[i].BoardList.FindBoardFromBoardPath(BoardPath, BoardID, ABoard)) then  begin
        Board   :=  ABoard;
        Result  :=  True;
        Break;
      end;
    end;
  end;
end;

function TSiteList.FindBoard(const URL: string; var Board: TBoard): boolean;
var
  ABoard  : TBoard;
  i : integer;
begin
  Result  :=  False;
  for i :=  0 to  Count - 1 do  begin
    if  (Items[i] <> ZonuEnviron.FavoritesSite) then  begin
      if  (Items[i].BoardList.FindBoardFromURL(URL, ABoard)) then  begin
        Board   :=  ABoard;
        Result  :=  True;
        Break;
      end;
    end;
  end;
end;

function TSiteList.FindSite(const SiteID: string;
  var Site: TSite): boolean;
var
  i : integer;
begin
  Result  :=  False;
  for i :=  0 to  Count - 1 do  begin
    if  (SiteID = Items[i].SiteID)  then  begin
      Result  :=  True;
      Site    :=  Items[i];
      Break;
    end;
  end;
end;

function TSiteList.GetSite(index: integer): TSite;
begin
  Result  :=  TSite(inherited Items[index]);
end;

procedure TSiteList.SetSite(index: integer; const Value: TSite);
begin
  inherited Items[index]  :=  Value;
end;

////////////////////////////////////////////////////////////////////////////////
{ TSite }
////////////////////////////////////////////////////////////////////////////////

constructor TSite.Create(const ABBSID, Path: string; AConfigPath: string = '');
begin
  BBS         :=  ZonuEnviron.BBSList.FindBBS(ABBSID);
  if  (AConfigPath = '')  then  begin
    FConfigPath :=  ZonuConfig.AppPath + PATH_SITE_CONFIG + Path + '\';
  end else begin
    FConfigPath :=  AConfigPath;
  end;

  FSiteIni    :=  TMemIniFile.Create(FConfigPath + INI_SITE);
  FSiteName   :=  FSiteIni.ReadString('SITE', 'NAME', '');
  FSiteID     :=  FSiteIni.ReadString('SITE', 'SITEID', '');
  FIncludeUrl :=  FSiteIni.ReadString('SITE', 'INCLUDE', '');
  FSiteType   :=  stNormal;
  if  (ABBSID = BBS_FAVORITES)  then  begin
    FSiteType   :=  stFavorites;
  end else
  if  (ABBSID = BBS_LOCAL)  then  begin
    FSiteType   :=  stLocal;
  end else
  //14 begin
  if  (ABBSID = BBS_RSS)  then  begin
    FSiteType   :=  stRSS;
  end else
  //14 end
  if  (FSiteIni.ReadBool('SITE', 'USERSITE', False))  then  begin
    FSiteType   :=  stUser;
  end;

  FIsSubscription :=  False;
  //18 begin
  {
  s           :=  AnsiUpperCase(FSiteIni.ReadString('SITE', 'CHARSET', 'SJIS'));
  if  (s = 'SJIS')  then  begin
    FCharSet  :=  csSJIS;
  end else
  if  (s = 'EUC')   then  begin
    FCharSet  :=  csEUC;
  end else
  if  (s = 'UTF8')   then  begin //14
    FCharSet  :=  csUTF8;        //14
  end else begin
    FCharSet  :=  csSJIS;
  end;
  }
  FCharSet  :=  TextToCharset(FSiteIni.ReadString('SITE', 'CHARSET', 'SJIS'));
  //18 end
  FNinkinetID :=  FSiteIni.ReadString('NINKINET', 'ID', '');

  FBoardList  :=  TBoardList.Create;
  FBoardList.Site :=  Self;
  FBoardList.BBS  :=  BBS;
  FImage      :=  TBitmap.Create;
end;

destructor TSite.Destroy;
begin
  if  (FBoardList <> nil) then  begin
    FBoardList.Clear;
    FBoardList.Free;
  end;
  FSiteIni.Free;
  FImage.Free;
  inherited;
end;

function TSite.GetCachePath: string;
begin
  Result  :=  ZonuConfig.CachePath + SiteID + '\';
end;

function TSite.GetLocalRuleUrl(Board: TBoard): string;
var
  BBSini : TMemIniFile;
  s : string;
begin
  BBSini  :=  TMemIniFile.Create(ConfigPath + INI_SITE);
  s :=  BBSini.ReadString('SITE', 'LOCALRULE', '');
  if  (s <> '') and (Board <> nil)  then  begin
    s :=  StringReplace(s, '<host>',
                        ExtractHostName(Board.Url),
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<bbs>',
                        Board.BoardID,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<boardpath>',
                        Board.BoardPath,
                        [rfReplaceAll, rfIgnoreCase]);
  end;
  Result  :=  S;
  BBSini.Free;
end;

function TSite.IsInclude(const AUrl: string): boolean;
var
  xIncludeUrl, xUrl : string;
  lstIncludes, lstInclude, lstUrl : TStringList;
  x, i : integer;
  ok : boolean;
begin
  lstIncludes :=  TStringList.Create;
  lstInclude  :=  TStringList.Create;
  lstUrl      :=  TStringList.Create;

  if  (Copy(AUrl, Length(AUrl), 1) = '/') then  begin
    xUrl  :=  Copy(AUrl, 1, Length(AUrl) - 1);
  end else begin
    xUrl  :=  AUrl;
  end;
  if  (AnsiPos('http://*.', IncludeUrl) > 0) then  begin
    //܂BBSȂ
  end else begin
    //megabbsȂ
    xUrl  :=  StringReplace(xUrl,  'http://www.', 'http://', [rfReplaceAll, rfIgnoreCase]);
  end;
  xUrl  :=  StringReplace(xUrl, '/', ',', [rfReplaceAll]);
  xUrl  :=  StringReplace(xUrl, '.', ',', [rfReplaceAll]);

  Result  :=  False;
  lstIncludes.CommaText :=  IncludeUrl;
  for x :=  0 to  lstIncludes.Count - 1 do  begin
    if  (Copy(lstIncludes[x], Length(lstIncludes[x]), 1) = '/') then  begin
      xIncludeUrl  :=  Copy(lstIncludes[x], 1, Length(lstIncludes[x]) - 1);
    end else begin
      xIncludeUrl  :=  lstIncludes[x];
    end;
    if  (AnsiPos('http://*.', IncludeUrl) > 0) then  begin
      //܂BBSȂ
    end else begin
      //megabbsȂ
      xIncludeUrl :=  StringReplace(xIncludeUrl,   'http://www.', 'http://', [rfReplaceAll, rfIgnoreCase]);
    end;
    xIncludeUrl :=  StringReplace(xIncludeUrl,  '/', ',', [rfReplaceAll]);
    xIncludeUrl :=  StringReplace(xIncludeUrl,  '.', ',', [rfReplaceAll]);

    lstInclude.CommaText  :=  xIncludeUrl;
    lstUrl.CommaText  :=  xUrl;

    if  (lstInclude.Count > lstUrl.Count) then  Continue;
    ok := True;
    for i :=  0 to  lstInclude.Count - 1  do  begin
      if  (lstInclude[i] <> '*')  and
          (lstInclude[i] <> lstUrl[i])  then
      begin
        ok := False;
        Break;
      end;
    end;
    if  (ok)  then  begin
      Result  :=  True;
      Break;
    end;
  end;
  lstIncludes.Free;
  lstInclude.Free;
  lstUrl.Free;
end;

procedure TSite.LoadBoardList;
var
  Board         : TBoard;
  ABoard        : TBoard;
  CategoryName  : string;
  Expanded      : string;
  List          : TStringList;
  i : integer;
  s : string;
  ID: string;
  cn: string;
begin
  FBoardList.Clear;
  List  :=  TStringList.Create;
  CategoryName  :=  '';
  Expanded      :=  '0';
  try
    if  (FileExists(ZonuConfig.UsersPath + 'config\site\' + SiteID + '\' + FILE_BOARD)) then begin
      List.LoadFromFile(ZonuConfig.UsersPath + 'config\site\' + SiteID + '\' +  FILE_BOARD);
      if  (List.Count > 1)  then  begin
        if  (List[0] = '2') then  begin
          for i :=  1 to  List.Count - 1  do  begin
            if  (List[i] <> '') then  begin
              if  (List[i][1] <> #9)  then  begin
                CategoryName  :=  ChooseString(List[i], #9, 0);
                Expanded      :=  ChooseString(List[i], #9, 1);
              end else begin
                Board               :=  TBoard.Create;
                Board.BoardType     :=  btBBSBoard;
                Board.Site          :=  Self;
                Board.Name          :=  ChooseString(List[i], #9, 3);
                Board.BoardPath     :=  ChooseString(List[i], #9, 1);
                ID  :=  ChooseString(List[i], #9, 2);
                if  (Board.BoardPath  = BOARDPATH_FAV)  then  begin
                  //Cɓ
                  Board.BoardPath     :=  ZonuConfig.UsersPath + PATH_CONFIG + PATH_FAVORITES;
                  Board.BoardType     :=  btFavorites;
                  Board.RemoteBoardID :=  ID;
                  Board.BoardID       :=  ID;
                end else
                if  (AnsiPos('>', ID) = 0)  then  begin
                  //GAXݒ
                  Board.RemoteBoardID :=  ID;
                  Board.BoardID       :=  ID;
                end else begin
                  Board.RemoteBoardID :=  Copy(ID, 1, AnsiPos('>', ID) - 1);
                  Board.BoardID       :=  Copy(ID, AnsiPos('>', ID) + 1, Length(ID));
                end;
                Board.Key         :=  ID; //22 ChooseString(List[i], #9, 2);
                Board.Expanded    :=  (Expanded = '1');
                Board.CategoryName:=  CategoryName;
                Board.BBS         :=  BBS;
                Board.CharSet     :=  CharSet;
                //̑BBSp
                //XNvg
                s :=  ChooseString(List[i], #9, 4);
                if  (AnsiLowerCase(s) = 'www') then  begin
                  Board.BoardType :=  btWebPage;
                end else
                if  (AnsiLowerCase(s) = 'rss') then  begin  //15
                  Board.BoardType :=  btRss;                //15
                end else                                    //15
                if  (s <> '') then  begin
                  Board.BBS :=  ZonuEnviron.BBSList.FindBBS(s);
                end;
                if  (Board.BBS = nil) then  begin
                  Board.Free;
                  Continue;
                end;
                //CɓL̏
                if  (Self.BBS.BBSID = BBS_FAVORITES)  then  begin
                  //22 if  (ZonuEnviron.SiteList.FindBoard(ChooseString(List[i], #9, 1), ChooseString(List[i], #9, 2), ABoard))  then  begin
                  if  (ZonuEnviron.SiteList.FindBoard(Board.BoardPath, ID, ABoard))  then  begin
                    cn  :=  Board.CategoryName;
                    Board.BBS   :=  ABoard.BBS;
                    Board.Site  :=  ABoard.Site;
                    Board.Assign(ABoard);
                    Board.CategoryName  :=  cn;
                  end;
                end;
                //R[h
                //18 begin
                {
                s :=  AnsiUpperCase(ChooseString(List[i], #9, 6));
                if  (s = 'SJIS') then  begin
                  Board.CharSet :=  csSJIS;
                end else
                if  (s = 'EUC') then  begin
                  Board.CharSet :=  csEUC;
                end else
                if  (s = 'UTF8') then  begin  //14
                  Board.CharSet :=  csUTF8;   //14
                end;
                }
                s :=  ChooseString(List[i], #9, 6);
                if  (s <> '') then  begin
                  //22 Board.CharSet :=  TextToCharset(ChooseString(List[i], #9, 6));
                  Board.CharSet :=  TextToCharset(s);
                end;
                //18 end
                
                //{[hpX
                //OutputDebugString(PChar(Board.Name));
                if  (AnsiLowerCase(BBS.BBSID)  =  BBS_LOCAL) or
                    (Board.BBS.BBSID  = BBS_LOCAL) then
                begin
                  //[JpX
                  //22  Board.Url         :=  IncludeTrailingPathDelimiter(ChooseString(List[i], #9, 1));
                  Board.Url         :=  IncludeTrailingPathDelimiter(Board.BoardPath);
                  Board.CachePath   :=  Board.Url;
                  Board.BoardType   :=  btLocalFolder;
                end else begin
                  if  (Board.BoardType = btWebPage) then  begin
                    //Weby[W
                    Board.Url       :=  Board.BoardPath;
                  end else
                  if  (Board.BoardType = btFavorites) then  begin
                    Board.Url       :=  '';
                    Board.CachePath :=  Board.BoardPath;
                  end else
                  //15 begin
                  if  (Board.BoardType = btRSS) then  begin
                    //22  Board.Url       :=  'http://' + ChooseString(List[i], #9, 1) + '/' + StringReplace(Board.BoardID,'@','/',[rfReplaceAll]);
                    Board.Url       :=  'http://' + Board.BoardPath + '/' + StringReplace(Board.BoardID,'@','/',[rfReplaceAll]);
                    //22 s :=  UrlToFileName(ChooseString(List[i], #9, 1) + '_' + Board.RemoteBoardID);
                    s :=  UrlToFileName(Board.BoardPath + '_' + Board.RemoteBoardID);
                    //s :=  s + '_' + UrlToFileName(Board.RemoteBoardID);
                    Board.CachePath :=  ZonuConfig.CachePath + 'rss\' + s + '\';
                    //15 end
                  end else begin
                    //22  s :=  ChooseString(List[i], #9, 1);
                    s :=  Board.BoardPath;
                    //15 begin
                    if  (AnsiLowerCase(s) = '<null>') then  begin
                      Board.Url   :=  Board.BBS.GetSubjectUrl(Board);
                    end else begin
                      Board.Url   :=  'http://' + s + '/' + Board.BoardID + '/';
                    end;
                    //15 end
                    s :=  ChooseString(List[i], #9, 5);
                    if  (s <> '') then  begin
                      s :=  StringReplace(s, '<boardid>', Board.BoardID, [rfReplaceAll, rfIgnoreCase]);
                      Board.CachePath :=  ZonuConfig.CachePath + s;
                    end;
                  end;
                end;

                Board.Gaishutu    :=  DirectoryExists(Board.CachePath);
                FBoardList.Add(Board);
              end;
            end;
          end;
        end else begin
          raise EZonuError.Create('m̌`̃{[ht@C' + #13#10 +
                                  ConfigPath + FILE_BOARD);
        end;
      end else begin
        {
        raise EZonuError.Create('{[ht@CςB' + #13#10 +
                                ConfigPath + FILE_BOARD);
        }
      end;
    end else begin
      {
      raise EZonuError.Create('{[ht@CB' + #13#10 +
                              ConfigPath + FILE_BOARD);
      }
    end;
  finally
    List.Free;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
{ TBBS }
////////////////////////////////////////////////////////////////////////////////

constructor TBBS.Create(const ABBSID: string);
begin
  FBBSID          :=  ABBSID;
  FConfigPath     :=  ZonuConfig.AppPath + PATH_BBS_CONFIG + FBBSID + '\';
  UpdateSetting;
end;

destructor TBBS.Destroy;
begin
  FSendParam.Free;
  FNewThreadParam.Free;
  inherited;
end;

//
//  subject.txtURL
//
function TBBS.GetSubjectUrl(Board: TBoard;
  const PageIndex: integer = 0): string;
var
  BBSini  : TMemIniFile;
  Siteini : TMemIniFile;
  s : string;
begin
  BBSini  :=  TMemIniFile.Create(ConfigPath + INI_BBS);
  Siteini :=  TMemIniFile.Create(Board.Site.ConfigPath + INI_SITE);
  //
  //  subject.txt̃pXݒ
  //
  s   :=  Siteini.ReadString('SUBJECT', ExtractHostName(Board.Url), '');
  if  (s = '')  then  begin
    s   :=  BBSini.ReadString('SUBJECT', ExtractHostName(Board.Url), '');
    if  (s = '')  then  begin
      s :=  Siteini.ReadString('SUBJECT', '*', '');
      if  (s = '')  then  begin
        s :=  BBSini.ReadString('SUBJECT', '*', '');
        //14 begin
        if  (s = '')  then  begin
          s :=  Siteini.ReadString('SUBJECT', '*', '');
        end;
        //14 end
      end;
    end;
  end;

  if  (s <> '') then  begin
    s :=  StringReplace(s, '<host>',
                        ExtractHostName(Board.Url),
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<bbs>',
                        Board.RemoteBoardID,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<boardpath>',
                        Board.BoardPath,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<page>',
                        IntToStr(PageIndex),
                        [rfReplaceAll, rfIgnoreCase]);
  end else begin
    s :=  '';
  end;
  BBSini.Free;
  SiteIni.Free;
  Result  :=  s;
end;

//
//  DATURL
//
function TBBS.GetDatUrl(ThreadItem: TThreadItem): string;
begin
  Result  :=  GetDatUrl(ThreadItem.Board, ThreadItem.DatNo);
end;

//
//  DATURL
//
function  TBBS.GetDatUrl(Board: TBoard; DatNo: string): string;
var
  SiteIni, BBSini : TMemIniFile;
  s : string;
begin
  BBSini  :=  TMemIniFile.Create(ConfigPath + INI_BBS);
  Siteini :=  TMemIniFile.Create(Board.Site.ConfigPath + INI_SITE);
  //
  //  DAT̃pXݒ
  //
  s   :=  Siteini.ReadString('DAT', ExtractHostName(Board.Url), '');
  if  (s = '')  then  begin
    s   :=  BBSini.ReadString('DAT', ExtractHostName(Board.Url), '');
    if  (s = '')  then  begin
      s   :=  Siteini.ReadString('DAT', '*', '');
      if  (s = '')  then  begin
        s :=  BBSini.ReadString('DAT', '*', '');
      end;
    end;
  end;
  if  (s <> '') then  begin
    s :=  StringReplace(s, '<host>',
                        ExtractHostName(Board.Url),
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<bbs>',
                        Board.RemoteBoardID,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<boardpath>',
                        Board.BoardPath,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<dat>',
                        ExtractDatNo(DatNo),
                        [rfReplaceAll, rfIgnoreCase]);
  end else begin
    s :=  '';
  end;
  BBSini.Free;
  Siteini.Free;
  Result  :=  s;
end;

//
//  read.cgi URL
//
function TBBS.GetReadCgiUrl: string;
var
  s : string;
  n : integer;
begin
  s :=  GetReadCgiUrl(nil, '');
  n :=  AnsiPos('?', s);
  if  (n > 0) then  begin
    s :=  Copy(s, 1, n - 1);
  end;
  Result  :=  s;
end;

//
//  read.cgi URL
//
function TBBS.GetReadCgiUrl(ThreadItem: TThreadItem): string;
begin
  Result  :=  GetReadCgiUrl(ThreadItem.Board, ThreadItem.DatNo);
end;

//
//  read.cgi URL
//
function  TBBS.GetReadCgiUrl(Board: TBoard; DatNo: string): string;
var
  SiteIni, BBSini : TMemIniFile;
  s : string;
begin
  BBSini  :=  TMemIniFile.Create(ConfigPath + INI_BBS);
  if  (Board <> nil)  then  begin
    Siteini :=  TMemIniFile.Create(Board.Site.ConfigPath + INI_SITE);
  end else begin
    Siteini :=  nil;
  end;
  //
  //  read.cgĩpXݒ
  //
  s := '';
  if  (Board <> nil) then begin
    s   :=  Siteini.ReadString('READCGI', ExtractHostName(Board.Url), '');
    if  (s = '')  then  begin
      s   :=  BBSini.ReadString('READCGI', ExtractHostName(Board.Url), '');
    end;
  end;
  if  (s = '')  then  begin
    s :=  BBSini.ReadString('READCGI', '*', '');
  end;
  //
  if  (s <> '') then  begin
    //
    //  p[^̕ϊ
    //
    s :=  StringReplace(s, '<PARAM_BBS>',
                        FSendParam.ParamBBS,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<PARAM_DAT>',
                        FSendParam.ParamDat,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<PARAM_START>',
                        FSendParam.ParamStart,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<PARAM_END>',
                        FSendParam.ParamEnd,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<PARAM_RES>',
                        FSendParam.ParamRes,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<PARAM_NOFIRST>',
                        FSendParam.ParamNoFirst,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<PARAM_TRUE>',
                        FSendParam.ParamTrue,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<PARAM_FALSE>',
                        FSendParam.ParamFalse,
                        [rfReplaceAll, rfIgnoreCase]);
    //
    //  READ.CGI̕ϊ
    //

    if  (Board <> nil)  then  begin
      s :=  StringReplace(s, '<host>',
                          ExtractHostName(Board.Url),
                          [rfReplaceAll, rfIgnoreCase]);
    end;
    if  (Board <> nil)  then  begin
      s :=  StringReplace(s, '<bbs>',
                          Board.RemoteBoardID,
                          [rfReplaceAll, rfIgnoreCase]);
    end;
    if  (Board <> nil)  then  begin
      s :=  StringReplace(s, '<boardpath>',
                          Board.BoardPath,
                          [rfReplaceAll, rfIgnoreCase]);
    end;
    if  (Board <> nil)  then  begin
      s :=  StringReplace(s, '<dir>',
                          Board.Dir,
                          [rfReplaceAll, rfIgnoreCase]);
    end;
    if  (DatNo <> '')  then  begin
      s :=  StringReplace(s, '<dat>',
                          ExtractDatNo(DatNo),
                          [rfReplaceAll, rfIgnoreCase]);
    end;
  end else begin
    s :=  '';
  end;
  BBSini.Free;
  if  (Siteini <> nil)  then  Siteini.Free;
  Result  :=  s;
end;


function TBBS.GetRemoteDatFileName(ThreadItem: TThreadItem): string;
begin
  if  (ThreadDownlaodMode = dmText)  then  begin
    Result  :=  GetDatUrl(ThreadItem.Board, ThreadItem.DatNo);
  end else begin
    Result  :=  GetReadCgiUrl(ThreadItem);
  end;
end;

function TBBS.GetResUrl(ThreadItem: TThreadItem; const StartNo,
  ToNo: integer; const NoFirst: boolean = True): string;
var
  ini: TMemIniFile;
  s: string;
  nf: string;
begin
  s   :=  GetReadCgiUrl(ThreadItem);
  ini :=  TMemIniFile.Create(ConfigPath + INI_BBS);
  s   :=  s + Format('&%s=%d&%s=%d',
                     [ini.ReadString('PARAM', 'PARAM_START', 'st'),
                      StartNo,
                      ini.ReadString('PARAM', 'PARAM_END', 'to'),
                      ToNo
                     ]);
  if  (ini.ReadString('PARAM', 'PARAM_NOFIRST', '') <> '')  then  begin
    if  (NoFirst) then  begin
      nf  :=  ini.ReadString('PARAM', 'PARAM_TRUE', 'true');
    end else begin
      nf  :=  ini.ReadString('PARAM', 'PARAM_FALSE', 'false');
    end;
    s :=  s + Format('&%s=%s',
                     [ini.ReadString('PARAM', 'PARAM_NOFIRST', 'nofirst'),
                      nf]);
  end;
  ini.Free;
  Result  :=  s;
end;

procedure TBBS.ZonuDataThreadList(Sender: TObject; Downloader: TDownloader;
  Data: string; TotalSize, DownloadSize: integer; var MoreData: boolean);
begin

end;

procedure TBBS.ZonuEndThreadList(Sender: TObject; Downloader: TDownloader;
  Error: boolean);
begin
  Downloader.NotModified  :=  (TZonuHttp(Sender).StatusCode = 304);
  Downloader.FireEndDownload(Error);
end;

procedure TBBS.ZonuThreadListError(Sender: TObject;
  Downloader: TDownloader; ErrorCode: integer; ErrorMsg, LastResponse: string);
begin
  Downloader.FireDownloadError(ErrorCode, ErrorMsg, LastResponse);
end;

procedure TBBS.DownloadNextThreadList(Downloader: TThreadListDownloader;
  const PageIndex: integer);
begin
  //
end;

procedure TBBS.ZonuDataRes(Sender: TObject; Downloader: TDownloader;
  Data: string; TotalSize, DownloadSize: integer; var MoreData: boolean);
begin
  //
end;

procedure TBBS.ZonuEndRes(Sender: TObject; Downloader: TDownloader;
  Error: boolean);
var
  inf : TMemIniFile;
  ThreadItem : TThreadItem;
  s: string;
begin
  ThreadItem := TResDownloader(Downloader).ThreadItem;
  if  (Sender is TZonuHttp) then  begin
    Downloader.NotModified  :=  (TZonuHttp(Sender).StatusCode = 304);
    if  (ThreadItem.DatDate = '')  then  begin
      ThreadItem.DatDate :=  TZonuHttp(Sender).ContentDate;
    end;
  end;
  if  (ZonuEnviron.Cached) and (not Error) and (not Downloader.NotModified) then  begin
    s :=  ExtractFilePath(ThreadItem.LocalDatFileName);
    if  (not DirectoryExists(s)) and (s <> '')  then  begin
      ForceDirectories(s);
    end;
    //
    if  (s <> '') then  begin
      ThreadItem.LastLoadDate :=  FormatDateTime('yyyy/mm/dd hh:nn:ss', Now);
      inf :=  TMemIniFile.Create(ChangeFileExt(ThreadItem.LocalDatFileName, '.inf'));
      inf.WriteInteger('LOG', 'COUNT', ThreadItem.DownloadCount);
      inf.WriteString('LOG', 'TITLE', ThreadItem.Title);
      inf.WriteString('LOG', 'BOARDID', ThreadItem.BoardID);
      inf.WriteString('LOG', 'LAST_LOAD', ThreadItem.LastLoadDate);
      inf.UpdateFile;
      inf.Free;
    end;
    //ThreadItem.DownloadCount := ThreadItem.DownloadCount + TResDownloader(Downloader).ResList.Count;
  end;
  Downloader.FireEndDownload(Error);
end;

procedure TBBS.ZonuResError(Sender: TObject; Downloader: TDownloader;
  ErrorCode: integer; ErrorMsg, LastResponse: string);
begin
  Downloader.FireDownloadError(ErrorCode, ErrorMsg, LastResponse);
end;

function TBBS.ConvUrl(const Url: string): string;
begin
  Result  :=  Url;
end;

function TBBS.GetSendUrl(Board: TBoard; ThreadItem: TThreadItem): string;
var
  SiteIni, BBSini : TMemIniFile;
  s : string;
begin
  BBSini  :=  TMemIniFile.Create(ConfigPath + INI_BBS);
  Siteini :=  TMemIniFile.Create(Board.Site.ConfigPath + INI_SITE);
  //
  //  send.cgĩpXݒ
  //
  s   :=  Siteini.ReadString('SENDCGI', ExtractHostName(Board.Url), '');
  if  (s = '')  then  begin
    s   :=  BBSini.ReadString('SENDCGI', ExtractHostName(Board.Url), '');
    if  (s = '')  then  begin
      s :=  BBSini.ReadString('SENDCGI', '*', '');
    end;
    if  (s = '')  then  begin
      s :=  Siteini.ReadString('SENDCGI', '*', '');
    end;
  end;
  if  (s <> '') then  begin
    s :=  StringReplace(s, '<host>',
                        ExtractHostName(Board.Url),
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<bbs>',
                        Board.RemoteBoardID,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<boardpath>',
                        Board.BoardPath,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<dir>',   //JBBSp
                        Board.Dir,
                        [rfReplaceAll, rfIgnoreCase]);
    if  (ThreadItem <> nil) then  begin
      s :=  StringReplace(s, '<dat>', 
                          ThreadItem.DatNo,
                          [rfReplaceAll, rfIgnoreCase]);
    end;
  end else begin
    s :=  '';
  end;
  BBSini.Free;
  Siteini.Free;
  Result  :=  s;
end;

function TBBS.GetSendParam: string;
var
  BBSini : TMemIniFile;
begin
  BBSini  :=  TMemIniFile.Create(ConfigPath + INI_BBS);
  Result  :=  AnsiDequotedStr(BBSini.ReadString('SENDPARAM', 'PARAM_SEND', ''), '"');
  BBSini.Free;
end;

function TBBS.GetSendCookie: string;
var
  BBSini : TMemIniFile;
begin
  BBSini  :=  TMemIniFile.Create(ConfigPath + INI_BBS);
  Result  :=  AnsiDequotedStr(BBSini.ReadString('SENDPARAM', 'PARAM_COOKIE', ''), '"');
  BBSini.Free;
end;

function TBBS.GetNewThreadUrl(Board: TBoard): string;
var
  SiteIni, BBSini : TMemIniFile;
  s : string;
begin
  BBSini  :=  TMemIniFile.Create(ConfigPath + INI_BBS);
  Siteini :=  TMemIniFile.Create(Board.Site.ConfigPath + INI_SITE);
  //
  //  cgĩpXݒ
  //
  s   :=  Siteini.ReadString('NEWTHREADCGI', ExtractHostName(Board.Url), '');
  if  (s = '')  then  begin
    s   :=  BBSini.ReadString('NEWTHREADCGI', ExtractHostName(Board.Url), '');
    if  (s = '')  then  begin
      s :=  BBSini.ReadString('NEWTHREADCGI', '*', '');
    end;
    if  (s = '')  then  begin
      s :=  Siteini.ReadString('NEWTHREADCGI', '*', '');
    end;
  end;
  if  (s <> '') then  begin
    s :=  StringReplace(s, '<host>',
                        ExtractHostName(Board.Url),
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<bbs>',
                        Board.RemoteBoardID,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<boardpath>',
                        Board.BoardPath,
                        [rfReplaceAll, rfIgnoreCase]);
    s :=  StringReplace(s, '<dir>', //JBBSp
                        Board.Dir,
                        [rfReplaceAll, rfIgnoreCase]);
  end else begin
    s :=  '';
  end;
  BBSini.Free;
  Siteini.Free;
  Result  :=  s;
end;

function TBBS.GetNewThreadParam: string;
var
  BBSini : TMemIniFile;
begin
  BBSini  :=  TMemIniFile.Create(ConfigPath + INI_BBS);
  Result  :=  AnsiDequotedStr(BBSini.ReadString('NEWTHREADPARAM', 'PARAM_SEND', ''), '"');
  BBSini.Free;
end;

function TBBS.GetNewThreadCookie: string;
var
  BBSini : TMemIniFile;
begin
  BBSini  :=  TMemIniFile.Create(ConfigPath + INI_BBS);
  Result  :=  AnsiDequotedStr(BBSini.ReadString('NEWTHREADPARAM', 'PARAM_COOKIE', ''), '"');
  BBSini.Free;
end;

function TBBS.GetDir(const Url: string): string;
begin
  Result  :=  ''; //JBBŜݎgp
end;

function TBBS.GetSendResultErr: string;
begin
  Result  :=  FSendResultErr;
end;

//14
function TBBS.GetWebRedirect: boolean;
begin
  Result  :=  False;
end;

procedure TBBS.ZonuSendEnd(Sender: TObject; Uploader: TUploader;
  RecvStr: string; Error: boolean);
begin
  Uploader.FireEndUpload(Error);
end;

procedure TBBS.ZonuSendError(Sender: TObject; Uploader: TUploader;
  ErrorCode: integer; ErrorMsg, Html: string);
begin
  Uploader.FireUploadError(ErrorCode, Html);
end;

procedure TBBS.UpdateSetting;
var
  ini : TMemIniFile;
begin
  ini             :=  TMemIniFile.Create(FConfigPath + INI_BBS);
  FAboneText      :=  ini.ReadString('ABONE', 'TEXT', '');
  FSendParam      :=  TScriptParam.Create;
  FSendParam.ParamBBS     :=  ini.ReadString('PARAM', 'PARAM_BBS', '');
  FSendParam.ParamDat     :=  ini.ReadString('PARAM', 'PARAM_DAT', '');
  FSendParam.ParamStart   :=  ini.ReadString('PARAM', 'PARAM_START', '');
  FSendParam.ParamEnd     :=  ini.ReadString('PARAM', 'PARAM_END', '');
  FSendParam.ParamRes     :=  ini.ReadString('PARAM', 'PARAM_RES', '');
  FSendParam.ParamNoFirst :=  ini.ReadString('PARAM', 'PARAM_NOFIRST', '');
  FSendParam.ParamTrue    :=  ini.ReadString('PARAM', 'PARAM_TRUE', '');
  FSendParam.ParamFalse   :=  ini.ReadString('PARAM', 'PARAM_FALSE', '');
  FSendParam.ValueSage    :=  ini.ReadString('SENDPARAM', 'SAGE_VALUE', '');
  FSendParam.ValuePre     :=  ini.ReadString('SENDPARAM', 'PRE_VALUE', '');
  FSendParam.ValueTouhaba :=  ini.ReadString('SENDPARAM', 'TOUHABA_VALUE', '');
  FSendParam.UsePathInfo  :=  ini.ReadBool('PATH_INFO', 'PATH_INFO', False);
  FSendParam.PathInfoReadCGI        :=  ini.ReadString('PATH_INFO', 'READCGI', '');
  FSendParam.PathInfoParamNofirst   :=  ini.ReadString('PATH_INFO', 'PARAM_NOFIRST', '');

  FScriptName :=  ini.ReadString('SCRIPT', 'NAME', '');
  if  (ini.ReadBool('SENDOPTION', 'SAGE', False))  then  begin
    Include(FSendOption, soSage);
  end;
  if  (ini.ReadBool('SENDOPTION', 'PRE', False))  then  begin
    Include(FSendOption, soPre);
  end;
  if  (ini.ReadBool('SENDOPTION', 'TOUHABA', False))  then  begin
    Include(FSendOption, soTouhaba);
  end;
  if  (ini.ReadBool('SENDOPTION', 'SAGEMAIL', False))  then  begin
    Include(FSendOption, soSageMail);
  end;
  FSendResultErr  :=  ini.ReadString('SENDRESULT', 'ERROR', '');
  //18 begein
  {
  if  (ini.ReadString('SCRIPT', 'CHARSET', 'SJIS') = 'SJIS')  then  begin
    FCharset      :=  csSJIS;
  end else
  if  (ini.ReadString('SCRIPT', 'CHARSET', 'SJIS') = 'UTF8')  then  begin //14
    FCharset      :=  csUTF8;                                             //14
  end else begin
    FCharset      :=  csEUC;
  end;
  }
  FCharset  :=  TextToCharset(ini.ReadString('SCRIPT', 'CHARSET', 'SJIS'));
  //18 end

  FNewThreadParam   :=  TScriptParam.Create;
  FNewThreadParam.ValueSage    :=  ini.ReadString('NEWTHREADPARAM', 'SAGE_VALUE', '');
  FNewThreadParam.ValuePre     :=  ini.ReadString('NEWTHREADPARAM', 'PRE_VALUE', '');
  FNewThreadParam.ValueTouhaba :=  ini.ReadString('NEWTHREADPARAM', 'TOUHABA_VALUE', '');
  if  (ini.ReadBool('NEWTHREADOPTION', 'SAGE', False))  then  begin
    Include(FNewThreadOption, soSage);
  end;
  if  (ini.ReadBool('NEWTHREADOPTION', 'PRE', False))  then  begin
    Include(FNewThreadOption, soPre);
  end;
  if  (ini.ReadBool('NEWTHREADOPTION', 'TOUHABA', False))  then  begin
    Include(FNewThreadOption, soTouhaba);
  end;
  if  (ini.ReadBool('NEWTHREADOPTION', 'SAGEMAIL', False))  then  begin
    Include(FNewThreadOption, soSageMail);
  end;
  if  (ini.ReadBool('NEWTHREADOPTION', 'PASSWORD', False))  then  begin
    Include(FNewThreadOption, soPassword);
  end;

  FVersion      :=  ini.ReadString('SETTING', 'VER', '');
  FLastModified :=  ini.ReadString('SETTING', 'LASTMODIFIED', '');
  FSettingUrl   :=  ini.ReadString('SETTING', 'URL', '');

  ini.Free;
end;

////////////////////////////////////////////////////////////////////////////////
{ TBoardList }
////////////////////////////////////////////////////////////////////////////////

destructor TBoardList.Destroy;
begin
  Clear;
  inherited;
end;

function TBoardList.Add(Value: TBoard): integer;
begin
  Result  :=  inherited Add(Value);
end;

procedure TBoardList.Clear;
var
  i : integer;
begin
  for i :=  Count - 1 downto  0 do  begin
    Delete(i);
  end;
  inherited;
end;

procedure TBoardList.Delete(Index: integer);
begin
  if  (Items[Index] <> nil) then  begin
    TBoard(Items[Index]).Free;
    Items[Index] := nil;
  end;
  inherited Delete(Index);
end;

function TBoardList.GetBoard(index: integer): TBoard;
begin
  Result  :=  TBoard(inherited Items[index]);
end;

procedure TBoardList.SetBoard(index: integer; const Value: TBoard);
begin
  inherited Items[index]  :=  Value;
end;

function TBoardList.FindBoard(const BoardID: string;
  var Board: TBoard): boolean;
var
  i : integer;
begin
  Result  :=  False;
  for i :=  0 to  Count - 1  do  begin
    if  (Items[i].BoardID = BoardID)  then  begin
      Board   :=  Items[i];
      Result  :=  True;
      Break;
    end;
  end;
end;

function TBoardList.FindBoardFromBoardPath(const BoardPath, BoardID: string;
  var Board: TBoard): boolean;
var
  i : integer;
begin
  Result  :=  False;
  for i :=  0 to  Count - 1  do  begin
    if  (Items[i].BoardPath = BoardPath) and (Items[i].BoardID = BoardID)  then  begin
      Board   :=  Items[i];
      Result  :=  True;
      Break;
    end;
  end;
end;

//31
function TBoardList.FindBoardFromURL(const URL: string; var Board: TBoard): boolean;
var
  i : integer;
begin
  Result  :=  False;
  for i :=  0 to  Count - 1  do  begin
    if  (Items[i].URL = URL) then  begin
      Board   :=  Items[i];
      Result  :=  True;
      Break;
    end;
  end;
end;

procedure TBoardList.SaveToFile(const FileName: string);
var
  CategoryName  : string;
  BoardData : TStringList;
  i : integer;
  s : string;
  sb: string;
begin
  BoardData     :=  TStringList.Create;
  if  (FileExists(FileName))  then  begin
    BoardData.LoadFromFile(FileName);
    BoardData.SaveToFile(ChangeFileExt(FileName,'.bak'));
    BoardData.Clear;
  end;
  BoardData.Add('2');
  CategoryName  :=  '';
  for i :=  0 to  Count - 1 do  begin
    if  (CategoryName <>  Items[i].CategoryName)  then  begin
      CategoryName  :=  Items[i].CategoryName;
      BoardData.Add(Items[i].CategoryName + #9 + '0');
    end;
    if  (Items[i].BoardID <> Items[i].RemoteBoardID)  and
        (Items[i].RemoteBoardID <> '')  then
    begin
      sb  :=  Items[i].RemoteBoardID + '>' + Items[i].BoardID;
    end else begin
      sb  :=  Items[i].BoardID;
    end;
    {
    TBoardType  = (btBBSBoard,
                   btFavorites,
                   btLocalFolder,
                   btWebPage);
    TSiteType = (stNormal,    //ʏ
                 stUser,
                 stLocal,
                 stFavorites);
    }
    if  (Items[i].BoardType = btBBSBoard) or (Items[i].BoardType = btRSS) then  begin
      if  (Site.SiteType  = stUser) or (Site.SiteType  = stRSS) then  begin
        //̑BBS
        s :=  #9 + Items[i].BoardPath + #9 +
                   sb + #9 +
                   Items[i].Name  + #9 +
                   Items[i].BBS.BBSID + #9 +
                   ExtractRelativePath(ZonuConfig.CachePath, Items[i].CachePath) +  #9;
        //18 begin
        {
        if  (Items[i].CharSet = csSJIS) then  begin
          s :=  s + 'SJIS';
        end else
        if  (Items[i].CharSet = csUTF8) then  begin //14
          s :=  s + 'UTF8';                         //14
        end else begin
          s :=  s + 'EUC';
        end;
        }
        s :=  s + CharsetToText(Items[i].CharSet);
        //18 end
      end else begin
        s :=  #9 + Items[i].BoardPath + #9 +
                   sb + #9 +
                   Items[i].Name;
        //age16 begin
        if  (Site.CharSet <> Items[i].CharSet)  then  begin
          s :=  s + #9  + #9  + #9;
          //18 begin
          {
          if  (Items[i].CharSet = csSJIS) then  begin
            s :=  s + 'SJIS';
          end else
          if  (Items[i].CharSet = csUTF8) then  begin //14
            s :=  s + 'UTF8';                         //14
          end else begin
            s :=  s + 'EUC';
          end;
          }
          s :=  s + CharsetToText(Items[i].CharSet);
          //18 end
        end;
        //age16 end
      end;
    end else
    if  (Items[i].BoardType = btWebPage) then  begin
      s :=  #9  + Items[i].url  + #9  +
                  Items[i].BoardID  + #9  +
                  Items[i].Name + #9  +
                  'www';
    end else
    if  (Items[i].BoardType = btFavorites) then  begin
      s :=  #9  + BOARDPATH_FAV  + #9  +
                  Items[i].BoardID  + #9  +
                  Items[i].Name;
    end else
    if  (Items[i].BoardType = btLocalFolder) then  begin
      s :=  #9  + Items[i].CachePath  + #9  +
                  Items[i].BoardID  + #9  +
                  Items[i].Name;
    end;
    BoardData.Add(s);
  end;
  BoardData.SaveToFile(FileName);
  BoardData.Free;
end;

////////////////////////////////////////////////////////////////////////////////
{ TBoard }
////////////////////////////////////////////////////////////////////////////////

procedure TBoard.Assign(Source: TBoard);
begin
  Self.Site             :=  Source.Site;
  Self.Name             :=  Source.Name;
  Self.BoardPath        :=  Source.BoardPath;
  Self.BoardID          :=  Source.BoardID;
  Self.Url              :=  Source.Url;
  Self.Bold             :=  Source.Bold;
  Self.Reverse          :=  Source.Reverse;
  Self.Color            :=  Source.Color;
  Self.Key              :=  Source.Key;
  Self.Expanded         :=  Source.Expanded;
  Self.CategoryName     :=  Source.CategoryName;
  Self.CharSet          :=  Source.CharSet;
end;

constructor TBoard.Create;
begin
  FSite             :=  nil;
  FName             :=  '';
  FBoardPath        :=  '';
  FBoardID          :=  '';
  FUrl              :=  '';
  FBold             :=  False;
  FReverse          :=  False;
  FColor            :=  clWindowText;
  FExpanded         :=  False;
  FCategoryName     :=  '';
end;

destructor TBoard.Destroy;
begin
  inherited;
end;

function TBoard.GetCachePath: string;
begin
  //24 begin
  {
  if  (FCachePath = '') then  begin
    Result  :=  Site.CachePath  + BoardID + '\';
  end else begin
    Result  :=  FCachePath;
  end;
  }
  if  (ZonuConfig.LogCompatibleMode = cmJane) and
      (Site.SiteID = '2ch') then
  begin
    //Jane݊[h̏ꍇ
    Result  :=  ZonuConfig.JanePath + '2ch\' +
                CategoryName + '\' +
                Name + '\';
  end else begin
    if  (FCachePath = '') then  begin
      Result  :=  Site.CachePath  + BoardID + '\';
    end else begin
      Result  :=  FCachePath;
    end;
  end;
end;

function TBoard.GetCanWrite: boolean;
begin
  Result  :=  (BBS.GetSendUrl(Self, nil) <> '');
end;

function TBoard.GetDir: string;
begin
  Result  :=  Self.BBS.GetDir(Url);
end;

function TBoard.GetThreadTitle(const DatNo: string): string;
var
  SubjectTxt : TStringList;
  AFileName : string;
  ATitle    : string;
  ACount    : integer;
  i : integer;
begin
  Result  :=  '';
  SubjectTxt := TStringList.Create;
  if  (FileExists(CachePath + 'subject.txt')) then  begin
    SubjectTxt.LoadFromFile(CachePath + 'subject.txt');
    for i :=  0 to  SubjectTxt.Count - 1  do  begin
      //BBS.ParseSubject(SubjectTxt[i], AFileName, ATitle, ACount);
      ZonuCommon.Parse2chSubject(SubjectTxt[i], AFileName, ATitle, ACount);
      if (DatFileNameToDatNo(AFileName) = DatNo)  then  begin
        Result  :=  ATitle;
        Break;
      end;
    end;
  end;
  SubjectTxt.Free;
end;

procedure TBoard.SetReverse(const Value: boolean);
begin
  FReverse := Value;
end;


//8 begin
function TBoard.GetBAPassword: string;
var
  ini: TMemIniFile;
begin
  ini     :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_BASIC_AUTHOR);
  Result  :=  ini.ReadString(Self.Site.SiteID + Self.BoardID, 'PASSWORD', '');
  ini.Free;
end;

function TBoard.GetBAUserName: string;
var
  ini: TMemIniFile;
begin
  ini     :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_BASIC_AUTHOR);
  Result  :=  ini.ReadString(Self.Site.SiteID + Self.BoardID, 'USERNAME', '');
  ini.Free;
end;
//8 end

////////////////////////////////////////////////////////////////////////////////
{ TDownloader }
////////////////////////////////////////////////////////////////////////////////

procedure TDownloader.FireDownloadError(const ErrorCode: integer;
  ErrorMsg, LastResponse: string);
begin
  if  (Assigned(FErrorEvt)) then  begin
    FErrorEvt(Self, ErrorCode, ErrorMsg, LastResponse);
  end;
end;

procedure TDownloader.FireEndDownload(const Error: boolean);
begin
  if  (Assigned(FEndDownloadEvt)) then  begin
    FEndDownloadEvt(Self, Error);
  end;
end;

////////////////////////////////////////////////////////////////////////////////
{ TThreadListDownloader }
////////////////////////////////////////////////////////////////////////////////

procedure TThreadListDownloader.FireDataEvt(ThreadItem: TThreadItem;
  Size, TotalSize: integer; var MoreData: boolean);
begin
  if  (Assigned(FDataEvt)) then  begin
    FDataEvt(Self, ThreadItem, Size, TotalSize, MoreData);
  end;
end;

////////////////////////////////////////////////////////////////////////////////
{ TThreadItemList }
////////////////////////////////////////////////////////////////////////////////

destructor TThreadItemList.Destroy;
begin
  Clear;
  inherited;
end;

function TThreadItemList.Add(Value: TThreadItem): integer;
begin
  if  (Value <> nil)  then  begin
    Result  :=  inherited Add(Value);
  end else begin
    Result  :=  -1;
  end;
end;

procedure TThreadItemList.Clear;
var
  i : integer;
begin
  for i :=  Count - 1 downto  0 do  begin
    Delete(i);
  end;
  inherited;
end;

procedure TThreadItemList.Delete(Index: integer);
begin
  TThreadItem(Items[Index]).ReleaseRef;
  inherited Delete(Index);
end;

procedure TThreadItemList.DeleteForce(Index: integer);
begin
  TThreadItem(Items[Index]).Free;
  inherited Delete(Index);
end;

function TThreadItemList.GetThreadItem(index: integer): TThreadItem;
begin
  Result  :=  TThreadItem(inherited Items[index]);
end;

procedure TThreadItemList.SetThreadItem(index: integer;
  const Value: TThreadItem);
begin
  inherited Items[index]  :=  Value;
end;

function TThreadItemList.GetNewCount: integer;
var
  i, n: integer;
begin
  n :=  0;
  for i :=  0 to  Count - 1 do  begin
    if  (Items[i].IsNew)  then  begin
      inc(n);
    end;
  end;
  Result  :=  n;
end;


function TThreadItemList.FindThreadItem(const DatFileName: string): TThreadItem;
var
  i : integer;
begin
  Result  :=  nil;
  for i :=  0 to  Count - 1 do  begin
    if  (AnsiLowerCase(Items[i].DatFileName) = AnsiLowerCase(DatFileName))  then
    begin
      Result  :=  Items[i];
      Break;
    end;
  end;
end;

function CompareInt(I1,I2 : integer) : integer;
begin
  if I1 > I2 then result := 1 else
   if I1 < I2 then result := -1 else
     Result := 0;
end;

function NoSort(item1,item2:pointer) : integer;
begin
  Result := CompareInt(TThreadItem(item1).No,
                        TThreadItem(item2).No);
  if not AscendSort then Result := -Result;
end;

function TitleSort(item1,item2:pointer) : integer;
begin
  Result := AnsiCompareText(TThreadItem(item1).Title,
                            TThreadItem(item2).Title);
  if not AscendSort then Result := -Result;
end;

function CountSort(item1,item2:pointer) : integer;
begin
  Result := CompareInt(TThreadItem(item1).AgeCount,
                        TThreadItem(item2).AgeCount);
  if not AscendSort then Result := -Result;
end;

function NewCountSort(item1,item2:pointer) : integer;
var
  x1, x2 : integer;
begin
  x1  :=  TThreadItem(item1).NewCount;
  if  (x1 < 1) and (TThreadItem(item1).ReadCount > 0) and (not TThreadItem(item1).IsKakoLog)  then
    x1  :=  TThreadItem(item1).AgeCount - TThreadItem(item1).ReadCount;

  x2  :=  TThreadItem(item2).NewCount;
  //age16 if  (x2 < 1) and (TThreadItem(item2).ReadCount > 0) and (not TThreadItem(item1).IsKakoLog) then
  if  (x2 < 1) and (TThreadItem(item2).ReadCount > 0) and (not TThreadItem(item2).IsKakoLog) then
    x2  :=  TThreadItem(item2).AgeCount - TThreadItem(item2).ReadCount;

  Result := CompareInt(x1, x2) * -1;
  if not AscendSort then Result := -Result;
end;

function ReadCountSort(item1,item2:pointer) : integer;
begin
  Result := CompareInt(TThreadItem(item1).ReadCount,
                        TThreadItem(item2).ReadCount);
  if not AscendSort then Result := -Result;
end;

function PrioritySort(item1,item2:pointer) : integer;
begin
  Result := CompareInt(TThreadItem(item1).Priority,
                        TThreadItem(item2).Priority);
  if AscendSort then Result := -Result;
end;

function LastLoadDateSort(item1,item2:pointer) : integer;
begin
  // item1 > item2 = -1
  // item1 < item2 = 1
  // item1 = item2 = 0
  if  (TThreadItem(item1).LastLoadDate =  '') and
      (TThreadItem(item2).LastLoadDate <> '') then
  begin
    Result  :=  1;
  end else
  if  (TThreadItem(item1).LastLoadDate <> '') and
      (TThreadItem(item2).LastLoadDate =  '') then
  begin
    Result  :=  -1;
  end else begin
    Result := AnsiCompareText(TThreadItem(item2).LastLoadDate,
                              TThreadItem(item1).LastLoadDate);
  end;
  if not AscendSort then Result := -Result;
end;

function LastSentDateSort(item1,item2:pointer) : integer;
begin
  if  (TThreadItem(item1).LastSentDate =  '') and
      (TThreadItem(item2).LastSentDate <> '') then
  begin
    Result  :=  1;
  end else
  if  (TThreadItem(item1).LastSentDate <> '') and
      (TThreadItem(item2).LastSentDate =  '') then
  begin
    Result  :=  -1;
  end else begin
    Result := AnsiCompareText(TThreadItem(item2).LastSentDate,
                              TThreadItem(item1).LastSentDate);
  end;
  if not AscendSort then Result := -Result;
end;

function MemoSort(item1,item2:pointer) : integer;
begin
  Result := AnsiCompareText(TThreadItem(item1).Memo,
                            TThreadItem(item2).Memo);
  if not AscendSort then Result := -Result;
end;

function BoardSort(item1,item2:pointer) : integer;
begin
  Result := AnsiCompareText(TThreadItem(item1).Board.BoardID,
                            TThreadItem(item2).Board.BoardID);
  if not AscendSort then Result := -Result;
end;

function SiteSort(item1,item2:pointer) : integer;
begin
  Result := AnsiCompareText(TThreadItem(item1).Site.SiteName +
                            TThreadItem(item1).Board.BoardID,
                            TThreadItem(item2).Site.SiteName +
                            TThreadItem(item2).Board.BoardID);
  if not AscendSort then Result := -Result;
end;

function ReadPointSort(item1,item2:pointer) : integer;
begin
  if  (TThreadItem(item1).ReadPoint =  0) and
      (TThreadItem(item2).ReadPoint > 0)  then
  begin
    Result  :=  1;
  end else
  if  (TThreadItem(item1).ReadPoint >  0) and
      (TThreadItem(item2).ReadPoint = 0)  then
  begin
    Result  :=  -1;
  end else begin
    Result := CompareInt(TThreadItem(item1).No,
                         TThreadItem(item2).No);
  end;
  if not AscendSort then Result := -Result;
end;

function ReadPointNoSort(item1,item2:pointer) : integer;
begin
  if  (TThreadItem(item1).ReadPoint =  0) and
      (TThreadItem(item2).ReadPoint > 0)  then
  begin
    Result  :=  1;
  end else
  if  (TThreadItem(item1).ReadPoint >  0) and
      (TThreadItem(item2).ReadPoint = 0)  then
  begin
    Result  :=  -1;
  end else begin
    Result := CompareInt(TThreadItem(item1).ReadPoint,
                         TThreadItem(item2).ReadPoint);
  end;
  if not AscendSort then Result := -Result;
end;

function DatSort(item1,item2:pointer) : integer;
begin
  if  (StrToIntDef(TThreadItem(item1).DatNo, -1) > -1) and
      (StrToIntDef(TThreadItem(item2).DatNo, -1) > -1) then
  begin
    Result := CompareInt(StrToInt(TThreadItem(item1).DatNo),
                         StrToInt(TThreadItem(item2).DatNo));
  end else begin
    Result := AnsiCompareText(TThreadItem(item1).DatNo,
                              TThreadItem(item2).DatNo);
  end;
  if not AscendSort then Result := -Result;
end;

function UpdateInfoSort(item1,item2:pointer) : integer;
begin
  // item1 > item2 = -1
  // item1 < item2 = 1
  // item1 = item2 = 0
  Result := CompareInt(TThreadItem(item1).SortInfo,
                        TThreadItem(item2).SortInfo);
  if not AscendSort then Result := -Result;
end;

function ReadInfoSort(item1,item2:pointer) : integer;
begin
  // item1 > item2 = -1
  // item1 < item2 = 1
  // item1 = item2 = 0
  if  (TThreadItem(Item1).ReadCount > 0) then begin
    if  (TThreadItem(Item2).ReadCount > 0)  then  begin
      Result  :=  CompareInt(TThreadItem(Item1).No,
                             TThreadItem(Item2).No);
    end else begin
      Result  :=  -1;
    end;
  end else begin
    if  (TThreadItem(Item2).ReadCount > 0)  then  begin
      Result  :=  1;
    end else begin
      Result  :=  CompareInt(TThreadItem(Item1).No,
                             TThreadItem(Item2).No);
    end;
  end;
  if not AscendSort then Result := -Result;
end;

function SinceSort(item1,item2:pointer) : integer;
begin
  Result := AnsiCompareText(TThreadItem(item2).DatSince,
                            TThreadItem(item1).DatSince);
  if not AscendSort then Result := -Result;
end;

function ThreadNoSort(item1,item2:pointer) : integer;
begin
  Result := AnsiCompareText(TThreadItem(item1).ThreadNo,
                            TThreadItem(item2).ThreadNo);
  if not AscendSort then Result := -Result;
end;

procedure TThreadItemList.SortItems(SortType: TItemsSortType;
  Ascend: boolean);
begin
  AscendSort := Ascend;
  case SortType of
    isNo  : Sort(NoSort);
    isUpdateInfo  : Sort(UpdateInfoSort);
    isReadInfo  : Sort(ReadInfoSort);
    isTitle : Sort(TitleSort);
    isCount : Sort(CountSort);
    isNewCount      : Sort(NewCountSort);
    isReadCount     : Sort(ReadCountSort);
    isPriority      : Sort(PrioritySort);
    isLastLoadDate  : Sort(LastLoadDateSort);
    isLastSentDate  : Sort(LastSentDateSort);
    isMemo          : Sort(MemoSort);
    isBoard         : Sort(BoardSort);
    isSite          : Sort(SiteSort);
    isReadPoint     : Sort(ReadPointSort);
    isReadPointNo   : Sort(ReadPointNoSort);
    isDat           : Sort(DatSort);
    isSince         : Sort(SinceSort);
    isThreadNo      : Sort(ThreadNoSort);
  end;
end;

////////////////////////////////////////////////////////////////////////////////
{ TThreadItem }
////////////////////////////////////////////////////////////////////////////////

constructor TThreadItem.Create;
begin
  FNewCount         :=  -1;
  FDownloading      :=  False;
  FBookmarkList     :=  TBookmarkList.Create;
  FInFavorites      :=  False;
  FInShortcut       :=  False;
  FRefCount         :=  0;
  //FShowAll          :=  False;
  FCanDownload      :=  True;
  FIsBroken         :=  False;
  FInLocalFolder    :=  False;
  FConfigLoaded     :=  False;
  FColor            :=  clWindowText;
  FProfiler         :=  TMonaProfiler.Create;
  FBoard := nil;
  AddRef;
end;

destructor TThreadItem.Destroy;
begin
  if  (Assigned(FDestroyEvt)) then  begin
    FDestroyEvt(Self);
  end;
  FBookmarkList.Free;
  if  (FAbonedList <> nil)  then  begin
    FreeAndNil(FAbonedList);
  end;
  FProfiler.Stop;
  FProfiler.Free;
  inherited;
end;

procedure TThreadItem.AddRef;
begin
  Inc(FRefCount);
  if  (Assigned(FAddRefEvt))  then  begin
    FAddRefEvt(Self);
  end;
end;

procedure TThreadItem.Assign(Source: TThreadItem);
begin
  FLocalDatFileName :=  Source.LocalDatFileName;
  FBoardID          :=  Source.BoardID;
  FSite             :=  Source.Site;
end;

procedure TThreadItem.ReleaseRef;
begin
  Dec(FRefCount);
  if  (Assigned(FReleaseRefEvt))  then  begin
    FReleaseRefEvt(Self);
  end;
  if  (FRefCount < 0) then  begin
    Exception.Create('Ȃ񂩂[');
  end;
  if  (FRefCount = 0) then  begin
    FreeAndNil(Self);
  end;
end;

procedure TThreadItem.LoadAbonedList;
begin
  if  (FAbonedList <> nil)  then  begin
    FreeAndNil(FAbonedList);
  end;
  FAbonedList :=  TMemIniFile.Create(ChangeFileExt(LocalDatFileName, '.inf'));
end;

procedure TThreadItem.LoadFromFile(var ResList: TResList);
var
  s : TStringList;
  i : integer;
  Res : TRes;
  ASubject : string;
  DatIni : TMemIniFile;
  InfPath: string;
  DatPath: string;
begin
  if  (DatExists)  then  begin
    s       :=  TStringList.Create;
    DatIni  :=  TMemIniFile.Create(ChangeFileExt(LocalDatFileName, '.inf'));
    DatPath :=  LocalDatFileName;
    if  (DatIni.SectionExists('INFO'))  then    begin
      DatPath :=  DatIni.ReadString('INFO', 'LOCAL', '') + DatNo + '.dat';
      InfPath :=  ChangeFileExt(DatPath, '.inf');
      DatIni.Free;
      DatIni  :=  TMemIniFile.Create(InfPath);
      FInLocalFolder  :=  True;
    end;
    s.LoadFromFile(DatPath);
    for i :=  0 to  s.Count - 1 do  begin
      Res :=  TRes.Create;
      //BBS.ParseDat(s[i], i, Res, ASubject);
      ParseLocalDat(S[i], i, Res, ASubject);
      Res.No  :=  i + 1;
      Res.IsAboned  :=  DatIni.ReadBool('ERASE', 'RES' + IntToStr(i + 1), False);
      Res.BBS       :=  BBS;
      Res.BBS       :=  BBS;
      Res.Site      :=  Site;
      Res.IsNew     :=  False;
      Res.IsSiori   :=  (BookmarkList.FindRes(i + 1) <> nil);
      ResList.Add(Res);
    end;
    DatIni.Free;
    s.Free;
  end;
end;

procedure TThreadItem.LoadConfig;
var
  FMemoList   : TStringList;
  Path        : string;
  ini         : TMemIniFile;
  s           : string;
  Count       : integer;
  i           : integer;
  res         : TBookmarkRes;
  sl          : TStringList;
begin
  FConfigLoaded :=  True;
  Path      :=  ChangeFileExt(LocalDatFileName, '.inf');
  ini       :=  TMemIniFile.Create(Path);
  if  (not ini.SectionExists('LOG'))  and (not ini.SectionExists('SETTING'))  then  begin
    if  (FileExists(Path))  then  begin
      //zbg]k1.0`
      ini.Free;
      sl  :=  TStringList.Create;
      sl.LoadFromFile(Path);
      sl.SaveToFile(ChangeFileExt(Path, '.bak'));
      sl.Insert(0, '[HZB10]');
      sl.Add('');
      sl.Add('[SETTING]');
      if  (sl.IndexOfName('BOLD') > -1) then
        sl.Add(sl[sl.IndexOfName('BOLD')])
      else
        sl.Add('BOLD=0');
      if  (sl.IndexOfName('REVERSE') > -1) then
        sl.Add(sl[sl.IndexOfName('REVERSE')])
      else
        sl.Add('REVERSE=0');
      if  (sl.IndexOfName('COLOR') > -1) then
        sl.Add(sl[sl.IndexOfName('COLOR')])
      else
        sl.Add('COLOR=clWindowText');
      if  (sl.IndexOfName('ABONE') > -1) then
        sl.Add(sl[sl.IndexOfName('ABONE')])
      else
        sl.Add('ABONE=0');
      sl.Add('KAKOLOG=0');
      if  (sl.IndexOfName('PRIORITY') > -1) then
        sl.Add(sl[sl.IndexOfName('PRIORITY')])
      else
        sl.Add('PRIORITY=0');
      sl.Add('FAVORITE=0');
      sl.Add('SHORTCUT=0');
      sl.Add('ROUND=0');
      if  (sl.IndexOfName('READ_POS') > -1) then
        sl.Add('READPOINT=' + sl.Values['READ_POS'])
      else
        sl.Add('READPOINT=0');
      sl.Add('');
      ////////////////
      sl.Add('[LOG]');
      if  (sl.IndexOfName('TITLE') > -1) then
        sl.Add(sl[sl.IndexOfName('TITLE')])
      else
        sl.Add('TITLE=');
      sl.Add('BOARDID=' + BoardID);
      if  (sl.IndexOfName('LAST_LOAD') > -1) then
        sl.Add(sl[sl.IndexOfName('LAST_LOAD')])
      else
        sl.Add('LAST_LOAD=0');
      sl.Add('LOAD_COUNT=0');
      if  (Site <> nil) then  sl.Add('SITEID=' + Site.SiteID);
      if  (sl.IndexOfName('TOP') > -1) then
        sl.Add(sl[sl.IndexOfName('TOP')])
      else
        sl.Add('TOP=0');
      sl.Add('LAST_SENT=');
      sl.Add('ETAG=');
      if  (sl.IndexOfName('READ') > -1) then begin
        sl.Add('AGECOUNT=' + sl.Values['READ']);
        sl.Add(sl[sl.IndexOfName('READ')]);
        sl.Add('COUNT=' + sl.Values['READ']);
      end else begin
        sl.Add('AGECOUNT=0');
        sl.Add('READ=0');
        sl.Add('COUNT=0');
      end;
      sl.Add('LAST_MODIFIED=');
      if  (sl.IndexOfName('SIZE') > -1) then
        sl.Add(sl[sl.IndexOfName('SIZE')])
      else
        sl.Add('SIZE=0');
      sl.SaveToFile(Path);
      sl.Free;
      ini :=  TMemIniFile.Create(Path);
    end;
  end;



  if  (ini.SectionExists('INFO'))  then  begin
    Path      :=  ini.ReadString('INFO', 'LOCAL', '') + DatNo + '.inf';
    ini.Free;
    ini       :=  TMemIniFile.Create(Path);
    FInLocalFolder  :=  True;
  end;
  s         :=  ini.ReadString('LOG', 'TITLE', '');
  if  (s <> '') then  begin
    Title :=  s;
  end;
  Bold            :=  ini.ReadBool('SETTING', 'BOLD',     False);
  Reverse         :=  ini.ReadBool('SETTING', 'REVERSE',  False);
  Color           :=  StringToColor(ini.ReadString('SETTING', 'COLOR', 'clWindowText'));
  IsAboned        :=  ini.ReadBool('SETTING', 'ABONE', False);
  Invisible       :=  ini.ReadBool('SETTING', 'INVISIBLE', False);
  //FReadAll      :=  ini.ReadBool('SETTING', 'READALL', False);
  Priority        :=  ini.ReadInteger('SETTING', 'PRIORITY', 0);
  InFavorites     :=  ini.ReadBool('SETTING', 'FAVORITE', False);
  //FInRoundList  :=  ini.ReadBool('SETTING', 'ROUND', False);
  InShortcut      :=  ini.ReadBool('SETTING', 'SHORTCUT', False);
  IsKakoLog       :=  ini.ReadBool('SETTING', 'KAKOLOG', False);
  ReadPoint       :=  ini.ReadInteger('SETTING', 'READPOINT', 0);

  ReadCount       :=  ini.ReadInteger('LOG', 'READ', 0);
  DownloadCount   :=  ini.ReadInteger('LOG', 'COUNT', 0);
  if  (ReadCount  >  DownloadCount) then  begin
    //Hotzonu 1.0 ݊p
    DownloadCount :=  FReadCount;
  end;
  ScrollTop       :=  ini.ReadInteger('LOG',  'TOP', 0);
  //FBoardID        :=  ini.ReadString('LOG',   'BOARDID', FBoardID);
  FLastModified   :=  ini.ReadString('LOG',   'LAST_MODIFIED', '');
  LastLoadDate    :=  ini.ReadString('LOG',   'LAST_LOAD', '');
  LastSentDate    :=  ini.ReadString('LOG',   'LAST_SENT', '');
  LoadCount       :=  ini.ReadInteger('LOG',  'LOAD_COUNT', 0);
  SentCount       :=  ini.ReadInteger('LOG',  'SENT_COUNT', 0); //12
  AgeCount        :=  ini.ReadInteger('LOG', 'AGECOUNT',  AgeCount);

  //
  Count           :=  ini.ReadInteger('BOOKMARK', 'COUNT', 0);
  FBookmarkList.Clear;
  for i :=  0 to  Count - 1 do  begin
    res :=  TBookmarkRes.Create;
    res.ResNo   :=  ini.ReadInteger('BOOKMARK', 'RESNO' + IntToStr(i + 1), 0);
    res.Name    :=  ini.ReadString('BOOKMARK', 'NAME' + IntToStr(i + 1), '');
    res.Date    :=  ini.ReadString('BOOKMARK', 'DATE' + IntToStr(i + 1), '');
    res.Body    :=  ini.ReadString('BOOKMARK', 'BODY' + IntToStr(i + 1), '');
    res.Memo    :=  ini.ReadString('BOOKMARK', 'MEMO' + IntToStr(i + 1), '');
    res.Category:=  ini.ReadString('BOOKMARK', 'CATEGORY' + IntToStr(i + 1), ''); //13
    res.ThreadItem  :=  Self; //15
    FBookmarkList.Add(res);
  end;
  ini.Free;
  //end;
  Memo        :=  '';
  if  (FileExists(ChangeFileExt(Path, '.txt'))) then  begin
    FMemoList :=  TStringList.Create;
    FMemoList.LoadFromFile(ChangeFileExt(Path, '.txt'));
    Memo  :=  FMemoList.Text;
    FMemoList.Free;
  end;
  //24 begin
  if  (ZonuConfig.LogCompatibleMode = cmJane) then  begin
    LoadJaneIdx;
  end;
  //24 end
end;

procedure TThreadItem.SaveConfig;
var
  Path  : string;
  S   : TStringList;
  ini : TMemIniFile;
  i   : integer;
begin
  if  (ZonuEnviron.Cached)  then  begin
    if  (not DirectoryExists(ExtractFilePath(LocalDatFileName))) then  begin
      ForceDirectories(ExtractFilePath(LocalDatFileName));
    end;
    Path  :=  ChangeFileExt(LocalDatFileName, '.inf');
    ini   :=  TMemIniFile.Create(Path);
    ini.WriteBool('SETTING', 'BOLD', Bold);
    ini.WriteBool('SETTING', 'REVERSE', Reverse);
    ini.WriteString('SETTING', 'COLOR', ColorToString(Color));
    ini.WriteBool('SETTING', 'ABONE', IsAboned);
    ini.WriteBool('SETTING', 'KAKOLOG', IsKakoLog);
    ini.WriteInteger('SETTING', 'PRIORITY', Priority);
    ini.WriteBool('SETTING', 'FAVORITE', InFavorites);
    //ini.WriteBool('SETTING', 'ROUND', InRoundList);
    ini.WriteBool('SETTING', 'SHORTCUT', InShortcut);
    ini.WriteInteger('SETTING', 'READPOINT', ReadPoint);

    ini.WriteInteger('LOG', 'READ',         ReadCount);
    ini.WriteString('LOG',  'TITLE',        Title);
    //ini.WriteString('LOG',  'BOARDURL',     Board.Url);
    ini.WriteString('LOG',  'BOARDID',      Board.BoardID);
    ini.WriteString('LOG',  'SITEID',       Site.SiteID);
    ini.WriteInteger('LOG', 'TOP',          ScrollTop);
    ini.WriteInteger('LOG', 'COUNT',        DownloadCount);
    ini.WriteInteger('LOG', 'AGECOUNT',     AgeCount);
    ////////////////////////////////////ini.WriteString('LOG', 'LAST_MODIFIED', LastModified);
    ini.WriteString('LOG', 'LAST_LOAD',     LastLoadDate);
    ini.WriteString('LOG', 'LAST_SENT',     LastSentDate);
    ini.WriteInteger('LOG', 'LOAD_COUNT',   LoadCount);
    ini.WriteInteger('LOG', 'SENT_COUNT',   SentCount); //12

    ini.EraseSection('BOOKMARK');
    ini.WriteInteger('BOOKMARK', 'COUNT', FBookmarkList.Count);
    for i :=  0 to  FBookmarkList.Count - 1  do  begin
      ini.WriteInteger('BOOKMARK', 'RESNO' + IntToStr(i + 1), FBookmarkList[i].ResNo);
      ini.WriteString('BOOKMARK', 'NAME' + IntToStr(i + 1), FBookmarkList[i].Name);
      ini.WriteString('BOOKMARK', 'DATE' + IntToStr(i + 1), FBookmarkList[i].Date);
      ini.WriteString('BOOKMARK', 'BODY' + IntToStr(i + 1), FBookmarkList[i].Body);
      ini.WriteString('BOOKMARK', 'MEMO' + IntToStr(i + 1), FBookmarkList[i].Memo);
      ini.WriteString('BOOKMARK', 'CATEGORY' + IntToStr(i + 1), FBookmarkList[i].Category); //13
    end;

    ini.UpdateFile;
    ini.Free;

    Memo  :=  Trim(Memo);

    if  (Trim(Memo) <> '')  then  begin
      S :=  TStringList.Create;
      S.Text  :=  Memo;
      for i :=  S.Count - 1 downto  0 do  begin
        if  (s[i] = '') then  begin
          s.Delete(i);
        end else begin
          Break;
        end;
      end;
      S.SaveToFile(ChangeFileExt(Path, '.txt'));
      S.Free;
    end else begin
      if  (FileExists(ChangeFileExt(Path, '.txt')))  then  begin
        DeleteFile(ChangeFileExt(Path, '.txt'));
      end;
    end;
    //24 begin
    if  (ZonuConfig.LogCompatibleMode = cmJane) then  begin
      SaveJaneIdx;
    end;
    //24 end
  end;
end;

procedure TThreadItem.LoadJaneIdx;
  function GetFileSize(AFileName: string): integer;
  var
    rec: TSearchRec;
  begin
    if  (FindFirst(AFileName, faAnyFile, rec) = 0)  then  begin
      Result  :=  rec.Size;
    end else begin
      Result  :=  0;
    end;
    FindClose(rec);
  end;
var
  sl: TStringList;
  ini: TMemIniFile;
  Path: string;
begin
  sl  :=  TStringList.Create;
  if  (FileExists(ChangeFileExt(LocalDatFileName, '.idx')))  then  begin
    if  (GetFileSize(ChangeFileExt(LocalDatFileName, '.inf')) <
         GetFileSize(ChangeFileExt(LocalDatFileName, '.idx'))) then
    begin
      sl.LoadFromFile(ChangeFileExt(LocalDatFileName, '.idx'));
      Path      :=  ChangeFileExt(LocalDatFileName, '.inf');
      ini       :=  TMemIniFile.Create(Path);
      //Jane̕ŐVۂ
      FTitle          :=  sl[0];
      FLastModified   :=  sl[1];
      FAgeCount       :=  StrToIntDef(sl[2], 0);
      FScrollTop      :=  StrToIntDef(sl[3], 0);
      FReadCount      :=  FAgeCount;
      //                  :=  sl[4];
      //                  :=  sl[5];
      //sl.Add('0');  State
      //sl.Add(IntToStr(Self.NewCount));
      //sl.Add('');   //UsedWriteName
      //sl.Add('');   //UsedWriteMail
      //sl.Add('0');  //IntToStr(LastWrote)
      //sl.Add('0');  //IntToStr(LastGot)
      ini.WriteString('LOG', 'LAST_MODIFIED', FLastModified);
      ini.WriteInteger('LOG', 'SIZE', GetFileSize(LocalDatFileName));
      ini.UpdateFile;
      ini.Free;
    end;
  end;
  sl.Free;
end;

procedure TThreadItem.SaveJaneIdx;
var
  sl: TStringList;
begin
  sl  :=  TStringList.Create;
  sl.Add(Title);
  sl.Add(LastModified);
  sl.Add(IntToStr(AgeCount));
  sl.Add(IntToStr(ScrollTop));
  sl.Add(''); //}[NH
  sl.Add(Self.Board.Url);
  {
  TThreadState = (tsCurrency=0, tsHistory1=1, tsHistory2=2,
                  tsComplete=3,
                  tsTransition1=4, tsTransition2=5, tsTransition3=6);
  }
  sl.Add('0');
  sl.Add(IntToStr(Self.NewCount));
  sl.Add('');   //UsedWriteName
  sl.Add('');   //UsedWriteMail
  sl.Add('0');  //IntToStr(LastWrote)
  sl.Add('0');  //IntToStr(LastGot)
  sl.Add(IntToStr(Self.ReadPoint));  //IntToStr(readPos)
  sl.SaveToFile(ChangeFileExt(LocalDatFileName, '.idx'));
  sl.Free;
end;

procedure TThreadItem.DeleteLog(DatDelete, InfDelete, OtherDelete,
  InfClear: boolean);
var
  s : string;
  ini : TMemIniFile;
begin
  s :=  LocalDatFileName;
  if  (DatDelete) then  begin
    if  (ZonuConfig.MoveToTrash)  then  begin
      DeleteFileEx(s, False);
    end else begin
      DeleteFile(s);
    end;
  end;
  if  (InfDelete) then  begin
    if  (ZonuConfig.MoveToTrash)  then  begin
      DeleteFileEx(ChangeFileExt(s, '.inf'), False);
      DeleteFileEx(ChangeFileExt(s, '.bak'), False);
    end else begin
      DeleteFile(ChangeFileExt(s, '.inf'));
      DeleteFile(ChangeFileExt(s, '.bak'));
    end;
  end;
  if  (OtherDelete) then  begin
    if  (ZonuConfig.MoveToTrash)  then  begin
      DeleteFileEx(ChangeFileExt(s, '.html'), False);
      DeleteFileEx(ChangeFileExt(s, '.htm'), False);
    end else begin
      DeleteFile(ChangeFileExt(s, '.html'));
      DeleteFile(ChangeFileExt(s, '.htm'));
    end;
  end;
  if  (not InfDelete) and (InfClear)  then  begin
    ini :=  TMemIniFile.Create(ChangeFileExt(s, '.inf'));
    ini.WriteString('BAK', 'LAST_MODIFIED', ini.ReadString('LOG', 'LAST_MODIFIED', ''));
    ini.WriteInteger('BAK','SIZE',  ini.ReadInteger('LOG', 'SIZE', 0));
    ini.WriteInteger('BAK','COUNT', ini.ReadInteger('LOG', 'COUNT', 0));
    ini.WriteInteger('BAK','READ',  ini.ReadInteger('LOG', 'READ', 0));
    ini.DeleteKey('LOG', 'LAST_MODIFIED');
    ini.DeleteKey('LOG', 'SIZE');
    ini.DeleteKey('LOG', 'COUNT');
    ini.DeleteKey('LOG', 'READ');
    ini.UpdateFile;
    ini.Free;
  end;
  LoadConfig;
end;

function TThreadItem.GetBoard: TBoard;
var
  Board: TBoard;
begin
  //37
  if  (FBoard = nil)  then  begin
    if  (Site <> nil) then  begin
      Site.BoardList.FindBoard(FBoardID, Board);
    end;
  end else begin
    Board :=  FBoard;
  end;
  Result  :=  Board;
  {
  Board :=  nil;
  if  (Site <> nil) then  begin
    Site.BoardList.FindBoard(FBoardID, Board);
  end;
  Result  :=  Board;
  }
end;

procedure TThreadItem.SetIsKakoLog(const Value: boolean);
begin
  FIsKakoLog    := Value;
  FCanDownload  :=  not Value;
end;

function TThreadItem.GetDatSince: string;
begin
  try
    if  (FDatSince = '')  then  begin
      Result  :=  MonaUtils.GetDatSince(DatNo);
    end else begin
      Result  :=  FDatSince;
    end;
  except
    Result  :=  '';
  end;
end;

function TThreadItem.GetDatExists: boolean;
begin
  Result  :=  FileExists(LocalDatFileName);
end;

function TThreadItem.GetInfExists: boolean;
begin
  Result  :=  FileExists(ChangeFileExt(LocalDatFileName,'.inf'));
end;

function TThreadItem.GetDatNo: string;
begin
  Result  :=  DatFileNameToDatNo(DatFileName);
end;

procedure TThreadItem.SetPriority(const Value: integer);
begin
  if  (Value < 0) then  begin
    FPriority := 0;
  end else
  if  (Value > 9999) then  begin
    FPriority := 9999;
  end else begin
    FPriority := Value;
  end;
end;

function TThreadItem.GetSortInfo: integer;
begin
  if  (IsNew) then  begin
    Result  :=  10000 + No;               //  1
  end else
  if  (Updated) then  begin
    Result  :=  30000 + No;               //  2
  end else
  if  (IsKakolog) then  begin
    Result  :=  60000 + No;               //  4
  end else
  if  (ReadCount > 0) then  begin
    Result  :=  50000 + No;               //  3
  end else begin
    Result  :=  80000 + No;               //  5
  end;
end;

function TThreadItem.CreateThreadItem(const ASiteID, ABoardID, ADatNo,
  ATitle: string; XSite : TSite = nil; XBoard: TBoard = nil): boolean;
var
  ASite  : TSite;
  ABoard : TBoard;
  ini: TMemIniFile;
  s: string;
begin
  Result  :=  False;
  ASite   :=  nil;
  ABoard  :=  nil;
  if  (XSite = nil) then  begin
    if  (ZonuEnviron.SiteList.FindSite(ASiteID, ASite)) then  begin
      XSite :=  ASite;
    end;
  end;
  if  (XSite <> nil)  then  begin
    if  (XBoard = nil)  then  begin
      if (XSite.BoardList.FindBoard(ABoardID, ABoard)) then  begin
        XBoard  :=  ABoard;
      end;
    end;
    if  (XBoard <> nil) then  begin
      Site     :=  XSite;
      BBS      :=  XBoard.BBS;
      BoardID  :=  XBoard.BoardID;
      if  (AnsiPos('.dat', ADatNo) > 0)  then  begin
        DatFileName        :=  ADatNo;
        LocalDatFileName   :=  XBoard.CachePath + ADatNo;
      end else begin
        DatFileName        :=  ADatNo + '.dat';
        LocalDatFileName   :=  XBoard.CachePath + ADatNo + '.dat';
      end;
      RemoteDatFileName  :=  BBS.GetRemoteDatFileName(Self);
      LoadConfig;
      if  (not FileExists(LocalDatFileName)) or
          (not FileExists(ChangeFileExt(LocalDatFileName, '.inf'))) then
      begin
        Title :=  ATitle;
      end;
      Result  :=  True;
    end;
  end;

  if  (ASite = nil)   then  ASite   := XSite;
  if  (ABoard = nil)  then  ABoard  := XBoard;

  if  (Site = ZonuEnviron.LocalSite)  then  begin
    ini :=  TMemIniFile.Create(ChangeFileExt(LocalDatFileName, '.inf'));
    s   :=  ini.ReadString('ORG', 'SITEID', '');
    if  (s <> '') then  begin
      if  (ZonuEnviron.SiteList.FindSite(s, ASite)) then  begin
        s   :=  ini.ReadString('ORG', 'BOARDID', '');
        if  (ASite.BoardList.FindBoard(s, ABoard))  then  begin
        end;
      end;
    end else begin
      if  (ini.ReadInteger('HZB10', 'BBSTYPE', -1) = 0) then  begin
        BBS   :=  ZonuEnviron.BBSList.FindBBS(BBS_DOLIB);
        if  (ZonuEnviron.SiteList.FindSite('2ch', ASite)) then  begin
          s :=  ini.ReadString('HZB10', 'BOARDURL', '');
          s :=  ChooseString(s, '/', 3);
          if  (ASite.BoardList.FindBoard(s, ABoard)) then  begin
          end;
        end;
      end;
    end;
    BBS     :=  ABoard.BBS;
    Site    :=  ASite;
    BoardID :=  ABoard.BoardID;
  end;
  
end;

function TThreadItem.IsAbonedRes(const ResNo: integer): boolean;
begin
  if  (FAbonedList = nil)  then  begin
    Self.LoadAbonedList;
  end;
  Result  :=  (FAbonedList.ReadBool('ERASE', 'RES' + IntToStr(ResNo), False));
end;

function TThreadItem.GetLocalDatFileName: string;
var
  s: string;
  inf: TMemIniFile;
begin
  s :=  FLocalDatFileName;
  if  (FileExists(ChangeFileExt(FLocalDatFileName, '.inf')))  then  begin
    inf :=  TMemIniFile.Create(ChangeFileExt(FLocalDatFileName, '.inf'));
    if  (inf.SectionExists('INFO')) then  begin
      s :=  inf.ReadString('INFO', 'LOCAL', '') + DatNo + '.dat';
      //FCanDownload    :=  False;
      FInLocalFolder  :=  True;
    end;
    inf.Free;
  end;
  Result  :=  s;
end;

procedure TThreadItem.SetLocalDatFileName(const Value: string);
begin
  if  (ExtractFileExt(Value) = '')  then  begin
    FLocalDatFileName := Value + '.dat';
  end else begin
    FLocalDatFileName := Value;
  end;
end;

procedure TThreadItem.SetDatDate(const Value: string);
begin
  FDatDate := Value;
  FProfiler.Stop;
  FProfiler.Start;
end;

//7
{
function TThreadItem.GetLastBookmarkDate: string;
var
  i:  integer;
  r:  string;
begin
  r :=  '';
  for i :=  0 to  BookmarkList.Count - 1  do  begin
    if  (BookmarkList[i].Date
  end;
end;
}

//12
procedure TThreadItem.SetLastLoadDate(const Value: string);
begin
  FLastLoadDate_  :=  FLastLoadDate;
  FLastLoadDate   :=  Value;
end;


////////////////////////////////////////////////////////////////////////////////
{ TResList }
////////////////////////////////////////////////////////////////////////////////

function TResList.Add(Value: TRes): integer;
begin
  Result  :=  inherited Add(Value);
end;

//procedure TResList.AddRef;
//begin
//  Inc(FRefCount);
//end;

procedure TResList.Clear;
var
  i : integer;
begin
  if  (FNGResNoList <> nil) then  FNGResNoList.Clear;
  for i :=  Count - 1 downto  0 do  begin
    //OutputDebugString(Pchar('Delete >> ' + IntToStr(i)));
    Delete(i);
  end;
  inherited;
end;

constructor TResList.Create(AThreadItem: TThreadItem);
begin
  FMegaCrypt    :=  '';
  FNGResNoList  :=  TStringList.Create;
  FThreadItem   :=  AThreadItem;
  if  (FThreadItem  <>  nil)  then  begin
    FThreadItem.AddRef;
  end;
  //FRefCount         :=  0;
  //AddRef;
end;

procedure TResList.Delete(Index: integer);
begin
  TRes(Items[Index]).Free;
  inherited Delete(Index);
end;

destructor TResList.Destroy;
begin
  Clear;
  FreeAndNil(FNGResNoList);
  if  (FThreadItem  <>  nil)  then  begin
    FThreadItem.ReleaseRef;
  end;
  inherited;
end;

function TResList.FindRes(const No: integer): TRes;
var
  i : integer;
begin
  Result  :=  nil;
  for i :=  0 to  Count - 1 do  begin
    if  (Items[i].No = No)  then
    begin
      Result  :=  Items[i];
      Break;
    end;
  end;
end;

function TResList.GetRes(index: integer): TRes;
begin
  Result  :=  TRes(inherited Items[index]);
end;

function TResList.IsRefNGRes(const ResBody: string): integer;
  function  _IsRefNGRes(S, r: string): boolean;
  var
    n : integer;
    x : string;
  begin
    Result  :=  False;
    n :=  AnsiPos(S, r);
    if  (n < 1) then  Exit;
    x :=  Copy(r, n + Length(S), 1);
    if  (not IsNumeric(x))  then  begin
      Result  :=  True;
    end;
  end;
var
  i :integer;
  s : string;
begin
  Result  :=  -1;
  s :=  ResBody;
  for i :=  0 to  FNGResNoList.Count - 1 do  begin
    if  (_IsRefNGRes('&gt;'  + FNGResNoList[i], S))  or
        (_IsRefNGRes(''    + FNGResNoList[i], S))  or
        (_IsRefNGRes('&gt;'  + HanToZen(FNGResNoList[i]), S))  or
        (_IsRefNGRes(''    + HanToZen(FNGResNoList[i]), S))  then
    begin
      Result  :=  i;
      Break;
    end;
  end;
end;

//procedure TResList.ReleaseRef;
//begin
//  Dec(FRefCount);
//  if  (FRefCount = 0) then  Free;
//end;

procedure TResList.SaveToFile(const FileName: string);
var
  s : string;
  id: string;
  i : integer;
  Res : TRes;
  //Cache : TStringList;  //24
  Cache: TStringListLF;
  AboneFile : TMemIniFile;
begin
  if  (ExtractFileExt(FileName) = '') then  begin
    raise Exception.Create('oOIL^[[[[[[[[[[[[I');
  end;
  if  (ZonuEnviron.Cached)  then  begin
    if  (not DirectoryExists(ExtractFilePath(FileName))) then  begin
      ForceDirectories(ExtractFilePath(FileName));
    end;
    //Cache     :=  TStringList.Create; //24
    Cache     :=  TStringListLF.Create;
    AboneFile :=  TMemIniFile.Create(ChangeFileExt(FileName, '.inf'));
    AboneFile.EraseSection('ERASE');
    for i :=  0 to  Count - 1 do  begin
      Res :=  Items[i];
      if  (Res.IsAboned) then  begin
        AboneFile.WriteBool('ERASE', 'RES' + IntToStr(i + 1), True);
      end;
      if  (Res.RemoteHost = '') then  begin
        if  (Res.ID = '') then  begin
          id := '';
          if  (Res.BeID <> '') then  begin
            //id  :=  ' BE:' + Res.BeID + ':' + IntToStr(Res.BeLevel);
            id  :=  ' BE:' + Res.BeID + '-' + StringOfChar('#', Res.BeLevel);
          end;
          //41 Ή
          if  (Res.StockURL <> '')  then  begin
            id  :=  ' <a href="' + Res.StockURL + '">' + Res.StockText + '</a>'  + id;
          end;
          s :=  Res.Name + '<>' + Res.Mail + '<>' + Res.Date + id +
                '<>' + Res.Body + '<>';
        end else begin
          //26 begin
          id  :=  ' ID:' + Res.ID;
          if  (Res.ImgURL <> '') then begin
            id  :=  id  + ' IMG:' + ExtractUrlName(Res.ImgURL);
          end;
          if  (Res.BeID <> '') then  begin
            id  :=  id  + ' BE:' + Res.BeID + '-' + StringOfChar('#', Res.BeLevel);
          end;

          //41 Ή
          if  (Res.StockURL <> '')  then  begin
            id  :=  '<a href="' + Res.StockURL + '">' + Res.StockText + '</a>' + id;
          end;

          s :=  Res.Name + '<>' + Res.Mail + '<>' + Res.Date + 
                id + '<>' + Res.Body + '<>';

          //26 end
        end;
      end else begin
        if  (Res.ID = '') then  begin
          s :=  Res.Name + '<>' + Res.Mail + '<>' + Res.Date +
                ' ' + Res.RemoteHost  + '<>' + Res.Body + '<>';
        end else begin
          s :=  Res.Name + '<>' + Res.Mail + '<>' + Res.Date + ' ID:' +
                Res.ID   + ' ' + Res.RemoteHost  + '<>' + Res.Body + '<>';
        end;
      end;
      if  (i = 0) then  begin
        S := S + Res.ThreadTitle;
      end else
      if  (Self.ThreadItem.BBS.BBSID = Hzbconst.BBS_DOLIB)  or
          (Self.ThreadItem.BBS.BBSID = Hzbconst.BBS_2CH)  then
      begin
        if  (Res.Date = 'ځ[') then  begin
          S := S + 'ځ['
        end;
      end;
      Cache.Add(s);
    end;
    if  (ExtractFileName(FileName) <> '') then  begin
      if  (not DirectoryExists(ExtractFilePath(FileName))) then  begin
        ForceDirectories(ExtractFilePath(FileName));
      end;
      //14
      if  (Cache.Text <> '')  then  begin
        if  (ZonuConfig.LogCompatibleMode = cmJane) then  begin
          Cache.SaveToFileLF(FileName);
        end else begin
          Cache.SaveToFile(FileName);
        end;
      end;
    end;

    AboneFile.UpdateFile;
    AboneFile.ReadSections(Cache);
    AboneFile.Free;
    if  (Cache.Count = 0) then  DeleteFile(ChangeFileExt(FileName, '.inf'));

    Cache.Free;
  end;
end;

procedure TResList.SetNGResNoList(const Value: TStrings);
begin
  FNGResNoList.Assign(Value);
end;

procedure TResList.SetRes(index: integer; const Value: TRes);
begin
  inherited Items[index]  :=  Value;
end;

////////////////////////////////////////////////////////////////////////////////
{ TRes }
////////////////////////////////////////////////////////////////////////////////

procedure TRes.Assign(Source: TRes);
begin
  No          :=  Source.No;
  Name        :=  Source.Name;
  Mail        :=  Source.Mail;
  Date        :=  Source.Date;
  Body        :=  Source.Body;
  IsNew       :=  Source.IsNew;
  Data        :=  Source.Data;
  ID          :=  Source.ID;
  BeID        :=  Source.BeID;    //11
  FBeLevel    :=  Source.BeLevel; //11
  RemoteHost  :=  Source.RemoteHost;
  ThreadTitle :=  Source.ThreadTitle;
  Visible     :=  Source.Visible;
  IsAboned    :=  Source.IsAboned;
  IsNG        :=  Source.IsNG;
  IsReadPoint :=  Source.IsReadPoint;
  IsSiori     :=  Source.IsSiori;
  Showing     :=  Source.Showing;
  ImgURL      :=  Source.ImgURL;  //26
  StockText   :=  Source.StockText; //41
  StockURL    :=  Source.StockURL; //41
end;

constructor TRes.Create;
begin
  FNo           :=  0;
  FName         :=  '';
  FMail         :=  '';
  FDate         :=  '';
  FBody         :=  '';
  FIsNew        :=  False;
  FData         :=  nil;
  FID           :=  '';
  FBeID         :=  ''; //11
  FBeLevel      :=  -1; //11
  FRemoteHost   :=  '';
  FThreadTitle  :=  '';
  FVisible      :=  True;
  FIsAboned     :=  False;
  FIsNG         :=  False;
  FShowing      :=  True;
  FIsReadPoint  :=  False;
  FIsSiori      :=  False;
  FIsChecked    :=  False;
  FImgURL       :=  ''; //26
  FStockText    :=  ''; //41
  FStockURL     :=  ''; //41
end;

//11
procedure TRes.SetID(const Value: string);
var
  n: integer;
  s: string;
  v: string;
begin
  //p^[01:yjiaNOGT <BE:37676677:0>
  //p^[02:??? BE:44688577-#'
  //p^[03:id=qc85lbOV IMG:200504260009185984837975452.jpg"
  //           WJr+MMAf0 BE:130637524-BRZ(3000) |CgT

  v :=  Value;
  if  (Length(Value) > 64)  then  begin
    v :=  '';
  end else
  if  (AnsiPos('HOST:', v) > 0) then  begin
    v :=  Copy(v, 1, AnsiPos('HOST:', v) - 1);
  end;

  n :=  AnsiPos('<BE:', v);
  if  (n > 0)  then  begin
    FID       :=  Copy(v, 1, n - 2);
    s         :=  Copy(v, n + 4, Length(v));
    n :=  AnsiPos(':', s);
    FBeID     :=  Copy(s, 1, n - 1);
    s         :=  Copy(s, n + 1, Length(s));
    FBeLevel  :=  StrToIntDef(Copy(s, 1, Length(s) - 1), 0);
  end else begin
    n :=  AnsiPos(' BE:', v);
    if  (n > 0)  then  begin
      FID       :=  Copy(v, 1, n - 1);
      s         :=  Copy(v, n + 4, Length(v));
      n :=  AnsiPos('-', s);
      FBeID     :=  Copy(s, 1, n - 1);
      s         :=  Copy(s, n + 1, Length(s));
      FBeLevel  :=  StrCount1('#', s);
    end else begin
      //26 begin
      n :=  AnsiPos(' IMG:', v );
      if  (n > 0) then  begin
        FID       :=  Copy(v, 1, n - 1);
        s         :=  Copy(v, n + 5, Length(Value));
        {

        http://up01.2ch.io/_img/2005/20050426/19/200504261940417076437335493.jpg

        200504261940417076437335493.jpg

        @t@C̐擪SoCg
        At@C̐擪WoCg
        Bt@ĈXoCgڂQoCg

        }

        FImgURL   :=  '_img/' +
                      Copy(s, 1, 4) + '/' +
                      Copy(s, 1, 8) + '/' +
                      Copy(s, 9, 2) + '/' + s;

        //26 end
      end else begin
        FID       :=  v;
        FBeID     :=  '';
        FBeLevel  :=  -1;
      end;
    end;
  end;
end;

procedure TRes.SetMail(const Value: string);
begin
  FMail := StringReplace(Value, '&', '', [rfReplaceAll]);
  FMail := StringReplace(FMail, '<', '', [rfReplaceAll]);
  FMail := StringReplace(FMail, '>', '', [rfReplaceAll]);
end;

////////////////////////////////////////////////////////////////////////////////
{ TScriptParam }
////////////////////////////////////////////////////////////////////////////////

procedure TScriptParam.Assign(Source: TPersistent);
begin
  if  (Source is TScriptParam)  then  begin
    FParamBBS     :=  TScriptParam(Source).ParamBBS;
    FParamNoFirst :=  TScriptParam(Source).ParamNoFirst;
    FParamDat     :=  TScriptParam(Source).ParamDat;
    FParamStart   :=  TScriptParam(Source).ParamStart;
    FParamEnd     :=  TScriptParam(Source).ParamEnd;
    FParamRes     :=  TScriptParam(Source).ParamRes;
    FParamTrue    :=  TScriptParam(Source).ParamTrue;
    FParamFalse   :=  TScriptParam(Source).ParamFalse;
  end else begin
    inherited Assign(Source);
  end;
end;

constructor TScriptParam.Create;
begin
  FParamBBS     :=  '';
  FParamNoFirst :=  '';
  FParamDat     :=  '';
  FParamStart   :=  '';
  FParamEnd     :=  '';
  FParamRes     :=  '';
  FParamTrue    :=  '';
  FParamFalse   :=  '';
end;

////////////////////////////////////////////////////////////////////////////////
{ TBookmarkList }
////////////////////////////////////////////////////////////////////////////////

function TBookmarkList.Add(Value: TBookmarkRes): integer;
var
  i : integer;
begin
  Result  :=  0;
  if  (Value.ResNo = 0) or (Count = 0)  then  begin
    Result  :=  inherited Add(Value);
  end else
  if  (Value.ResNo < Items[0].ResNo)  then  begin
    Insert(0, Value);
    Result  :=  0;
  end else begin
    for i :=  Count - 1 downto  0 do  begin
      if  (Value.ResNo > Items[i].ResNo)  then  begin
        Insert(i + 1, Value);
        Result  :=  i;
        Break;
      end;
    end;
  end;
end;

procedure TBookmarkList.Assign(Source: TObject);
var
  i : integer;
  a : TBookmarkRes;
begin
  if  (Source is TBookmarkList)  then  begin
    Clear;
    for i :=  0 to  TBookmarkList(Source).Count - 1 do  begin
      a :=  TBookmarkRes.Create;
      a.Assign(TBookmarkList(Source).Items[i]);
      Add(a);
    end;
  end else begin
    //
  end;
end;

procedure TBookmarkList.Clear;
var
  i : integer;
begin
  for i :=  Count - 1 downto  0 do  begin
    Delete(i);
  end;
  inherited;
end;

constructor TBookmarkList.Create;
begin
  //
end;

procedure TBookmarkList.Delete(Index: integer);
begin
  TBookmarkRes(Items[Index]).Free;
  inherited Delete(Index);
end;

destructor TBookmarkList.Destroy;
begin
  Clear;
  inherited;
end;

function TBookmarkList.FindRes(ResNo: integer): TBookmarkRes;
var
  i : integer;
begin
  Result  :=  nil;
  for i :=  0 to  Count - 1 do  begin
    if  (ResNo  = Items[i].ResNo) then  begin
      Result  :=  Items[i];
      Break;
    end;
  end;
end;

function TBookmarkList.GetBookmarkRes(index: integer): TBookmarkRes;
begin
  Result  :=  TBookmarkRes(inherited Items[index]);
end;

procedure TBookmarkList.SetBookmarkRes(index: integer;
  const Value: TBookmarkRes);
begin
  inherited Items[index]  :=  Value;
end;

////////////////////////////////////////////////////////////////////////////////
{ TBookmarkRes }
////////////////////////////////////////////////////////////////////////////////

procedure TBookmarkRes.Assign(Source: TPersistent);
begin
  if  (Source is TBookmarkRes)  then  begin
    FMemo   :=  TBookmarkRes(Source).Memo;
    FResNo  :=  TBookmarkRes(Source).ResNo;
    FBody   :=  TBookmarkRes(Source).Body;
    FName   :=  TBookmarkRes(Source).Name;
    FDate   :=  TBookmarkRes(Source).Date;
  end else begin
    inherited Assign(Source);
  end;
end;

////////////////////////////////////////////////////////////////////////////////
{ TResDownloader }
////////////////////////////////////////////////////////////////////////////////

constructor TResDownloader.Create;
begin
  FBoard      :=  nil;
  FResList    :=  nil;
  FThreadItem :=  nil;
  FOriginalUrl:=  '';
  FNoCache    :=  False;
  FAutoPilot  :=  False;
  FCacheReady :=  False;
  FHttpObj    :=  nil;
  FOriginalUrl  :=  '';
end;

procedure TResDownloader.FireDataEvt(Res: TRes; Size, TotalSize: integer);
var
  ARes : TRes;
begin
  while true  do  begin
    if  (Res.No > ResList.Count + 1) then begin
      ARes          :=  TRes.Create;
      ARes.No       :=  ResList.Count + 1;
      ARes.Name     :=  BBS.AboneText;
      ARes.Mail     :=  BBS.AboneText;
      ARes.Date     :=  BBS.AboneText;
      ARes.Body     :=  BBS.AboneText;
      ARes.BBS      :=  BBS;
      ARes.Site     :=  Site;
      ARes.IsNew    :=  (ThreadItem.ReadCount < ResList.Count + 1);
      //ResList.Add(ARes);
      if  (Assigned(FDataEvt)) then  begin
        FDataEvt(Self, ARes, Size, TotalSize);
      end;
    end else
    if  (Res.No < ResList.Count + 1) then begin
      FreeAndNil(Res);
      ThreadItem.DownloadCount := ThreadItem.DownloadCount - 1;
      Break;
    end else begin
      if  (Assigned(FDataEvt)) then  begin
        FDataEvt(Self, Res, Size, TotalSize);
      end;
      Break;
    end;
  end;
end;

procedure TResDownloader.FireRedirect(Url: string); //14
begin
  if  (Assigned(FRedirectEvt)) then  begin
    FRedirectEvt(Self, Url);
  end;
end;


procedure TResDownloader.SetCacheReady(const Value: boolean);
begin
  if  (Value) then  begin
    {*!*} OutputDebugString('ZonuHttp.CacheReady := True'); {*!*}
  end else begin
    {*!*} OutputDebugString('ZonuHttp.CacheReady := False'); {*!*}
  end;
  FCacheReady := Value;
  if  (HttpObj <> nil)  then  begin
    {*!*} OutputDebugString('HttpObj Set'); {*!*}
    TZonuHttp(HttpObj).CacheReady :=  Value;
  end;
end;

{ TSendData }

constructor TSendData.Create;
begin
  FBody     :=  '';
  FMail     :=  '';
  FName     :=  '';
  FCrypt    :=  '';
  FSage     :=  False;
  FPre      :=  False;
  FTouhaba  :=  False;
  FPassword :=  '';
  FBoardID  :=  '';
  FDatNo    :=  '';
  FValuePre     :=  '';
  FValueSage    :=  '';
  FValueTouhaba :=  '';
  FExtraContent :=  '';
  FServerDate   :=  '';  
end;

function TSendData.ConvSendContent(Param: string; AServerDate: string = ''; Sa: integer = 0): string;
var
  s : string;
  tx: string;
  dt: TDateTime;
  //hh, mm, ss, ms : integer;
begin
  s :=  Param;
  s :=  StringReplace(s, '<body>',
                         HTTPEncode(JConvOut(FBoard.CharSet , FBody)),
                         [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<mail>',
                         HTTPEncode(JConvOut(FBoard.CharSet, FMail)),
                         [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<name>',
                         HTTPEncode(JConvOut(FBoard.CharSet, FName)),
                         [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<crypt>',
                         HTTPEncode(FCrypt),
                         [rfReplaceAll, rfIgnoreCase]);
  if  (FSage) then  begin
    s :=  StringReplace(s, '<sage>',
                           FValueSage,
                           [rfReplaceAll, rfIgnoreCase]);
  end else begin
    s :=  StringReplace(s, '<sage>',  '',
                           [rfReplaceAll,
                           rfIgnoreCase]);
  end;
  if  (FPre)  then  begin
    s :=  StringReplace(s, '<pre>',
                           FValuePre,
                           [rfReplaceAll, rfIgnoreCase]);
  end else begin
    s :=  StringReplace(s, '<pre>',  '',
                            [rfReplaceAll, rfIgnoreCase]);
  end;
  if  (FTouhaba)  then  begin
    s :=  StringReplace(s, '<touhaba>',  FValueTouhaba, [rfReplaceAll, rfIgnoreCase]);
  end else begin
    s :=  StringReplace(s, '<touhaba>',  '', [rfReplaceAll, rfIgnoreCase]);
  end;
  s :=  StringReplace(s, '<bbs>',  HTTPEncode(FBoard.RemoteBoardID), [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<dat>',  HTTPEncode(FDatNo), [rfReplaceAll, rfIgnoreCase]);
  if  (AServerDate = '')  then  begin
    if  (FServerDate = '')  then  begin
      //TIMEp[^Ɍ݂̎Ԃ𗘗p
      s :=  StringReplace(s, '<time>', Get2chDate(Now), [rfReplaceAll, rfIgnoreCase]);
    end else begin
      s :=  StringReplace(s, '<time>', FServerDate, [rfReplaceAll, rfIgnoreCase]);
    end;
  end else begin
    //T[o[t𗘗p
    ShortDateFormat:='yyyy/mm/dd';
    dt  :=  DateStrToDateTime(AServerDate);
    {
    hh  :=  (sa div (1000 * 60 * 60));
    mm  :=  (sa div (1000 * 60)) - (hh * 60);
    ss  :=  (sa div 1000) - (mm * 60) - (hh * 60 * 60);
    dt  :=  dt + EncodeTime(hh,mm,ss,0);
    }
    tx  :=  DateTimeToIntStr(dt);
    s   :=  StringReplace(s, '<time>', tx, [rfReplaceAll, rfIgnoreCase]);
  end;
  s :=  StringReplace(s, '<subject>',
                         HTTPEncode(JConvOut(FBoard.CharSet, FSubject)),
                         [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<password>',
                         HTTPEncode(FPassword),
                         [rfReplaceAll, rfIgnoreCase]);
  s :=  StringReplace(s, '<dir>',
                         HTTPEncode(FBoard.Dir),
                         [rfReplaceAll, rfIgnoreCase]);
  Result  :=  s;
end;

{ TResUploader }

constructor TResUploader.Create;
begin
  FBoard      :=  nil;
  FResList    :=  nil;
  FThreadItem :=  nil;
  FSendData   :=  nil;
end;

destructor TResUploader.Destroy;
begin
  if  (FSendData <> nil)  then  begin
    FSendData.Free;
  end;
  inherited;
end;

{ TUploader }

procedure TUploader.FireEndUpload(const Error: boolean);
begin
  //FEndUploadEvt
  if  (Assigned(FEndUploadEvt)) then  begin
    FEndUploadEvt(Self, Error);
  end;
end;

procedure TUploader.FireSendRetry(RecvStr: string);
begin
  if  (Assigned(FSendRetryEvt)) then  begin
    FSendRetryEvt(Self, RecvStr);
  end;
end;

procedure TUploader.FireUploadError(const ErrorCode: integer;
  ErrorMsg: string);
begin
  //FUploadErrorEvt
  if  (Assigned(FUploadErrorEvt)) then  begin
    FUploadErrorEvt(Self, ErrorCode, ErrorMsg, '');
  end;
end;

{ TThreadUploader }

constructor TThreadUploader.Create;
begin
  FBoard      :=  nil;
  FSendData   :=  nil;
end;

destructor TThreadUploader.Destroy;
begin
  if  (FSendData <> nil)  then  begin
    FSendData.Free;
  end;
  inherited;
end;

{ TBoardListDownloader }

procedure TBoardListDownloader.FireDataEvt(s: string; Size,
  TotalSize: integer; var MoreData: boolean);
begin
  if  (Assigned(FDataEvt)) then  begin
    FDataEvt(Self, s, Size, TotalSize);
  end;
end;

function TThreadItem.GetDatSize: integer;
var
  ini: TMemIniFile;
  Rec: TSearchRec;
  Size: integer;
begin
  if  (BBS.GetThreadDownloadMode = dmCGI)  then  begin
    Size  :=  0;
    if  (FileExists(LocalDatFileName))  then  begin
      if  (FindFirst(LocalDatFileName, faAnyFile, Rec) = 0) then  begin
        Size  :=  Rec.Size;
      end;
      FindClose(Rec);
    end;
    Result  :=  Size;
  end else begin
    ini     :=  TMemIniFile.Create(ChangeFileExt(LocalDatFileName, '.inf'));
    Result  :=  ini.ReadInteger('LOG', 'SIZE', 0);
    ini.Free;
  end;
end;

procedure TThreadItemList.Erase(Index: integer);
begin
  inherited Delete(Index);
end;

procedure TResDownloader.SetOriginalUrl(const Value: string);
begin
  if  (AnsiPos('http://', Value) = 1) or
      (AnsiPos('https://', Value) = 1) then
  begin
    FOriginalUrl := Value;
  end else begin
    FOriginalUrl := '';
  end;
end;


procedure TThreadItem.SetReadCount(const Value: integer);
begin
  FReadCount := Value;
end;

procedure TThreadItem.SetTitle(const Value: string);
var
  s, x: string;
  n: integer;
begin
  FTitle  :=  Value;
  s       :=  '';
  x       :=  '';
  if  (AnsiPos('', FTitle) > 0) then  begin
    s :=  Copy(FTitle, AnsiPos('', FTitle) + 2, Length(FTitle));
    s :=  ZenToHan(s);
    n :=  1;
    while (true)  do  begin
      if  (n <= Length(s)) then  begin
        if  (StrToIntDef(Copy(s, n, 1), -1) > -1)  then begin
          x :=  x + Copy(s, n, 1);
          Inc(n);
        end else begin
          Break;
        end;
      end else begin
        Break;
      end;
    end;
  end;
  FThreadNo := x;
end;


{ TStringListLF }

//24
procedure TStringListLF.SaveToFileLF(const FileName: string);
var
  s: string;
  i: integer;
  ss: TStringStream;
  ms: TMemoryStream;
begin
  s :=  '';
  for i :=  0 to  Count - 1 do  begin
    s :=  s + Strings[i] + #10;
  end;
  ss  :=  TStringStream.Create(s);
  ms  :=  TMemoryStream.Create;
  ms.LoadFromStream(ss);
  ms.SaveToFile(FileName);
  ss.Free;
  ms.Free;
end;

procedure TThreadItem.SetRemoteDatFileName(const Value: string);
begin
  FRemoteDatFileName := Value;
end;

initialization
////////////////////////////////////////////////////////////////////////////////
begin
  ZonuConfig  :=  TZonuConfig.Create;
  ZonuEnviron :=  TZonuEnviron.Create;
end;

////////////////////////////////////////////////////////////////////////////////
finalization
////////////////////////////////////////////////////////////////////////////////
begin
  ZonuEnviron.Free;
  ZonuConfig.Free;
end;

end.
