{ *************************************************************************** }
{                                                                             }
{ Hotzonu Config Class Unit                                                   }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit ZonuConf;

interface

uses
  Windows, Graphics, Forms, ComCtrls, Controls,
  Classes, SysUtils, IniFiles, MonaUtils, Hzbconst;

type
  TOpenMode = (omOpenInHotzonu, omOpenByBrowser, omOpenWithChotto);
  TTabEvent = (teReload, teClose);
  THttpMode = (hmModifiedSince, hmNoneMatch);
  TThreadTitlePanel = (ttpShowTop, ttpShowBottom, ttpHide);
  TPopupPosition    = (ppTop, ppBottom);
  //TToolbarPosition  = (tbpTop, tbpBottom, tbpLeft, tbpRight);
  TThreadListDownloadMode = (dmRealtime, dmBatch);
  TBreederMode = (bmWindowsUser, bmZonuUser);
  TImageDropPane = (dpBrowserBottom, dpThreadPanel, dpUnderThreadPanel);  //11
  TResPopupOrder = (poAsc, poDesc); //13
  TOpenApp = (oaHotzonu, oaBrowser, oaChotto); //15
  TResAnchorBrowse = (abDoubleWindow, abMoveToRes); //19
  TTabOrder = (taLeftToRight, taRightToLeft); //24
  TLogCompatibleMode = (cmOff, cmJane); //24   ]
  TRoundKakoOti = (koBroken, koDatochi, koIgnore); //30
  TReadMode = (rmLast50, rmFrom1); //33
  TDatOchiMode = (doNoDownload, doAlways, doShowAll); //33 

  TZonuConfig = class(TObject)
  private
    FAppPath: string;
    FCachePath: string;
    FProxyUse: boolean;
    FProxyPort: string;
    FProxyUserName: string;
    FProxy: string;
    FProxyPassword: string;
    FProxyMemo: string; //13
    FThreadListCount: integer;
    FCached: boolean;
    FOpenNewBrowser: boolean;
    FSendProxyUse: boolean;
    FSendProxy: string;
    FSendProxyPort: string;
    FSendProxyPassword: string;
    FSendProxyUserName: string;
    FSendProxyMemo: string; //13
    FDrawThreadList: boolean;
    FMaxPopupCount: integer;
    FResPopupOrder: TResPopupOrder; //13
    FSendWindowFontSize: integer;
    FSendWindowFontName: string;
    FSendWindowExpand: boolean;
    FSendWindowTrans: boolean;
    FSendWindowPosLeft: integer;
    FSendWindowHeight: integer;
    FSendWindowWidth: integer;
    FSendWindowPosTop: integer;
    FPreviewWindowHeight: integer;
    FPreviewWindowWidth: integer;
    FPreviewWindowPosTop: integer;
    FPreviewWindowPosLeft: integer;
    FSendWindowShowPreview: boolean;
    FWindowLeft: integer;
    FWindowWidth: integer;
    FWindowTop: integer;
    FWindowHeight: integer;
    FWindowState: TWindowState;
    FVerticalView: boolean;
    FTwoPaneMode: boolean;
    FThreadListPaneSize: integer;
    FBoardListPaneSize: integer;
    FShowBoardList: boolean;
    FShowFavorites: boolean;
    FCommentPosLeft: integer;
    FCommentHeight: integer;
    FCommentWidth: integer;
    FCommentPosTop: integer;
    //FColumnWidth: array [0..13] of integer;
    FFavColumnWidth: array [0..10] of integer;
    FActionColumnWidth: array [0..3] of integer;
    FSioriColumnWidth: array [0..4] of integer;
    ALoadThreadCount: integer;
    FLoadBoardCount: integer;
    FStartDate: TDateTime;
    FWorkedTime: integer;
    FProfiler : TMonaProfiler;
    FShowBrowser: boolean;
    FShowThreadList: boolean;
    FExtThreadList: boolean;
    FShowMessage: boolean;
    FMessageHeight: integer;
    FSkinPath: string;
    FKatjushaSkin: boolean;
    FResFilterHandleChecked: boolean;
    FResFilterIDChecked: boolean;
    FResFilterBodyChecked: boolean;
    FResFilterHandleIndex: integer;
    FGlobalHandle: string;
    FGlobalMail: string;
    FSaveHandle: boolean;
    FSendCount: integer;
    //FLoadByte: integer;
    //FSendByte: integer;
    FDefaultResCount: integer;
    FQueryAboneMailIndex: integer;
    FQueryAboneHandleIndex: integer;
    FFavEditWindowHeight: integer;
    FFavEditWindowLeft: integer;
    FFavEditWindowTop: integer;
    FFavEditWindowWidth: integer;
    FFavEditWindowState: TWindowState;
    FFavEditPaneWidth: integer;
    FCheckBroCra: boolean;
    FOpenMode: TOpenMode;
    FBCCUrl: string;
    FExecDefBrowser: boolean;
    FExecBrowser: string;
    FThreadListTabPos: TTabPosition;
    //FThreadListTabStyle: TTabStyle;
    //FThreadListMultiline: boolean;
    FBrowserTabPos: TTabPosition;
    //FBrowserTabStyle: TTabStyle;
    //FBrowserMultiline: boolean;
    //FOpenManyTabs: boolean;
    FDolibProxyPort: integer;
    FDolibUserName: string;
    FDolibPassword: string;
    FDolibProxyAddress: string;
    FDolibUseProxy: boolean;
    FAutoActivate: boolean;
    FThreadListSetting: integer;
    FBoardListSetting: integer;
    FFavListSetting: integer;
    FBoardListAutoExpand: boolean;
    FCheckBBSLink: boolean;
    FResChar: string;
    FThreadListDblClick: TTabEvent;
    FBrowserWheelClick: TTabEvent;
    FThreadListWheelClick: TTabEvent;
    FBrowserDblClick: TTabEvent;
    FUseHtmlPopup: boolean;
    FUseCgiPopup: boolean;
    FHeadline2chUrl: string;
    //FHeadline2chPages: boolean;
    //FHeadline2chBoardName: boolean;
    //FHeadline2chRank: boolean;
    FHeadline2chBkColor: TColor;
    FAmesca2chUrl: string;
    FHeadline2chExecUrl: string;
    FDolibShowDialog: boolean;
    FDolibAutoLogin: boolean;
    //FThreadListDeactiveColor: TColor;
    //FBrowserDeactiveColor: TColor;
    //FThreadListActiveColor: TColor;
    //FBrowserActiveColor: TColor;
    //FThreadListBusyColor: TColor;
    //FBrowserBusyColor: TColor;
    //FShitarabaMsgUrl: string;
    //FShitarabaVoteUrl: string;
    {
    FUrlGooJtoE: string;
    FUrlGooEtoJ: string;
    FUrlYahoo: string;
    FUrlGooNew: string;
    FUrlGooKokugo: string;
    FUrlAllTheWeb: string;
    FUrlGoogle: string;
    }
    FCancelMailTo: boolean;
    FIntoTaskTray: boolean;
    FShowThreadInfo: boolean;
    FThreadInfoWidth: integer;
    FInfoColWidth : array [0..1] of integer;
    FShowRound: boolean;
    FRoundListSetting: integer;
    FClosePageCount: integer;
    FZonuMemoMultiline: boolean;
    FZonuMemoWidth: integer;
    FZonuMemoHeight: integer;
    FZonuMemoPosTop: integer;
    FZonuMemoPosLeft: integer;
    FShowBrowserInfoBar: boolean;
    FShowThreadListInfoBar: boolean;
    FScrollTopAfterSort: boolean;
    FJumpAfterClicked: boolean;
    FShowHostName: boolean;
    FCategoryBkColor: TColor;
    FLoadResCount: integer;
    FNewThreadCount: integer;
    FAppStartCount: integer;
    FAppEndCount: integer;
    FScrollerSize: integer;
    FBoardListTextColor: TColor;
    FBoardListBkColor: TColor;
    FThreadListTextColor: TColor;
    FThreadListBkColor1: TColor;
    FThreadListBkColor2: TColor;
    FPopupFontName: string;
    FPopupTextColor: TColor;
    FPopupBkColor: TColor;
    FPopupTitleColor: TColor;
    FPopupFontSize: integer;
    FThreadShortTitle: boolean;
    FThreadTitleLength: integer;
    FBoardShortTitle: boolean;
    FBoardTitleLength: integer;
    FChangePaneBrowser: boolean;
    FChangePaneThreadList: boolean;
    FChangePaneBoardList: boolean;
    FHttpMode: THttpMode;
    FCopyWithBoardName: boolean;
    FResLoadAll: boolean;
    FResShowCount: integer;
    FAddHrefLink: boolean;
    FAddExtendRes: boolean;
    FRes1NonPopup: boolean;
    FHotzonuSkin: boolean;
    FActionHeight: integer;
    FActionPane2Size: integer;
    FActionPane1Size: integer;
    FActionWidth: integer;
    FActionPosTop: integer;
    FActionPosLeft: integer;
    FWebPageShortTitle: boolean;
    FWebPageTitleLength: integer;
    FExtractLinkPosTop: integer;
    FExtractLinkPosLeft: integer;
    FExtractLinkWidth: integer;
    FExtractLinkHeight: integer;
    FExtractLinkWindowState: TWindowState;
    FBookmarkMemoHeight: integer;
    FBookmarkManagerPosLeft: integer;
    FBookmarkManagerHeight: integer;
    FBookmarkManagerWidth: integer;
    FBookmarkManagerPosTop: integer;
    FBookmarkManagerWindowState: TWindowState;
    FBookmarkManagerPaneWidth: integer;
    FBookmarkManagerPaneHeight: integer;
    FExportFileNameType: integer;
    FExportFormat: integer;
    FExportWithIDText: boolean;
    FExportDatFormat: string;
    FExportPath: string;
    FExportSkinName: string;
    FExportSkinKatjusha: boolean;
    FExportSkinHotzonu: boolean;
    FExportSeparator: string;
    FDefaultFavoriteFolderName: string;
    FInfoDialogPosLeft: integer;
    FInfoDialogHeight: integer;
    FInfoDialogWidth: integer;
    FInfoDialogPosTop: integer;
    FExportHtmlExt: string;
    FExportDatExt: string;
    FBoardListDelete: boolean;
    FBoardListAddNew: boolean;
    FBoardListChange: boolean;
    FBoardListUpdateMode: integer;
    FThreadInfoIndex: integer;
    FActionDialogTrans: boolean;
    FActionDialogExpand: boolean;
    FZonuMemoTrans: boolean;
    FZonuMemoExpand: boolean;
    FChottoTrans: boolean;  //22
    FChottoExpand: boolean; //22
    FGaishutuCategorize: boolean;
    FZonuMemoFontSize: integer;
    FZonuMemoFontName: string;
    FAppName: string;
    FAppIcon: string;
    FThreadTitlePanel: TThreadTitlePanel;
    FThreadTitlePanelColor: TColor;
    FThreadTitleTextColor: TColor;
    FThreadTitleSize: integer;
    FAppBusyIcon: string;
    FBrowserExistsReload: boolean;
    FThreadListExistsReload: boolean;
    FMachiBBSWarning: boolean;
    FFusianasanWarning: boolean;
    FHistReloadAfterLoad: boolean;
    {
    FShitarabaMsgWindowWidth: integer;
    FShitarabaMsgPaneWidth: integer;
    FShitarabaMsgWindowLeft: integer;
    FShitarabaMsgWindowTop: integer;
    FShitarabaMsgWindowHeight: integer;
    FShitarabaMsgWindowState: TWindowState;
    FShitarabaMsgColumnWidth: array [0..2] of integer;
    }
    FMegabbsNewCgiURL: string;
    FMegabbsNewCgiURL2: string;
    FIchigoRankingUrl: string;
    FIchigo156Url: string;
    FIchigoHeadlineUrl: string;
    FIchigoHeadlineCount: integer;
    FIchigoHeadlineGaishutuOnly: boolean;
    FLocalFolderLastPath: string;
    FBBSToolBarShowImage: boolean;
    FShowBBSToolBar: boolean;
    FNinkinetUrl: string;
    FExecNinkinet: boolean;
    FUseBrowserPopup: boolean;
    FShowLogTab: boolean;
    FLogFontSize: integer;
    FLogFontName: string;
    FLogBackColor: TColor;
    FLogFontColor: TColor;
    FLogPaneWidth: integer;
    //FShitarabaMsgPassword: string;
    FLastChecked: string;
    FLastCommand: integer;
    FShowCountGap: boolean;
    FSaveHist: boolean;
    FSaveHist_Send: boolean;  //age16
    FKatjuBoardPath: string;
    FThreadTitleShowSize: boolean;
    FAppToolBarWidth: integer;
    FBoardListShowRight: boolean;
    FStartUpHzbDirect: boolean;
    FStartUpLoadDirect: boolean;
    FTabClickChangePane: boolean;
    FSndThreadNoNewRes: string;
    FSndError: string;
    FSndUpdateCheck: string; //13
    FSndRound: string; //13
    FSndThreadHasNewRes: string;
    FSndSendComplete: string;
    FSndThreadListComplete: string;
    FPopupPosition: TPopupPosition;
    FResAnchorBrowse: TResAnchorBrowse; //19
    FBrowserToolbarPosition: TAlign;
    FThreadListToolbarPosition: TAlign;
    FThreadListShowTooltip: boolean;
    FThreadListFontSize: integer;
    FThreadListFontName: string;
    FBoardListFontSize: integer;
    FBoardListFontName: string;
    //FOpenInHotzonu: boolean;
    FOpenInHotzonu: TOpenApp; //15
    FThreadListTooltipPos: TPopupPosition;
    FResFilterAllChecked: boolean;
    FThreadListRefreshCount: integer;
    FThreadListDownloadMode: TThreadListDownloadMode;
    FChottoPosTop: integer;
    FChottoPosLeft: integer;
    FChottoWidth: integer;
    FChottoHeight: integer;
    FChottoWindowState: TWindowState;
    FPromptDeleteWithFav: boolean;
    FMoveToTrash: boolean;
    FShortcutBarPos: TThreadTitlePanel;
    FShortcutBarFontName: string;  //13
    FShortcutBarFontColor: TColor;  //13
    FShortcutBarFontSize: integer;  //13
    FFilterTag2: string;
    FFilterTag1: string;
    FFilterAutoComplete: boolean; //13
    FReloadOnKokoyon: boolean;
    FExecSndSendComplete: boolean;
    FExecSndThreadListComplete: boolean;
    FExecSndError: boolean;
    FExecSndUpdateCheck: boolean; //13
    FExecSndRound: boolean; //13
    FExecSndThreadHasNewRes: boolean;
    FExecSndThreadNoNewRes: boolean;
    FStartupSite: string;
    FMilkcafeDiaryUrl: string;
    FBreederMode: TBreederMode;
    FBreederName: string;
    FUseJpegPopup: boolean;
    FJpegPopupPosLeft: integer;
    FJpegPopupHeight: integer;
    FJpegPopupWidth: integer;
    FJpegPopupPosTop: integer;
    FHeeUrl: string;
    FUseHee: boolean;
    FLockToolbar: boolean;
    FFindDialogAutoComplete: boolean; //13
    FJpegAlphaBlendValue: integer;
    FResFilterMailChecked: boolean;
    FCheckHee: boolean;
    FBrowserCheckLockTabClose: boolean;
    FThreadListCheckLockTabClose: boolean;
    FCanJpegPopupWithCtrlKey: boolean;
    FJpegPopupOnTopStay: boolean;
    FRecentCount: integer;
    FShortcutBarAddAfterEdit: boolean;  //age16
    FFilterIgnoreCase: boolean; //7
    FThreadTitleAutoFit: boolean; //8
    FBeUserName: string;  //11
    FBePassword: string;  //11
    FBeMdMdCode: string;  //11
    FBeShowDialog: boolean; //11
    FBeAutoLogin: boolean; //11
    FBeSendLoginInfo: boolean; //15
    //FDatUpdate: boolean;
    FImageDropPane: TImageDropPane; //11
    FImageDropPaneHeight: integer;  //11
    FImageDropPaneHidden: boolean;  //11
    FHistDialogPosLeft: integer;    //11
    FHistDialogPosTop: integer;     //11
    FHistDialogHeight: integer;     //11
    FHistDialogWidth: integer;      //11
    FHistDialogState: TWindowState; //11
    FHistDialogColumnWidth: array [0..4] of integer;  //11
    FAppState: TAppState; //15
    FThreadListShowCloseButton: boolean;  //16
    FBrowserShowCloseButton: boolean;     //16
    FThreadListTabOrder: TTabOrder;   //24
    FBrowserTabOrder: TTabOrder;      //24
    FLogCompatibleMode: TLogCompatibleMode;     //24
    FJanePath: string;
    FDolibUseProxyCustomSetting: boolean;
    FDolibUseProxyHotzonuSetting: boolean;  //24
    FShowSaveModeWarning: boolean;  //29
    FRoundKakoOti: TRoundKakoOti;
    FShowExitWarning: boolean;
    FSndRoundNo: string;
    FSndUpdateCheckNo: string;
    FExecSndUpdateCheckNo: boolean;
    FExecSndRoundNo: boolean;
    FFavoriteAddAfterEdit: boolean;
    FReadMode: TReadMode;
    FDatOchiMode: TDatOchiMode;
    FAddIDLink: boolean;
    FDoubleWindowHeight: integer;
    FExecSndUpdateCheckThread: boolean;
    FExecSndRoundThread: boolean;
    FShowExifInfo: boolean;
    FChottoShortTitle: boolean;
    FChottoTitleLength: integer;
    FChottoCloseAllTabs: boolean;
    FUpdateCheck: boolean;
    FCheckedVer: string;
    FUseSimpleAPI: boolean;
    FBookmarkManagerTrans: boolean;
    FBookmarkManagerExpand: boolean; //bata40 Exif

    function GetConfigPath: string;
    function GetUsersPath: string;
    function GetTempPath: string;
    //function GetColumnWidth(idx: integer): integer;
    //procedure SetColumnWidth(idx: integer; const Value: integer);
    function GetWorkedTime: integer;
    procedure SetLoadThreadCount(const Value: integer);
    function GetInfoColWidth(idx: integer): integer;
    procedure SetInfoColWidth(idx: integer; const Value: integer);
    function GetFavColumnWidth(idx: integer): integer;
    procedure SetFavColumnWidth(idx: integer; const Value: integer);
    function GetActionColumnWidth(idx: integer): integer;
    procedure SetActionColumnWidth(idx: integer; const Value: integer);
    function GetColumnWidth(ColName: string): integer;
    procedure SetColumnWidth(ColName: string; const Value: integer);
    function GetSioriColumnWidth(idx: integer): integer;
    procedure SetSioriColumnWidth(idx: integer; const Value: integer);
    {
    function GetShitarabaMsgColumnWidth(idx: integer): integer;
    procedure SetShitarabaMsgColumnWidth(idx: integer;
      const Value: integer);
    }
    function GetHistDialogColumnWidth(idx: integer): integer;  //11
    procedure SetHistDialogColumnWidth(idx: integer; const Value: integer);  //11
  protected
    function GetCookieSPID(Host: string): string; virtual;
    procedure SetCookieSPID(Host: string; const Value: string); virtual;

    //29
    function GetCookie2ch(Host: string): string; virtual;
    procedure SetCookie2ch(Host: string; const Value: string); virtual;

    property  BreederMode: TBreederMode read  FBreederMode;
    property  BreederName: string read  FBreederName;
  public
    Fini: TMemIniFile;
    constructor Create;
    destructor  Destroy; override;
    //عݖ
    property  AppName: string read  FAppName  write FAppName;
    //ع݃ACR
    property  AppIcon: string read  FAppIcon  write FAppIcon;
    property  AppBusyIcon: string read  FAppBusyIcon  write FAppBusyIcon;
    //N
    property  AppStartCount:  integer read  FAppStartCount  write FAppStartCount;
    //I
    property  AppEndCount:  integer read  FAppEndCount  write FAppEndCount;
    //߂ċN
    property  StartDate: TDateTime read  FStartDate;
    //삵Ă
    property  WorkedTime: integer read  GetWorkedTime write FWorkedTime;
    //[hXbh̐
    property  LoadThreadCount: integer read  ALoadThreadCount write SetLoadThreadCount;
    //[hX̐
    property  LoadResCount: integer read  FLoadResCount write FLoadResCount;
    //Xbh̃[h
    //property  ReadThreadCount: integer read  FReadThreadCount write FReadThreadCount;
    //[h̐
    property  LoadBoardCount: integer read  FLoadBoardCount write FLoadBoardCount;
    //݉
    property  SendCount: integer read  FSendCount write FSendCount;
    //Xĉ
    property  NewThreadCount: integer read  FNewThreadCount write FNewThreadCount;
    //ǂݍ݃oCg
    //property  LoadByte: integer read  FLoadByte write FLoadByte;
    //݃oCg
    //property  SendByte: integer read  FSendByte write FSendByte;
    //}~URL/^Cg̐
    property  ClosePageCount : integer  read  FClosePageCount write FClosePageCount;
    //fBNg
    property  ConfigPath: string   read  GetConfigPath;
    //OfBNg
    property  CachePath: string read  FCachePath  write FCachePath;
    //[U[fBNg
    property  UsersPath: string read  GetUsersPath;
    //AvP[VpX
    property  AppPath: string read FAppPath;
    //ꎞtH_pX
    property  TempPath: string read GetTempPath;
    //DAT_E[hɏ邩ǂ
    //property  DatUpdate: boolean  read  FDatUpdate  write FDatUpdate;
    //֌W
    property  ProxyUse: boolean read  FProxyUse write FProxyUse;
    property  Proxy:  string  read  FProxy  write FProxy;
    property  ProxyPort:  string  read  FProxyPort  write FProxyPort;
    property  ProxyUserName:  string  read FProxyUserName  write FProxyUserName;
    property  ProxyPassword:  string  read FProxyPassword write FProxyPassword;
    property  ProxyMemo: string read  FProxyMemo  write FProxyMemo; //13
    property  SendProxyUse: boolean read  FSendProxyUse write FSendProxyUse;
    property  SendProxy:  string  read  FSendProxy  write FSendProxy;
    property  SendProxyPort:  string  read  FSendProxyPort  write FSendProxyPort;
    property  SendProxyUserName:  string  read FSendProxyUserName  write FSendProxyUserName;
    property  SendProxyPassword:  string  read FSendProxyPassword write FSendProxyPassword;
    property  SendProxyMemo: string read  FSendProxyMemo  write FSendProxyMemo; //13
    property  HttpMode: THttpMode read  FHttpMode write FHttpMode;
    //{[hꗗŏɂЂƂ̃JeSWJ
    property  BoardListAutoExpand: boolean  read  FBoardListAutoExpand  write FBoardListAutoExpand;
    //Xbhꗗɕ\錏
    property  ThreadListCount: integer  read  FThreadListCount  write FThreadListCount;
    //ۑ[hǂ
    property  Cached: boolean  read  FCached  write FCached;
    //ɐV^uŊJǂ
    property  OpenNewBrowser: boolean  read  FOpenNewBrowser  write FOpenNewBrowser;
    //XbhꗗsPʂŒF邩ǂ
    property  DrawThreadList: boolean  read  FDrawThreadList  write FDrawThreadList;
    //>>n|bvAbvŕ\ő僌X
    property  MaxPopupCount: integer  read  FMaxPopupCount  write FMaxPopupCount;
    property  ResPopupOrder: TResPopupOrder read FResPopupOrder write FResPopupOrder; //13
    //X̃ftHg\
    property  DefaultResCount:  integer read  FDefaultResCount  write FDefaultResCount;
    //BBS̃Nł_CAOo
    property  CheckBBSLink: boolean read  FCheckBBSLink write FCheckBBSLink;
    //p
    property  ResChar: string   read  FResChar  write FResChar;
    //zXg̕\
    property  ShowHostName: boolean read  FShowHostName write FShowHostName;
    //JeS̔wiF
    property  CategoryBkColor: TColor read  FCategoryBkColor  write FCategoryBkColor;
    property  BoardListBkColor: TColor  read  FBoardListBkColor write FBoardListBkColor;
    property  BoardListTextColor: TColor  read  FBoardListTextColor write FBoardListTextColor;
    property  BoardListFontName: string   read  FBoardListFontName  write FBoardListFontName;
    property  BoardListFontSize:  integer read  FBoardListFontSize  write FBoardListFontSize;
    //Xbhꗗ̔wiF
    property  ThreadListBkColor1: TColor  read  FThreadListBkColor1 write FThreadListBkColor1;
    property  ThreadListBkColor2: TColor  read  FThreadListBkColor2 write FThreadListBkColor2;
    property  ThreadListTextColor: TColor  read  FThreadListTextColor write FThreadListTextColor;
    property  ThreadListFontName: string    read  FThreadListFontName write FThreadListFontName;
    property  ThreadListFontSize: integer   read  FThreadListFontSize write FThreadListFontSize;
    //>>n|bvAbv̔zF
    property  PopupFontName: string read  FPopupFontName  write FPopupFontName;
    property  PopupFontSize: integer read  FPopupFontSize  write FPopupFontSize;
    property  PopupBkColor: TColor  read  FPopupBkColor write FPopupBkColor;
    property  PopupTextColor: TColor  read  FPopupTextColor write FPopupTextColor;
    property  PopupTitleColor: TColor read  FPopupTitleColor  write FPopupTitleColor;
    property  PopupPosition: TPopupPosition read  FPopupPosition  write FPopupPosition;
    property  ResAnchorBrowse: TResAnchorBrowse read FResAnchorBrowse write FResAnchorBrowse; //19
    //XN[[̃{^TCY
    property  ScrollerSize: integer read  FScrollerSize write FScrollerSize;
    //݃EBhE
    property  SendWindowFontName: string  read  FSendWindowFontName write FSendWindowFontName;
    property  SendWindowFontSize: integer read  FSendWindowFontSize write FSendWindowFontSize;
    property  SendWindowExpand: boolean read  FSendWindowExpand write FSendWindowExpand;
    property  SendWindowTrans: boolean  read  FSendWindowTrans  write FSendWindowTrans;
    property  SendWindowPosLeft: integer read  FSendWindowPosLeft write FSendWindowPosLeft;
    property  SendWindowPosTop: integer read  FSendWindowPosTop write FSendWindowPosTop;
    property  SendWindowWidth: integer read  FSendWindowWidth write FSendWindowWidth;
    property  SendWindowHeight: integer read  FSendWindowHeight write FSendWindowHeight;
    property  SendWindowShowPreview: boolean read  FSendWindowShowPreview write FSendWindowShowPreview;
    property  PreviewWindowPosLeft: integer read  FPreviewWindowPosLeft write FPreviewWindowPosLeft;
    property  PreviewWindowPosTop: integer read  FPreviewWindowPosTop write FPreviewWindowPosTop;
    property  PreviewWindowWidth: integer read  FPreviewWindowWidth write FPreviewWindowWidth;
    property  PreviewWindowHeight: integer read  FPreviewWindowHeight write FPreviewWindowHeight;
    property  SaveHandle: boolean read  FSaveHandle write FSaveHandle;
    //ʂ̏
    property  WindowLeft: integer read  FWindowLeft write FWindowLeft;
    property  WindowTop: integer read  FWindowTop write FWindowTop;
    property  WindowWidth: integer read  FWindowWidth write FWindowWidth;
    property  WindowHeight: integer read  FWindowHeight write FWindowHeight;
    property  WindowState:  TWindowState  read  FWindowState  write FWindowState;
    property  VerticalView: boolean read  FVerticalView write FVerticalView;
    property  TwoPaneMode: boolean read  FTwoPaneMode write FTwoPaneMode;
    property  ThreadListPaneSize: integer read  FThreadListPaneSize write FThreadListPaneSize;
    property  BoardListPaneSize: integer  read  FBoardListPaneSize  write FBoardListPaneSize;
    property  ShowBoardList: boolean  read  FShowBoardList  write FShowBoardList;
    property  ShowFavorites: boolean  read  FShowFavorites  write FShowFavorites;
    property  ShowRound: boolean  read  FShowRound  write FShowRound;
    //property  ColumnWidth[idx: integer] : integer read  GetColumnWidth  write SetColumnWidth;
    property  ColumnWidth[ColName: string] : integer read  GetColumnWidth  write SetColumnWidth;
    property  ShowThreadList: boolean read  FShowThreadList write FShowThreadList;
    property  ShowBrowser: boolean  read  FShowBrowser  write FShowBrowser;
    property  ExtThreadList: boolean  read  FExtThreadList  write FExtThreadList;
    property  ShowMessage: boolean  read  FShowMessage  write FShowMessage;
    property  MessageHeight: integer  read  FMessageHeight  write FMessageHeight;
    property  AppToolBarWidth: integer  read  FAppToolBarWidth  write FAppToolBarWidth;
    property  BoardListShowRight: boolean  read  FBoardListShowRight  write FBoardListShowRight;

    property  ShowThreadInfo: boolean read  FShowThreadInfo write FShowThreadInfo;
    property  ThreadInfoWidth: integer  read  FThreadInfoWidth  write FThreadInfoWidth;
    property  InfoColWidth[idx: integer]: integer  read  GetInfoColWidth  write SetInfoColWidth;
    property  BookmarkMemoHeight: integer read  FBookmarkMemoHeight write FBookmarkMemoHeight;

    property  ShowThreadListInfoBar: boolean  read  FShowThreadListInfoBar  write FShowThreadListInfoBar;
    property  ShowBrowserInfoBar: boolean read  FShowBrowserInfoBar write FShowBrowserInfoBar;
    //EBhE
    property  CommentPosTop: integer read  FCommentPosTop write FCommentPosTop;
    property  CommentPosLeft: integer read  FCommentPosLeft write FCommentPosLeft;
    property  CommentWidth: integer read  FCommentWidth write FCommentWidth;
    property  CommentHeight: integer read  FCommentHeight write FCommentHeight;
    //
    property  ExtractLinkWindowState:  TWindowState  read  FExtractLinkWindowState  write FExtractLinkWindowState;
    property  ExtractLinkPosTop: integer  read  FExtractLinkPosTop  write FExtractLinkPosTop;
    property  ExtractLinkPosLeft: integer  read  FExtractLinkPosLeft write FExtractLinkPosLeft;
    property  ExtractLinkWidth: integer  read  FExtractLinkWidth write FExtractLinkWidth;
    property  ExtractLinkHeight: integer  read  FExtractLinkHeight write FExtractLinkHeight;
    //
    property  BookmarkManagerWindowState:  TWindowState  read  FBookmarkManagerWindowState  write FBookmarkManagerWindowState;
    property  BookmarkManagerPosTop: integer  read  FBookmarkManagerPosTop  write FBookmarkManagerPosTop;
    property  BookmarkManagerPosLeft: integer  read  FBookmarkManagerPosLeft write FBookmarkManagerPosLeft;
    property  BookmarkManagerWidth: integer  read  FBookmarkManagerWidth write FBookmarkManagerWidth;
    property  BookmarkManagerHeight: integer  read  FBookmarkManagerHeight write FBookmarkManagerHeight;
    property  BookmarkManagerPaneWidth: integer  read  FBookmarkManagerPaneWidth write FBookmarkManagerPaneWidth;
    property  BookmarkManagerPaneHeight: integer  read  FBookmarkManagerPaneHeight write FBookmarkManagerPaneHeight;
    //EBhE
    property  ZonuMemoPosTop: integer read  FZonuMemoPosTop write FZonuMemoPosTop;
    property  ZonuMemoPosLeft: integer read  FZonuMemoPosLeft write FZonuMemoPosLeft;
    property  ZonuMemoWidth: integer read  FZonuMemoWidth write FZonuMemoWidth;
    property  ZonuMemoHeight: integer read  FZonuMemoHeight write FZonuMemoHeight;
    property  ZonuMemoMultiline: boolean read  FZonuMemoMultiline write FZonuMemoMultiline;
    property  ZonuMemoExpand: boolean read  FZonuMemoExpand write FZonuMemoExpand;
    property  ZonuMemoTrans: boolean  read  FZonuMemoTrans  write FZonuMemoTrans;
    property  ZonuMemoFontName: string  read  FZonuMemoFontName write FZonuMemoFontName;
    property  ZonuMemoFontSize: integer read  FZonuMemoFontSize write FZonuMemoFontSize;
    //ANV
    property  ActionPosTop: integer read  FActionPosTop write FActionPosTop;
    property  ActionPosLeft: integer read  FActionPosLeft write FActionPosLeft;
    property  ActionWidth: integer read  FActionWidth write FActionWidth;
    property  ActionHeight: integer read  FActionHeight write FActionHeight;
    property  ActionPane1Size: integer  read  FActionPane1Size  write FActionPane1Size;
    property  ActionPane2Size: integer  read  FActionPane2Size  write FActionPane2Size;
    property  ActionColumnWidth[idx: integer]: integer read  GetActionColumnWidth write SetActionColumnWidth;
    property  ActionDialogExpand: boolean read  FActionDialogExpand write FActionDialogExpand;
    property  ActionDialogTrans: boolean  read  FActionDialogTrans  write FActionDialogTrans;
    //XL
    property  SkinPath: string  read  FSkinPath write FSkinPath;
    property  KatjushaSkin: boolean read  FKatjushaSkin write FKatjushaSkin;
    property  HotzonuSkin: boolean  read  FHotzonuSkin  write FHotzonuSkin;
    //tB^
    property  ResFilterHandleIndex: integer  read  FResFilterHandleIndex  write FResFilterHandleIndex;
    property  ResFilterAllChecked: boolean  read  FResFilterAllChecked  write FResFilterAllChecked;
    property  ResFilterHandleChecked: boolean  read  FResFilterHandleChecked  write FResFilterHandleChecked;
    property  ResFilterMailChecked: boolean  read  FResFilterMailChecked  write FResFilterMailChecked;
    property  ResFilterIDChecked: boolean read  FResFilterIDChecked write FResFilterIDChecked;
    property  ResFilterBodyChecked: boolean read  FResFilterBodyChecked write FResFilterBodyChecked;
    //nh
    property  GlobalHandle: string  read  FGlobalHandle write FGlobalHandle;
    property  GlobalMail: string  read  FGlobalMail write FGlobalMail;
    //NG[A{[
    property  QueryAboneHandleIndex: integer  read  FQueryAboneHandleIndex  write FQueryAboneHandleIndex;
    property  QueryAboneMailIndex: integer  read  FQueryAboneMailIndex  write FQueryAboneMailIndex;
    //ubN}[NGfB^
    property  FavEditWindowLeft: integer read  FFavEditWindowLeft write FFavEditWindowLeft;
    property  FavEditWindowTop: integer read  FFavEditWindowTop write FFavEditWindowTop;
    property  FavEditWindowWidth: integer read  FFavEditWindowWidth write FFavEditWindowWidth;
    property  FavEditWindowHeight: integer read  FFavEditWindowHeight write FFavEditWindowHeight;
    property  FavEditWindowState:  TWindowState  read  FFavEditWindowState  write FFavEditWindowState;
    property  FavEditPaneWidth:  integer  read  FFavEditPaneWidth write FFavEditPaneWidth;
    property  FavColumnWidth[idx: integer] : integer read  GetFavColumnWidth  write SetFavColumnWidth;
    //
    property  SioriColumnWidth[idx: integer]: integer read  GetSioriColumnWidth write SetSioriColumnWidth;
    //URL
    property  CheckBroCra: boolean  read  FCheckBroCra  write FCheckBroCra;
    property  OpenMode: TOpenMode read  FOpenMode write FOpenMode;
    property  BCCUrl: string  read  FBCCUrl write FBCCUrl;
    property  ExecDefBrowser: boolean read  FExecDefBrowser write FExecDefBrowser;
    //property  OpenInHotzonu: boolean  read  FOpenInHotzonu  write FOpenInHotzonu;
    property  OpenInHotzonu: TOpenApp  read  FOpenInHotzonu  write FOpenInHotzonu; //15
    property  ExecBrowser: string read  FExecBrowser  write FExecBrowser;
    //^u
    property  ThreadListTabPos: TTabPosition read  FThreadListTabPos write FThreadListTabPos;
    //property  ThreadListTabStyle: TTabStyle read  FThreadListTabStyle write FThreadListTabStyle;
    //property  ThreadListMultiline:  boolean read  FThreadListMultiline  write FThreadListMultiline;
    property  ThreadListDblClick: TTabEvent read  FThreadListDblClick write FThreadListDblClick;
    property  ThreadListWheelClick: TTabEvent read  FThreadListWheelClick write FThreadListWheelClick;
    //property  ThreadListActiveColor: TColor read  FThreadListActiveColor  write FThreadListActiveColor;
    //property  ThreadListDeactiveColor: TColor read  FThreadListDeactiveColor  write FThreadListDeactiveColor;
    //property  ThreadListBusyColor: TColor read  FThreadListBusyColor  write FThreadListBusyColor;
    property  ThreadListToolbarPosition: TAlign read  FThreadListToolbarPosition write FThreadListToolbarPosition;
    property  ThreadListCheckLockTabClose: boolean  read  FThreadListCheckLockTabClose  write FThreadListCheckLockTabClose;
    property  BrowserTabPos: TTabPosition read  FBrowserTabPos write FBrowserTabPos;
    //property  BrowserTabStyle: TTabStyle read  FBrowserTabStyle write FBrowserTabStyle;
    //property  BrowserMultiline:  boolean read  FBrowserMultiline  write FBrowserMultiline;
    property  BrowserDblClick: TTabEvent read  FBrowserDblClick write FBrowserDblClick;
    property  BrowserWheelClick: TTabEvent read  FBrowserWheelClick write FBrowserWheelClick;
    property  BrowserToolbarPosition: TAlign read  FBrowserToolbarPosition write FBrowserToolbarPosition;
    //property  BrowserActiveColor: TColor read  FBrowserActiveColor  write FBrowserActiveColor;
    //property  BrowserDeactiveColor: TColor read  FBrowserDeactiveColor  write FBrowserDeactiveColor;
    //property  BrowserBusyColor: TColor read  FBrowserBusyColor  write FBrowserBusyColor;
    property  BrowserCheckLockTabClose: boolean  read  FBrowserCheckLockTabClose  write FBrowserCheckLockTabClose;
    //Cɓ
    //property  OpenManyTabs: boolean read FOpenManyTabs  write FOpenManyTabs;
    //DOLIB
    property  DolibProxyAddress: string read  FDolibProxyAddress  write FDolibProxyAddress;
    property  DolibProxyPort: integer read  FDolibProxyPort write FDolibProxyPort;
    property  DolibUserName: string read  FDolibUserName  write FDolibUserName;
    property  DolibPassword:  string  read  FDolibPassword  write FDolibPassword;
    property  DolibUseProxy:  boolean  read  FDolibUseProxy  write FDolibUseProxy;
    property  DolibShowDialog: boolean  read  FDolibShowDialog  write FDolibShowDialog;
    property  DolibAutoLogin: boolean  read  FDolibAutoLogin  write FDolibAutoLogin;
    property  DolibUseProxyHotzonuSetting: boolean read FDolibUseProxyHotzonuSetting  write FDolibUseProxyHotzonuSetting;
    property  DolibUseProxyCustomSetting: boolean   read  FDolibUseProxyCustomSetting write FDolibUseProxyCustomSetting;
    //BE
    property  BeUserName: string  read  FBeUserName write FBeUserName;  //11
    property  BePassword: string  read  FBePassword write FBePassword;  //11
    property  BeMdMdCode: string  read  FBeMdMdCode write FBeMdMdCode;  //11
    property  BeShowDialog: boolean  read  FBeShowDialog  write FBeShowDialog;  //11
    property  BeAutoLogin: boolean  read  FBeAutoLogin  write FBeAutoLogin; //11
    property  BeSendLoginInfo: boolean read FBeSendLoginInfo write FBeSendLoginInfo; //15
    //Avݒ
    property  AutoActivate: boolean read  FAutoActivate write FAutoActivate;
    property  BoardListSetting : integer  read  FBoardListSetting write FBoardListSetting;
    property  ThreadListSetting: integer  read  FThreadListSetting  write FThreadListSetting;
    property  FavListSetting: integer read  FFavListSetting write FFavListSetting;
    property  RoundListSetting: integer read  FRoundListSetting write FRoundListSetting;
    property  CancelMailTo: boolean read  FCancelMailTo write FCancelMailTo;
    property  IntoTaskTray: boolean read  FIntoTaskTray write FIntoTaskTray;
    property  ScrollTopAfterSort: boolean read  FScrollTopAfterSort write FScrollTopAfterSort;
    property  RecentCount: integer  read  FRecentCount  write FRecentCount;
    //HTML|bvAbv
    property  UseHtmlPopup: boolean read  FUseHtmlPopup write FUseHtmlPopup;
    property  UseCgiPopup: boolean read  FUseCgiPopup write FUseCgiPopup;
    property  UseSimpleApi: boolean read FUseSimpleAPI write FUseSimpleAPI; //bata56
    //V[gJbg
    property  JumpAfterClicked: boolean read  FJumpAfterClicked write FJumpAfterClicked;
    //BBSŗL̋@\
    property  Headline2chUrl: string read  FHeadline2chUrl  write FHeadline2chUrl;
    property  Headline2chExecUrl: string read  FHeadline2chExecUrl  write FHeadline2chExecUrl;
    //property  Headline2chPages: boolean read  FHeadline2chPages write FHeadline2chPages;
    //property  Headline2chBoardName: boolean read  FHeadline2chBoardName write FHeadline2chBoardName;
    //property  Headline2chRank: boolean read  FHeadline2chRank write FHeadline2chRank;
    property  Headline2chBkColor: TColor read  FHeadline2chBkColor write FHeadline2chBkColor;
    property  Amesca2chUrl: string  read  FAmesca2chUrl write FAmesca2chUrl;
    //property  ShitarabaMsgUrl: string read  FShitarabaMsgUrl  write FShitarabaMsgUrl;
    //property  ShitarabaVoteUrl: string read  FShitarabaVoteUrl  write FShitarabaVoteUrl;
    property  CookieSPID[Host: string]: string  read  GetCookieSPID write SetCookieSPID;
    //29
    property  Cookie2ch[Host: string]: string  read  GetCookie2ch write SetCookie2ch;

    property  HeeUrl: string  read  FHeeUrl write FHeeUrl;
    property  UseHee: boolean read  FUseHee write FUseHee;
    property  CheckHee: boolean read  FCheckHee write FCheckHee;
    //
    {
    property  UrlGoogle: string read  FUrlGoogle  write FUrlGoogle;
    property  UrlYahoo: string  read  FUrlYahoo write FUrlYahoo;
    property  UrlAllTheWeb: string  read  FUrlAllTheWeb write FUrlAllTheWeb;
    property  UrlGooEtoJ: string  read  FUrlGooEtoJ write FUrlGooEtoJ;
    property  UrlGooJtoE: string  read  FUrlGooJtoE write FUrlGooJtoE;
    property  UrlGooKokugo: string  read  FUrlGooKokugo write FUrlGooKokugo;
    property  UrlGooNew: string  read  FUrlGooNew write FUrlGooNew;
    }
    //
    property  ThreadShortTitle: boolean read  FThreadShortTitle write FThreadShortTitle;
    property  ThreadTitleLength: integer  read  FThreadTitleLength  write FThreadTitleLength;
    property  BoardShortTitle: boolean read  FBoardShortTitle write FBoardShortTitle;
    property  BoardTitleLength: integer  read  FBoardTitleLength  write FBoardTitleLength;
    property  ChangePaneThreadList: boolean read  FChangePaneThreadList write FChangePaneThreadList;
    property  ChangePaneBrowser: boolean read  FChangePaneBrowser write FChangePaneBrowser;
    property  ChangePaneBoardList: boolean read  FChangePaneBoardList write FChangePaneBoardList;
    property  CopyWithBoardName: boolean  read  FCopyWithBoardName  write FCopyWithBoardName;
    property  ResLoadAll: boolean read  FResLoadAll write FResLoadAll;
    property  ResShowCount: integer read  FResShowCount write FResShowCount;
    property  AddHrefLink: boolean  read  FAddHrefLink  write FAddHrefLink;
    property  AddIDLink: boolean  read  FAddIDLink  write FAddIDLink;
    property  AddExtendRes: boolean read  FAddExtendRes write FAddExtendRes;
    property  Res1NonPopup: boolean  read  FRes1NonPopup  write FRes1NonPopup;
    property  WebPageShortTitle: boolean read  FWebPageShortTitle write FWebPageShortTitle;
    property  WebPageTitleLength: integer  read  FWebPageTitleLength  write FWebPageTitleLength;
    property  ThreadListShowCloseButton: boolean read FThreadListShowCloseButton  write FThreadListShowCloseButton;  //16
    property  BrowserShowCloseButton: boolean read FBrowserShowCloseButton  write FBrowserShowCloseButton;  //16
    property  ThreadListTabOrder: TTabOrder read FThreadListTabOrder  write FThreadListTabOrder;  //24
    property  BrowserTabOrder: TTabOrder read FBrowserTabOrder  write FBrowserTabOrder;  //24
    //Oo
    property  ExportSkinName: string  read  FExportSkinName write FExportSkinName;
    property  ExportSkinKatjusha: boolean read  FExportSkinKatjusha write FExportSkinKatjusha;
    property  ExportSkinHotzonu: boolean read  FExportSkinHotzonu write FExportSkinHotzonu;
    property  ExportDatFormat: string read  FExportDatFormat  write FExportDatFormat;
    property  ExportSeparator: string read  FExportSeparator  write FExportSeparator;
    property  ExportWithIDText: boolean read  FExportWithIDText  write FExportWithIDText;
    property  ExportFormat: integer read  FExportFormat write FExportFormat;
    property  ExportFileNameType: integer read  FExportFileNameType write FExportFileNameType;
    property  ExportHtmlExt: string read  FExportHtmlExt  write FExportHtmlExt;
    property  ExportDatExt: string read  FExportDatExt  write FExportDatExt;
    property  ExportPath: string  read  FExportPath write FExportPath;
    //
    property  DefaultFavoriteFolderName: string read FDefaultFavoriteFolderName write FDefaultFavoriteFolderName;
    //
    property  InfoDialogPosLeft: integer read  FInfoDialogPosLeft write FInfoDialogPosLeft;
    property  InfoDialogPosTop: integer read  FInfoDialogPosTop write FInfoDialogPosTop;
    property  InfoDialogWidth: integer read  FInfoDialogWidth write FInfoDialogWidth;
    property  InfoDialogHeight: integer read  FInfoDialogHeight write FInfoDialogHeight;
    //
    property  BoardListUpdateMode: integer  read  FBoardListUpdateMode  write FBoardListUpdateMode;
    property  BoardListAddNew: boolean  read  FBoardListAddNew  write FBoardListAddNew;
    property  BoardListDelete: boolean  read  FBoardListDelete  write FBoardListDelete;
    property  BoardListChange: boolean  read  FBoardListChange  write FBoardListChange;
    property  ThreadInfoIndex: integer  read  FThreadInfoIndex  write FThreadInfoIndex;
    property  GaishutuCategorize: boolean read  FGaishutuCategorize write FGaishutuCategorize;
    property  ThreadTitlePanel: TThreadTitlePanel read  FThreadTitlePanel write FThreadTitlePanel;
    property  ThreadTitlePanelColor: TColor read  FThreadTitlePanelColor write FThreadTitlePanelColor;
    property  ThreadTitleTextColor: TColor read  FThreadTitleTextColor write FThreadTitleTextColor;
    property  ThreadTitleSize: integer  read  FThreadTitleSize write FThreadTitleSize;
    property  ThreadTitleShowSize: boolean  read  FThreadTitleShowSize  write FThreadTitleShowSize;
    property  ThreadTitleAutoFit: boolean read  FThreadTitleAutoFit write FThreadTitleAutoFit;  //8
    property  ThreadListExistsReload: boolean read  FThreadListExistsReload write FThreadListExistsReload;
    property  ThreadListShowTooltip: boolean  read  FThreadListShowTooltip  write FThreadListShowTooltip;
    property  ThreadListTooltipPos: TPopupPosition  read  FThreadListTooltipPos write FThreadListTooltipPos;  
    property  BrowserExistsReload: boolean  read  FBrowserExistsReload  write FBrowserExistsReload;
    property  MachiBBSWarning: boolean  read  FMachiBBSWarning  write FMachiBBSWarning;
    property  FusianasanWarning: boolean  read  FFusianasanWarning  write FFusianasanWarning;
    property  HistReloadAfterLoad: boolean  read  FHistReloadAfterLoad  write FHistReloadAfterLoad;
    //΃bZW[
    {
    property  ShitarabaMsgWindowLeft: integer read  FShitarabaMsgWindowLeft write FShitarabaMsgWindowLeft;
    property  ShitarabaMsgWindowTop: integer read  FShitarabaMsgWindowTop write FShitarabaMsgWindowTop;
    property  ShitarabaMsgWindowWidth: integer read  FShitarabaMsgWindowWidth write FShitarabaMsgWindowWidth;
    property  ShitarabaMsgWindowHeight: integer read  FShitarabaMsgWindowHeight write FShitarabaMsgWindowHeight;
    property  ShitarabaMsgWindowState:  TWindowState  read  FShitarabaMsgWindowState  write FShitarabaMsgWindowState;
    property  ShitarabaMsgPaneWidth:  integer  read  FShitarabaMsgPaneWidth write FShitarabaMsgPaneWidth;
    property  ShitarabaMsgColumnWidth[idx: integer] : integer read  GetShitarabaMsgColumnWidth  write SetShitarabaMsgColumnWidth;
    property  ShitarabaMsgPassword: string  read  FShitarabaMsgPassword write FShitarabaMsgPassword;
    }
    //
    property  MegabbsNewCgiURL: string  read  FMegabbsNewCgiURL write FMegabbsNewCgiURL;
    property  MegabbsNewCgiURL2: string  read  FMegabbsNewCgiURL2 write FMegabbsNewCgiURL2;
    //
    property  Ichigo156Url: string  read  FIchigo156Url write FIchigo156Url;
    property  IchigoRankingUrl: string  read  FIchigoRankingUrl write FIchigoRankingUrl;
    property  IchigoHeadlineUrl: string read  FIchigoHeadlineUrl  write FIchigoHeadlineUrl;
    property  IchigoHeadlineCount: integer read  FIchigoHeadlineCount  write FIchigoHeadlineCount;
    property  IchigoHeadlineGaishutuOnly: boolean read  FIchigoHeadlineGaishutuOnly  write FIchigoHeadlineGaishutuOnly;
    //
    property  MilkcafeDiaryUrl: string  read  FMilkcafeDiaryUrl write FMilkcafeDiaryUrl;
    //
    property  LocalFolderLastPath: string read  FLocalFolderLastPath  write FLocalFolderLastPath;
    property  BBSToolBarShowImage: boolean  read  FBBSToolBarShowImage  write FBBSToolBarShowImage;
    property  ShowBBSToolBar: boolean  read  FShowBBSToolBar  write FShowBBSToolBar;
    property  NinkinetUrl: string read  FNinkinetUrl  write FNinkinetUrl;
    property  ExecNinkinet: boolean read  FExecNinkinet  write FExecNinkinet;
    property  UseBrowserPopup: boolean  read  FUseBrowserPopup  write FUseBrowserPopup;
    property  ShowLogTab: boolean read  FShowLogTab write FShowLogTab;
    //
    property  LogFontName: string read  FLogFontName  write FLogFontName;
    property  LogFontSize: integer  read  FLogFontSize  write FLogFontSize;
    property  LogFontColor: TColor  read  FLogFontColor write FLogFontColor;
    property  LogBackColor: TColor  read  FLogBackColor write FLogBackColor;
    property  LogPaneWidth: integer  read  FLogPaneWidth write FLogPaneWidth;
    //
    property  LastChecked: string   read  FLastChecked  write FLastChecked;
    property  LastCommand: integer  read  FLastCommand  write FLastCommand;
    //
    property  ShowCountGap: boolean  read  FShowCountGap  write FShowCountGap;
    property  SaveHist: boolean  read  FSaveHist  write FSaveHist;
    property  SaveHist_Send: boolean  read  FSaveHist_Send  write FSaveHist_Send; //age16
    property  KatjuBoardPath: string  read FKatjuBoardPath  write FKatjuBoardPath;
    property  StartUpHzbDirect: boolean read  FStartUpHzbDirect write FStartUpHzbDirect;
    property  StartUpLoadDirect:  boolean read  FStartUpLoadDirect  write  FStartUpLoadDirect;
    property  TabClickChangePane:  boolean read  FTabClickChangePane  write  FTabClickChangePane;
    //Sound
    property  SndThreadListComplete: string read  FSndThreadListComplete  write FSndThreadListComplete;
    property  SndThreadHasNewRes: string  read  FSndThreadHasNewRes write FSndThreadHasNewRes;
    property  SndThreadNoNewRes:  string  read  FSndThreadNoNewRes  write FSndThreadNoNewRes;
    property  SndSendComplete:  string  read  FSndSendComplete  write FSndSendComplete;
    property  SndError: string  read  FSndError write FSndError;
    property  SndUpdateCheck: string  read  FSndUpdateCheck write FSndUpdateCheck; //13
    property  SndUpdateCheckNo: string  read  FSndUpdateCheckNo write FSndUpdateCheckNo; //32
    property  SndRound: string  read  FSndRound write FSndRound; //13
    property  SndRoundNo: string  read  FSndRoundNo write FSndRoundNo; //32

    property  ExecSndThreadListComplete: boolean read  FExecSndThreadListComplete  write FExecSndThreadListComplete;
    property  ExecSndThreadHasNewRes: boolean  read  FExecSndThreadHasNewRes write FExecSndThreadHasNewRes;
    property  ExecSndThreadNoNewRes:  boolean  read  FExecSndThreadNoNewRes  write FExecSndThreadNoNewRes;
    property  ExecSndSendComplete:  boolean  read  FExecSndSendComplete  write FExecSndSendComplete;
    property  ExecSndError: boolean  read  FExecSndError write FExecSndError;
    property  ExecSndUpdateCheck: boolean  read  FExecSndUpdateCheck write FExecSndUpdateCheck; //13
    property  ExecSndUpdateCheckNo: boolean  read  FExecSndUpdateCheckNo write FExecSndUpdateCheckNo; //32
    property  ExecSndRound: boolean  read  FExecSndRound write FExecSndRound; //13
    property  ExecSndRoundNo: boolean  read  FExecSndRoundNo write FExecSndRoundNo; //32

    property  ExecSndUpdateCheckThread: boolean  read  FExecSndUpdateCheckThread write FExecSndUpdateCheckThread; //37
    property  ExecSndRoundThread: boolean  read  FExecSndRoundThread write FExecSndRoundThread; //37

    //
    property  ThreadListDownloadMode: TThreadListDownloadMode read  FThreadListDownloadMode write FThreadListDownloadMode;
    property  ThreadListRefreshCount: integer read  FThreadListRefreshCount write FThreadListRefreshCount;
    //
    property  ChottoWindowState:  TWindowState  read  FChottoWindowState  write FChottoWindowState;
    property  ChottoPosTop: integer  read  FChottoPosTop  write FChottoPosTop;
    property  ChottoPosLeft: integer  read  FChottoPosLeft write FChottoPosLeft;
    property  ChottoWidth: integer  read  FChottoWidth write FChottoWidth;
    property  ChottoHeight: integer  read  FChottoHeight write FChottoHeight;
    property  ChottoTrans: boolean  read  FChottoTrans  write FChottoTrans;   //22
    property  ChottoExpand: boolean read  FChottoExpand write FChottoExpand;  //22
    property  ChottoShortTitle: boolean read  FChottoShortTitle write FChottoShortTitle;  //49
    property  ChottoTitleLength: integer  read  FChottoTitleLength  write FChottoTitleLength; //49
    property  ChottoCloseAllTabs: boolean read  FChottoCloseAllTabs write FChottoCloseAllTabs; //49
    //
    property  PromptDeleteWithFav: boolean  read  FPromptDeleteWithFav  write FPromptDeleteWithFav;
    property  MoveToTrash: boolean  read  FMoveToTrash  write FMoveToTrash;
    property  LockToolbar: boolean  read  FLockToolbar  write FLockToolbar;
    property  FindDialogAutoComplete: boolean read  FFindDialogAutoComplete write FFindDialogAutoComplete; //13
    property  ShortcutBarPos: TThreadTitlePanel read  FShortcutBarPos write FShortcutBarPos;
    property  ShortcutBarFontName: string read  FShortcutBarFontName  write FShortcutBarFontName;  //13
    property  ShortcutBarFontColor: TColor  read  FShortcutBarFontColor write FShortcutBarFontColor;  //13
    property  ShortcutBarFontSize: integer read  FShortcutBarFontSize  write FShortcutBarFontSize;  //13
    property  FilterTag1: string  read  FFilterTag1 write FFilterTag1;
    property  FilterTag2: string  read  FFilterTag2 write FFilterTag2;
    property  FilterAutoComplete: boolean read  FFilterAutoComplete write FFilterAutoComplete; //13
    property  FilterIgnoreCase: boolean read FFilterIgnoreCase  write FFilterIgnoreCase; //7
    property  ShortcutBarAddAfterEdit: boolean  read  FShortcutBarAddAfterEdit  write FShortcutBarAddAfterEdit; //age16
    //
    property  ReloadOnKokoyon: boolean  read  FReloadOnKokoyon  write FReloadOnKokoyon;
    //
    property  StartupSite: string   read  FStartupSite  write FStartupSite;
    //
    property  UseJpegPopup: boolean read  FUseJpegPopup write FUseJpegPopup;
    property  CanJpegPopupWithCtrlKey: boolean read  FCanJpegPopupWithCtrlKey write FCanJpegPopupWithCtrlKey;
    property  JpegPopupOnTopStay: boolean read  FJpegPopupOnTopStay write FJpegPopupOnTopStay;
    property  JpegPopupPosTop: integer  read  FJpegPopupPosTop  write FJpegPopupPosTop;
    property  JpegPopupPosLeft: integer  read  FJpegPopupPosLeft write FJpegPopupPosLeft;
    property  JpegPopupWidth: integer  read  FJpegPopupWidth write FJpegPopupWidth;
    property  JpegPopupHeight: integer  read  FJpegPopupHeight write FJpegPopupHeight;
    property  JpegAlphaBlendValue: integer  read  FJpegAlphaBlendValue  write FJpegAlphaBlendValue;
    //
    property  ImageDropPane: TImageDropPane read  FImageDropPane  write FImageDropPane; //11
    property  ImageDropPaneHeight: integer  read  FImageDropPaneHeight  write FImageDropPaneHeight;  //11
    property  ImageDropPaneHidden: boolean  read  FImageDropPaneHidden  write FImageDropPaneHidden;  //11
    //
    property  HistDialogState:  TWindowState  read  FHistDialogState  write FHistDialogState;
    property  HistDialogPosTop: integer  read  FHistDialogPosTop  write FHistDialogPosTop;
    property  HistDialogPosLeft: integer  read  FHistDialogPosLeft write FHistDialogPosLeft;
    property  HistDialogWidth: integer  read  FHistDialogWidth write FHistDialogWidth;
    property  HistDialogHeight: integer  read  FHistDialogHeight write FHistDialogHeight;
    property  HistDialogColumnWidth[idx: integer] : integer read  GetHistDialogColumnWidth  write SetHistDialogColumnWidth;
    //
    property  BookmarkManagerExpand: boolean read FBookmarkManagerExpand write FBookmarkManagerExpand; //bata61
    property  BookmarkManagerTrans: boolean read FBookmarkManagerTrans write FBookmarkManagerTrans; //bata61
    //
    property  AppState: TAppState   read  FAppState write FAppState;  //15
    property  LogCompatibleMode: TLogCompatibleMode read FLogCompatibleMode write FLogCompatibleMode; //24
    property  JanePath: string  read  FJanePath write FJanePath;  //24
    property  ShowSaveModeWarning: boolean  read  FShowSaveModeWarning write FShowSaveModeWarning; //29
    property  RoundKakoOti: TRoundKakoOti read  FRoundKakoOti write FRoundKakoOti;  //30
    property  ShowExitWarning: boolean  read FShowExitWarning write FShowExitWarning; //31
    property  FavoriteAddAfterEdit: boolean  read  FFavoriteAddAfterEdit  write FFavoriteAddAfterEdit; //age32
    property  ReadMode: TReadMode read  FReadMode write FReadMode;  //33
    property  DatOchiMode: TDatOchiMode read  FDatOchiMode write FDatOchiMode; //33
    property  DoubleWindowHeight: integer  read FDoubleWindowHeight write FDoubleWindowHeight; //36
    property  ShowExifInfo: boolean read  FShowExifInfo write FShowExifInfo; //bata40 Exif
    property  UpdateCheck: boolean read FUpdateCheck write FUpdateCheck; //bata54
    property  CheckedVer: string read FCheckedVer write FCheckedVer; //bata54
    //
    procedure LoadSetting;
    procedure SaveSetting;
  end;

var
  ZonuConfig : TZonuConfig;

implementation

{ TZonuConfig }

//uses
//  ZonuClass;

constructor TZonuConfig.Create;
var
  breeder: TMemIniFile;
begin
  FAppPath    :=  ExtractFilePath(Application.ExeName);
  ForceDirectories(ConfigPath);

  breeder :=  TMemIniFile.Create(FAppPath + INI_BREEDER);
  FBreederMode  :=  TBreederMode(breeder.ReadInteger('BREEDER', 'MODE', 0));
  FBreederName  :=  breeder.ReadString('BREEDER', 'NAME', 'default');
  breeder.Free;

  ForceDirectories(UsersPath);
  //13
  if  (not FileExists(UsersPath + INI_NAME))  then  begin
    CopyFile(PChar(AppPath + PATH_DEF + INI_NAME),
             PChar(UsersPath + INI_NAME),
             True);
  end;

  Fini        :=  TMemIniFile.Create(UsersPath + INI_NAME);
  FCachePath  :=  '';
  FProfiler   :=  TMonaProfiler.Create;
  FProfiler.Start;
  LoadSetting;
  if  (not Fini.SectionExists('COOLBAR1')) then  begin
    Fini.WriteInteger('COOLBAR1', 'BAND0ID', 0);
    Fini.WriteInteger('COOLBAR1', 'BAND0WD', 528);
    Fini.WriteInteger('COOLBAR1', 'BAND0BR', 1);
    Fini.WriteInteger('COOLBAR1', 'BAND1ID', 1);
    Fini.WriteInteger('COOLBAR1', 'BAND1WD', 451);
    Fini.WriteInteger('COOLBAR1', 'BAND1BR', 0);
    Fini.WriteInteger('COOLBAR1', 'BAND2ID', 2);
    Fini.WriteInteger('COOLBAR1', 'BAND2WD', 80);
    Fini.WriteInteger('COOLBAR1', 'BAND2BR', 1);
    Fini.WriteInteger('COOLBAR1', 'BAND3ID', 3);
    Fini.WriteInteger('COOLBAR1', 'BAND3WD', 113);
    Fini.WriteInteger('COOLBAR1', 'BAND3BR', 0);
    Fini.WriteInteger('COOLBAR1', 'BAND4ID', 4);
    Fini.WriteInteger('COOLBAR1', 'BAND4WD', 784);
    Fini.WriteInteger('COOLBAR1', 'BAND4BR', 0);
    Fini.UpdateFile;
  end;
end;

destructor TZonuConfig.Destroy;
begin
  FProfiler.Stop;
  FWorkedTime :=  FWorkedTime + FProfiler.MilliSec;
  FProfiler.Free;
  SaveSetting;
  Fini.Free;
  inherited;
end;

function TZonuConfig.GetActionColumnWidth(idx: integer): integer;
begin
  if  (idx <= High(FActionColumnWidth))  then  begin
    Result  :=  FActionColumnWidth[idx];
  end else begin
    //9 Result  :=  1;
    Result  :=  100;
  end;
end;

function TZonuConfig.GetColumnWidth(ColName: string): integer;
begin
  Result  :=  Fini.ReadInteger('COLUMNSIZE', ColName, -1);  
end;

function TZonuConfig.GetConfigPath: string;
begin
  Result  :=  AppPath +  PATH_CONFIG;
end;

function TZonuConfig.GetCookieSPID(Host: string): string;
begin
  Result  :=  ExtractQuotedStr(Fini.ReadString('CookieSPID', Host, ''), ''''); //PONΉ
end;

//29
function TZonuConfig.GetCookie2ch(Host: string): string;
begin
  Result  :=  ExtractQuotedStr(Fini.ReadString('Cookie2ch', Host, ''), '''');
end;


function TZonuConfig.GetFavColumnWidth(idx: integer): integer;
begin
  if  (idx <= High(FFavColumnWidth))  then  begin
    Result  :=  FFavColumnWidth[idx];
  end else begin
    Result  :=  1;
  end;
end;

function TZonuConfig.GetInfoColWidth(idx: integer): integer;
begin
  Result  :=  FInfoColWidth[idx];
end;
{
function TZonuConfig.GetShitarabaMsgColumnWidth(idx: integer): integer;
begin
  if  (idx <= High(FShitarabaMsgColumnWidth))  then  begin
    Result  :=  FShitarabaMsgColumnWidth[idx];
  end else begin
    Result  :=  1;
  end;
end;
}
function TZonuConfig.GetSioriColumnWidth(idx: integer): integer;
begin
  if  (idx <= High(FActionColumnWidth))  then  begin
    Result  :=  FSioriColumnWidth[idx];
  end else begin
    Result  :=  1;
  end;
end;

function TZonuConfig.GetTempPath: string;
var
 chrTempPath : array [0..MAX_PATH] of char;
begin
  Windows.GetTempPath(sizeof(chrTempPath),chrTempPath);
  Result  :=  chrTempPath;
end;

function TZonuConfig.GetUsersPath: string;
var
  buffer : array [0..255] of char;
  size : Cardinal;
begin
  if  (FBreederMode = bmWindowsUser)  then  begin
    size  :=  256;
    if  (GetUserName(@buffer, size)) then  begin
      Result  :=  AppPath + PATH_USERS + buffer + '\';
    end else begin
      Result  :=  AppPath + PATH_USERS + DEFAULT_USER + '\';
    end;
  end else begin
    Result  :=  AppPath + PATH_USERS + BreederName + '\';
  end;
end;

function TZonuConfig.GetWorkedTime: integer;
begin
  Result := FWorkedTime  +  FProfiler.MilliSec;
end;

procedure TZonuConfig.LoadSetting;
var
  i : integer;
begin
  FAppName          :=  FIni.ReadString('HOTZONU', 'APPNAME', 'zbg]k');
  SetCurrentDir(AppPath);
  FAppIcon          :=  ExpandFileName(Fini.ReadString('HOTZONU', 'APPICON', 'resource\zonu.ico'));
  FAppBusyIcon      :=  ExpandFileName(Fini.ReadString('HOTZONU', 'BUSYICON', 'resource\busy.ico'));
  FAppStartCount    :=  Fini.ReadInteger('MONAZILLA', 'APPSTARTCOUNT', 0);
  FAppEndCount      :=  Fini.ReadInteger('MONAZILLA', 'APPSTARTCOUNT', 0);
  FStartDate        :=  Fini.ReadDateTime('MONAZILLA', 'START_DATE', Now);
  FWorkedTime       :=  Fini.ReadInteger('MONAZILLA', 'WORKTIME', 0);
  ALoadThreadCount  :=  Fini.ReadInteger('MONAZILLA', 'LOAD_THREAD_COUNT', 0);
  FLoadBoardCount   :=  Fini.ReadInteger('MONAZILLA', 'LOAD_BOARD_COUNT', 0);
  FSendCount        :=  Fini.ReadInteger('MONAZILLA', 'SEND_COUNT', 0);
  FNewThreadCount   :=  Fini.ReadInteger('MONAZILLA', 'NEWTHREAD_COUNT', 0);
  FLoadResCount     :=  Fini.ReadInteger('MONAZILLA', 'LOAD_RES_COUNT', 0);
  FClosePageCount   :=  Fini.ReadInteger('MONAZILLA', 'CLOSETAB', 0);
  SetCurrentDir(UsersPath);
  FCachePath      :=  ExpandFileName(Fini.ReadString('HOTZONU', 'LOG', UsersPath + PATH_CACHE));
  //FDatUpdate      :=  Fini.ReadBool('HOTZONU', 'DATUPD', True);
  FProxyUse       :=  Fini.ReadBool('PROXY', 'USE', False);
  FProxy          :=  Fini.ReadString('PROXY', 'HOST', '');
  FProxyPort      :=  Fini.ReadString('PROXY', 'PORT', '80');
  FProxyUserName  :=  Fini.ReadString('PROXY', 'USERNAME', '');
  FProxyPassword  :=  Fini.ReadString('PROXY', 'PASSWORD', '');
  FProxyMemo      :=  Fini.ReadString('PROXY', 'MEMO', ''); //13
  FSendProxyUse       :=  Fini.ReadBool('SEND_PROXY', 'USE', False);
  FSendProxy          :=  Fini.ReadString('SEND_PROXY', 'HOST', '');
  FSendProxyPort      :=  Fini.ReadString('SEND_PROXY', 'PORT', '80');
  FSendProxyUserName  :=  Fini.ReadString('SEND_PROXY', 'USERNAME', '');
  FSendProxyPassword  :=  Fini.ReadString('SEND_PROXY', 'PASSWORD', '');
  FSendProxyMemo      :=  Fini.ReadString('SEND_PROXY', 'MEMO', ''); //13
  FHttpMode       :=  THttpMode(Fini.ReadInteger('HTTP', 'MODE', 0));
  FThreadListCount:=  Fini.ReadInteger('HOTZONU', 'THREADLISTCOUNT', 100);
  FCached         :=  Fini.ReadBool('HOTZONU', 'CACHED', True);
  FOpenNewBrowser :=  Fini.ReadBool('HOTZONU', 'OPENNEWBROWSER', True);
  FDrawThreadList :=  Fini.ReadBool('HOTZONU', 'DRAWTHREADLIST', True);
  FMaxPopupCount  :=  Fini.ReadInteger('HOTZONU', 'MAXPOPUPCOUNT', 10);
  FResPopupOrder  :=  TResPopupOrder(Fini.ReadInteger('HOTZONU', 'POPUPORDER', 0)); //13
  FDefaultResCount:=  Fini.ReadInteger('HOTZONU', 'DEFAULTRESCOUNT', 50);
  FShowHostName   :=  Fini.ReadBool('HOTZONU', 'SHOWHOSTNAME', False);
  FCategoryBkColor    :=  StringToColor(Fini.ReadString('HOTZONU', 'CATEGORYBKCOLOR', 'clInfoBk'));
  FBoardListBkColor   :=  StringToColor(Fini.ReadString('HOTZONU', 'BOARDLISTBKCOLOR', 'clWindow'));
  FBoardListTextColor :=  StringToColor(Fini.ReadString('HOTZONU', 'BOARDTEXTCOLOR', 'clWindowText'));
  FBoardListFontName  :=  Fini.ReadString('HOTZONU', 'BOARDLISTFONTNAME', 'lr oSVbN');
  FBoardListFontSize  :=  Fini.ReadInteger('HOTZONU', 'BOARDLISTFONTSIZE', 9);
  FThreadListBkColor1 :=  StringToColor(Fini.ReadString('HOTZONU', 'THREADLISTCOLOR1', 'clWindow'));
  FThreadListBkColor2 :=  StringToColor(Fini.ReadString('HOTZONU', 'THREADLISTCOLOR2', '$00EDEDE2'));
  FThreadListTextColor:=  StringToColor(Fini.ReadString('HOTZONU', 'THREADLISTTEXTCOLOR', 'clWindowText'));
  FThreadListFontName :=  Fini.ReadString('HOTZONU', 'THREADLISTFONTNAME', 'lr oSVbN');
  FThreadListFontSize :=  Fini.ReadInteger('HOTZONU', 'THREADLISTFONTSIZE', 9);
  FPopupFontName      :=  Fini.ReadString('HOTZONU', 'POPUPFONTNAME', 'lr oSVbN');
  FPopupFontSize      :=  Fini.ReadInteger('HOTZONU', 'POPUPFONTSIZE', 9);
  FPopupBkColor       :=  StringToColor(Fini.ReadString('HOTZONU', 'POPUPBKCOLOR', 'clInfoBk'));
  FPopupTextColor     :=  StringToColor(Fini.ReadString('HOTZONU', 'POPUPTEXTCOLOR', 'clWindowText'));
  FPopupTitleColor    :=  StringToColor(Fini.ReadString('HOTZONU', 'POPUPTITLECOLOR', 'clGreen'));
  FPopupPosition      :=  TPopupPosition(Fini.ReadInteger('HOTZONU', 'POPUPPOS', 0));
  FResAnchorBrowse    :=  TResAnchorBrowse(Fini.ReadInteger('HOTZONU', 'RESANCHORBROWSE', 0));
  FScrollerSize       :=  Fini.ReadInteger('HOTZONU', 'SCROLLERSIZE', 12);
  FSendWindowFontName :=  Fini.ReadString('HOTZONU','SEND_FONTNAME', 'lr oSVbN');
  FSendWindowFontSize :=  Fini.ReadInteger('HOTZONU','SEND_FONTSIZE',9);
  FSendWindowExpand   :=  Fini.ReadBool('HOTZONU', 'SEND_EXPAND',  True);
  FSendWindowTrans    :=  Fini.ReadBool('HOTZONU', 'SEND_TRANS',  True);
  FSendWindowPosLeft  :=  Fini.ReadInteger('HOTZONU', 'SENDWIN_LEFT', 80);
  FSendWindowPosTop   :=  Fini.ReadInteger('HOTZONU', 'SENDWIN_TOP', 80);
  FSendWindowHeight   :=  Fini.ReadInteger('HOTZONU', 'SENDWIN_HEIGHT', 410);
  FSendWindowWidth    :=  Fini.ReadInteger('HOTZONU', 'SENDWIN_WIDTH', 450);
  FSendWindowShowPreview  :=  Fini.ReadBool('HOTZONU', 'SENDWIN_PREVIEW', True);
  FPreviewWindowPosLeft   :=  Fini.ReadInteger('HOTZONU', 'PREVIEWWIN_LEFT', 80);
  FPreviewWindowPosTop    :=  Fini.ReadInteger('HOTZONU', 'PREVIEWWIN_TOP', 80);
  FPreviewWindowHeight    :=  Fini.ReadInteger('HOTZONU', 'PREVIEWWIN_HEIGHT', 410);
  FPreviewWindowWidth     :=  Fini.ReadInteger('HOTZONU', 'PREVIEWWIN_WIDTH', 450);
  FThreadShortTitle       :=  Fini.ReadBool('HOTZONU', 'SHORTTITLE', True);
  FThreadTitleLength      :=  Fini.ReadInteger('HOTZONU', 'TITLELEN', 20);
  FBoardShortTitle        :=  Fini.ReadBool('HOTZONU', 'BOARDSHORTTITLE', False);
  FBoardTitleLength       :=  Fini.ReadInteger('HOTZONU', 'BOARDTITLELEN', 20);
  FChangePaneThreadList   :=  Fini.ReadBool('HOTZONU', 'CHANGEPANE_THREADLIST', True);
  FChangePaneBrowser      :=  Fini.ReadBool('HOTZONU', 'CHANGEPANE_BROWSER', True);
  FChangePaneBoardList    :=  Fini.ReadBool('HOTZONU', 'CHANGEPANE_BOARDLIST', True);
  FWebPageShortTitle      :=  Fini.ReadBool('HOTZONU', 'WEBSHORTTITLE', True);
  FWebPageTitleLength     :=  Fini.ReadInteger('HOTZONU', 'WEBTITLELEN', 20);
  FThreadListShowCloseButton  :=  Fini.ReadBool('HOTZONU',  'THREADLIST_SHOWCLOSEBTN',  True); //16
  FBrowserShowCloseButton     :=  Fini.ReadBool('HOTZONU',  'BROWSER_SHOWCLOSEBTN',     True); //16
  FThreadListTabOrder         :=  TTabOrder(Fini.ReadInteger('HOTZONU',  'THREADLIST_TABORDER',  0)); //24
  FBrowserTabOrder            :=  TTabOrder(Fini.ReadInteger('HOTZONU',  'BROWSER_TABORDER',     0)); //24


  FWindowLeft   :=  Fini.ReadInteger('DESKTOP', 'LEFT',   0);
  FWindowTop    :=  Fini.ReadInteger('DESKTOP', 'TOP',    0);
  FWindowWidth  :=  Fini.ReadInteger('DESKTOP', 'WIDTH',  650);
  FWindowHeight :=  Fini.ReadInteger('DESKTOP', 'HEIGHT', 400);
  FWindowState  :=  TWindowState(Fini.ReadInteger('DESKTOP', 'WINDOWSTATE', 2));
  FVerticalView :=  Fini.ReadBool('DESKTOP', 'VERTICAL', False);
  FTwoPaneMode  :=  Fini.ReadBool('DESKTOP', '2PANE', False);
  FThreadListPaneSize :=  Fini.ReadInteger('DESKTOP', 'THREADLISTSIZE', 159);
  FBoardListPaneSize  :=  Fini.ReadInteger('DESKTOP', 'BOARDLISTSIZE',217);
  FShowBoardList      :=  Fini.ReadBool('DESKTOP', 'SHOWBOARDLIST', True);
  FShowFavorites      :=  Fini.ReadBool('DESKTOP', 'SHOWFAVORITES', False);
  FShowRound          :=  Fini.ReadBool('DESKTOP', 'ShowRound', False);
  FCommentPosTop   :=  Fini.ReadInteger('DESKTOP', 'COMMENTWIN_TOP', 80);
  FCommentPosLeft  :=  Fini.ReadInteger('DESKTOP', 'COMMENTWIN_LEFT', 80);
  FCommentWidth    :=  Fini.ReadInteger('DESKTOP', 'COMMENTWIN_WIDTH',200);
  FCommentHeight   :=  Fini.ReadInteger('DESKTOP', 'COMMENTWIN_HEIGHT',300);
  FExtractLinkWindowState :=  TWindowState(Fini.ReadInteger('DESKTOP', 'EXTRACTLINK_WINDOWSTATE', 2));
  FExtractLinkPosTop  :=  Fini.ReadInteger('DESKTOP', 'EXTRACTLINK_TOP', 0);
  FExtractLinkPosLeft :=  Fini.ReadInteger('DESKTOP', 'EXTRACTLINK_LEFT', 80);
  FExtractLinkWidth   :=  Fini.ReadInteger('DESKTOP', 'EXTRACTLINK_WIDTH', 200);
  FExtractLinkHeight  :=  Fini.ReadInteger('DESKTOP', 'EXTRACTLINK_HEIGHT', 200);
  FBookmarkManagerWindowState :=  TWindowState(Fini.ReadInteger('DESKTOP', 'BOOKMARK_WINDOWSTATE', 2));
  FBookmarkManagerPosTop      :=  Fini.ReadInteger('DESKTOP', 'BOOKMARK_TOP', 80);
  FBookmarkManagerPosLeft     :=  Fini.ReadInteger('DESKTOP', 'BOOKMARK_LEFT', 80);
  FBookmarkManagerWidth       :=  Fini.ReadInteger('DESKTOP', 'BOOKMARK_WIDTH', 200);
  FBookmarkManagerHeight      :=  Fini.ReadInteger('DESKTOP', 'BOOKMARK_HEIGHT', 200);
  FBookmarkManagerPaneWidth   :=  Fini.ReadInteger('DESKTOP', 'BOOKMARK_PANEWIDTH', 269);
  FBookmarkManagerPaneHeight  :=  Fini.ReadInteger('DESKTOP', 'BOOKMARK_PANEHEIGHT', 280);

  FZonuMemoPosTop   :=  Fini.ReadInteger('DESKTOP', 'ZONUMEMOWIN_TOP', 80);
  FZonuMemoPosLeft  :=  Fini.ReadInteger('DESKTOP', 'ZONUMEMOWIN_LEFT', 80);
  FZonuMemoWidth    :=  Fini.ReadInteger('DESKTOP', 'ZONUMEMOWIN_WIDTH',300);
  FZonuMemoHeight   :=  Fini.ReadInteger('DESKTOP', 'ZONUMEMOWIN_HEIGHT',300);
  FZonuMemoMultiline  :=  Fini.ReadBool('DESKTOP', 'ZONUMEMOMULTILINE', True);
  FZonuMemoExpand     :=  Fini.ReadBool('DESKTOP', 'ZONUMEMOEXPAND', True);
  FZonuMemoTrans      :=  Fini.ReadBool('DESKTOP', 'ZONUMEMOTRANS', True);
  FZonuMemoFontName   :=  Fini.ReadString('DESKTOP', 'ZONUMEMOFONTNAME', '');
  FZonuMemoFontSize   :=  Fini.ReadInteger('DESKTOP', 'ZONUMEMOFONTSIZE', 9);
  FActionPosTop           :=  Fini.ReadInteger('DESKTOP', 'ACTWIN_TOP',  80);
  FActionPosLeft          :=  Fini.ReadInteger('DESKTOP', 'ACTWIN_LEFT', 80);
  FActionHeight           :=  Fini.ReadInteger('DESKTOP', 'ACTWIN_HEIGHT',300);
  FActionWidth            :=  Fini.ReadInteger('DESKTOP', 'ACTWIN_WIDTH', 400);
  FActionPane1Size        :=  Fini.ReadInteger('DESKTOP', 'ACTWIN_PANE1', 185);
  FActionPane2Size        :=  Fini.ReadInteger('DESKTOP', 'ACTWIN_PANE2', 433);
  FActionDialogExpand     :=  Fini.ReadBool('DESKTOP', 'ACTWIN_EXPAND', True);
  FActionDialogTrans      :=  Fini.ReadBool('DESKTOP', 'ACTWIN_TRANS', True);
  {
  for i :=  Low(FColumnWidth) to  High(FColumnWidth)  do  begin
    FColumnWidth[i] :=  Fini.ReadInteger('DESKTOP', 'COLUMNWIDTH' + IntToStr(i), -1);
    if  (FColumnWidth[i] = 0) or (FColumnWidth[i] < -1) then  begin
      FColumnWidth[i] :=  1;
    end;
  end;
  }
  for i :=  Low(FInfoColWidth) to  High(FInfoColWidth)  do  begin
    FInfoColWidth[i] :=  Fini.ReadInteger('DESKTOP', 'INFOCOLWIDTH' + IntToStr(i), 90);
  end;
  for i :=  Low(FActionColumnWidth) to  High(FActionColumnWidth)  do  begin
    FActionColumnWidth[i]  :=  Fini.ReadInteger('DESKTOP', 'ACTIONCOLWIDTH' + IntToStr(i), 90);
  end;
  for i :=  Low(FSioriColumnWidth) to  High(FSioriColumnWidth)  do  begin
    FSioriColumnWidth[i]  :=  Fini.ReadInteger('DESKTOP', 'SIORI_COLWIDTH' + IntToStr(i), 30);
  end;

  FShowThreadList   :=  Fini.ReadBool('DESKTOP', 'SHOWTHREADLIST', False);
  FShowBrowser      :=  Fini.ReadBool('DESKTOP', 'SHOWBROWSER', True);
  FExtThreadList    :=  Fini.ReadBool('DESKTOP', 'EXTTHREADLIST', False);
  FShowMessage      :=  Fini.ReadBool('DESKTOP', 'SHOWMESSAGE', True);
  FMessageHeight    :=  Fini.ReadInteger('DESKTOP', 'MESSAGESIZE', 50);
  FAppToolBarWidth  :=  Fini.ReadInteger('DESKTOP', 'APPTOOLBARWIDTH', 185);
  FBoardListShowRight :=  Fini.ReadBool('DESKTOP', 'BOARDLISTSHOWRIGHT', False);
  FShowThreadInfo   :=  Fini.ReadBool('DESKTOP', 'THREADINFO', False);
  FThreadInfoWidth  :=  Fini.ReadInteger('DESKTOP', 'THREADINFOWIDTH', 185);
  FBookmarkMemoHeight   :=  Fini.ReadInteger('DESKTOP', 'BOOKMARKMEMO', 250);
  FShowBrowserInfoBar   :=  Fini.ReadBool('DESKTOP', 'SHOWTHREADLISTINFO', True);
  FShowThreadListInfoBar:=  Fini.ReadBool('DESKTOP', 'SHOWBROWSERINFO', True);

  FSkinPath       :=  Fini.ReadString('SKIN', 'PATH', UsersPath + PATH_SKIN + 'default');
  FKatjushaSkin   :=  Fini.ReadBool('SKIN', 'KATJUSHA', False);
  FHotzonuSkin    :=  Fini.ReadBool('SKIN', 'HOTZONU', False);
  FResFilterHandleIndex     :=  Fini.ReadInteger('FILTERDLG' , 'HANDLE', 0);
  FResFilterAllChecked      :=  Fini.ReadBool('FILTERDLG' , 'ALLCHK',  True);
  FResFilterHandleChecked   :=  Fini.ReadBool('FILTERDLG' , 'HANDLECHK',  False);
  FResFilterIDChecked       :=  Fini.ReadBool('FILTERDLG' , 'IDCHK',      False);
  FResFilterBodyChecked     :=  Fini.ReadBool('FILTERDLG' , 'BODYCHK',    False);
  FResFilterMailChecked     :=  Fini.ReadBool('FILTERDLG',  'MAILCHK',    False);
  FGlobalHandle             :=  Fini.ReadString('HOTZONU', 'GLOBALHANDLE', '');
  FGlobalMail               :=  Fini.ReadString('HOTZONU', 'GLOBALMAIL', '');
  FSaveHandle               :=  Fini.ReadBool('DESKTOP', 'SENDWIN_SAVEHANDLE', True);
  QueryAboneHandleIndex     :=  Fini.ReadInteger('RESQUERYABONE', 'HANDLE', 0);
  QueryAboneMailIndex       :=  Fini.ReadInteger('RESQUERYABONE', 'MAIL', 0);
  FFavEditWindowLeft    :=  Fini.ReadInteger('DESKTOP', 'FAVLEFT',   (Screen.Width - 400) div 2);
  FFavEditWindowTop     :=  Fini.ReadInteger('DESKTOP', 'FAVTOP',    (Screen.Height- 300) div 2);
  FFavEditWindowWidth   :=  Fini.ReadInteger('DESKTOP', 'FAVWIDTH',  400);
  FFavEditWindowHeight  :=  Fini.ReadInteger('DESKTOP', 'FAVHEIGHT', 300);
  FFavEditWindowState   :=  TWindowState(Fini.ReadInteger('DESKTOP', 'FAVWINDOWSTATE', 0));
  FFavEditPaneWidth     :=  Fini.ReadInteger('DESKTOP', 'FAVPANEWIDTH', 180);
  for i :=  Low(FFavColumnWidth) to  High(FFavColumnWidth)  do  begin
    FFavColumnWidth[i ] :=  Fini.ReadInteger('DESKTOP', 'FAVCOLUMNWIDTH' + IntToStr(i), -1);
    if  (FavColumnWidth[i] = 0) or (FavColumnWidth[i] < -1) then  begin
      FFavColumnWidth[i] :=  1;
    end;
  end;

  FCheckBroCra          :=  Fini.ReadBool('URL', 'CHECKBROCRA', True);
  FOpenMode             :=  TOpenMode(Fini.ReadInteger('URL', 'OPENMODE', 0));
  FBCCUrl               :=  Fini.ReadString('URL', 'BCC', 'http://www.jah.ne.jp/~fild/cgi-bin/LBCC/lbcc.cgi?');
  FExecDefBrowser       :=  Fini.ReadBool('URL', 'EXECDEFAULTBROWSER', True);
  //FOpenInHotzonu        :=  Fini.ReadBool('URL', 'OPENINHOTZONU', True);
  FOpenInHotzonu        :=  TOpenApp(Fini.ReadInteger('URL', 'OPENINHOTZONU', 0)); //15
  FExecBrowser          :=  Fini.ReadString('URL', 'BROWSERPATH', '');
  FThreadListTabPos     :=  TTabPosition(Fini.ReadInteger('THREADTAB', 'POSITION', 1));
  FThreadListDblClick   :=  TTabEvent(Fini.ReadInteger('THREADTAB', 'DBLCLICK', 0));
  FThreadListWheelClick :=  TTabEvent(Fini.ReadInteger('THREADTAB', 'WHEELCLICK', 1));
  FThreadListToolbarPosition    :=  TAlign(Fini.ReadInteger('THREADTAB', 'TOOLBARPOS', 3));
  FThreadListCheckLockTabClose  :=  Fini.ReadBool('THREADTAB', 'CHECKLOCKCLOSE', True);
  FBrowserTabPos        :=  TTabPosition(Fini.ReadInteger('BROWSERTAB', 'POSITION', 0));
  FBrowserDblClick      :=  TTabEvent(Fini.ReadInteger('BROWSERTAB', 'DBLCLICK', 0));
  FBrowserWheelClick    :=  TTabEvent(Fini.ReadInteger('BROWSERTAB', 'WHEELCLICK', 1));
  FBrowserToolbarPosition       :=  TAlign(Fini.ReadInteger('BROWSERTAB', 'TOOLBARPOS', 3));
  FBrowserCheckLockTabClose     :=  Fini.ReadBool('BROWSERTAB', 'CHECKLOCKCLOSE', True);
  FDolibProxyPort       :=  Fini.ReadInteger('DOLIB', 'PROXYPORT', 80);
  FDolibProxyAddress    :=  Fini.ReadString('DOLIB', 'PROXYADDRESS', '');
  FDolibUserName        :=  Fini.ReadString('DOLIB', 'USERNAME', '');
  FDolibPassword        :=  Fini.ReadString('DOLIB', 'PASSWORD', '');
  FDolibUseProxy        :=  Fini.ReadBool('DOLIB', 'USERPROXY', False);
  FDolibShowDialog      :=  Fini.ReadBool('DOLIB', 'SHOWDIALOG', False);
  FDolibAutoLogin       :=  Fini.ReadBool('DOLIB', 'AUTOLOGIN', False);
  FDolibUseProxyHotzonuSetting  :=  Fini.ReadBool('DOLIB', 'PROXY_HOTZONU', False);
  FDolibUseProxyCustomSetting   :=  Fini.ReadBool('DOLIB', 'PROXY_CUSTOM', True);
  FBeUserName           :=  Fini.ReadString('BE', 'USERNAME', '');  //11
  FBePassword           :=  Fini.ReadString('BE', 'PASSWORD', '');  //11
  FBeMdMdCode           :=  Fini.ReadString('BE', 'MDMDCODE', '');  //11
  FBeShowDialog         :=  Fini.ReadBool('BE', 'SHOWDIALOG', True);  //11
  FBeAutoLogin          :=  Fini.ReadBool('BE', 'AUTOLOGIN', False);  //11
  FBeSendLoginInfo      :=  Fini.ReadBool('BE', 'SENDLOGININFO', False); //15
  FAutoActivate         :=  Fini.ReadBool('HOTZONU', 'AUTOACTIVE', False);
  FBoardListSetting     :=  Fini.ReadInteger('HOTZONU', 'BOARDLISTSETTING', 0);
  FThreadListSetting    :=  Fini.ReadInteger('HOTZONU', 'THREADLISTSETTING', 1);
  FFavListSetting       :=  Fini.ReadInteger('HOTZONU', 'FAVLISTSETTING', 0);
  FRoundListSetting     :=  Fini.ReadInteger('HOTZONU', 'ROUNDLISTSETTING', 0);
  FCancelMailTo         :=  Fini.ReadBool('HOTZONU', 'CANCELMAILTO', False);
  FIntoTaskTray         :=  Fini.ReadBool('HOTZONU', 'INTOTASKTRAY', False);
  FScrollTopAfterSort   :=  Fini.ReadBool('HOTZONU', 'SCROLLTOP', True);
  FRecentCount          :=  Fini.ReadInteger('HOTZONU', 'RECENTCOUNT', 10);
  FBoardListAutoExpand  :=  Fini.ReadBool('HOTZONU', 'BOARDLISTAUTOEXPAND', False);
  FCheckBBSLink         :=  Fini.ReadBool('HOTZONU', 'CHECKBBSLINK', True);
  FResChar              :=  Fini.ReadString('HOTZONU', 'RESCHAR', '>');
  FUseHtmlPopup         :=  Fini.ReadBool('HOTZONU', 'USEHTMLPOPUP', True);
  FUseCgiPopup          :=  Fini.ReadBool('HOTZONU', 'USECGIPOPUP', True);
  FUseSimpleAPI         :=  Fini.ReadBool('HOTZONU', 'USESIMPLEAPI', True);
  FJumpAfterClicked     :=  Fini.ReadBool('HOTZONU', 'JUMPSHORTCUT', True);
  FCopyWithBoardName    :=  Fini.ReadBool('HOTZONU', 'COPYWITHBOARDNAME', False);
  FHeadline2chUrl       :=  Fini.ReadString('2CH', 'HEADLINE_URL', 'http://nmgm.s2.xrea.com/2ch.htm');
  FHeadline2chExecUrl   :=  Fini.ReadString('2CH', 'HEADLINE_CGI', 'http://nmgm.s2.xrea.com/x/getsub2.cgi');
  FHeadline2chBkColor   :=  Fini.ReadInteger('2CH', 'HEADLINE_BKCOLOR', $006BD2E9);
  FAmesca2chUrl         :=  Fini.ReadString('2CH', 'AMESCA_URL', 'http://www.amezoscape.to/cgi-bin/namazu.cgi');
  //FShitarabaMsgUrl      :=  Fini.ReadString('SHITARABA', 'MSGURL', 'http://www.shitaraba.com/cgi-bin/message.cgi');
  //FShitarabaVoteUrl     :=  Fini.ReadString('SHITARABA', 'VOTEURL', 'http://www.shitaraba.com/cgi-bin/vote.cgi');
  {
  FUrlGooJtoE           :=  Fini.ReadString('SEARCHENGINE', 'GOO_E2J', 'http://dictionary.goo.ne.jp/cgi-bin/dict_search.cgi?MT=%s&sw=0');
  FUrlGooEtoJ           :=  Fini.ReadString('SEARCHENGINE', 'GOO_J2E', 'http://dictionary.goo.ne.jp/cgi-bin/dict_search.cgi?MT=%s&sw=1');
  FUrlYahoo             :=  Fini.ReadString('SEARCHENGINE', 'YAHOO', 'http://search.yahoo.co.jp/bin/search?p=%s');
  FUrlGooNew            :=  Fini.ReadString('SEARCHENGINE', 'GOO_NEW', 'http://dictionary.goo.ne.jp/cgi-bin/dict_search.cgi?MT=%s&sw=3');
  FUrlGooKokugo         :=  Fini.ReadString('SEARCHENGINE', 'GOO_KOKUGO', 'http://dictionary.goo.ne.jp/cgi-bin/dict_search.cgi?MT=%s&sw=2');
  FUrlAllTheWeb         :=  Fini.ReadString('SEARCHENGINE', 'ALLTHEWEB', 'http://www.alltheweb.com/search?cat=web&lang=japanese&query=%s');
  FUrlGoogle            :=  Fini.ReadString('SEARCHENGINE', 'GOOGLE', 'http://www.google.co.jp/search?q=%s&hl=ja&btnG=Google+%s&lr=lang_ja');
  }

  FResLoadAll           :=  Fini.ReadBool('HOTZONU', 'RESLOADALL', False);
  FResShowCount         :=  Fini.ReadInteger('HOTZONU', 'RESSHOWCOUNT', 100);
  FAddHrefLink          :=  Fini.ReadBool('HOTZONU', 'ADDHREFLINK', True);
  FAddIDLink            :=  Fini.ReadBool('HOTZONU', 'ADDIDLINK', True);
  FAddExtendRes         :=  Fini.ReadBool('HOTZONU', 'ADDEXTRES', True);
  FRes1NonPopup         :=  Fini.ReadBool('HOTZONU', 'RES1NOPOPUP', False);
  //
  FExportFileNameType   :=  Fini.ReadInteger('HOTZONU', 'EXPORT_FILENAMETYPE', 0);
  FExportFormat         :=  Fini.ReadInteger('HOTZONU', 'EXPORT_FORMAT', 0);
  FExportWithIDText     :=  Fini.ReadBool('HOTZONU', 'EXPORT_WITHIDTEXT', True);
  FExportDatFormat      :=  Fini.ReadString('HOTZONU', 'EXPORT_DATFORMAT', '<NAME/><><MAIL/><><DATE/> <ID/><><MESSAGE/><><THREADNAME><>');
  FExportSeparator      :=  Fini.ReadString('HOTZONU', 'EXPORT_SEPARATOR', '<>');
  FExportPath           :=  Fini.ReadString('HOTZONU', 'EXPORT_PATH', '');
  FExportHtmlExt        :=  Fini.ReadString('HOTZONU', 'EXPORT_HTMLEXT', '.html');
  FExportDatExt         :=  Fini.ReadString('HOTZONU', 'EXPORT_DATEXT', '.dat');
  FExportSkinName       :=  Fini.ReadString('HOTZONU', 'EXPORT_SKINNAME', '');
  ExportSkinKatjusha    :=  Fini.ReadBool('HOTZONU', 'EXPORT_SKIN_KATJUSHA', False);
  ExportSkinHotzonu     :=  Fini.ReadBool('HOTZONU', 'EXPORT_SKIN_HOTZONU', False);
  FDefaultFavoriteFolderName  :=  Fini.ReadString('HOTZONU', 'DEFFAVNAME', 'default');
  FInfoDialogPosLeft    :=  Fini.ReadInteger('DESKTOP', 'INFO_LEFT', 80);
  FInfoDialogPosTop     :=  Fini.ReadInteger('DESKTOP', 'INFO_TOP', 80);
  FInfoDialogWidth      :=  Fini.ReadInteger('DESKTOP', 'INFO_WIDTH', 357);
  FInfoDialogHeight     :=  Fini.ReadInteger('DESKTOP', 'INFO_HEIGHT', 284);
  FBoardListUpdateMode  :=  Fini.ReadInteger('HOTZONU', 'BOARDLISTUPDATEMODE', 0);
  FBoardListAddNew      :=  Fini.ReadBool('HOTZONU', 'BOARDLISTADDNEW', True);
  FBoardListDelete      :=  Fini.ReadBool('HOTZONU', 'BOARDLISTDELETE', True);
  FBoardListChange      :=  Fini.ReadBool('HOTZONU', 'BOARDLISTCHANGE', True);
  FThreadInfoIndex      :=  Fini.ReadInteger('HOTZONU', 'THREADINFOINDEX', 0);
  FGaishutuCategorize   :=  Fini.ReadBool('HOTZONU', 'GAISHUTUCATEGO', True);
  FThreadTitlePanel     :=  TThreadTitlePanel(Fini.ReadInteger('HOTZONU', 'THREADTITLEPANEL', 0));
  FThreadTitlePanelColor:=  StringToColor(Fini.ReadString('HOTZONU', 'THREADTITLEPANELCOLOR', 'clBtnShadow'));
  FThreadTitleTextColor :=  StringToColor(Fini.ReadString('HOTZONU', 'THREADTITLETEXTCOLOR', 'clHighlightText'));
  FThreadTitleSize      :=  Fini.ReadInteger('HOTZONU', 'THREADTITLESIZE', 14);
  FThreadTitleShowSize  :=  Fini.ReadBool('HOTZONU', 'THREADTITLESHOWSIZE', False);
  FThreadTitleAutoFit   :=  Fini.ReadBool('HOTZONU', 'THREADTITLEAUTOFIT', True);
  FThreadListExistsReload   :=  Fini.ReadBool('HOTZONU', 'THREADLISTEXISTSRELOAD', False);
  FThreadListShowTooltip    :=  Fini.ReadBool('HOTZONU', 'THREADLISTSHOWTOOLTIP', True);
  FThreadListTooltipPos     :=  TPopupPosition(Fini.ReadInteger('HOTZONU', 'THREADLISTTOOLTIPPOS', 1));
  FBrowserExistsReload      :=  Fini.ReadBool('HOTZONU', 'BROWSEREXISTSRELOAD', False);
  FMachiBBSWarning      :=  Fini.ReadBool('MACHIBBS', 'WARNING', True);
  FFusianasanWarning    :=  Fini.ReadBool('HOTZONU', 'FUSIANASAN', True);
  FHistReloadAfterLoad  :=  Fini.ReadBool('HOTZONU', 'HISTRELOAD', True);
  {
  FShitarabaMsgWindowLeft    :=  Fini.ReadInteger('DESKTOP', 'SHITARABALEFT',   (Screen.Width - 400) div 2);
  FShitarabaMsgWindowTop     :=  Fini.ReadInteger('DESKTOP', 'SHITARABATOP',    (Screen.Height- 300) div 2);
  FShitarabaMsgWindowWidth   :=  Fini.ReadInteger('DESKTOP', 'SHITARABAWIDTH',  400);
  FShitarabaMsgWindowHeight  :=  Fini.ReadInteger('DESKTOP', 'SHITARABAHEIGHT', 300);
  FShitarabaMsgWindowState   :=  TWindowState(Fini.ReadInteger('DESKTOP', 'SHITARABAWINDOWSTATE', 0));
  FShitarabaMsgPaneWidth     :=  Fini.ReadInteger('DESKTOP', 'SHITARABAPANEWIDTH', 180);
  for i :=  Low(FShitarabaMsgColumnWidth) to  High(FShitarabaMsgColumnWidth)  do  begin
    FShitarabaMsgColumnWidth[i] :=  Fini.ReadInteger('DESKTOP', 'SHITARABACOLUMNWIDTH' + IntToStr(i), -1);
    if  (FShitarabaMsgColumnWidth[i] = 0) or (FShitarabaMsgColumnWidth[i] < -1) then  begin
      FShitarabaMsgColumnWidth[i] :=  1;
    end;
  end;
  }
  FHeeUrl               :=  Fini.ReadString('CHBOX', 'HEURL', 'http://vote.chbox.com/he.jsp?id=<THREADNAME/>&url=<THREADURL/>&gr=2ch');
  FUseHee               :=  Fini.ReadBool('CHBOX', 'USEHE', True);
  FCheckHee             :=  Fini.ReadBool('CHBOX', 'CHECKHE', False);
  //FShitarabaMsgPassword :=  Fini.ReadString('SHITARABA', 'PASSWORD', '');
  FMegabbsNewCgiURL     :=  Fini.ReadString('MEGABBS_NEWCGI', 'megabbs', 'http://www.megabbs.com/cgi-bin/new.cgi');
  FMegabbsNewCgiURL2    :=  Fini.ReadString('MEGABBS_NEWCGI', 'lemmingdead', 'http://lemmingdead.mine.nu/cgi-bin/megabbs/new.cgi');
  FIchigo156Url         :=  Fini.ReadString('ICHIGOBBS', '156', 'http://www.ichigobbs.com/156/');
  FIchigoRankingUrl     :=  Fini.ReadString('ICHIGOBBS', 'RANKING', 'http://www.d-w-b.com/cgi-bin/lank/lank.cgi?name=suren&mode=today&genre=15');
  FIchigoHeadlineUrl    :=  Fini.ReadString('ICHIGOBBS', 'HEADLINE', 'http://matari.ichigobbs.com/cgi/15news/hl_all.cgi');
  FIchigoHeadlineCount  :=  Fini.ReadInteger('ICHIGOBBS', 'HEADLINECOUNT', 10);
  FIchigoHeadlineGaishutuOnly :=  Fini.ReadBool('ICHIGOBBS', 'HEADLINESHOW', False);
  FMilkcafeDiaryUrl     :=  Fini.ReadString('MILKCAFE', 'DIARY', 'http://d.hatena.ne.jp/kensuu/');
  FLocalFolderLastPath  :=  Fini.ReadString('HOTZONU', 'LOCALFOLDERLASTPATH', '');
  FBBSToolBarShowImage  :=  Fini.ReadBool('HOTZONU', 'BBSTOOLBARSHOWIMAGE', True);
  FShowBBSToolBar       :=  Fini.ReadBool('HOTZONU', 'SHOWBBSTOOLBAR', False);
  FNinkinetUrl          :=  Fini.ReadString('NINKINET', 'URL', 'http://www.ninki.net/cgi-bin/bdisp.cgi?id=<ID>');
  FExecNinkinet         :=  Fini.ReadBool('NINKINET', 'CHECK', True);
  FUseBrowserPopup      :=  Fini.ReadBool('HOTZONU', 'BROWSERPOPUP', True);
  FShowLogTab           :=  Fini.ReadBool('DESKTOP', 'SHOWLOGTAB', True);
  FLogFontName          :=  Fini.ReadString('DESKTOP', 'LOGFONTNAME', 'lr oSVbN');
  FLogFontSize          :=  Fini.ReadInteger('DESKTOP', 'LOGFONTSIZE', 9);
  FLogFontColor         :=  StringToColor(Fini.ReadString('DESKTOP', 'LOGFONTCOLOR', 'clWindowText'));
  FLogBackColor         :=  StringToColor(Fini.ReadString('DESKTOP', 'LOGBACKCOLOR', 'clWindow'));
  FLogPaneWidth         :=  Fini.ReadInteger('DESKTOP', 'LOGPANEWIDTH', 130);
  FLastChecked          :=  Fini.ReadString('HOTZONU', 'LASTCHECK', '');
  FLastCommand          :=  Fini.ReadInteger('HOTZONU', 'LASTCOMMAND', 0);
  FShowCountGap         :=  Fini.ReadBool('HOTZONU', 'SHOWCOUNTGAP', False);
  FSaveHist             :=  Fini.ReadBool('HOTZONU', 'SAVEHIST', True);
  FSaveHist_Send        :=  Fini.ReadBool('HOTZONU', 'SAVEHIST_SEND', FSaveHist); //age16
  FKatjuBoardPath       :=  Fini.ReadString('HOTZONU', 'KATJUBOARDPATH', '');
  FStartUpHzbDirect     :=  Fini.ReadBool('HOTZONU', 'STARTUPSHOWDIRECT', False);
  FStartUpLoadDirect    :=  Fini.ReadBool('HOTZONU', 'STARTUPLOADDIRECT', False);
  FTabClickChangePane   :=  Fini.ReadBool('HOTZONU', 'TABCLICKCHANGEPANE', False);
  FThreadListDownloadMode   :=  TThreadListDownloadMode(Fini.ReadInteger('HOTZONU', 'THREADLISTDOWNLOADMODE', 0));
  FThreadListRefreshCount   :=  Fini.ReadInteger('HOTZONU', 'THREADLISTREFRESHCOUNT', 50);

  SetCurrentDir(UsersPath);
  FSndThreadNoNewRes    :=  ExpandFileName(Fini.ReadString('SOUND', 'THREADNONEWRES', 'nores.wav'));
  FSndError             :=  ExpandFileName(Fini.ReadString('SOUND', 'ERROR', 'nores.wav'));
  FSndUpdateCheck       :=  ExpandFileName(Fini.ReadString('SOUND', 'UPDATECHECK', '')); //13
  FSndUpdateCheckNo     :=  ExpandFileName(Fini.ReadString('SOUND', 'UPDATECHECK_NO', '')); //32
  FSndRound             :=  ExpandFileName(Fini.ReadString('SOUND', 'ROUND', '')); //13
  FSndRoundNo           :=  ExpandFileName(Fini.ReadString('SOUND', 'ROUND_NO', '')); //32
  FSndThreadHasNewRes   :=  ExpandFileName(Fini.ReadString('SOUND', 'THREADNEWRES', 'newres.wav'));
  FSndSendComplete      :=  ExpandFileName(Fini.ReadString('SOUND', 'SEND', 'send.wav'));
  FSndThreadListComplete:=  ExpandFileName(Fini.ReadString('SOUND', 'THREADLIST', 'error.wav'));
  FExecSndThreadNoNewRes    :=  Fini.ReadBool('SOUND', 'EXECTHREADNONEWRES', True);
  FExecSndError             :=  Fini.ReadBool('SOUND', 'EXECERROR', True);
  FExecSndUpdateCheck       :=  Fini.ReadBool('SOUND', 'EXECUPDATECHECK', False);
  FExecSndUpdateCheckNo     :=  Fini.ReadBool('SOUND', 'EXECUPDATECHECK_NO', False);
  FExecSndRound             :=  Fini.ReadBool('SOUND', 'EXECROUND', False);
  FExecSndRoundNo           :=  Fini.ReadBool('SOUND', 'EXECROUND_NO', False);
  FExecSndUpdateCheckThread :=  Fini.ReadBool('SOUND', 'EXECUPDATECHECK_THREAD', False);
  FExecSndRoundThread       :=  Fini.ReadBool('SOUND', 'EXECROUND_THREAD', False);
  FExecSndThreadHasNewRes   :=  Fini.ReadBool('SOUND', 'EXECTHREADNEWRES', True);
  FExecSndSendComplete      :=  Fini.ReadBool('SOUND', 'EXECSEND', True);
  FExecSndThreadListComplete:=  Fini.ReadBool('SOUND', 'EXECTHREADLIST', True);
  FChottoWindowState :=  TWindowState(Fini.ReadInteger('DESKTOP', 'CHOTTOWIN_WINDOWSTATE', 2));
  FChottoPosTop  :=  Fini.ReadInteger('DESKTOP', 'CHOTTOWIN_TOP', 80);
  FChottoPosLeft :=  Fini.ReadInteger('DESKTOP', 'CHOTTOWIN_LEFT', 80);
  FChottoWidth   :=  Fini.ReadInteger('DESKTOP', 'CHOTTOWIN_WIDTH', 200);
  FChottoHeight  :=  Fini.ReadInteger('DESKTOP', 'CHOTTOWIN_HEIGHT', 200);

  FChottoTrans        :=  Fini.ReadBool('DESKTOP', 'CHOTTOWIN_TRANS', False); //22
  FChottoExpand       :=  Fini.ReadBool('DESKTOP', 'CHOTTOWIN_EXPND', True); //22
  FChottoShortTitle   :=  Fini.ReadBool('HOTZONU', 'CHOTTO_SHORTTITLE', True); //49
  FChottoTitleLength  :=  Fini.ReadInteger('HOTZONU', 'CHOTTO_TITLELEN', 20); //49
  FChottoCloseAllTabs :=  Fini.ReadBool('HOTZONU', 'CHOTTO_CLOSEALLTABS', True); //49

  FPromptDeleteWithFav  :=  Fini.ReadBool('HOTZONU' , 'PRMPTDELETEFAV', False);
  FMoveToTrash          :=  Fini.ReadBool('HOTZONU', 'MOVETOTRASH', False);
  FLockToolbar          :=  Fini.ReadBool('HOTZONU', 'LOCKTOOLBAR', False);
  FFindDialogAutoComplete   :=  Fini.ReadBool('HOTZONU', 'FINDDLGAUTOCOMPLETE', True); //13
  FShortcutBarPos       :=  TThreadTitlePanel(Fini.ReadInteger('HOTZONU', 'SHORTCUTBARPOS', 0));
  FShortcutBarFontName  :=  Fini.ReadString('HOTZONU', 'SHORTCUTBARFONTNAME', 'lr oSVbN'); //13
  FShortcutBarFontColor :=  Fini.ReadInteger('HOTZONU', 'SHORTCUTBARFONTCOLOR', clWindowText); //13
  FShortcutBarFontSize  :=  Fini.ReadInteger('HOTZONU', 'SHORTCUTBARFONTSIZE', 9); //13
  FFilterTag1           :=  Fini.ReadString('HOTZONU', 'FILTERTAG1', '<B><FONT COLOR=RED>');
  FFilterTag2           :=  Fini.ReadString('HOTZONU', 'FILTERTAG2', '</FONT></B>');
  FFilterAutoComplete   :=  Fini.ReadBool('HOTZONU', 'FILtERAUTOCOMPLETE', True ); //13
  FFilterIgnoreCase     :=  Fini.ReadBool('HOTZONU', 'FILTERIGNORECASE', False);
  FShortcutBarAddAfterEdit  :=  Fini.ReadBool('HOTZONU', 'SHORTCUTBAR_ADDEDIT', False); //age16
  FReloadOnKokoyon      :=  Fini.ReadBool('HOTZONU', 'RELOADKOKOYON', True);
  FStartupSite          :=  Fini.ReadString('HOTZONU', 'STARTUPSITE', '');
  FUseJpegPopup         :=  Fini.ReadBool('HOTZONU', 'JPEGPOPUP', True);
  FCanJpegPopupWithCtrlKey  :=  Fini.ReadBool('HOTZONU', 'JPEGPOPUP_CTRL', False);
  FJpegPopupOnTopStay   :=  Fini.ReadBool('HOTZONU', 'JPEGWIN_ONTOP', True);
  FJpegPopupPosTop      :=  Fini.ReadInteger('DESKTOP', 'JPEGWIN_TOP', 80);
  FJpegPopupPosLeft     :=  Fini.ReadInteger('DESKTOP', 'JPEGWIN_LEFT', 80);
  FJpegPopupWidth       :=  Fini.ReadInteger('DESKTOP', 'JPEGWIN_WIDTH', 200);
  FJpegPopupHeight      :=  Fini.ReadInteger('DESKTOP', 'JPEGWIN_HEIGHT', 200);
  FJpegAlphaBlendValue  :=  Fini.ReadInteger('DESKTOP', 'JPEGWIN_ALPHA', 200);
  FImageDropPane        :=  TImageDropPane(Fini.ReadInteger('DESKTOP', 'IMAGEPANE', 1));  //11
  FImageDropPaneHeight  :=  Fini.ReadInteger('DESKTOP', 'IMAGEPANE_HEIGHT', 41);  //11
  FImageDropPaneHidden  :=  Fini.ReadBool('DESKTOP', 'IMAGEPANE_HIDDEN', False);  //11
  FHistDialogState   :=  TWindowState(Fini.ReadInteger('DESKTOP', 'HISTDIALOG_WINDOWSTATE', 0));  //11
  FHistDialogPosTop  :=  Fini.ReadInteger('DESKTOP', 'HISTDIALOG_TOP', 80);     //11
  FHistDialogPosLeft :=  Fini.ReadInteger('DESKTOP', 'HISTDIALOG_LEFT', 80);    //11
  FHistDialogWidth   :=  Fini.ReadInteger('DESKTOP', 'HISTDIALOG_WIDTH', 696);  //11
  FHistDialogHeight  :=  Fini.ReadInteger('DESKTOP', 'HISTDIALOG_HEIGHT', 480); //11
  FBookmarkManagerExpand    :=  Fini.ReadBool('BOOKMARKMANAGER', 'EXPAND', True); //bata61
  FBookmarkManagerTrans     :=  Fini.ReadBool('BOOKMARKMANAGER', 'TRANS', True); //bata61
  FAppState             :=  TAppState(Fini.ReadInteger('HOTZONU', 'APPSTATE', 0)); //15
  FLogCompatibleMode    :=  TLogCompatibleMode(Fini.ReadInteger('HOTZONU', 'LOGMODE', 0));  //24
  FJanePath             :=  Fini.ReadString('HOTZONU', 'JANE_PATH', '');
  FShowSaveModeWarning  :=  Fini.ReadBool('HOTZONU', 'SAVEMODE_WARNING', True); //29
  FRoundKakoOti         :=  TRoundKakoOti(Fini.ReadInteger('HOTZONU', 'ROUND_KAKO_OCHI', 0));  //30
  FShowExitWarning      :=  Fini.ReadBool('HOTZONU', 'EXIT_WARNING', False);  //31
  FFavoriteAddAfterEdit :=  Fini.ReadBool('HOTZONU', 'FAVADDEDIT', False);  //32
  FReadMode             :=  TReadMode(Fini.ReadInteger('HOTZONU', 'READMODE',0)); //33
  FDatOchiMode          :=  TDatOchiMode(Fini.ReadInteger('HOTZONU', 'DATOCHIMODE', 0));  //33
  FDoubleWindowHeight   :=  Fini.ReadInteger('HOTZONU', 'DOUBLEWINDOW_HEIGHT', 0);  //36
  FShowExifInfo         :=  FIni.ReadBool('HOTZONU', 'SHOWEXIFINFO', False); //bata40
  FUpdateCheck          :=  Fini.ReadBool('HOTZONU', 'UPDCHECK', True); //bata54
  FCheckedVer           :=  Fini.ReadString('HOTZONU', 'CHECKVER', ''); //bata54
  for i :=  Low(FHistDialogColumnWidth) to  High(FHistDialogColumnWidth)  do  begin
    FHistDialogColumnWidth[i ] :=  Fini.ReadInteger('DESKTOP', 'HISTDIALOG_COLUMNWIDTH' + IntToStr(i), -1);
    if  (FHistDialogColumnWidth[i] = 0) or (FHistDialogColumnWidth[i] < -1) then  begin
      FHistDialogColumnWidth[i] :=  1;
    end;
  end;

  DeleteFile(ChangeFileExt(UsersPath + INI_NAME, '.bak'));
  CopyFile(PChar(UsersPath + INI_NAME),
           PChar(ChangeFileExt(UsersPath + INI_NAME, '.bak')),
           False);
end;

procedure TZonuConfig.SaveSetting;
var
  i : integer;
begin
  FIni.WriteString('HOTZONU', 'APPNAME', FAppName);
  Fini.WriteString('HOTZONU', 'APPICON', ExtractRelativePath(AppPath , FAppIcon));
  Fini.WriteString('HOTZONU', 'BUSYICON', ExtractRelativePath(AppPath , FAppBusyIcon));
  Fini.WriteInteger('MONAZILLA', 'APPSTARTCOUNT', FAppStartCount);
  Fini.WriteInteger('MONAZILLA', 'APPSTARTCOUNT', FAppEndCount);
  Fini.WriteDateTime('MONAZILLA', 'START_DATE', FStartDate);
  Fini.WriteInteger('MONAZILLA', 'WORKTIME', FWorkedTime);
  Fini.WriteInteger('MONAZILLA', 'LOAD_THREAD_COUNT', ALoadThreadCount);
  Fini.WriteInteger('MONAZILLA', 'LOAD_BOARD_COUNT', FLoadBoardCount);
  Fini.WriteInteger('MONAZILLA', 'SEND_COUNT', FSendCount);
  Fini.WriteInteger('MONAZILLA', 'NEWTHREAD_COUNT', FNewThreadCount);
  Fini.WriteInteger('MONAZILLA', 'LOAD_RES_COUNT', FLoadResCount);
  Fini.WriteInteger('MONAZILLA', 'CLOSETAB', FClosePageCount);
  Fini.WriteString('HOTZONU', 'LOG', ExtractRelativePath(UsersPath , FCachePath));
  Fini.WriteBool('PROXY', 'USE', FProxyUse);
  Fini.WriteString('PROXY', 'HOST', FProxy);
  Fini.WriteString('PROXY', 'PORT', FProxyPort);
  Fini.WriteString('PROXY', 'USERNAME', FProxyUserName);
  Fini.WriteString('PROXY', 'PASSWORD', FProxyPassword);
  Fini.WriteString('PROXY', 'MEMO', FProxyMemo);
  Fini.WriteBool('SEND_PROXY', 'USE',FSendProxyUse);
  Fini.WriteString('SEND_PROXY', 'HOST', FSendProxy);
  Fini.WriteString('SEND_PROXY', 'PORT', FSendProxyPort);
  Fini.WriteString('SEND_PROXY', 'USERNAME', FSendProxyUserName);
  Fini.WriteString('SEND_PROXY', 'PASSWORD', FSendProxyPassword);
  Fini.WriteString('SEND_PROXY', 'MEMO', FSendProxyMemo);
  Fini.WriteInteger('HOTZONU', 'THREADLISTCOUNT', FThreadListCount);
  Fini.WriteInteger('HTTP', 'MODE', Integer(FHttpMode));
  Fini.WriteBool('HOTZONU', 'CACHED', FCached);
  Fini.WriteBool('HOTZONU', 'OPENNEWBROWSER', FOpenNewBrowser);
  Fini.WriteBool('HOTZONU', 'DRAWTHREADLIST', FDrawThreadList);
  Fini.WriteInteger('HOTZONU', 'MAXPOPUPCOUNT', FMaxPopupCount);
  Fini.WriteInteger('HOTZONU', 'POPUPORDER', Integer(FResPopupOrder)); //13
  Fini.WriteInteger('HOTZONU', 'DEFAULTRESCOUNT', FDefaultResCount);
  Fini.WriteBool('HOTZONU', 'SHOWHOSTNAME', FShowHostName);
  Fini.WriteString('HOTZONU', 'CATEGORYBKCOLOR', ColorToString(FCategoryBkColor));
  Fini.WriteString('HOTZONU', 'BOARDLISTBKCOLOR', ColorToString(FBoardListBkColor));
  Fini.WriteString('HOTZONU', 'BOARDTEXTCOLOR', ColorToString(FBoardListTextColor));
  Fini.WriteString('HOTZONU', 'BOARDLISTFONTNAME', FBoardListFontName);
  Fini.WriteInteger('HOTZONU', 'BOARDLISTFONTSIZE', FBoardListFontSize);
  Fini.WriteString('HOTZONU', 'THREADLISTCOLOR1', ColorToString(FThreadListBkColor1));
  Fini.WriteString('HOTZONU', 'THREADLISTCOLOR2', ColorToString(FThreadListBkColor2));
  Fini.WriteString('HOTZONU', 'THREADLISTTEXTCOLOR', ColorToString(FThreadListTextColor));
  Fini.WriteString('HOTZONU', 'THREADLISTFONTNAME', FThreadListFontName);
  Fini.WriteInteger('HOTZONU', 'THREADLISTFONTSIZE', FThreadListFontSize);
  Fini.WriteString('HOTZONU', 'POPUPFONTNAME', FPopupFontName);
  Fini.WriteInteger('HOTZONU', 'POPUPFONTSIZE',FPopupFontSize);
  Fini.WriteString('HOTZONU', 'POPUPBKCOLOR', ColorToString(FPopupBkColor));
  Fini.WriteString('HOTZONU', 'POPUPTEXTCOLOR', ColorToString(FPopupTextColor));
  Fini.WriteString('HOTZONU', 'POPUPTITLECOLOR', ColorToString(FPopupTitleColor));
  Fini.WriteInteger('HOTZONU', 'POPUPPOS', Integer(FPopupPosition));
  Fini.WriteInteger('HOTZONU', 'RESANCHORBROWSE', Integer(FResAnchorBrowse));
  Fini.WriteInteger('HOTZONU', 'SCROLLERSIZE', FScrollerSize);
  Fini.WriteString('HOTZONU','SEND_FONTNAME', FSendWindowFontName);
  Fini.WriteInteger('HOTZONU','SEND_FONTSIZE',FSendWindowFontSize);
  Fini.WriteBool('HOTZONU', 'SEND_EXPAND',  FSendWindowExpand);
  Fini.WriteBool('HOTZONU', 'SEND_TRANS',  FSendWindowTrans);
  Fini.WriteInteger('HOTZONU', 'SENDWIN_LEFT', FSendWindowPosLeft);
  Fini.WriteInteger('HOTZONU', 'SENDWIN_TOP', FSendWindowPosTop);
  Fini.WriteInteger('HOTZONU', 'SENDWIN_HEIGHT', FSendWindowHeight);
  Fini.WriteInteger('HOTZONU', 'SENDWIN_WIDTH', FSendWindowWidth);
  Fini.WriteBool('HOTZONU', 'SENDWIN_PREVIEW', FSendWindowShowPreview);
  Fini.WriteInteger('HOTZONU', 'PREVIEWWIN_LEFT', FPreviewWindowPosLeft);
  Fini.WriteInteger('HOTZONU', 'PREVIEWWIN_TOP', FPreviewWindowPosTop);
  Fini.WriteInteger('HOTZONU', 'PREVIEWWIN_HEIGHT', FPreviewWindowHeight);
  Fini.WriteInteger('HOTZONU', 'PREVIEWWIN_WIDTH', FPreviewWindowWidth);
  Fini.WriteBool('HOTZONU', 'SHORTTITLE', FThreadShortTitle);
  Fini.WriteInteger('HOTZONU', 'TITLELEN', FThreadTitleLength);
  Fini.WriteBool('HOTZONU', 'BOARDSHORTTITLE', FBoardShortTitle);
  Fini.WriteBool('HOTZONU', 'CHANGEPANE_THREADLIST', FChangePaneThreadList);
  Fini.WriteBool('HOTZONU', 'CHANGEPANE_BROWSER', FChangePaneBrowser);
  Fini.WriteBool('HOTZONU', 'CHANGEPANE_BOARDLIST', FChangePaneBoardList);
  Fini.WriteBool('HOTZONU', 'COPYWITHBOARDNAME', FCopyWithBoardName);
  Fini.WriteBool('HOTZONU', 'WEBSHORTTITLE', FWebPageShortTitle);
  Fini.WriteInteger('HOTZONU', 'WEBTITLELEN', FWebPageTitleLength);
  Fini.WriteBool('HOTZONU',  'THREADLIST_SHOWCLOSEBTN',  FThreadListShowCloseButton); //16
  Fini.WriteBool('HOTZONU',  'BROWSER_SHOWCLOSEBTN',     FBrowserShowCloseButton);    //16
  Fini.WriteInteger('HOTZONU',  'THREADLIST_TABORDER',  Integer(FThreadListTabOrder)); //24
  Fini.WriteInteger('HOTZONU',  'BROWSER_TABORDER',     Integer(FBrowserTabOrder));    //24

  Fini.WriteInteger('HOTZONU', 'BOARDTITLELEN', FBoardTitleLength);
  Fini.WriteInteger('DESKTOP', 'LEFT',   FWindowLeft);
  Fini.WriteInteger('DESKTOP', 'TOP',    FWindowTop);
  Fini.WriteInteger('DESKTOP', 'WIDTH',  FWindowWidth);
  Fini.WriteInteger('DESKTOP', 'HEIGHT', FWindowHeight);
  Fini.WriteInteger('DESKTOP', 'WINDOWSTATE', Integer(FWindowState));
  Fini.WriteBool('DESKTOP', 'VERTICAL', FVerticalView);
  Fini.WriteBool('DESKTOP', '2PANE', FTwoPaneMode);
  Fini.WriteInteger('DESKTOP', 'THREADLISTSIZE', FThreadListPaneSize);
  Fini.WriteInteger('DESKTOP', 'BOARDLISTSIZE', FBoardListPaneSize);
  Fini.WriteBool('DESKTOP', 'SHOWBOARDLIST', FShowBoardList);
  Fini.WriteBool('DESKTOP', 'SHOWFAVORITES', FShowFavorites);
  Fini.WriteBool('DESKTOP', 'ShowRound', FShowRound);
  Fini.WriteInteger('DESKTOP', 'COMMENTWIN_TOP', FCommentPosTop);
  Fini.WriteInteger('DESKTOP', 'COMMENTWIN_LEFT', FCommentPosLeft);
  Fini.WriteInteger('DESKTOP', 'COMMENTWIN_WIDTH',FCommentWidth);
  Fini.WriteInteger('DESKTOP', 'COMMENTWIN_HEIGHT',FCommentHeight);
  Fini.WriteInteger('DESKTOP', 'EXTRACTLINK_WINDOWSTATE', Integer(FExtractLinkWindowState));
  Fini.WriteInteger('DESKTOP', 'EXTRACTLINK_TOP', FExtractLinkPosTop);
  Fini.WriteInteger('DESKTOP', 'EXTRACTLINK_LEFT', FExtractLinkPosLeft);
  Fini.WriteInteger('DESKTOP', 'EXTRACTLINK_WIDTH', FExtractLinkWidth);
  Fini.WriteInteger('DESKTOP', 'EXTRACTLINK_HEIGHT', FExtractLinkHeight);
  Fini.WriteInteger('DESKTOP', 'BOOKMARK_WINDOWSTATE', Integer(FBookmarkManagerWindowState));
  Fini.WriteInteger('DESKTOP', 'BOOKMARK_TOP', FBookmarkManagerPosTop);
  Fini.WriteInteger('DESKTOP', 'BOOKMARK_LEFT', FBookmarkManagerPosLeft);
  Fini.WriteInteger('DESKTOP', 'BOOKMARK_WIDTH', FBookmarkManagerWidth);
  Fini.WriteInteger('DESKTOP', 'BOOKMARK_HEIGHT', FBookmarkManagerHeight);
  Fini.WriteInteger('DESKTOP', 'BOOKMARK_PANEWIDTH', FBookmarkManagerPaneWidth);
  Fini.WriteInteger('DESKTOP', 'BOOKMARK_PANEHEIGHT', FBookmarkManagerPaneHeight);

  Fini.WriteInteger('DESKTOP', 'ZONUMEMOWIN_TOP', FZonuMemoPosTop);
  Fini.WriteInteger('DESKTOP', 'ZONUMEMOWIN_LEFT', FZonuMemoPosLeft);
  Fini.WriteInteger('DESKTOP', 'ZONUMEMOWIN_WIDTH',FZonuMemoWidth);
  Fini.WriteInteger('DESKTOP', 'ZONUMEMOWIN_HEIGHT',FZonuMemoHeight);
  Fini.WriteBool('DESKTOP', 'ZONUMEMOMULTILINE', FZonuMemoMultiline);
  Fini.WriteBool('DESKTOP', 'ZONUMEMOEXPAND', FZonuMemoExpand);
  Fini.WriteBool('DESKTOP', 'ZONUMEMOTRANS', FZonuMemoTrans);
  Fini.WriteString('DESKTOP', 'ZONUMEMOFONTNAME', FZonuMemoFontName);
  Fini.WriteInteger('DESKTOP', 'ZONUMEMOFONTSIZE', FZonuMemoFontSize);
  for i :=  Low(FInfoColWidth) to  High(FInfoColWidth)  do  begin
    Fini.WriteInteger('DESKTOP', 'INFOCOLWIDTH' + IntToStr(i), FInfoColWidth[i]);
  end;
  for i :=  Low(FActionColumnWidth) to  High(FActionColumnWidth)  do  begin
    Fini.WriteInteger('DESKTOP', 'ACTIONCOLWIDTH' + IntToStr(i), FActionColumnWidth[i]);
  end;
  for i :=  Low(FSioriColumnWidth) to  High(FSioriColumnWidth)  do  begin
    Fini.WriteInteger('DESKTOP', 'SIORI_COLWIDTH' + IntToStr(i), FSioriColumnWidth[i]);
  end;
  Fini.WriteBool('DESKTOP', 'SHOWTHREADLIST', FShowThreadList);
  Fini.WriteBool('DESKTOP', 'SHOWBROWSER', FShowBrowser);
  Fini.WriteBool('DESKTOP', 'EXTTHREADLIST', FExtThreadList);
  Fini.WriteBool('DESKTOP', 'SHOWMESSAGE', FShowMessage);
  Fini.WriteInteger('DESKTOP', 'MESSAGESIZE', FMessageHeight);
  Fini.WriteInteger('DESKTOP', 'APPTOOLBARWIDTH', FAppToolBarWidth);
  Fini.WriteBool('DESKTOP', 'BOARDLISTSHOWRIGHT', FBoardListShowRight);
  Fini.WriteBool('DESKTOP', 'SHOWTHREADLISTINFO', FShowBrowserInfoBar);
  Fini.WriteBool('DESKTOP', 'SHOWBROWSERINFO', FShowThreadListInfoBar);
  Fini.WriteString('SKIN', 'PATH', FSkinPath);
  Fini.WriteBool('SKIN', 'KATJUSHA', FKatjushaSkin);
  Fini.WriteBool('SKIN', 'HOTZONU', FHotzonuSkin);
  Fini.WriteInteger('FILTERDLG' , 'HANDLE', FResFilterHandleIndex);
  Fini.WriteBool('FILTERDLG' , 'ALLCHK',  FResFilterAllChecked);
  Fini.WriteBool('FILTERDLG' , 'HANDLECHK',  FResFilterHandleChecked);
  Fini.WriteBool('FILTERDLG' , 'IDCHK',      FResFilterIDChecked);
  Fini.WriteBool('FILTERDLG' , 'BODYCHK',    FResFilterBodyChecked);
  Fini.WriteBool('FILTERDLG',  'MAILCHK',    FResFilterMailChecked);
  Fini.WriteString('HOTZONU', 'GLOBALHANDLE', FGlobalHandle);
  Fini.WriteString('HOTZONU', 'GLOBALMAIL', FGlobalMail);
  Fini.WriteBool('DESKTOP', 'SENDWIN_SAVEHANDLE', FSaveHandle);
  Fini.WriteInteger('RESQUERYABONE', 'HANDLE', QueryAboneHandleIndex);
  Fini.WriteInteger('RESQUERYABONE', 'MAIL', QueryAboneMailIndex);
  Fini.WriteInteger('DESKTOP', 'FAVLEFT',   FFavEditWindowLeft);
  Fini.WriteInteger('DESKTOP', 'FAVTOP',    FFavEditWindowTop);
  Fini.WriteInteger('DESKTOP', 'FAVWIDTH',  FFavEditWindowWidth);
  Fini.WriteInteger('DESKTOP', 'FAVHEIGHT', FFavEditWindowHeight);
  Fini.WriteInteger('DESKTOP', 'FAVWINDOWSTATE', Integer(FFavEditWindowState));
  Fini.WriteInteger('DESKTOP', 'FAVPANEWIDTH', FFavEditPaneWidth);
  Fini.WriteInteger('DESKTOP', 'ACTWIN_TOP',  FActionPosTop);
  Fini.WriteInteger('DESKTOP', 'ACTWIN_LEFT', FActionPosLeft);
  Fini.WriteInteger('DESKTOP', 'ACTWIN_HEIGHT',FActionHeight);
  Fini.WriteInteger('DESKTOP', 'ACTWIN_WIDTH', FActionWidth);
  Fini.WriteInteger('DESKTOP', 'ACTWIN_PANE1', FActionPane1Size);
  Fini.WriteInteger('DESKTOP', 'ACTWIN_PANE2', FActionPane2Size);
  Fini.WriteBool('DESKTOP', 'ACTWIN_EXPAND', FActionDialogExpand);
  Fini.WriteBool('DESKTOP', 'ACTWIN_TRANS', FActionDialogTrans);
  for i :=  Low(FFavColumnWidth) to  High(FFavColumnWidth)  do  begin
    Fini.WriteInteger('DESKTOP', 'FAVCOLUMNWIDTH' + IntToStr(i), FFavColumnWidth[i]);
  end;
  Fini.WriteBool('DESKTOP', 'THREADINFO', FShowThreadInfo);
  Fini.WriteInteger('DESKTOP', 'THREADINFOWIDTH', FThreadInfoWidth);
  Fini.WriteInteger('DESKTOP', 'BOOKMARKMEMO', FBookmarkMemoHeight);

  Fini.WriteBool('URL', 'CHECKBROCRA', FCheckBroCra);
  Fini.WriteInteger('URL', 'OPENMODE', Integer(FOpenMode));
  Fini.WriteString('URL', 'BCC', FBCCUrl);
  Fini.WriteBool('URL', 'EXECDEFAULTBROWSER', FExecDefBrowser);
  //Fini.WriteBool('URL', 'OPENINHOTZONU', FOpenInHotzonu); //15
  Fini.WriteInteger('URL', 'OPENINHOTZONU', Integer(FOpenInHotzonu));
  Fini.WriteString('URL', 'BROWSERPATH', FExecBrowser);

  Fini.WriteInteger('THREADTAB', 'POSITION', Integer(FThreadListTabPos));
  Fini.WriteInteger('THREADTAB', 'DBLCLICK', Integer(FThreadListDblClick));
  Fini.WriteInteger('THREADTAB', 'WHEELCLICK', Integer(FThreadListWheelClick));
  Fini.WriteInteger('THREADTAB', 'TOOLBARPOS', Integer(FThreadListToolbarPosition));
  Fini.WriteBool('THREADTAB', 'CHECKLOCKCLOSE', FThreadListCheckLockTabClose);

  Fini.WriteInteger('BROWSERTAB', 'POSITION', Integer(FBrowserTabPos));
  Fini.WriteInteger('BROWSERTAB', 'DBLCLICK', Integer(FBrowserDblClick));
  Fini.WriteInteger('BROWSERTAB', 'WHEELCLICK', Integer(FBrowserWheelClick));
  Fini.WriteInteger('BROWSERTAB', 'TOOLBARPOS', Integer(FBrowserToolbarPosition));
  Fini.WriteBool('BROWSERTAB', 'CHECKLOCKCLOSE', FBrowserCheckLockTabClose);

  Fini.WriteInteger('DOLIB', 'PROXYPORT', FDolibProxyPort);
  Fini.WriteString('DOLIB', 'PROXYADDRESS', FDolibProxyAddress);
  Fini.WriteString('DOLIB', 'USERNAME', FDolibUserName);
  Fini.WriteString('DOLIB', 'PASSWORD', FDolibPassword);
  Fini.WriteBool('DOLIB', 'USERPROXY', FDolibUseProxy);
  Fini.WriteBool('DOLIB', 'SHOWDIALOG', FDolibShowDialog);
  Fini.WriteBool('DOLIB', 'AUTOLOGIN', FDolibAutoLogin);
  Fini.WriteBool('DOLIB', 'PROXY_HOTZONU', FDolibUseProxyHotzonuSetting);
  Fini.WriteBool('DOLIB', 'PROXY_CUSTOM', FDolibUseProxyCustomSetting);

  Fini.WriteString('BE', 'USERNAME', FBeUserName);  //11
  Fini.WriteString('BE', 'PASSWORD', FBePassword);  //11
  Fini.WriteString('BE', 'MDMDCODE', FBeMdMdCode);  //11
  Fini.WriteBool('BE', 'SHOWDIALOG', FBeShowDialog);  //11
  Fini.WriteBool('BE', 'AUTOLOGIN', FBeAutoLogin);  //11
  Fini.WriteBool('BE', 'SENDLOGININFO', FBeSendLoginInfo); //15


  Fini.WriteBool('HOTZONU', 'AUTOACTIVE', FAutoActivate);
  Fini.WriteInteger('HOTZONU', 'BOARDLISTSETTING', FBoardListSetting);
  Fini.WriteInteger('HOTZONU', 'THREADLISTSETTING',FThreadListSetting);
  Fini.WriteInteger('HOTZONU', 'FAVLISTSETTING', FFavListSetting);
  Fini.WriteInteger('HOTZONU', 'ROUNDLISTSETTING', FRoundListSetting);
  Fini.WriteBool('HOTZONU', 'CANCELMAILTO', FCancelMailTo);
  Fini.WriteBool('HOTZONU', 'INTOTASKTRAY', FIntoTaskTray);
  Fini.WriteBool('HOTZONU', 'SCROLLTOP', FScrollTopAfterSort);
  Fini.WriteInteger('HOTZONU', 'RECENTCOUNT', FRecentCount);
  Fini.WriteBool('HOTZONU', 'BOARDLISTAUTOEXPAND', FBoardListAutoExpand);
  Fini.WriteBool('HOTZONU', 'CHECKBBSLINK', FCheckBBSLink);
  Fini.WriteString('HOTZONU', 'RESCHAR', FResChar);
  Fini.WriteBool('HOTZONU', 'USEHTMLPOPUP', FUseHtmlPopup);
  Fini.WriteBool('HOTZONU', 'USECGIPOPUP', FUseCgiPopup);
  Fini.WriteBool('HOTZONU', 'USESIMPLEAPI', FUseSimpleAPI);
  Fini.WriteBool('HOTZONU', 'JUMPSHORTCUT', FJumpAfterClicked);
  Fini.WriteString('2CH', 'HEADLINE_URL', FHeadline2chUrl);
  Fini.WriteString('2CH', 'HEADLINE_CGI', FHeadline2chExecUrl);
  Fini.WriteInteger('2CH', 'HEADLINE_BKCOLOR', FHeadline2chBkColor);
  Fini.WriteString('2CH', 'AMESCA_URL', FAmesca2chUrl);
  Fini.WriteString('CHBOX', 'HEURL', FHeeUrl);
  Fini.WriteBool('CHBOX', 'USEHE',  FUseHee);
  Fini.WriteBool('CHBOX', 'CHECKHE', FCheckHee);

  {
  Fini.WriteString('SHITARABA', 'MSGURL', FShitarabaMsgUrl);
  Fini.WriteString('SHITARABA', 'VOTEURL', FShitarabaVoteUrl);
  Fini.WriteString('SEARCHENGINE', 'GOO_E2J', FUrlGooJtoE);
  Fini.WriteString('SEARCHENGINE', 'GOO_J2E', FUrlGooEtoJ);
  Fini.WriteString('SEARCHENGINE', 'YAHOO', FUrlYahoo);
  Fini.WriteString('SEARCHENGINE', 'GOO_NEW', FUrlGooNew);
  Fini.WriteString('SEARCHENGINE', 'GOO_KOKUGO', FUrlGooKokugo);
  Fini.WriteString('SEARCHENGINE', 'ALLTHEWEB', FUrlAllTheWeb);
  Fini.WriteString('SEARCHENGINE', 'GOOGLE', FUrlGoogle);
  }
  Fini.WriteBool('HOTZONU', 'RESLOADALL', FResLoadAll);
  Fini.WriteInteger('HOTZONU', 'RESSHOWCOUNT', FResShowCount);
  Fini.WriteBool('HOTZONU', 'ADDHREFLINK', FAddHrefLink);
  Fini.WriteBool('HOTZONU', 'ADDIDLINK', FAddIDLink);
  Fini.WriteBool('HOTZONU', 'ADDEXTRES', FAddExtendRes);
  Fini.WriteBool('HOTZONU', 'RES1NOPOPUP', FRes1NonPopup);
  //
  Fini.WriteInteger('HOTZONU', 'EXPORT_FILENAMETYPE',   FExportFileNameType);
  Fini.WriteInteger('HOTZONU', 'EXPORT_FORMAT',   FExportFormat);
  Fini.WriteBool('HOTZONU', 'EXPORT_WITHIDTEXT',   FExportWithIDText);
  Fini.WriteString('HOTZONU', 'EXPORT_DATFORMAT', FExportDatFormat);
  Fini.WriteString('HOTZONU', 'EXPORT_SEPARATOR', FExportSeparator);
  Fini.WriteString('HOTZONU', 'EXPORT_PATH', FExportPath);
  Fini.WriteString('HOTZONU', 'EXPORT_HTMLEXT',   FExportHtmlExt);
  Fini.WriteString('HOTZONU', 'EXPORT_DATEXT',   FExportDatExt);
  Fini.WriteString('HOTZONU', 'EXPORT_SKINNAME', FExportSkinName);
  Fini.WriteBool('HOTZONU', 'EXPORT_SKIN_KATJUSHA', ExportSkinKatjusha);
  Fini.WriteBool('HOTZONU', 'EXPORT_SKIN_HOTZONU', ExportSkinHotzonu);
  Fini.WriteString('HOTZONU', 'DEFFAVNAME', FDefaultFavoriteFolderName);
  Fini.WriteInteger('DESKTOP', 'INFO_LEFT',FInfoDialogPosLeft);
  Fini.WriteInteger('DESKTOP', 'INFO_TOP',FInfoDialogPosTop);
  Fini.WriteInteger('DESKTOP', 'INFO_WIDTH', FInfoDialogWidth);
  Fini.WriteInteger('DESKTOP', 'INFO_HEIGHT', FInfoDialogHeight);
  Fini.WriteInteger('HOTZONU', 'BOARDLISTUPDATEMODE', FBoardListUpdateMode);
  Fini.WriteBool('HOTZONU', 'BOARDLISTADDNEW', FBoardListAddNew);
  Fini.WriteBool('HOTZONU', 'BOARDLISTDELETE', FBoardListDelete);
  Fini.WriteBool('HOTZONU', 'BOARDLISTCHANGE', FBoardListChange);
  Fini.WriteInteger('HOTZONU', 'THREADINFOINDEX', FThreadInfoIndex);
  Fini.WriteBool('HOTZONU', 'GAISHUTUCATEGO', FGaishutuCategorize);
  Fini.WriteInteger('HOTZONU', 'THREADTITLEPANEL', Integer(FThreadTitlePanel));
  Fini.WriteString('HOTZONU', 'THREADTITLEPANELCOLOR', ColorToString(FThreadTitlePanelColor));
  Fini.WriteString('HOTZONU', 'THREADTITLETEXTCOLOR', ColorToString(ThreadTitleTextColor));
  Fini.WriteInteger('HOTZONU', 'THREADTITLESIZE', FThreadTitleSize);
  Fini.WriteBool('HOTZONU', 'THREADTITLESHOWSIZE', FThreadTitleShowSize);
  Fini.WriteBool('HOTZONU', 'THREADTITLEAUTOFIT', FThreadTitleAutoFit);
  Fini.WriteBool('HOTZONU', 'THREADLISTEXISTSRELOAD', FThreadListExistsReload);
  Fini.WriteBool('HOTZONU', 'THREADLISTSHOWTOOLTIP', FThreadListShowTooltip);
  Fini.WriteInteger('HOTZONU', 'THREADLISTTOOLTIPPOS', Integer(FThreadListTooltipPos));
  Fini.WriteBool('HOTZONU', 'BROWSEREXISTSRELOAD', FBrowserExistsReload);
  Fini.WriteBool('MACHIBBS', 'WARNING', FMachiBBSWarning);
  Fini.WriteBool('HOTZONU', 'FUSIANASAN', FFusianasanWarning);
  Fini.WriteBool('HOTZONU', 'HISTRELOAD', FHistReloadAfterLoad);
  {
  Fini.WriteInteger('DESKTOP', 'SHITARABALEFT',   FShitarabaMsgWindowLeft);
  Fini.WriteInteger('DESKTOP', 'SHITARABATOP',    FShitarabaMsgWindowTop);
  Fini.WriteInteger('DESKTOP', 'SHITARABAWIDTH',  FShitarabaMsgWindowWidth);
  Fini.WriteInteger('DESKTOP', 'SHITARABAHEIGHT', FShitarabaMsgWindowHeight);
  Fini.WriteInteger('DESKTOP', 'SHITARABAWINDOWSTATE', Integer(FShitarabaMsgWindowState));
  Fini.WriteInteger('DESKTOP', 'SHITARABAPANEWIDTH', FShitarabaMsgPaneWidth);
  for i :=  Low(FShitarabaMsgColumnWidth) to  High(FShitarabaMsgColumnWidth)  do  begin
    Fini.WriteInteger('DESKTOP', 'SHITARABACOLUMNWIDTH' + IntToStr(i), FShitarabaMsgColumnWidth[i]);
  end;
  Fini.WriteString('SHITARABA', 'PASSWORD', FShitarabaMsgPassword);
  }
  Fini.WriteString('MEGABBS_NEWCGI', 'megabbs', FMegabbsNewCgiURL);
  Fini.WriteString('MEGABBS_NEWCGI', 'lemmingdead', FMegabbsNewCgiURL2);
  Fini.WriteString('ICHIGOBBS', '156', FIchigo156Url);
  Fini.WriteString('ICHIGOBBS', 'RANKING', FIchigoRankingUrl);
  Fini.WriteString('ICHIGOBBS', 'HEADLINE', FIchigoHeadlineUrl);
  Fini.WriteInteger('ICHIGOBBS', 'HEADLINECOUNT', FIchigoHeadlineCount);
  Fini.WriteBool('ICHIGOBBS', 'HEADLINESHOW', FIchigoHeadlineGaishutuOnly);
  Fini.WriteString('MILKCAFE', 'DIARY', FMilkcafeDiaryUrl);

  Fini.WriteString('HOTZONU', 'LOCALFOLDERLASTPATH', FLocalFolderLastPath);
  Fini.WriteBool('HOTZONU', 'BBSTOOLBARSHOWIMAGE', FBBSToolBarShowImage);
  Fini.WriteBool('HOTZONU', 'SHOWBBSTOOLBAR', FShowBBSToolBar);
  Fini.WriteString('NINKINET', 'URL', FNinkinetUrl);
  Fini.WriteBool('NINKINET', 'CHECK', FExecNinkinet);
  Fini.WriteBool('HOTZONU', 'BROWSERPOPUP', FUseBrowserPopup);
  Fini.WriteBool('DESKTOP', 'SHOWLOGTAB', FShowLogTab);
  Fini.WriteString('DESKTOP', 'LOGFONTNAME', FLogFontName);
  Fini.WriteInteger('DESKTOP', 'LOGFONTSIZE', FLogFontSize);
  Fini.WriteString('DESKTOP', 'LOGFONTCOLOR', ColorToString(FLogFontColor));
  Fini.WriteString('DESKTOP', 'LOGBACKCOLOR', ColorToString(FLogBackColor));
  Fini.WriteInteger('DESKTOP', 'LOGPANEWIDTH', FLogPaneWidth);
  Fini.WriteString('HOTZONU', 'LASTCHECK', FLastChecked);
  Fini.WriteInteger('HOTZONU', 'LASTCOMMAND', FLastCommand);
  Fini.WriteBool('HOTZONU', 'SHOWCOUNTGAP', FShowCountGap);
  Fini.WriteBool('HOTZONU', 'SAVEHIST', FSaveHist);
  Fini.WriteBool('HOTZONU', 'SAVEHIST_SEND', FSaveHist_Send); //age16
  Fini.WriteString('HOTZONU', 'KATJUBOARDPATH', FKatjuBoardPath);
  Fini.WriteBool('HOTZONU', 'STARTUPSHOWDIRECT', FStartUpHzbDirect);
  Fini.WriteBool('HOTZONU', 'STARTUPLOADDIRECT', FStartUpLoadDirect);
  Fini.WriteBool('HOTZONU', 'TABCLICKCHANGEPANE', FTabClickChangePane);
  Fini.WriteString('SOUND', 'THREADNONEWRES', ExtractRelativePath(UsersPath , FSndThreadNoNewRes));
  Fini.WriteString('SOUND', 'ERROR', ExtractRelativePath(UsersPath , FSndError));
  Fini.WriteString('SOUND', 'UPDATECHECK', ExtractRelativePath(UsersPath , FSndUpdateCheck)); //13
  Fini.WriteString('SOUND', 'UPDATECHECK_NO', ExtractRelativePath(UsersPath , FSndUpdateCheckNo)); //32
  Fini.WriteString('SOUND', 'ROUND', ExtractRelativePath(UsersPath , FSndRound)); //13
  Fini.WriteString('SOUND', 'ROUND_NO', ExtractRelativePath(UsersPath , FSndRoundNo)); //32
  Fini.WriteString('SOUND', 'THREADNEWRES', ExtractRelativePath(UsersPath , FSndThreadHasNewRes));
  Fini.WriteString('SOUND', 'SEND', ExtractRelativePath(UsersPath , FSndSendComplete));
  Fini.WriteString('SOUND', 'THREADLIST', ExtractRelativePath(UsersPath , FSndThreadListComplete));

  Fini.WriteBool('SOUND', 'EXECTHREADNONEWRES', FExecSndThreadNoNewRes);
  Fini.WriteBool('SOUND', 'EXECERROR', FExecSndError);
  Fini.WriteBool('SOUND', 'EXECUPDATECHECK', FExecSndUpdateCheck);
  Fini.WriteBool('SOUND', 'EXECUPDATECHECK_NO', FExecSndUpdateCheckNo);
  Fini.WriteBool('SOUND', 'EXECROUND', FExecSndRound);
  Fini.WriteBool('SOUND', 'EXECROUND_NO', FExecSndRoundNo);
  Fini.WriteBool('SOUND', 'EXECUPDATECHECK_THREAD', FExecSndUpdateCheckThread);
  Fini.WriteBool('SOUND', 'EXECROUND_THREAD', FExecSndRoundThread);
  Fini.WriteBool('SOUND', 'EXECTHREADNEWRES', FExecSndThreadHasNewRes);
  Fini.WriteBool('SOUND', 'EXECSEND', FExecSndSendComplete);
  Fini.WriteBool('SOUND', 'EXECTHREADLIST', FExecSndThreadListComplete);

  Fini.WriteInteger('HOTZONU', 'THREADLISTDOWNLOADMODE', Integer(FThreadListDownloadMode));
  Fini.WriteInteger('HOTZONU', 'THREADLISTREFRESHCOUNT', FThreadListRefreshCount);
  Fini.WriteInteger('DESKTOP', 'CHOTTOWIN_TOP', FChottoPosTop);
  Fini.WriteInteger('DESKTOP', 'CHOTTOWIN_LEFT', FChottoPosLeft);
  Fini.WriteInteger('DESKTOP', 'CHOTTOWIN_WIDTH', FChottoWidth);
  Fini.WriteInteger('DESKTOP', 'CHOTTOWIN_HEIGHT', FChottoHeight);
  Fini.WriteBool('DESKTOP', 'CHOTTOWIN_TRANS', FChottoTrans); //22
  Fini.WriteBool('DESKTOP', 'CHOTTOWIN_EXPND', FChottoExpand); //22
  Fini.WriteBool('HOTZONU', 'CHOTTO_SHORTTITLE', FChottoShortTitle); //49
  Fini.WriteInteger('HOTZONU', 'CHOTTO_TITLELEN', FChottoTitleLength); //49
  Fini.WriteBool('HOTZONU', 'CHOTTO_CLOSEALLTABS', FChottoCloseAllTabs); //49

  Fini.WriteInteger('DESKTOP', 'CHOTTOWIN_WINDOWSTATE', Integer(FChottoWindowState));
  Fini.WriteBool('HOTZONU' , 'PRMPTDELETEFAV', FPromptDeleteWithFav);
  Fini.WriteBool('HOTZONU', 'MOVETOTRASH', FMoveToTrash);
  Fini.WriteBool('HOTZONU', 'LOCKTOOLBAR', FLockToolbar);
  Fini.WriteBool('HOTZONU', 'FINDDLGAUTOCOMPLETE', FFindDialogAutoComplete); //13
  Fini.WriteInteger('HOTZONU', 'SHORTCUTBARPOS', Integer(FShortcutBarPos));
  Fini.WriteString('HOTZONU', 'SHORTCUTBARFONTNAME', FShortcutBarFontName); //13
  Fini.WriteInteger('HOTZONU', 'SHORTCUTBARFONTCOLOR', FShortcutBarFontColor); //13
  Fini.WriteInteger('HOTZONU', 'SHORTCUTBARFONTSIZE', FShortcutBarFontSize); //13

  Fini.WriteBool('BOOKMARKMANAGER', 'EXPAND', FBookmarkManagerExpand); //bata61
  Fini.WriteBool('BOOKMARKMANAGER', 'TRANS', FBookmarkManagerTrans); //bata61

  Fini.WriteString('HOTZONU', 'FILTERTAG1', FFilterTag1);
  Fini.WriteString('HOTZONU', 'FILTERTAG2', FFilterTag2);
  Fini.WriteBool('HOTZONU', 'FILtERAUTOCOMPLETE', FFilterAutoComplete); //13
  Fini.WriteBool('HOTZONU', 'FILTERIGNORECASE', FFilterIgnoreCase);
  Fini.WriteBool('HOTZONU', 'SHORTCUTBAR_ADDEDIT', FShortcutBarAddAfterEdit); //age16
  Fini.WriteBool('HOTZONU', 'RELOADKOKOYON', FReloadOnKokoyon);
  Fini.WriteString('HOTZONU', 'STARTUPSITE', FStartupSite);
  Fini.WriteBool('HOTZONU', 'JPEGPOPUP', FUseJpegPopup);
  Fini.WriteBool('HOTZONU', 'JPEGPOPUP_CTRL', FCanJpegPopupWithCtrlKey);
  Fini.WriteBool('HOTZONU', 'JPEGWIN_ONTOP', FJpegPopupOnTopStay);
  Fini.WriteInteger('DESKTOP', 'JPEGWIN_TOP', FJpegPopupPosTop);
  Fini.WriteInteger('DESKTOP', 'JPEGWIN_LEFT', FJpegPopupPosLeft);
  Fini.WriteInteger('DESKTOP', 'JPEGWIN_WIDTH', FJpegPopupWidth);
  Fini.WriteInteger('DESKTOP', 'JPEGWIN_HEIGHT', FJpegPopupHeight);
  Fini.WriteInteger('DESKTOP', 'JPEGWIN_ALPHA', FJpegAlphaBlendValue);
  Fini.WriteInteger('DESKTOP', 'IMAGEPANE', Integer(FImageDropPane)); //11
  Fini.WriteInteger('DESKTOP', 'IMAGEPANE_HEIGHT', FImageDropPaneHeight);  //11
  Fini.WriteBool('DESKTOP', 'IMAGEPANE_HIDDEN', FImageDropPaneHidden);  //11
  Fini.WriteInteger('DESKTOP', 'HISTDIALOG_WINDOWSTATE', Integer(FHistDialogState)); //11
  Fini.WriteInteger('DESKTOP', 'HISTDIALOG_TOP', FHistDialogPosTop); //11
  Fini.WriteInteger('DESKTOP', 'HISTDIALOG_LEFT', FHistDialogPosLeft); //11
  Fini.WriteInteger('DESKTOP', 'HISTDIALOG_WIDTH', FHistDialogWidth);//11
  Fini.WriteInteger('DESKTOP', 'HISTDIALOG_HEIGHT', FHistDialogHeight);//11
  Fini.WriteInteger('HOTZONU', 'APPSTATE', Integer(FAppState)); //15
  Fini.WriteInteger('HOTZONU', 'LOGMODE', Integer(FLogCompatibleMode));  //24
  Fini.WriteString('HOTZONU', 'JANE_PATH', FJanePath);  //24
  Fini.WriteBool('HOTZONU', 'SAVEMODE_WARNING', FShowSaveModeWarning); //29
  Fini.WriteInteger('HOTZONU', 'ROUND_KAKO_OCHI', Integer(FRoundKakoOti));  //30
  Fini.WriteBool('HOTZONU', 'EXIT_WARNING', FShowExitWarning);  //31
  Fini.WriteBool('HOTZONU', 'FAVADDEDIT', FFavoriteAddAfterEdit);  //32
  Fini.WriteInteger('HOTZONU', 'READMODE', Integer(FReadMode)); //33
  Fini.WriteInteger('HOTZONU', 'DATOCHIMODE', Integer(FDatOchiMode));  //33
  Fini.WriteInteger('HOTZONU', 'DOUBLEWINDOW_HEIGHT', FDoubleWindowHeight);  //36
  FIni.WriteBool('HOTZONU', 'SHOWEXIFINFO', FShowExifInfo); //bata40
  Fini.WriteBool('HOTZONU', 'UPDCHECK', FUpdateCheck); //bata54
  Fini.WriteString('HOTZONU', 'CHECKVER', FCheckedVer); //bata54

  for i :=  Low(FHistDialogColumnWidth) to  High(FHistDialogColumnWidth)  do  begin
    Fini.WriteInteger('DESKTOP', 'HISTDIALOG_COLUMNWIDTH' + IntToStr(i), FHistDialogColumnWidth[i]);
  end;

  Fini.UpdateFile;
end;

procedure TZonuConfig.SetActionColumnWidth(idx: integer;
  const Value: integer);
begin
  if  (idx <= High(FActionColumnWidth))  then  begin
    FActionColumnWidth[idx] :=  Value;
  end;
end;

procedure TZonuConfig.SetColumnWidth(ColName: string;
  const Value: integer);
begin
  Fini.WriteInteger('COLUMNSIZE', ColName, Value);
end;

procedure TZonuConfig.SetCookieSPID(Host: string; const Value: string);
begin
  Fini.WriteString('CookieSPID', Host, QuotedStr(Value)); //PONΉ
end;

//29
procedure TZonuConfig.SetCookie2ch(Host: string; const Value: string);
begin
  Fini.WriteString('Cookie2ch', Host, QuotedStr(Value));
end;

procedure TZonuConfig.SetFavColumnWidth(idx: integer;
  const Value: integer);
begin
  if  (idx <= High(FFavColumnWidth))  then  begin
    FFavColumnWidth[idx] :=  Value;
  end;
end;

procedure TZonuConfig.SetInfoColWidth(idx: integer; const Value: integer);
begin
  FInfoColWidth[idx] :=  Value;
end;

procedure TZonuConfig.SetLoadThreadCount(const Value: integer);
begin
  ALoadThreadCount := Value;
end;

{
function TZonuConfig.GetColumnWidth(idx: integer): integer;
begin
  if  (idx <= High(FColumnWidth))  then  begin
    Result  :=  FColumnWidth[idx];
  end else begin
    Result  :=  1;
  end;
end;

procedure TZonuConfig.SetColumnWidth(idx: integer; const Value: integer);
begin
  if  (idx <= High(FColumnWidth))  then  begin
    FColumnWidth[idx] :=  Value;
  end;
end;

}
{
procedure TZonuConfig.SetShitarabaMsgColumnWidth(idx: integer;
  const Value: integer);
begin
  FShitarabaMsgColumnWidth[idx]  :=  Value;
end;
}
procedure TZonuConfig.SetSioriColumnWidth(idx: integer;
  const Value: integer);
begin
  FSioriColumnWidth[idx]  :=  Value;
end;

//11
function TZonuConfig.GetHistDialogColumnWidth(idx: integer): integer;
begin
  if  (idx <= High(FHistDialogColumnWidth))  then  begin
    Result  :=  FHistDialogColumnWidth[idx];
  end else begin
    Result  :=  1;
  end;
end;

//11
procedure TZonuConfig.SetHistDialogColumnWidth(idx: integer;
  const Value: integer);
begin
  if  (idx <= High(FHistDialogColumnWidth))  then  begin
    FHistDialogColumnWidth[idx] :=  Value;
  end;
end;


end.

